--  Created by zhangchao on 15-04-27.
ZCConfirmDialog = class("ZCConfirmDialog", function(params)
    return ZCPopLayer:create({isRemoveLayout = false})
end)

--[[设置左边按钮的点击事件]]
function ZCConfirmDialog:setCallbackLeft(callback)
    self._btn_left:setTouchEndedCall(callback)
end

--[[设置右边按钮的点击事件,如有需要可以在这里手动移除pop弹窗]]
function ZCConfirmDialog:setCallbackRight(callback)
    self._btn_right:setTouchEndedCall(callback)
end

--[[设置关闭回调]]
function ZCConfirmDialog:setCallbackClose(callback)
    self.closeCallback = callback or nil
end

--[[获取弹出框文字背景]]
function ZCConfirmDialog:getContainer()
    return self.containerBg or  nil
end

function ZCConfirmDialog:ctor(params)
    local default = {
        msg                     = "",
        contentNode             = nil, ---中间需要显示的内容，如果是纯文本，传入msg即可，此值为默认值
        leftText                = zc.lang("cancel2"),
        rightText               = zc.lang("confirm2"),   
        leftVisible             = true,
        rightVisible            = true,
        leftLabel               = nil,
        rightLabel              = nil,
        fontSize                = 22,   
        leftCallback            = nil,
        rightCallback           = nil,
        closeCallback           = nil,
        isHide                  = true,
        showDi                  = false,
        doShowAction            = false
    }
    
    if params == nil then params = {} end
    for k,v in pairs(default) do
        if params[k] == nil then
            params[k] =v
        end
    end
    
    local msg                   = params.msg
    local contentNode           = params.contentNode
    local fontSize              = params.fontSize
    local leftText              = params.leftText
    local rightText             = params.rightText
    local leftLabel             = params.leftLabel
    local rightLabel            = params.rightLabel
    local leftVisible           = params.leftVisible
    local rightVisible          = params.rightVisible
    local leftCallback          = params.leftCallback
    local rightCallback         = params.rightCallback
    local closeCallback         = params.closeCallback
    local isHide                = params.isHide
    local title_txt             = params.title
    local titleSrc              = params.titleSrc
    local showDi                = params.showDi
    local doShowAction          = params.doshow
    local isRich                = params.isRich
    self.isRich = isRich
    self._fontSize = fontSize
    self:setLeftTouchEndedCallback(leftCallback)
    self:setRightTouchEndedCallback(rightCallback)

    local width = self:getContentSize().width
    local height = self:getContentSize().height

    local bg_sp = zc.getSprite({
        src = "res/Main/common/popBg/popup_Bg_blue.png",
    })
    self.containerBg = bg_sp
    local _bgSize = bg_sp:getContentSize()
    bg_sp:setPosition(width/2,height/2)
    self:addContent(bg_sp)

    local close = zc.createBackButton({
        pos = cc.p(_bgSize.width-10, _bgSize.height-10),
        listener = function () 
            self:hide({music=true})
        end,
    })
    bg_sp:addChild(close)
    self._close_btn = close
    
    --标题
    if titleSrc or not title_txt or title_txt == zc.lang("prompt") then
        local _src = titleSrc or "res/Main/common/tipTitle/tishi.png"
        local _titleTextDi = zc.getSprite({
            src = "res/Main/common/popBg/tipDi.png",
            ap = cc.p(0.5, 1),
            pos = cc.p(_bgSize.width/2, _bgSize.height - 10),
        })
        bg_sp:addChild(_titleTextDi, 1)
        local title = zc.getSprite({
            src = _src,
            ap = cc.p(0.5, 1),
            pos = cc.p(_titleTextDi:getPosition()),
        })
        bg_sp:addChild(title, 1)
    elseif title_txt then
        local title = zc.createLabel({
            text = ""..title_txt,
            outLine = true,
            fontSize = 30,
            ap = cc.p(0.5, 1),
            pos = cc.p(_bgSize.width/2, _bgSize.height-13),
            align = kCCTextAlignmentCenter,
        })
        bg_sp:addChild(title, 1)
    end

    

    local txt_content  = nil
    if not contentNode then 
        showDi = true
        txt_content = self:setMsg(msg)
    else 
        txt_content = contentNode
    end

    if showDi then
        local middleBg = zc.getScaleNode("res/Main/common/popBg/di_1.png", cc.size(460, 200))
        middleBg:setPosition(_bgSize.width*0.5, _bgSize.height*0.5 + 30)
        middleBg:setName("middleBg")
        bg_sp:addChild(middleBg)
        self._middleBg = middleBg
    end

    txt_content:setName("txt_content")
    txt_content:setPosition(_bgSize.width/2,_bgSize.height/2 + 30)
    bg_sp:addChild(txt_content)

    local btn_left = zc.createCommomBtn({
        tag = 1,
        text = leftText,
        anchor = cc.p(0.5, 0.5),
        pos = cc.p(130, 65),
        endCallback = function()
            if self._left_callback_running == true then
                return
            end
            self._left_callback_running = true
            
            if self:getLeftTouchEndedCallback() then
                self:getLeftTouchEndedCallback()()
            end
            if isHide == true then
                self:hide({music = true})
            else
                self._left_callback_running = false
            end
        end,
    })
    btn_left:setCascadeOpacityEnabled(true)
    btn_left:setOpacity(255)
    bg_sp:addChild(btn_left)
    
    ------------be added artistic word
  
    local btn_right = zc.createCommomBtn({
        tag = 2,
        text = rightText,
        pos = cc.p(_bgSize.width - 130, btn_left:getPositionY()),
        endCallback = function()
            if self._right_callback_running == true then
                return
            end
            self._right_callback_running = true

            if self:getRightTouchEndedCallback() then
                self:getRightTouchEndedCallback()()
            end
            if isHide == true then
                xpcall(function()
                    self:hide({music = true}) end
                    ,function() 
                    print("ZCConfirmDialog已经被移除了，在这里你又移除？")
                    cclog("----------------------------------------")
                    cclog("LUA ERROR: " .. tostring(msg) .. "\n")
                    cclog(debug.traceback())
                    cclog("----------------------------------------")
                    end)
            else
                self._right_callback_running = false
            end
        end,
    })
    btn_right:setCascadeOpacityEnabled(true)
    btn_right:setOpacity(255)
    bg_sp:addChild(btn_right)

    ------------be added artistic word

    self.closeCallback = closeCallback or nil

    self._btn_left = btn_left
    self._btn_right = btn_right

    if leftVisible == false then
        btn_left:setVisible(false)
        btn_right:setPositionX(_bgSize.width / 2)
    end
    print("doShowAction --------------------> ", doShowAction)
    self:show(doShowAction)
end

function ZCConfirmDialog:setLeftTouchEndedCallback(callback)
    self._leftTouchEndedCallback = callback
end

function ZCConfirmDialog:getLeftTouchEndedCallback()
    return self._leftTouchEndedCallback or nil
end

function ZCConfirmDialog:setRightTouchEndedCallback(callback)
    self._rightTouchEndedCallback = callback
end

function ZCConfirmDialog:getRightTouchEndedCallback()
    return self._rightTouchEndedCallback or nil
end

function ZCConfirmDialog:onExit()
    if self.closeCallback then
        self.closeCallback()
    end
end

function ZCConfirmDialog:createWithParams(params)
    local layer = ZCConfirmDialog.new(params)
    return layer

end

function ZCConfirmDialog:getLeftButton( )
    return self._btn_left
end

function ZCConfirmDialog:getRightButton(  )
    return self._btn_right
end

function ZCConfirmDialog:getCloseButton(  )
    return self._close_btn
end

function ZCConfirmDialog:getMiddleBg()
    return self._middleBg
end

function ZCConfirmDialog:setMsg( msg )
    if self.isRich then
        self._txt_content = zc.createRichLabel({
            text = msg,
            fontSize = self._fontSize,
            fontSize = 24
        })
        if self._txt_content:getContentSize().width > 410 then
            self._txt_content:setDimensions(cc.size(410, 100))
        end
    else
        local txt_content = zc.createLabel({
            text = msg,
            fontSize = self._fontSize,
            color = cc.c3b(75, 30, 0),
        })
        -- --解决文字过短居中的问题
        local text_width = 380
        if tonumber(txt_content:getContentSize().width)< text_width then
            text_width =  tonumber(txt_content:getContentSize().width) 
        end
        if self._txt_content then
            self._txt_content:setString(msg)
            self._txt_content:setWidth(text_width)
        else
            self._txt_content = zc.createLabel({
                text = msg,
                fontSize = self._fontSize,
                width = text_width,
                color = cc.c3b(75, 30, 0),
            })
        end
    end
    return self._txt_content
end
