--[[
	折扣商店
]]
local ChengjiuCountry = class("ChengjiuCountry", function()
    local layer = cc.Sprite:create()
    layer:setContentSize(720,463)
	return layer
end)

function ChengjiuCountry:create( params )
	return ChengjiuCountry.new( params )
end

function ChengjiuCountry:ctor( params )
    self._activityType = params.activityType
	self._size = self:getContentSize()
	self:initData( params )
	self:initUI()
end

function ChengjiuCountry:initData( params )
	self._stateTable = params.table or {}
	self.ownList = params.taskList.own or {}
	self.countryList = params.taskList.country or {}
	self.tag = 1
	self:freshListData(self.tag)
end

function ChengjiuCountry:freshListData( sType )
	local _nowlist
	if sType == 1 then
		_nowlist = self.ownList
	else
		_nowlist = self.countryList
	end
	local bt = {}
	for k,v in pairs(_nowlist) do
		local _taskId = tostring(v.taskId)
		local _status = tonumber(v.status) or 0
		local _data = self._stateTable[_taskId] or {}
		if _status == 1 or _status == 2 then
			local _preposeId = tonumber(_data.preposeId) or 0
			if _preposeId == 0 then
				table.insert(bt, v)
			else
				local _addFlag = false
				for _k, _v in pairs(_nowlist) do
					if tonumber(_v.taskId) == _preposeId then
						local _status2 = tonumber(_v.status) or 0
						if _status2 == 3  then
							_addFlag = true
						end	
						break
					end
				end
				if _addFlag then
					table.insert(bt, v)
				end
			end
		elseif _status == 3 then
			local _nextTaskId = tonumber(_data.nextTaskId) or 0
			if _nextTaskId == 0 then
				table.insert(bt, v)
			end
		end
	end

	table.sort(bt, function( a, b )
		local numA = tonumber(a.status) or 0
		local numB = tonumber(b.status) or 0
		if numA ~= numB then
			numA = numA%3
			numB = numB%3
			return numA > numB
		end
		numA = tonumber(a.id) or 0
		numB = tonumber(b.id) or 0
		return numA < numB
	end)
	self._nowShowList = bt
end

function ChengjiuCountry:initUI()
	local bg = ccui.Scale9Sprite:create(cc.rect(12, 11, 14, 10), "res/Main/common/popBg/di_4.png")
	bg:setContentSize(self._size.width - 25,self._size.height - 60 )
	bg:setAnchorPoint(0.5, 0)
	bg:setPosition(self._size.width/2, 7)
	self:addChild(bg)

	local tagbtns = {}
	local fontcolors = {cc.c3b(225, 213, 147), cc.c3b(140, 35, 35)}
	local texts = {zc.lang("person"),zc.lang("country_")}
	local function _selectedBtn()
		tagbtns[1]:setEnable(self.tag == 2)
		tagbtns[2]:setEnable(self.tag == 1)

		for i=1, 2 do
			local label = tagbtns[i]:getLabel()
		    local outlineColor = self.tag == i and fontcolors[2] or cc.c3b(59, 59, 59)
		    label:enableOutline(cc.c4b(outlineColor.r,outlineColor.g,outlineColor.b,255), 2) 
		end
	end

	for i=1, 2 do
		local personbtn =  zc.createPushButton({
			normalFile = "res/Main/activity/unsele.png",
			selectedFile = "res/Main/activity/unsele.png",
			disableFile = "res/Main/activity/sele.png",
			noScaleAction = true,
			needSwallow = false,
			needEnableWhenMoving = true,
			text = texts[i],
			fontSize = 24,
			fontColor = fontcolors[1],
			pos = cc.p(120 + (i - 1) * 185, self._size.height - 30),
			endCallback = function()
				self.tag = i
				self:freshListData(self.tag)
				self._tableview:reloadData()

				_selectedBtn()
			end
		})
		self:addChild(personbtn)
		tagbtns[i] = personbtn
	end
	_selectedBtn()

	local time_bg = ccui.Scale9Sprite:create(cc.rect(12, 11, 14, 10), "res/Main/role/common/name_bg.png")
	time_bg:setContentSize(280,30 )
	time_bg:setPosition(tagbtns[2]:getPositionX() + tagbtns[2]:getContentSize().width + 90,tagbtns[2]:getPositionY())
	self:addChild(time_bg)

	-- tableview
	local tableview = zc.ZCTableView:create(cc.size(685, bg:getContentSize().height - 2))
    tableview:setBounceable( true )
    tableview:setInertia( true )
    tableview:setDirection( cc.SCROLLVIEW_DIRECTION_VERTICAL )
    tableview:setPosition( cc.p( 20, 8 ) )
    tableview:setDelegate()
    tableview:setVerticalFillOrder( cc.TABLEVIEW_FILL_TOPDOWN )
    local cellWidth = 670
    local cellHeight = 120
    local function cellSizeForTable(table, index) 
        return cellHeight, cellWidth
    end
    local function tableCellAtIndex(table, index)
        local cell = table:dequeueCell()
        -- 创建模板
        if cell == nil then
            cell = zc.ZCTableViewCell:new()
            self:buildCell( cell, cellWidth, cellHeight)
        end
        self:updateCell( cell, index + 1 )
        return cell
    end
    local function numberOfCellsInTableView()
    	return #self._nowShowList
    end
    tableview:registerScriptHandler( cellSizeForTable, cc.TABLECELL_SIZE_FOR_INDEX )
    tableview:registerScriptHandler( tableCellAtIndex, cc.TABLECELL_SIZE_AT_INDEX )
    tableview:registerScriptHandler( numberOfCellsInTableView, cc.NUMBER_OF_CELLS_IN_TABLEVIEW )
    self:addChild(tableview)
    self._tableview = tableview
    tableview:reloadData()

    local _turnInfo = PlayerData:getActivityInfoById(21)
    if _turnInfo.openTime and _turnInfo.endTime then
        --活动时间
        local timeTip = zc.createLabel({
            text = zc.lang("activity_time") .. "：",
            fontSize = 18,
            ap = cc.p(0, 0.5),
            pos = cc.p(10, time_bg:getContentSize().height/2),
            color = cc.c3b(209, 148, 148),
        })
        time_bg:addChild(timeTip)
        local _openTime = os.date("%m" .. zc.lang("date_month") .. "%d" .. zc.lang("date_day_1"), _turnInfo.openTime )
        local _endTime = os.date("%m" .. zc.lang("date_month") .. "%d" .. zc.lang("date_day_1"), _turnInfo.endTime )
        local timeLab = zc.createLabel({
            text = _openTime .. " ~ " .. _endTime,
            fontSize = 18,
            ap = cc.p(0, 0.5),
            pos = cc.p(timeTip:getPositionX() + timeTip:getContentSize().width, timeTip:getPositionY()),
            color = cc.c3b(223, 207, 196),
        })
        time_bg:addChild(timeLab)
    end
end

function ChengjiuCountry:buildCell( cell, cellWidth, cellHeight)
	-- x,y,w,h
	local bg = ccui.Scale9Sprite:create(cc.rect(25, 25, 2, 10),"res/Main/grabFood/cellDi.png")
	bg:setContentSize(680,112)
	bg:setPosition( cellWidth/2 + 5,cellHeight/2)
	cell:addChild( bg )
	local bgSize = bg:getContentSize()
	cell._bg = bg

	local bg_icon = cc.Sprite:create("res/Main/activity/country_icon.png")
	bg_icon:setPosition(70,bgSize.height/2)
	bg:addChild(bg_icon)


	local _icon = cc.Sprite:create(zc.getImgByType(1))
	_icon:setPosition(bg_icon:getContentSize().width/2,bg_icon:getContentSize().height/2)
    _icon:setScale(0.6)
    bg_icon:addChild(_icon)

	local title_label  = zc.createLabel({
		text = "",
        fontSize = 20,
        color = cc.c3b(214, 192, 153),
        ap = cc.p( 0, 0.5 ),
        pos = cc.p( _icon:getPositionX() + _icon:getContentSize().width/2 + 70, bgSize.height/2 + 40),
	})
	bg:addChild(title_label)

	local title_label_num  = zc.createLabel({
		text = "",
        fontSize = 20,
        color = cc.c3b(255, 0, 28),
        ap = cc.p( 0, 0.5 ),
        outLine = true,
        pos = cc.p( title_label:getPositionX() + title_label:getContentSize().width, title_label:getPositionY()),
	})
	bg:addChild(title_label_num)

	local title_label_ci  = zc.createLabel({
		text = zc.lang("ci"),
        fontSize = 20,
        color = cc.c3b(214, 192, 153),
        ap = cc.p( 0, 0.5 ),
        outLine = true,
        pos = cc.p( title_label_num:getPositionX() + title_label_num:getContentSize().width,title_label:getPositionY()),
	})
	bg:addChild(title_label_ci)

	 --经验进度
    local progressBg = ccui.Scale9Sprite:create(cc.rect(9, 0, 1, 26 ), "res/Main/smithy/practice/progressBg.png")
    progressBg:setContentSize(cc.size(330, 26))
    progressBg:setAnchorPoint(0,0.5)
    progressBg:setPosition(cc.p(title_label:getPositionX(), title_label:getPositionY() - title_label:getContentSize().height - 5))
    bg:addChild(progressBg)

    local progress = ccui.Scale9Sprite:create(cc.rect(3, 0, 1, 23 ), "res/Main/smithy/practice/progress.png")
    progress:setContentSize(cc.size(330, 25))
    progress:setAnchorPoint(0,0.5)
    progress:setPosition(cc.p(0,12))
    progressBg:addChild(progress)

    local times_label = zc.createLabel({
        text = "",
        fontSize = 22,
        color = cc.c3b(255, 251, 142),
        pos = cc.p(progressBg:getContentSize().width/2-20, 11),
        outLine = true,
    })
    progressBg:addChild(times_label)

	local rewardlabel  = zc.createLabel({
		text = zc.lang("reward")..":",
        fontSize = 20,
        color = cc.c3b(68,34,23),
        ap = cc.p( 0, 0.5 ),
        pos = cc.p( title_label:getPositionX(),bgSize.height/2 - 30),
	})
	bg:addChild(rewardlabel)

	local reward_ditiao = ccui.Scale9Sprite:create(cc.rect(12, 11, 14, 10), "res/Main/role/common/name_bg.png")
	reward_ditiao:setAnchorPoint(0,0.5)
	reward_ditiao:setContentSize(281,30)
	reward_ditiao:setPosition(rewardlabel:getPositionX() + rewardlabel:getContentSize().width,rewardlabel:getPositionY())
	bg:addChild(reward_ditiao)

	local reward_ditiaoSize = reward_ditiao:getContentSize()
	local rewardImage1 = zc.createSprite()
	rewardImage1:setAnchorPoint(0, 0.5)
	rewardImage1:setPosition(0, reward_ditiaoSize.height/2)
	local img = zc.getImgByType(1)
	rewardImage1:setTexture(img)
	reward_ditiao:addChild(rewardImage1)

	local num = 50000
	local reward_num1  = zc.createLabel({
		text = num,
        fontSize = 20,
        color = cc.c3b(255,247,248),
        ap = cc.p( 0, 0.5 ),
        pos = cc.p( rewardImage1:getPositionX() + rewardImage1:getContentSize().width,rewardImage1:getPositionY()),
	})
	reward_ditiao:addChild(reward_num1)

	local rewardImage2 = zc.createSprite()
	rewardImage2:setAnchorPoint(0, 0.5)
	local img = zc.getImgByType(1)
	rewardImage2:setTexture(img)
	rewardImage2:setPosition(reward_ditiaoSize.width/2 - 40, reward_ditiaoSize.height/2)
	reward_ditiao:addChild(rewardImage2)

	local reward_num2 = zc.createLabel({
		text = num,
        fontSize = 20,
        color = cc.c3b(255,247,248),
        ap = cc.p( 0, 0.5 ),
        pos = cc.p( rewardImage2:getPositionX() + rewardImage2:getContentSize().width,rewardImage2:getPositionY()),
	})
	reward_ditiao:addChild(reward_num2)

	local rewardImage3 = zc.createSprite()
	rewardImage3:setAnchorPoint(0, 0.5)
	local img = zc.getImgByType(1)
	rewardImage3:setTexture(img)
	rewardImage3:setPosition(185, reward_ditiaoSize.height/2)
	reward_ditiao:addChild(rewardImage3)

	local reward_num3 = zc.createLabel({
		text = num,
        fontSize = 20,
        color = cc.c3b(255,247,248),
        ap = cc.p( 0, 0.5 ),
        pos = cc.p( rewardImage3:getPositionX() + rewardImage3:getContentSize().width,rewardImage3:getPositionY()),
	})
	reward_ditiao:addChild(reward_num3)

	local btn = zc.createCommomBtn({
		tag = 2,
		text = zc.lang("qianwang_2"),
		pos = cc.p(600, 56),
		endCallback = function() 
			local _statedata = cell._statedata
	        LayerManager.backToMainCity(false)
	        zc.toReceiveRewardsView(_statedata.conditions)	
		end
	})
	bg:addChild(btn)

	local btn2 = zc.createCommomBtn({
		tag = 1,
		text = zc.lang("fetch"),
		pos = cc.p(btn:getPosition()),
		endCallback = function() 
			local _data = cell._data
	        self:receiveTaskRewards(_data.id)
		end
	})
	bg:addChild(btn2)

	local _get_icon = zc.createSprite("res/Main/activity/yiwancheng.png")
	_get_icon:setPosition(btn:getPosition())
	bg:addChild(_get_icon)

	cell._get_icon = _get_icon
	cell.btn = btn
	cell.btn2 = btn2
	cell._icon = _icon
	cell.title_label = title_label
	cell.title_label_num = title_label_num
	cell.title_label_ci = title_label_ci
	cell.progressBg = progressBg
	cell.progress = progress
	cell.times_label = times_label
	cell.rewardImage1 = rewardImage1
	cell.rewardImage2 = rewardImage2
	cell.rewardImage3 = rewardImage3
	cell.reward_num1 = reward_num1
	cell.reward_num2 = reward_num2
	cell.reward_num3 = reward_num3
end

function ChengjiuCountry:updateCell( cell, index )
	local _data = self._nowShowList[index]
	if not _data then return end  -- 判断为空时直接返回

	local _statedata = self._stateTable[_data.taskId]
	dump(_statedata, "wm---test : ")
	cell._statedata = _statedata 
	cell._data = _data 

	if not _statedata then return end
	cell._icon:setTexture("res/Main/common/common_icon_".._statedata.icon..".png")

	cell.title_label:setString(_statedata.desc)

	local _cont_arr = string.split(_statedata.conditions or "","|")
	local _times = tonumber(_cont_arr[3]) or 0
	local num = tonumber(_data.arg) or 0
	num = num > _times and _times or num

	cell.progress:setContentSize(num/_times * 330,23)
	
	_times = zc.getWan(_times)
	num = zc.getWan(num)

	cell.title_label_num:setString(_times)
	local titleSize = cell.title_label:getContentSize()
	cell.title_label_num:setPositionX(cell.title_label:getPositionX() + titleSize.width + 5)
	if tonumber(_statedata.ifSecond) == 1 then
		cell.title_label_ci:setVisible(true)
		cell.title_label_ci:setPositionX(cell.title_label_num:getPositionX() + cell.title_label_num:getContentSize().width + 5)
	else
		cell.title_label_ci:setVisible(false)
	end

	cell.times_label:setString(num.."/".._times)
	cell.progressBg:setPosition(cell.title_label:getPositionX(), cell.title_label:getPositionY() - titleSize.height - 5)

	

	local _arr_one = string.split(_statedata.awards,",")
	local _arr = {}
	for i=1, 3 do
		local _reward_num = cell["reward_num" .. i]
		local _rewardImage = cell["rewardImage" .. i]
		if _arr_one[i] then
			_reward_num:setVisible(true)
			_rewardImage:setVisible(true)
			local _tb_ = string.split(_arr_one[i], "|")
			table.insert(_arr, _tb_)
			_reward_num:setString(zc.getWan(_tb_[3]))

			local _img, _scale
			if tonumber(_tb_[1]) == zc.mainTypeResource then
				_img = zc.getImgByType(_tb_[2])
				_scale = 1.0
			else
				local _info = zc._getIconInfo({
					data = {
						mainType = _tb_[1],
						type = _tb_[2],
						id = _tb_[2],
					}
				})
				_img = _info.img
				_scale = 0.37
			end
			_rewardImage:setTexture(_img)
			_rewardImage:setScale(_scale)
		else
			_reward_num:setVisible(false)
			_rewardImage:setVisible(false)
		end
	end

	local _status_value = tonumber(_data.status) or 1

	cell.btn:setVisible(_status_value == 1)
	cell.btn2:setVisible(_status_value == 2)
	cell._get_icon:setVisible(_status_value == 3)
end
--领取奖励
function ChengjiuCountry:receiveTaskRewards(taskId)
    local _taskId = tonumber(taskId) or 0
	zc.sendHttp({
        apiName = "CountryTask_get",
        params = {id = taskId},
        successCallback = function (data)
        	local list 
        	if self.tag == 1 then
        		list = self.ownList
        	else
        		list = self.countryList
        	end
            for k,v in pairs(list) do
                if tonumber(v.id) == _taskId then
                    v.status = 3
                    break
                end
            end
            self:freshListData(self.tag)
            self._tableview:reloadData()
        	PlayerData:updataData(data)
        	self:updateRedDot()
        end,
    })
end

function ChengjiuCountry:updateRedDot()
	for k,v in pairs(self.ownList) do
		if v.status == 2 then
			PlayerData:updateRedDotData(9, 1)
			return
		end
	end

	for k,v in pairs(self.countryList) do
		if v.status == 2 then
			PlayerData:updateRedDotData(9, 1)
			return
		end
	end

	PlayerData:updateRedDotData(9, 0)

	zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_ACTIVITY_REDDOT, data = {id = 12}})
end

return ChengjiuCountry