--[[
	挑战活动
	wangming
	2017.4.1
]]
local DekaronLayer = class("DekaronLayer", function()
    local layer = cc.Sprite:create()
    layer:setContentSize( 720, 463 )
	return layer
end)

function DekaronLayer:create( params )
	return DekaronLayer.new( params )
end

function DekaronLayer:ctor( params )
    self._activityType = params.activityType
	self:initData( params )
	self:initUI()
end

function DekaronLayer:initData( params )
	local _tasks = params.task or {}
    self._activityName = params.activityName or ""
    self.activityType = params.activityType

	self._datas = {}
	for k,v in pairs(params.table or {}) do
		local _tb = {}
        v.name = zc.getActivityGtChangeTest( v.name )
        v.descDown = zc.getActivityGtChangeTest( v.descDown )
        v.desc = zc.getActivityGtChangeTest( v.desc )
		_tb.db = v
		_tb.id = tonumber(v.id) or 0
		_tb.arg = 0
		local _data = _tasks[v.id] or {}
		_tb.arg = tonumber(_data.arg) or 0
		_tb.status = tonumber(_data.status) or 1
		table.insert(self._datas, _tb)
	end
    self:sortData()
    local _data1 = self._datas[1] or {}
    _data1.db = _data1.db or {}
	self._typeName = _data1.db.name
    self._tipText = _data1.db.descDown

	self._size = self:getContentSize()
end

function DekaronLayer:sortData()
    table.sort(self._datas, function( a, b )
        if a.status ~= b.status then
            if a.status == 2 then
                return true
            elseif b.status == 3 then
                return true
            elseif a.status == 3 then
                return false
            elseif b.status == 2 then
                return false
            end
        end
        return a.id < b.id
    end)
end

function DekaronLayer:udpateRedDot( data )
    for k,v in pairs(data) do
        if v.status == 2 then
            PlayerData:updateRedDotData(8, 1)
            return
        end
    end
    PlayerData:updateRedDotData(8, 0)
    zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_ACTIVITY_REDDOT, data = {id = 15}})
end

function DekaronLayer:initUI()
    local leftpos
    if self.activityType == 2 then
        leftpos = cc.p(-40,self._size.height + 15)
    else
        leftpos = cc.p(90,self._size.height)
    end

	local _tipDi = zc.createSprite("res/Main/activity/hotPacks/itemBg.png")
	_tipDi:setAnchorPoint(0.5, 1)
	_tipDi:setPosition(leftpos)

	local _leftBt = zc.createSprite("res/Main/activity/hotPacks/bj_3.png")
    _leftBt:setAnchorPoint(0.5, 1)
    _leftBt:setPosition(_tipDi:getPositionX(), _tipDi:getPositionY() - _tipDi:getContentSize().height*0.5)
    self:addChild(_leftBt)
	self:addChild(_tipDi)
	local _leftHeada = zc.createSprite("res/Main/activity/hotPacks/lb_104.png")
    _leftHeada:setPosition(_tipDi:getPositionX(), _leftBt:getPositionY())
    self:addChild(_leftHeada)

    local _w, _h = 44, 180
    local _titleDi = ccui.Scale9Sprite:create(cc.rect(2, 11, 14, 10), "res/Main/role/common/name_bg.png")
    _titleDi:setContentSize(_w, _h)
    _titleDi:setAnchorPoint(1, 0.5)
    _titleDi:setPosition(_leftBt:getContentSize().width*0.5 + 5, _leftBt:getContentSize().height*0.5 + 10)
    _leftBt:addChild(_titleDi)

    local _labelTitle = zc.createLabel({
    	text = self._activityName,
    	fontSize = 28,
    	outLine = true,
    	pixel = 2,
    	color = cc.c3b(240, 232, 168),
    	width = 40,
    	pos = cc.p(_w*0.5 + 5, _h*0.5)
	})
	_titleDi:addChild(_labelTitle)

	local _labelTitle = zc.createLabel({
    	text = self._typeName,
    	fontSize = 18,
    	outLine = true,
    	pixel = 2,
    	color = cc.c3b(255, 158, 184),
    	width = 20,
        ap = cc.p(0.5, 1),
    	pos = cc.p(_leftBt:getContentSize().width*0.5 + 35, _leftBt:getContentSize().height - 90)
	})
	_leftBt:addChild(_labelTitle)
    local _cellWidth = 550
    local _cellHeight = 160
    local _bottomH = 68
    local y = 68
    if self.activityType == 2 then
        _bottomH = 48
        y = 68
        _cellHeight = 160
        _cellWidth = 770
    else

    end
	-- tableview
	local tableview = zc.ZCTableView:create(cc.size(_cellWidth, self._size.height - _bottomH))
    tableview:setBounceable(true)
    tableview:setInertia(true)
    tableview:setDirection(cc.SCROLLVIEW_DIRECTION_VERTICAL)
    tableview:setPosition(_tipDi:getPositionX() + _tipDi:getContentSize().width*0.5, y)
    tableview:setDelegate()
    tableview:setVerticalFillOrder(cc.TABLEVIEW_FILL_TOPDOWN)

    local function cellSizeForTable(table, index) 
        return _cellHeight, _cellWidth
    end
	local _iconSize = 90
    local function tableCellAtIndex(table, index)
        local cell = table:dequeueCell()
        -- 创建模板
        local disize
        if self.activityType == 2 then
            disize = cc.size(800, 38)
        else
            disize = cc.size(284, 38)
        end
        if cell == nil then
            cell = zc.ZCTableViewCell:new()
            local _di = ccui.Scale9Sprite:create(cc.rect(20,20,150,150),"res/Main/activity/dekaron/cellDi.png")
            if self.activityType == 2 then
                _di:setContentSize(_cellWidth,156)
            else
                _di:setContentSize(543,156)
            end
            _di:setPosition(_cellWidth*0.5, _cellHeight*0.5)
            cell:addChild(_di)

            local _titleDi =  zc.createScale9Sprite({
                rect = cc.rect(13, 5, 9, 20),
                file = "res/Main/activity/dekaron/titleTip.png",
                size = cc.size(284, 38),
            })
        	_titleDi:setAnchorPoint(0, 1)
        	_titleDi:setPosition(0, _di:getContentSize().height)
        	_di:addChild(_titleDi)

        	local _titleLab = zc.createLabel({
        		fontSize = 20,
        		color = cc.c3b(248, 242, 205),
        		outLine = true,
        		ap = cc.p(0, 0.5),
        		pos = cc.p(10, _titleDi:getContentSize().height*0.5 + 1),
    		})
        	_titleDi:addChild(_titleLab)

			local _scrollView = zc.createScrollview({
		        pos = cc.p(20, (_di:getContentSize().height - _iconSize)*0.5),
		        size = cc.size(320, _iconSize),
		        dir = ccui.ScrollViewDir.horizontal,
		    })
		    _scrollView:setSwallowTouches(false)
		    _di:addChild(_scrollView)

		    local _jdLab = zc.createLabel({
		    	fontSize = 24,
		    	outLine = true,
		    	pos = cc.p(_di:getContentSize().width - 90, _di:getContentSize().height*0.5 + 25)
	    	})
		    _di:addChild(_jdLab)
            
		    local _btn = zc.createCommomBtn({
		    	tag = 3,
		    	fontSize = 30,
		    	text = zc.lang("qianwang_2"),
		    	scale = 0.8,
		    	pos = cc.p(_jdLab:getPositionX(), _di:getContentSize().height*0.5 - 20),
		    	endCallback = function()
			        local _data = self._datas[cell._idx] or {}
			        local _status = _data.status
			        if _status == 1 then
			        	LayerManager.backToMainCity(false)
		                zc.toReceiveRewardsView(_data.db.conditions)
		        	elseif _status == 2 then
		        		zc.sendHttp({
							apiName = "Dekaron_get", 
							params = {id = _data.id},
							successCallback = function(net_data)
								net_data.noAnimation = true
								PlayerData:updataData(net_data)
								zc.createShowReward(net_data)
								self._datas[cell._idx].status = 3
                                self:udpateRedDot(self._datas)
                                self:sortData()
								self._tableview:reloadDataAndScrollToCurrentCell()
							end,
						})
		        	end
		    	end,
	    	})
		    _di:addChild(_btn)

		    local _haveGet = zc.createSprite("res/Main/activity/monthSign/fetched.png")
		    _haveGet:setPosition(_btn:getPositionX(), _di:getContentSize().height*0.5)
		    _di:addChild(_haveGet)

		    cell._titleLab = _titleLab
		    cell._scrollView = _scrollView
            cell._titleDi = _titleDi
		    cell._btn = _btn
		    cell._jdLab = _jdLab
		    cell._haveGet = _haveGet
        end

        cell._idx = index + 1
        local _data = self._datas[cell._idx] or {}
        local _status = _data.status
        if tonumber(_data.db.schedule) == 1 and _status ~= 3 then
        	cell._jdLab:setVisible(true)
	        local _now = _data.arg
	        local _max = string.split(_data.db.conditions, "|")
	        _max = tonumber(_max[3]) or 3
	        cell._jdLab:setString(_now .. "/" .. _max)
	    else
        	cell._jdLab:setVisible(false)
        end
        cell._titleLab:setString(_data.db.desc)
        local _wid = cell._titleLab:getContentSize().width
        if _wid < 100 then
            _wid = 100
        end
        _wid = _wid + 40
        cell._titleDi:setContentSize(_wid, cell._titleDi:getContentSize().height)
        cell._btn:setVisible(_status ~= 3)
        cell._haveGet:setVisible(_status == 3)
        if _status == 1 then
        	cell._btn:setText(zc.lang("qianwang_2"))
        	cell._jdLab:setColor(display.COLOR_RED)
    	elseif _status == 2 then
        	cell._btn:setText(zc.lang("fetch_2"))
        	cell._jdLab:setColor(display.COLOR_GREEN)
    	end
        cell._scrollView:removeAllChildren()
        local _table = string.split(_data.db.awards, ",")
        local _width = #_table*_iconSize
        if _width < cell._scrollView:getContentSize().width then
        	_width = cell._scrollView:getContentSize().width
        end
        cell._scrollView:setInnerContainerSize(cc.size(_width, cell._scrollView:getContentSize().height))
        for i = 1, #_table do
        	local _info = string.split(_table[i], "|")
        	local _icon = zc.createIconByData({
        		data = {
        			mainType = _info[1],
        			type = _info[2],
        			id = _info[2],
        			num = _info[3]
	        	},
	        	pos = cc.p(_iconSize*(i-0.5), _iconSize*0.5),
    		})
    		_icon:setTouchEndedShowTip()
    		_icon:setScale(0.6)
    		cell._scrollView:addChild(_icon)
        end

        return cell
    end
    local function numberOfCellsInTableView()
    	return #self._datas
    end
    tableview:registerScriptHandler(cellSizeForTable, cc.TABLECELL_SIZE_FOR_INDEX)
    tableview:registerScriptHandler(tableCellAtIndex, cc.TABLECELL_SIZE_AT_INDEX)
    tableview:registerScriptHandler(numberOfCellsInTableView, cc.NUMBER_OF_CELLS_IN_TABLEVIEW)
    self:addChild(tableview)
    self._tableview = tableview
    tableview:reloadData()

    -- bottom
    local _file = "res/Main/role/trinket/sellDi.png"
    local _rect = cc.rect(20, 10, 549, 71)
    if self.activityType ~= 2 then
        if self._activityType == 1 then 
            _file = "res/Main/activity/newDi.png"
            _rect = cc.rect(25, 10, 30, 30)
        end
    end

    local bottom = ccui.Scale9Sprite:create(_rect, _file)
    if self.activityType == 2 then
        bottom:setContentSize(950, 70)
        bottom:setAnchorPoint(0.5, 0)
        bottom:setPosition(self._size.width*0.5 - 10, 5)
    else
        if self._activityType == 1 then 
            bottom:setContentSize(710, 62)
            bottom:setAnchorPoint(0.5, 0)
            bottom:setPosition(self._size.width*0.5, 3)
        else
            bottom:setContentSize(728, _bottomH)
            bottom:setAnchorPoint(0, 0)
            bottom:setPosition(-2, -5)
        end
    end
    self:addChild( bottom )
    local bottomSize = bottom:getContentSize()
    -- 活动时间
    local timeBg = ccui.Scale9Sprite:create(cc.rect(12, 11, 14, 10), "res/Main/role/common/name_bg.png")
    timeBg:setContentSize(265, 40)
    timeBg:setAnchorPoint(0, 0.5)
    timeBg:setPosition(20, bottomSize.height*0.5)
    bottom:addChild(timeBg)
    
    local _turnInfo = PlayerData:getActivityInfoById(15)
    if _turnInfo.openTime and _turnInfo.endTime then
        --活动时间
        local timeTip = zc.createLabel({
            text = zc.lang("time") .. "：",
            fontSize = 20,
            ap = cc.p(0, 0.5),
            pos = cc.p(10, timeBg:getContentSize().height*0.5),
            color = cc.c3b(230,224,163),
        })
        timeBg:addChild(timeTip)
        local _openTime = os.date("%m" .. zc.lang("date_month") .. "%d" .. zc.lang("date_day_1"), _turnInfo.openTime )
        local _endTime = os.date("%m" .. zc.lang("date_month") .. "%d" .. zc.lang("date_day_1"), _turnInfo.endTime )
        local timeLab = zc.createLabel({
            text = _openTime .. " ~ " .. _endTime,
            fontSize = 20,
            ap = cc.p(0, 0.5),
            pos = cc.p(timeTip:getPositionX() + timeTip:getContentSize().width + 5, timeBg:getContentSize().height*0.5),
            color = cc.c3b(230,224,163),
        })
        timeBg:addChild(timeLab)
    end

    local _tipLabel = zc.createLabel({
    	text = self._tipText,
    	outLine = true,
    	fontSize = 18,
    	ap = cc.p(0, 0.5),
    	color = cc.c3b(210, 191, 138),
    	color2 = cc.c3b(129, 63, 0),
    	pos = cc.p(timeBg:getPositionX() + timeBg:getContentSize().width + 10, bottomSize.height*0.5),
    })
    bottom:addChild(_tipLabel)
end

return DekaronLayer