-- FileName: FightEnterLayer.lua
-- Author: wangming
-- Date: 2016-12-29
-- Purpose: 战力排行活动
--[[TODO List]]
local FightingRankLayer = class("FightingRankLayer", function()
    local layer = cc.Sprite:create()
    layer:setContentSize( 720, 463 )
	return layer
end)

function FightingRankLayer:create( params )
	return FightingRankLayer.new( params )
end

function FightingRankLayer:ctor( params )
    self._activityType = params.activityType
    if self._activityType == 1 then
    end
	-- FightingRank_main
	local _rankInfo = self:initData(params)
	------left
	local _size = self:getContentSize()

	local _leftNode = cc.Node:create()
	local _leftW = 335
	_leftNode:setContentSize(_leftW, _size.height)
	self:addChild(_leftNode)
	local _qualifications = {8, 5, 3}
	for i=1, 3 do
		-- fighting,info,rank,userId,userName
		local _heroInfo = _rankInfo[i]
		local _iconId = tonumber(_heroInfo.info.iconId) or 1
		local _cellDi = zc.createHeroListShow({
			heroSide = 1,
			quality = _qualifications[i],
			iconId = _iconId,
			size = cc.size(315, 0)
		})
		_cellDi:setTouchEndedCallback(function()
		    zc.createOtherPlayerSelect(_heroInfo.info.userId)
		end)
		_cellDi:setPosition(_leftW*0.5, 80 + (3-i)*150)
		_leftNode:addChild(_cellDi)
		-- local _rankImg = zc.createSprite("res/Main/activity/fightingRank/no" .. i .. ".png")
	    local _rankImg = zc.getSpine("zhanlipaihang")
	    _rankImg:playAction("zhanli" .. i, true)
		_rankImg:setPosition(24, 115)
		_cellDi:addChild(_rankImg, 1)
		local _pY = 16
		local _pX = 15
		local _pH = 32
		local _pW = 155
		local _partW = 30

		-- 战斗力
		local fightBg = ccui.Scale9Sprite:create(cc.rect(15, 12, 163, 8), "res/Main/common/popBg/di_properties.png")
		fightBg:setAnchorPoint(0, 0)
		fightBg:setContentSize(_pW - _partW, _pH)
		fightBg:setPosition(_pX, _pY)
		_cellDi:addChild(fightBg, 1)
	    local fightingSp = zc.createSprite("res/Main/role/list/fight.png")
	    fightingSp:setPosition(0, _pH/2)
		fightBg:addChild(fightingSp)
		-- 战斗力数字
		local fightingNum = zc.createFntLabel({
			text = _heroInfo.fighting,
	        fnt = "res/Main/common/fnt/fight_change.fnt",
	        pos = cc.p((_pW - _partW)*0.5 + 7, _pH*0.5),
	        addwidth = -13,
	    })
	    fightingNum:setScale(0.5)
	    fightBg:addChild(fightingNum)
	    --名字
		local nameBg = ccui.Scale9Sprite:create(cc.rect(15, 12, 163, 8), "res/Main/common/popBg/di_properties.png")
		nameBg:setContentSize(_pW, _pH)
		nameBg:setAnchorPoint(1, 0)
		nameBg:setPosition(_cellDi:getContentSize().width - _pX*0.5, _pY)
		_cellDi:addChild(nameBg, 1)
	    -- 兵器图标
	    local _weaponType = (_iconId == 1 or _iconId == 4) and 1 or 5
	    local weaponIcon = zc.createSprite(zc.getHeroTypeImg(_weaponType))
	    weaponIcon:setPosition(0, _pH*0.5)
		nameBg:addChild(weaponIcon)
		local name = zc.createLabel({
	        text = _heroInfo.userName,
	        fontSize = 18,
	        color = cc.c3b(255, 236, 203),
	        pos = cc.p(_pW*0.5 + 5, _pH*0.5),
	        outLine = true,
	        pixel = 1,
		})
		nameBg:addChild(name)
	end

	--------right
	local _rightNode = cc.Node:create()
	local _rightW = 380
	_rightNode:setContentSize(_rightW, _size.height)
	_rightNode:setAnchorPoint(1, 0)
	_rightNode:setPositionX(_size.width)
	self:addChild(_rightNode)
	local _topNode = cc.Node:create()
	_topNode:setPosition(_rightW, _size.height - 35)
	_rightNode:addChild(_topNode)
	self._topNode = _topNode
	local _tipLocked = zc.createLabel({
        text = zc.lang("rank_locked"),
        fontSize = 20,
        ap = cc.p(0, 0),
        color = cc.c3b(186, 154, 114),
        pos = cc.p(-_rightW, 0),
	})
	_topNode:addChild(_tipLocked)
	_topNode._tipLocked = _tipLocked
	local _endTimeTipLab = zc.createLabel({
        text = zc.lang("activity_time_count_down") .. ": ",
        fontSize = 20,
        ap = cc.p(1, 0),
        color = cc.c3b(186, 154, 114),
        pos = cc.p(0, 0),
	})
	_topNode:addChild(_endTimeTipLab)
	_topNode._endTimeTipLab = _endTimeTipLab
	local _endTimeLab = zc.createLabel({
        fontSize = 20,
        ap = cc.p(1, 0),
        color = display.COLOR_RED,
        pos = cc.p(-10, 0),
	})
	_topNode:addChild(_endTimeLab)
	_topNode._endTimeLab = _endTimeLab

	local _infoSize = cc.size(372, 420)
	local _infoNode = zc.createGeneralPopScale({
        tag = 3,
        width = _infoSize.width,
        height = _infoSize.height,
    })
	_infoNode:setAnchorPoint(1, 0)
	_infoNode:setPosition(_rightW - 15, 8)
	_rightNode:addChild(_infoNode)

	local _historyRankLab = zc.createLabel({
        text = zc.lang("my_fight_num_now") .. "：",
        fontSize = 20,
        ap = cc.p(0, 0),
        color = cc.c3b(186, 154, 114),
        pos = cc.p(3, _infoSize.height - 30),
	})
	_infoNode:addChild(_historyRankLab)

	local _fightingNumLab = zc.createFntLabel({
		text = PlayerData.info.fighting,
		ap = cc.p(0, 0),
        fnt = "res/Main/common/fnt/fight_change.fnt",
        pos = cc.p(_historyRankLab:getContentSize().width, 3),
        addwidth = -13,
    })
    _fightingNumLab:setScale(0.6)
    _historyRankLab:addChild(_fightingNumLab)

    local _rankListBtn = zc.createPushButton({
    	normalFile = "res/Main/activity/fightingRank/seeRank.png",
    	pos = cc.p(_infoSize.width - 50, _infoSize.height - 18),
    	endCallback = function() 
	    	self:addRankShow()
    	end,
    })
    _infoNode:addChild(_rankListBtn)


	local _cellH = 100
	local _scrollSize = cc.size(360, _infoSize.height - 35)
	local _innerSize = cc.size(_scrollSize.width, table.nums(self._allDbs)*_cellH)
    
	local _scrollView = zc.createScrollview({
        pos = cc.p((_infoSize.width - _scrollSize.width)*0.5, 2),
        size = _scrollSize,
        innerSize = _innerSize,
        dir = ccui.ScrollViewDir.vertical,
    })
    _infoNode:addChild(_scrollView)

    self._rewardBtns = {}
    for k,v in pairs(self._allDbs) do
    	local _id = tonumber(v.id) or 1
    	local _cellDi = zc.createSprite("res/Main/activity/fightingRank/cellDi.png")
    	_cellDi:setPosition(_innerSize.width*0.5, _innerSize.height - (_id - 1 + 0.5)*_cellH)
    	_scrollView:addChild(_cellDi)
    	local _cellDiSize = _cellDi:getContentSize()
    	local _title = ""
    	if v.maxRank == v.minRank then
    		_title = string.format(zc.lang("di_x_ming"), tostring(v.minRank))
    	else
    		_title = string.format(zc.lang("di_x_x_ming"), tostring(v.minRank), tostring(v.maxRank))
    	end
    	local title = zc.createLabel({
	        text = _title,
	        fontSize = 18,
	        pos = cc.p(_cellDiSize.width*0.5, _cellDiSize.height - 15),
	        color = cc.c3b(186, 154, 114),
		})
	    _cellDi:addChild(title)
		local titleLeft = zc.createSprite("res/Main/common/lace.png")
	    titleLeft:setAnchorPoint(1, 0.5)
	    titleLeft:setPosition(title:getPositionX() - title:getContentSize().width/2, title:getPositionY())
	    _cellDi:addChild(titleLeft)
	    local titleRight = zc.createSprite("res/Main/common/lace.png")
	    titleRight:setAnchorPoint(0, 0.5)
	    titleRight:setPosition(title:getPositionX() + title:getContentSize().width/2, title:getPositionY())
	    titleRight:setFlippedX(true)
	    _cellDi:addChild(titleRight)

	    for i=1, 4 do
	    	local _itemInfo = v["items" .. i]
	    	if _itemInfo and _itemInfo ~= "" then
		    	_itemInfo = string.split(_itemInfo, "|")
		    	local _iconImg = zc.createIconByData({
		    		data = {
		                mainType = _itemInfo[1],
		                type = _itemInfo[2],
		                id = _itemInfo[2],
		                num = _itemInfo[3],
		            },
		            pos = cc.p(35 + (i - 1)*55, 35), 
		        })
		        _iconImg:setTouchEndedShowTip()
		        _iconImg:setScale(0.4)
		        _cellDi:addChild(_iconImg)
		        local _nameLabel = _iconImg:getChildByName("nameLabel")
		    	if _nameLabel then
		    		_nameLabel:setScale(_nameLabel:getScale()*1.4)
		    	end
		    end
	    end

	    local _rewardBtn = zc.createPushButton({
	    	normalFile = "res/Main/role/fetter/rewardBtn_canGet.png",
	    	pos = cc.p(_cellDiSize.width - 60, _cellDiSize.height*0.5),
	    	endCallback = function() 
	    		zc.sendHttp({
	    			apiName = "FightingRank_reward",
	    			successCallback = function( backData )
                        zc.createShowReward(backData)
                        backData.noAnimation = true
	    				PlayerData:updataData(backData)
	    				self._rewardStatus = 1
	    				self:freshUI()
	    			end
    			})
	    	end,
	    })
	    _cellDi:addChild(_rewardBtn)
    	self._rewardBtns[_id] = _rewardBtn
    end

    self:freshUI()
end

function FightingRankLayer:updateRedDot()

end

function FightingRankLayer:initData( params )
	self._status = tonumber(params.status) or 0
	self._rewardStatus = tonumber(params.rewardStatus) or 0
	self._endTime = tonumber(params.endTime) or 0
	self._historyRank = tonumber(params.historyRank) or -1
	self._ownRank = tonumber(params.ownRank) or 0
	local _rankInfo = {}
	for k,v in pairs(params.rank or {}) do
		table.insert(_rankInfo, v)
	end
	table.sort(_rankInfo, function( a, b )
		if not a or not b then
			return false
		end
		local _rankA = tonumber(a.rank) or 0
		local _rankB = tonumber(b.rank) or 0
		return _rankA < _rankB
	end)
	self._rankInfo = _rankInfo
	-- self._allDbs = gameData.getAllDataWithNoClone("fight_rank")
	self._allDbs = params.table or {}
	return _rankInfo
end

function FightingRankLayer:freshUI()
	local _tag = 1024
	local _topNode = self._topNode
	_topNode:stopActionByTag(_tag)

	local _oneDay = 60*60*24	
	_topNode._tipLocked:setVisible(self._status ~= 0)
	local _str1 =  self._status == 0 and "activity_time_count_down" or "get_award_time_count_down"
	_topNode._endTimeTipLab:setString(zc.lang(_str1) .. ": ")
	local function _freshTime()
		local _nowTime = self._endTime - PlayerData:getTime()
		if _nowTime <= 0 then
			_topNode:stopActionByTag(_tag)
			if self._status == 0 then
				self._status = 1
				zc.sendHttp({
					apiName = "FightingRank_main",
					successCallback = function(params)
						self:initData(params)
						self:freshUI()
					end
				})
			else
				_topNode._endTimeLab:setString("")
				_topNode._endTimeTipLab:setString(zc.lang("activity") .. zc.lang("have_finished"))
				_topNode._endTimeTipLab:setPositionX(_topNode._endTimeLab:getPositionX() - _topNode._endTimeLab:getContentSize().width - 5)
			end
		else
			local _day, _leftTime = math.modf(_nowTime/_oneDay)
			if _day > 1 then
				_topNode._endTimeLab:setString(_day .. zc.lang("date_day"))
			else
				local _hour = math.modf(_nowTime/(60*60))
				local _leftTime = _nowTime%(60*60)
				local _minute = math.modf(_leftTime/60)
				local _seconds = _leftTime%60
				_hour = _hour >= 10 and _hour or ("0" .. _hour)
				_minute = _minute >= 10 and _minute or ("0" .. _minute)
				_seconds = _seconds >= 10 and _seconds or ("0" .. _seconds)
				_topNode._endTimeLab:setString(_hour .. ":" .. _minute .. ":" .. _seconds)
			end
			_topNode._endTimeTipLab:setPositionX(_topNode._endTimeLab:getPositionX() - _topNode._endTimeLab:getContentSize().width - 5)
		end
	end
	schedule(_topNode, _freshTime, 1, _tag)
	_freshTime()

	local isRedDot = (PlayerData:getRedState(5) == 1)

    for k,v in pairs(self._allDbs) do
    	local _id = tonumber(v.id) or 1
		local _max = tonumber(v.maxRank) or 0
		local _min = tonumber(v.minRank) or 0
		local _rewardBtn = self._rewardBtns[_id]
		if _rewardBtn then
			local _flag = false
			local _normal = _rewardBtn:getStateNormal()
			local _scale = 1.0
			if self._ownRank == 0 then
				_normal:setTexture("res/Main/activity/fightingRank/unGet.png")
			elseif self._ownRank >= _min and self._ownRank <= _max then
				if self._status == 0 then
					_normal:setTexture("res/Main/activity/fightingRank/get.png")
				elseif self._rewardStatus == 0 then
					_flag = true
					_normal:setTexture("res/Main/role/fetter/rewardBtn_canGet.png")
					isRedDot = true
				else
					_normal:setTexture("res/Main/activity/monthSign/fetched.png")
					_scale = 0.8
				end
			elseif self._ownRank <= _min then
				_normal:setTexture("res/Main/activity/fightingRank/get.png")
			else
				_normal:setTexture("res/Main/activity/fightingRank/unGet.png")
			end
			_normal:setScale(_scale)
			_rewardBtn:setEnable(_flag)
		end
	end

	if isRedDot == true then
		PlayerData:updateRedDotData(5, 1)
	else
		PlayerData:updateRedDotData(5, 0)
	end
	zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_ACTIVITY_REDDOT, data = {id = 7}})
end

function FightingRankLayer:addRankShow()
	local _rankLength = #self._rankInfo
	if _rankLength == 0 then
		return
	end
	local _dialog = ZCPopLayer:create({opacityValue = 255*0.7})
	LayerManager.addNode(_dialog, {isPop = true})


    local _size = cc.size(510, 452)
    local _midBg = zc.getScaleNode("res/Main/ornaments/general_tips_s_bg.png", _size)
    _midBg:setPosition(zc.width*0.5, zc.height*0.5)
    _dialog:addContent(_midBg)

    local _title = zc.createSprite("res/Main/activity/fightingRank/rankTitle.png")
    _title:setPosition(_size.width*0.5, _size.height)
    _midBg:addChild(_title)

    local _topDi = zc.createSprite("res/Main/activity/fightingRank/topDi.png")
    _topDi:setPosition(_size.width*0.5, _size.height - 40)
    _midBg:addChild(_topDi)

    local _posXs = {75, _size.width*0.5, _size.width - 75}

    local _keys = {"rank", "userName", "fighting"}
    for i=1,3 do
	    local _historyRankLab = zc.createLabel({
	        text = zc.lang(_keys[i]),
	        fontSize = 20,
	        color = cc.c3b(186, 154, 114),
	        pos = cc.p(_posXs[i], _topDi:getPositionY()),
		})
		_midBg:addChild(_historyRankLab)
    end

    local _myRankTip = zc.createLabel({
        text = LANGUAGE_ARENA.rank_mine,
        fontSize = 20,
        ap = cc.p(1, 0.5),
        color = cc.c3b(186, 154, 114),
        pos = cc.p(_size.width*0.5 + 10, 30),
	})
	_midBg:addChild(_myRankTip) 
	local _flag = (self._ownRank > _rankLength or self._ownRank == 0)
	local _myRankNum = zc.createLabel({
        text = _flag and LANGUAGE_ARENA.un_rank or self._ownRank,
        fontSize = 20,
        ap = cc.p(0, 0.5),
        color = _flag and display.COLOR_RED or display.COLOR_GREEN,
        pos = cc.p(_size.width*0.5 + 15, _myRankTip:getPositionY()),
	})
	_midBg:addChild(_myRankNum) 

    local _scrollH = 350
	local _cellH = 50
    local _innerH = _cellH*_rankLength
    _innerH = _innerH < _scrollH and _scrollH or _innerH
    local _scrollView = zc.createScrollview({
        pos = cc.p(0, 43),
        size = cc.size(_size.width, _scrollH),
        innerSize = cc.size(_size.width, _innerH),
        dir = ccui.ScrollViewDir.vertical,
    })
    _midBg:addChild(_scrollView)

    local function _getColorByLevel( id )
		local _id = tonumber(id)
	    if _id == 2 then 
	        return cc.c3b(91, 167, 214)
	    elseif _id == 3 then 
	        return cc.c3b(98, 192, 50)
	    elseif _id == 4 then 
	        return cc.c3b(221, 89, 221)
	    elseif _id == 5 then 
	        return cc.c3b(255, 126, 0)
	    elseif _id == 6 then 
	        return display.COLOR_RED
	    end
        return cc.c3b(197, 195, 197)
	end
	local function _getLevel( i )
		local _flag = 1
		if i == 1 then
			_flag = 5
		elseif i == 2 then
			_flag = 4 
		elseif i == 3 then
			_flag = 3
		elseif i == 4 then
			_flag = 2
		end
		return _flag
	end

    for i=1, #self._rankInfo do
    	local _level = _getLevel(i)
    	local _di = ZCSprite:create("res/Main/role/fetter/lineDi" .. _level .. ".png")
    	_di:setPosition(_size.width*0.5, _innerH - (i - 1 + 0.5)*_cellH)
		_di:setSwallowTouches(false)
		_di:setTouchEndedCallback(function()
		    zc.createOtherPlayerSelect(self._rankInfo[i].userId)
		end)
		_scrollView:addChild(_di)

		local _diSize = _di:getContentSize()
		local _line1 = zc.getSprite({
			src = "res/Main/role/fetter/line.png",
			ap = cc.p(0.5, 0),
			pos = cc.p(_diSize.width*0.5, _diSize.height + 1)
		})
		_di:addChild(_line1)
		local _line2 = zc.getSprite({
			src = "res/Main/role/fetter/line.png",
			ap = cc.p(0.5, 1),
			pos = cc.p(_diSize.width*0.5, -1)
		})
		_di:addChild(_line2)

    	local _color = _getColorByLevel(_level)
		for j=1,3 do
			local _text = self._rankInfo[i][_keys[j]]
			if j == 3 then
				_text = zc.getWan(_text)
			end
		    local _historyRankLab = zc.createLabel({
		        text = _text,
		        fontSize = 20,
		        color = _color,
		        pos = cc.p(_posXs[j] - 15, _diSize.height*0.5),
			})
			_di:addChild(_historyRankLab)
	    end
    end

	_dialog:show()
end

return FightingRankLayer