--[[
    FileName: HotPacksRewardPop.lua
    Author: andong
    Date: 2016-11-26
    Purpose: 热卖礼包奖励界面
]]
local HotPacksRewardPop = class( "HotPacksRewardPop", function ()
    return ZCPopLayer:create({opacityValue=150})
end)
function HotPacksRewardPop:create(params)
    return HotPacksRewardPop.new(params)
end
function HotPacksRewardPop:ctor(params)
    self:initData(params)
    self:initUI()
    self:show()

    zc.addEventListener({
        name = CUSTOM_EVENT.EVENT_HOT_PACKAGE_BUY,
        callback = function(event)
            if zc.getPop("Buy") then
                LayerManager.removeLayout(true)
            end
            zc.tipInfo(zc.lang("tips_buy_success") .. "！")
            self._params._buyNum = tonumber(self._params._buyNum) + 1
            self:hide()
        end
    })
end
function HotPacksRewardPop:initData(params)
    self._callback = params.callback
    local params = params.packageInfo or {}
    self._params = params
    self._info = params._info

    self._rewardData = {}
    local rewardStr = params._info.reward
    local reward = string.split(rewardStr,",")
    for i = 1, #reward do
        self._rewardData[#self._rewardData+1] = {
            items = reward[i]
        }
    end
end
function HotPacksRewardPop:initUI()
    local popBg = zc.createNormalPop({
        tag = 4,
        srcTag = 1,
        titleSrc = "res/Main/common/tipTitle/libaoneirong.png",
        showSide = false,
        height = 500+31,
        width = 488,
        bianZOrder = 2
    })
    popBg:setPosition(zc.width*0.5, zc.height*0.5)
    self:addContent(popBg)
    local popSize = cc.size(488, 500)
    self._popBg = popBg
    self._popSize = popSize

    local close = zc.createBackButton({
        pos = cc.p(popBg:getContentSize().width-10, popBg:getContentSize().height-10),
        listener = function () 
            self:hide()
        end,
    })
    popBg:addChild(close, 10)

    -------up
    local _equipCircle = zc.getSpine("jsxxyxg", 0.9)
    _equipCircle:setPosition( popSize.width/2, popSize.height - 140)
    _equipCircle:playAction("animation", true)
    popBg:addChild(_equipCircle)

    local iocnPath = "res/Main/activity/hotPacks/lb_"..self._info.icon..".png"
    if not zc.checkFileExist(iocnPath) then
        iocnPath = "res/Main/activity/hotPacks/lb_101.png"
    end
    local itemImg = zc.createSprite(iocnPath)
    itemImg:setAnchorPoint(0.5, 0.5)
    itemImg:setPosition(_equipCircle:getPosition())
    popBg:addChild(itemImg)

    local _equip_arrow_l = cc.Sprite:create( "res/Main/role/equip/arrow_1.png" )
    _equip_arrow_l:setPosition( _equipCircle:getPositionX() - 105, _equipCircle:getPositionY() )
    popBg:addChild( _equip_arrow_l )
    local _equip_arrow_r = cc.Sprite:create( "res/Main/role/equip/arrow_1.png" )
    _equip_arrow_r:setPosition( _equipCircle:getPositionX() + 105, _equipCircle:getPositionY() )
    _equip_arrow_r:setFlippedX( true )
    popBg:addChild( _equip_arrow_r )


    --middle
    self:createTableView()

    --bottom
    local attr_bg = ccui.Scale9Sprite:create( cc.rect( 589/2, 0, 1, 71 ), "res/Main/role/trinket/sellDi.png")
    attr_bg:setContentSize(cc.size(477, 87))
    attr_bg:setAnchorPoint(0.5, 0)
    attr_bg:setPosition(popSize.width/2-1, 5)
    popBg:addChild(attr_bg, 1)


    local getBtn = zc.createCommomBtn({
        tag =1,
        btnText =  zc.getGtMoneyFlag() .. " " .. zc.changeGtMoney(self._info.price),
        needSwallow = false,
        endCallback = function()
            local _data = {
                price = self._info.price,
                desc = self._info.giftname,
                id = self._info.id,
                addGold = tonumber(self._info.addGold) or 0,
            }
            local price = zc.getGtMoneyFlag() .. zc.changeGtMoney(_data.price)
            local _tips = LANGUAGE_RECHARGE_BUYGOLD(zc.changeGtMoney(_data.price)) .. tostring(_data.desc)
            zc.createBuyPop({
                tip = _tips,
                isRecharge = true,
                special = {
                    {
                        begin = 5,
                        length = #price - 2,
                        color = display.COLOR_YELLOW,
                    }
                },
                callback = function( isAliPay, isWeixin )
                    print("-----------log--------ad-------------isAliPay isWeixin ", isAliPay , isWeixin)
                    _data.isAliPay = isAliPay
                    _data.isWeixin = isWeixin
                    --充值类型：1普通、2月卡、3热卖礼包
                    local params = {
                        data = _data,
                        goodsType = 3,  --热卖礼包 type 固定为3 
                    }
                    zc.recharge(params)
                end
            })

        end,
        anchor = cc.p(0.5, 0.5),
        pos = cc.p(attr_bg:getContentSize().width/2, attr_bg:getContentSize().height/2)
    })
    attr_bg:addChild(getBtn)

    --限购类型（1不限、2个人每天、3全服每天、4个人活动时间内、5全服活动时间内）
    local _scaledOut = false --是否卖完
    local _limitType = tonumber(self._params._limitType) or 1
    local _buyNum = tonumber(self._params._buyNum) or 0
    local _limitNum = tonumber(self._params._limitNum) or 0

    if _limitType == 1 then
    elseif _limitType == 2 then
    elseif _limitType == 3 then
    elseif _limitType == 4 then
    elseif _limitType == 5 then
    end
    if _limitType ~= 1 and _buyNum >= _limitNum then
        _scaledOut = true
    end
    -- _scaledOut = true
    if _scaledOut then
        getBtn:setEnable(false)
    end
end
function HotPacksRewardPop:createTableView()
    local tableNode = self._popBg

    local _middleBg = zc.createGeneralPopScale({
        tag = 3,
        width = self._popSize.width - 40,
        height = 162,
    })
    _middleBg:setAnchorPoint( 0.5, 0 )
    _middleBg:setPosition( self._popSize.width/2, 102 )
    self._popBg:addChild( _middleBg )

    local _attrBg = zc.createGeneralPopScale({
        tag = 2,
        width = _middleBg:getContentSize().width-28,
        height = 134,
    })
    _attrBg:setPosition( _middleBg:getContentSize().width/2, _middleBg:getContentSize().height/2 )
    _middleBg:addChild( _attrBg )


    local title = zc.createSprite("res/Main/activity/hotPacks/title.png")
    title:setAnchorPoint(0.5, 0.5)
    title:setPosition(_attrBg:getContentSize().width/2, _attrBg:getContentSize().height-18)
    _attrBg:addChild(title)

    local lace_left = zc.createSprite("res/Main/common/lace.png")
    lace_left:setAnchorPoint(1, 0.5)
    lace_left:setPosition(0, title:getContentSize().height/2 )
    title:addChild(lace_left)

    local lace_right = zc.createSprite("res/Main/common/lace.png")
    lace_right:setAnchorPoint(0, 0.5)
    lace_right:setPosition(title:getContentSize().width+2, lace_left:getPositionY() )
    lace_right:setFlipX(true)
    title:addChild(lace_right)


    local _widthMax = _middleBg:getContentSize().width-30
    local _realWidth = #self._rewardData * 84 or 0

    local _canBounce = false
    if _realWidth >= _widthMax then
        _realWidth = _widthMax
        _canBounce = true
    end

    local tableSize = cc.size(_realWidth, 100)
    local myTableBg = _attrBg
    local myTable = zc.ZCTableView:create(cc.size(tableSize.width,100))
    myTable:setInertia(true) --设置惯性
    myTable:setBounceable(_canBounce)
    myTable:setDirection(zctech.SCROLLVIEW_DIRECTION_HORIZONTAL) --设置横向纵向
    myTable:setAnchorPoint(cc.p(0.5,0))
    myTable:setPosition(_widthMax/2,2)
    myTable:ignoreAnchorPointForPosition(false)
    myTable:setVerticalFillOrder(zctech.TABLEVIEW_FILL_TOPDOWN)
    
    myTableBg:addChild(myTable)
    
    local function cellSizeForTable(table,idx)
        return 100, 84
    end
    local function numberOfCellsInTableView(table)
        return #self._rewardData
    end
    local function tableCellAtIndex(table,idx)
        local nowIdx = idx + 1
        local cell = table:dequeueCell()
        if cell == nil then
            cell = zc.ZCTableViewCell:new()
            cell:setContentSize(cc.size(84, 100))
        else
            cell:removeAllChildren()
        end
        self:updateCell(cell, nowIdx)
        return cell
    end
    myTable:registerScriptHandler(numberOfCellsInTableView,cc.NUMBER_OF_CELLS_IN_TABLEVIEW)
    myTable:registerScriptHandler(cellSizeForTable,cc.TABLECELL_SIZE_FOR_INDEX)
    myTable:registerScriptHandler(tableCellAtIndex,cc.TABLECELL_SIZE_AT_INDEX)
    
    myTable:reloadData()
end

function HotPacksRewardPop:updateCell(cell, indx)
    local cellData = self._rewardData[indx]
    local cellSize = cell:getContentSize()
    local reward = string.split(cellData.items, "|")
    local item, info = zc.createIconByData({
        data = {
            mainType = reward[1],
            type = reward[2], 
            id = reward[2],
            num = reward[3],
        }, 
        showDetailPop = true,
        pos = cc.p(cellSize.width/2, cellSize.height/2), 
    })
    item:setScale(0.65)
    cell:addChild(item)
end

function HotPacksRewardPop:onCleanup()
    zc.removeEventListener(CUSTOM_EVENT.EVENT_HOT_PACKAGE_BUY)
    if self._callback then
        self._callback()
    end
end

return HotPacksRewardPop