--[[
	签到活动
	唐实聪
	2016.6.3
]]
local MonthSignLayer = class("MonthSignLayer", function()
    local layer = cc.Sprite:create()
    layer:setContentSize( 720, 463 )
	return layer
end)

function MonthSignLayer:create( params )
	return MonthSignLayer.new( params )
end

function MonthSignLayer:ctor( params )
	self._status = {}
	self._grandStatus = {}
	self._nowDay = tonumber(params.nowDay) or 0
	self._grandDays = tonumber(params.grandDays) or 0
	self._countNum = tonumber(params.afterSignLimit) or 0
	self._mounth = tonumber(params.month) or 0
	self._table = params.table or {}

	local function _getData( day )
		for k,v in pairs(self._table) do
			if tonumber(v.month) == self._mounth and tonumber(v.day) == day then
				return v
			end
		end
		return {}
	end

	local _status = params.status or {}
	for k,v in pairs(_status) do
		-- local _db = gameData.getDataFromCacheWithPrimaryKey("attendance", k)
		local _db = _getData(tonumber(k))
		if next(_db) ~= nil then
			local _tb = {
				id = tonumber(k) or 0,
				status = tonumber(v) or 0,
				db = _db,
			}
			table.insert(self._status, _tb)
		end
	end
	local _grandStatus = params.grandStatus or {}
	for k,v in pairs(_grandStatus) do
		-- local _db = gameData.getDataFromCacheWithPrimaryKey("attendance", k)
		local _db = _getData(tonumber(k))
		if next(_db) ~= nil then
			local _tb = {
				id = tonumber(k) or 0,
				status = tonumber(v) or 0,
				db = _db,
			}
			table.insert(self._grandStatus, _tb)
		end
	end

	table.sort(self._status, function( a, b )
		if not a or not b then return false end
		local _idA = tonumber(a.id) or 0
		local _idB = tonumber(b.id) or 0
		return _idA < _idB 
	end)
	table.sort(self._grandStatus, function( a, b )
		if not a or not b then return false end
		local _idA = tonumber(a.id) or 0
		local _idB = tonumber(b.id) or 0
		return _idA < _idB 
	end)

	self._nowGrandId = 1
	for i=1,#self._grandStatus do
		if self._grandStatus[i].status ~= 2 then
			self._nowGrandId = i
			break
		end
	end

	self:initUI()
end


function MonthSignLayer:initUI()
	local _size = self:getContentSize()
	-- 背景
	local bg = zc.createSprite("res/Main/activity/monthSign/bg.jpg")
	bg:setAnchorPoint(0.5, 1)
	bg:setPosition(_size.width*0.5, _size.height)
	self:addChild(bg)

	-- bottom
    local bottom = ccui.Scale9Sprite:create(cc.rect(20, 10, 549, 71), "res/Main/role/trinket/sellDi.png")
    bottom:setContentSize(728, 100)
    bottom:setAnchorPoint(0, 0)
    bottom:setPosition(-2, -5)
    self:addChild(bottom, 1)
    local bottomSize = bottom:getContentSize()

    local _countDi = zc.createSprite("res/Main/activity/monthSign/countDi.png")
	_countDi:setAnchorPoint(0, 0.5)
    _countDi:setPosition(5, bottomSize.height - 15)
    bottom:addChild(_countDi, 1)

    local _countDay = zc.createLabel({
    	text = "",
    	fontSize = 30,
    	outLine = true,
    	pixel = 2,
    	color = display.COLOR_YELLOW,
    	pos = cc.p(65, 25),
    })
    _countDi:addChild(_countDay)
    self._countDay = _countDay

    local _inSize = cc.size(360, 85)
    local timeBg = ccui.Scale9Sprite:create(cc.rect(12, 11, 14, 10), "res/Main/role/common/name_bg.png")
    timeBg:setContentSize(_inSize)
    timeBg:setAnchorPoint(0, 0.5)
    timeBg:setPosition(20, bottomSize.height*0.5)
    bottom:addChild(timeBg)

    local _infoSize = cc.size(230, 70)
	local _infoNode = zc.createGeneralPopScale({
        tag = 3,
        width = _infoSize.width,
        height = _infoSize.height,
    })
	_infoNode:setPosition(_inSize.width*0.5, _inSize.height*0.5)
	timeBg:addChild(_infoNode)
	self:createInfoTable(_infoNode)

    local _leftBtn = zc.createPushButton({
    	normalFile = "res/Main/arena/hallFame/arrow_up.png",
    	selectedFile = "res/Main/arena/hallFame/arrow_down.png",
    	pos = cc.p(28, _inSize.height*0.5),
    	endCallback = function()
    		local _tmp = self._nowGrandId - 1
    		if _tmp <= 0 then
    			return
    		end
    		self._nowGrandId = _tmp
    		self:freshGrandData()
    	end,
    })
    timeBg:addChild(_leftBtn, 1)
    self._leftBtn = _leftBtn

    local _node1 = zc.createSprite("res/Main/arena/hallFame/arrow_up.png")
    _node1:setFlippedX(true)
    local _node2 = zc.createSprite("res/Main/arena/hallFame/arrow_down.png")
    _node2:setFlippedX(true)
    local function _goRight(isForce)
		local _tmp = self._nowGrandId + 1
		if _tmp > #self._grandStatus then
			_tmp = #self._grandStatus
			if not isForce then
				return
			end
		end
		self._nowGrandId = _tmp
		self:freshGrandData()
    end
    local _rightBtn = zc.createPushButton({
    	normalNode = _node1,
    	selectedNode = _node2,
    	pos = cc.p(_inSize.width - 28, _inSize.height*0.5),
    	endCallback = _goRight,
    })
    timeBg:addChild(_rightBtn, 1)
    self._rightBtn = _rightBtn

    local _rewardBtn = zc.createCommomBtn({
    	tag = 1,
    	text = zc.lang("fetch_2"),
    	pos = cc.p(bottomSize.width - 150, bottomSize.height*0.5),
    	endCallback = function()
	    	local _id = self._grandStatus[self._nowGrandId].id
    		zc.sendHttp({
				apiName = "MonthSignNew_reward",
				params = {type=2, id = _id},
				successCallback = function( backData )
					self:freshData(backData)
		    		_goRight(true)
				end
			})
    	end
    })
    bottom:addChild(_rewardBtn)
    self._rewardBtn = _rewardBtn
	self:freshGrandData()


	-- tableview
	local _hangNum = 6
	local tableview = zc.ZCTableView:create(cc.size(_size.width, 300))
    tableview:setBounceable(true)
    tableview:setInertia(true)
    tableview:setDirection(cc.SCROLLVIEW_DIRECTION_VERTICAL)
    tableview:setPosition(cc.p(0, 95))
    tableview:setDelegate()
    tableview:setVerticalFillOrder(cc.TABLEVIEW_FILL_TOPDOWN)
    local cellWidth = _size.width
    local cellHeight = 100
    local function cellSizeForTable(table, index) 
        return cellHeight, cellWidth
    end
    local function tableCellAtIndex(table, index)
        local cell = table:dequeueCell()
        if cell == nil then
            cell = zc.ZCTableViewCell:new()
        end
        cell:removeAllChildren()

        for i=1, _hangNum do
        	local _idx = index*_hangNum + i
        	local _data = self._status[_idx]
        	if not _data then
        		break
        	end
        	local _icon = self:createOneIcon(_data)
        	_icon:setScale(0.8)
        	_icon:setPosition(70 + (i - 1)*115, 50)
        	cell:addChild(_icon)
        end

        return cell
    end
    local function numberOfCellsInTableView()
    	return math.ceil(#self._status/_hangNum)
    end
    tableview:registerScriptHandler(cellSizeForTable, cc.TABLECELL_SIZE_FOR_INDEX)
    tableview:registerScriptHandler(tableCellAtIndex, cc.TABLECELL_SIZE_AT_INDEX)
    tableview:registerScriptHandler(numberOfCellsInTableView, cc.NUMBER_OF_CELLS_IN_TABLEVIEW)
    self:addChild(tableview)
    tableview:reloadData()

    local _hang = math.ceil(self._nowDay/_hangNum) - 1
    tableview:scrollToCell(_hang)
end

function MonthSignLayer:createOneIcon(data)
	local _di = zc.createSprite("res/Main/role/fetter/fetterItemBg.png")
	local _db = data.db
	if not _db then
		return _di
	end
	local _id = data.id
	_di._id = _id
	local _diSize = _di:getContentSize()
	local _info = string.split(_db.reward, "|")

	local function _freshIcon()
		local _icon = _di._icon
		local _data = self._status[_id] or {}
		if self._nowDay > _id or _data.status == 2 then
			_icon:doShowGray({showGray = true})
		else
			_icon:doShowGray({showGray = false})
		end
		if self._nowDay < _id then
			if _di._kebu then
				_di._kebu:removeFromParent()
				_di._kebu = nil
			end
			if _di._spine then
				_di._spine:removeFromParent()
				_di._spine = nil
			end
			if _di._over then
				_di._over:removeFromParent()
				_di._over = nil
			end
	        _icon:setTouchEndedShowTip()
			return
		end

		if _data.status == 2 then
			if _di._kebu then
				_di._kebu:removeFromParent()
				_di._kebu = nil
			end
			if _di._spine then
				_di._spine:removeFromParent()
				_di._spine = nil
			end
			if not _di._over then
				_di._over = zc.getSprite({
					src = "res/Main/activity/monthSign/get.png",
					pos = cc.p(_diSize.width*0.5, _diSize.height*0.5),
					scale = 1.2,
				})
				_di:addChild(_di._over)
			end
			_icon:setTouchEndedShowTip()
			return
		end
		-- _icon:setTouchEndedCall()
		if _di._over then
			_di._over:removeFromParent()
			_di._over = nil
		end

		if self._nowDay == _id then
			if not _di._spine then
				_di._spine = zc.createSpine({
		            fileName = "jiban",
		            actName = "unlock",
		            loop = true,
		        })
		        _di._spine:setPosition(_diSize.width*0.5, _diSize.height*0.5)
		        _di:addChild(_di._spine, 1)
		    end
		else
			if _di._spine then
				_di._spine:removeFromParent()
				_di._spine = nil
			end
		end

		if self._nowDay > _id then
			if not _di._kebu then
				_di._kebu = zc.getSprite({
					src = "res/Main/activity/monthSign/unGet.png",
					pos = cc.p(_diSize.width*0.5, _diSize.height*0.5),
				})
				_di:addChild(_di._kebu)
			end
		else
			if _di._kebu then
				_di._kebu:removeFromParent()
				_di._kebu = nil
			end
		end
	end

	local _icon = zc.createIconByData({
		data = {
			mainType = _info[1],
	        type = _info[2], 
	        id = _info[2],
	        num = _info[3],
		},
		pos = cc.p(_diSize.width*0.5, _diSize.height*0.5 + 3),
		listener = function()
			local _data = self._status[_id]
			if _data and _data.status == 2 then
				return
			end
			if self._nowDay > _id then
				--补签
				local _buCost = tonumber(zc.getConsumePriceData(52, self._countNum + 1).price) or 0
				local comfirm = ZCConfirmDialog:createWithParams({
			        title = zc.lang("prompt"),
			        msg = string.format(zc.lang("tips_sign_buqian"), tostring(_buCost)),
			        showDi = true,
                	rightCallback = function()
                		zc.sendHttp({
							apiName = "MonthSignNew_afterSign",
							params = {id=_id},
							successCallback = function( backData )
								self._countNum = tonumber(backData.afterSignLimit) or 0
								self:freshData(backData)
								_freshIcon()
								self:freshGrandData()
							end
						})
	                end,
			    })
			    self:getParent():getParent():addChild(comfirm, 11)
			elseif self._nowDay == _id then
				--签到
				zc.sendHttp({
					apiName = "MonthSignNew_reward",
					params = {type=1, id=_id},
					successCallback = function( backData )
						self:freshData(backData)
						_freshIcon()
						self:freshGrandData()
					end
				})
			end
		end
	})
	_icon:setScale(0.78)
	_di:addChild(_icon)
	_di._icon = _icon


	local _vip = tonumber(_db.vipDouble) or 0
	if _vip > 0 then
		local _limitDi =zc.createSprite("res/Main/activity/blackMarket/corner.png")
		_limitDi:setAnchorPoint(0, 1)
		_limitDi:setPosition(0, _diSize.height)
		_di:addChild(_limitDi, 2)
        local _limitLv = zc.createLabel({
        	text = "V" .. _vip .. zc.lang("double"),
	        fontSize = 18,
	        outLine = true,
	        color2 = cc.c3b(233, 64, 28),
	        pos = cc.p(_limitDi:getContentSize().width*0.5 - 12, _limitDi:getContentSize().height*0.5 + 12),
	    })  
        _limitLv:setRotation(-45)
	    _limitDi:addChild(_limitLv, 1)
	end

	_freshIcon()
	return _di
end

function MonthSignLayer:freshData( backData )
	if backData.status then
		for k,v in pairs(backData.status) do
			local _idx = tonumber(k)
			if self._status[_idx] then
				self._status[_idx].status = tonumber(v) or 0
			end
		end
	end
	if backData.grandStatus then
		for k,v in pairs(backData.grandStatus) do
			local _idx = tonumber(k)
			for i=1, #self._grandStatus do
				if self._grandStatus[i].id == _idx then
					self._grandStatus[i].status = tonumber(v) or 0
				end
			end
		end
	end
	backData.noAnimation = true
	PlayerData:updataData(backData)
	zc.createShowReward(backData)
end

function MonthSignLayer:createInfoTable( infoNode )
	local _size = infoNode:getContentSize()
	local tableview = zc.ZCTableView:create(_size)
    tableview:setInertia(true)
    tableview:setBounceable(true)
    tableview:setAutoAlign(true)
    tableview:setDirection(cc.SCROLLVIEW_DIRECTION_HORIZONTAL)
    tableview:setPosition(cc.p(0, 0))
    tableview:setDelegate()
    tableview:setVerticalFillOrder(cc.TABLEVIEW_FILL_TOPDOWN)
    local function cellSizeForTable(table, index) 
        return _size.height, _size.width
    end
    local function tableCellAtIndex(table, index)
        local cell = table:dequeueCell()
        if cell == nil then
            cell = zc.ZCTableViewCell:new()
        end
        cell:removeAllChildren()
        local _idx = index + 1
        local _data = self._grandStatus[_idx] or {}
        local _db = _data.db or {}
        local _infos = string.split(_db.cumulativeReward or "", ",")
        for i=1, 3 do
        	local _info = _infos[i]
        	if not _info or _info == "" then
        		break
        	end
    		local _itemData = string.split(_info, "|")
    		local _icon = zc.createIconByData({
				data = {
					mainType = _itemData[1],
			        type = _itemData[2], 
			        id = _itemData[2],
			        num = _itemData[3],
				},
				pos = cc.p(40 + (i-1)*75, _size.height*0.5),
			})
			_icon:setScale(0.5)
			_icon:setTouchEndedShowTip()
			cell:addChild(_icon)
        end
        return cell
    end
    local function numberOfCellsInTableView()
    	return #self._grandStatus
    end
    tableview:registerScriptHandler(cellSizeForTable, cc.TABLECELL_SIZE_FOR_INDEX)
    tableview:registerScriptHandler(tableCellAtIndex, cc.TABLECELL_SIZE_AT_INDEX)
    tableview:registerScriptHandler(numberOfCellsInTableView, cc.NUMBER_OF_CELLS_IN_TABLEVIEW)
    infoNode:addChild(tableview)
    tableview:reloadData()
    self._grandTableView = tableview
    tableview:setTouchEnabled(false)
end

function MonthSignLayer:freshGrandData()
	self._grandTableView:scrollToCell(self._nowGrandId - 1, true)
    local _data = self._grandStatus[self._nowGrandId] or {}
    local _status = tonumber(_data.status) or 0
    self._rewardBtn:setEnable(_status == 1)
    self._rewardBtn:setString(_status == 2 and LANGUAGE_TOLLGATEHERO.fetched or zc.lang("fetch_2"))
    self._countDay:setString(_data.id)

    if self._nowGrandId == 1 then
    	self._leftBtn:setVisible(false)
    else
    	self._leftBtn:setVisible(true)
    end
    if self._nowGrandId == #self._grandStatus then
    	self._rightBtn:setVisible(false)
    else
    	self._rightBtn:setVisible(true)
    end
end

return MonthSignLayer