local MorraLayer = class( "MorraLayer", function ()
    local layer = cc.Sprite:create()
    layer:setContentSize(975,490)
    return layer
end)

function MorraLayer:create(params)
	return MorraLayer.new(params)
end

function MorraLayer:ctor(params)
    self:initData(params)
    LayerManager.getTopInfoLayer():setPopInfo("MorraLayer")
    self._size = self:getContentSize()
	self:initUI()
	self:initShouShi()
    self:initBtn()
    self:initRole()
end

function MorraLayer:initData(params)
    -- 积分
    PlayerData.intergral = params.intergral or 0
    -- 免费次数 -- 只有每天的首次是免费的
    self.freeNum = params.freeNum or 0
    -- 当前元宝猜拳次数  
    self.buyNum = (params.buyNum or 0)

    self.consumeData = {}
    local data = gameData.getDataFromCache("consume_price",{type = 69})
    local num = self.buyNum + 1
    if num >= #data then
        num = #data
    end
    self.consumeData = gameData.getDataFromCache("consume_price",{type = 69, subtype = num})
    -- dump("tesdt----",self.consumeData)
    self.type = true -- 猜拳
    self.caiquan = 0
end

function MorraLayer:initUI()
    -- 裁剪区
    local _node_size = cc.size(995,495)
    local clipNode = cc.ClippingNode:create()
    clipNode:setPosition(cc.p(self._size.width/2, self._size.height/2 + 20))
    self:addChild(clipNode)
    clipNode:setContentSize(_node_size)
    clipNode:setAnchorPoint(cc.p(0.5,0.5))
    clipNode:setInverted(false)
    local clipNode_size = clipNode:getContentSize()
    -- 裁剪区大小
    local boxSpriteStencil = zc.getScaleNode("res/Main/common/img_empty.png",_node_size)  --测试
    clipNode:setStencil(boxSpriteStencil)
    boxSpriteStencil:setPosition(clipNode_size.width/2 ,clipNode_size.height/2 )
    -- 裁剪区内 房子
    local bg = ccui.Scale9Sprite:create(cc.rect(15, 15, 650, 400),"res/Main/morra/bg.jpg")
    bg:setContentSize(_node_size)
    bg:setPosition(self._size.width/2,self._size.height/2+16)
    clipNode:addChild(bg)
    self.bg = bg
    -- fangzi
    local bg_size = bg:getContentSize()
    local morra = zc.createSprite("res/Main/morra/morra.png")
    morra:setPosition(bg_size.width/2,bg_size.height/2)
    morra:setScale(0.7)
    bg:addChild(morra)

    self.morra = morra

    local morra_size = morra:getContentSize()
    -- men
    local leftDoor = zc.createSprite("res/Main/morra/leftdoor.png")
    -- leftDoor:setScaleX(0.9)
    leftDoor:setPosition(morra_size.width/2 - 124,morra_size.height/2 - 29)
    
    -- leftDoor:setScaleY(0.7)
<<<<<<< .mine
    morra:addChild(leftDoor,100)
=======
    morra:addChild(leftDoor,10000)
>>>>>>> .r32118
    self.leftDoor = leftDoor

    local rightdoor = zc.createSprite("res/Main/morra/rightdoor.png")
    -- rightdoor:setScaleX(0.9)
    rightdoor:setPosition(leftDoor:getPositionX() + leftDoor:getContentSize().width/2 + 129 ,leftDoor:getPositionY())
    
    -- rightdoor:setScaleY(0.7)
<<<<<<< .mine
    morra:addChild(rightdoor,100)
=======
    morra:addChild(rightdoor,10000)
>>>>>>> .r32118
    self.rightdoor = rightdoor

    -- 木板
    local muban = zc.createSprite("res/Main/morra/muban.png")
    muban:setPosition(bg_size.width/2 - 20,50)
    muban:setScaleY(0.8)
    bg:addChild(muban)
    self.muban = muban
    -- 左边棋子
    local left = zc.createSprite("res/Main/morra/left.png")
    left:setPosition(100,bg_size.height/2 + 25)
    bg:addChild(left)
    self.left = left
    -- 右边旗帜
    local right = zc.createSprite("res/Main/morra/right.png")
    right:setPosition(bg_size.width - 100,bg_size.height/2 + 25)
    bg:addChild(right)
    self.right = right
end
-- 初始化手势按钮
function MorraLayer:initShouShi()
    local tagbtns = {}
    local function _selectedBtn(tag)
        for i = 1, 3 do
            if i == tag then
                tagbtns[i]:setEnable(false)
            else
                tagbtns[i]:setEnable(true)
            end
        end
    end
    local bg = zc.createSprite()
    bg:setContentSize(200,self._size.height)
    bg:setPosition(self._size.width - 100,self._size.height/2)
    self:addChild(bg)
    self.shoushi_bg = bg

    local list_normal = {"res/Main/morra/quan.png","res/Main/morra/jiandao.png","res/Main/morra/bu.png"}
    local selected_normal = {"res/Main/morra/lightquan.png","res/Main/morra/lightjiandao.png","res/Main/morra/lightbu.png"}
    for i = 1, 3 do
        local personbtn =  zc.createPushButton({
            normalFile = list_normal[i],
            selectedFile = list_normal[i],
            disableFile = selected_normal[i],
            noScaleAction = true,
            needSwallow = false,
            needEnableWhenMoving = true,
            pos = cc.p(self._size.width - 100, 170 + (i - 1) * 110 ),
            endCallback = function()
                self.caiquan = i
                _selectedBtn(i)
            end
        })
        self:addChild(personbtn)
        tagbtns[i] = personbtn
    end
    _selectedBtn(0)
    self.tagbtns = tagbtns
end
-- 开始播放特效
function MorraLayer:setShoushi()
    print("self.caiquan_system. ",self.caiquan_system,self.caiquan)
    self:playActionRole()
end
-- 返回结果
function MorraLayer:getResult()
    local state
    if self.caiquan == 1 then -- 石头
        if self.caiquan_system == 2 then 
            state =  true
        elseif self.caiquan_system == 3 then
            state = false
        end
    elseif self.caiquan == 2 then -- 剪刀
        if self.caiquan_system == 1 then 
            state = false
        elseif self.caiquan_system == 3 then
            state = true
        end
    elseif self.caiquan == 3 then -- 步
        if self.caiquan_system == 2 then
            state = false
        elseif self.caiquan_system == 1 then
            state = true
        end
    end
    return state
end
-- 播放胜利或者失败的特效
function MorraLayer:playIconAction(state)
    local size = self.bg:getContentSize()
    if state == true then
        local size = self.bg:getContentSize()
        local win1,win2,win3,icon
        local call = cc.CallFunc:create(function()
            win1 = zc.getSpine("caiquanshengli")
            win1:setPosition(size.width*0.5, size.height*0.5)
            win1:setScale(0.9)
            win1:playAction("idle1", false)
            self.bg:addChild(win1,11,300)
        end)

        local callfunc1 = cc.CallFunc:create(function()
            win2 = zc.getSpine("caiquanshengli")
            win2:setPosition(size.width*0.5, size.height*0.5)
            win2:playAction("idle3", true)
            win2:setScale(1)
            win2:setTag(302)
            self.bg:addChild(win2)
        end)
        local callfunc2 = cc.CallFunc:create(function()
            performWithDelay(self, function()
                win3 = zc.getSpine("caiquanshengli")
                win3:setPosition(size.width*0.5, size.height*0.5 - 90)
                win3:setScale(1.3)
                win3:playAction("idle2",false)
                self.bg:addChild(win3,13,301)
            end, 0.2)
        end)
        local callfunc3 = cc.CallFunc:create(function()
            icon = zc.createSprite("res/Main/morra/rewardbg.png")
            icon:setPosition(size.width*0.5, size.height*0.5 - 90)
            icon:setTag(304)
            self.bg:addChild(icon,12)
            local data = gameData.getDataFromCacheWithPrimaryKey("guessingGame",1)
            local num = data.getPoints or 1

            local label = zc.createLabel({
                text = "获得: "..num,
                fontSize = 20,
                ap = cc.p(0,0.5),
                outLine = true,   
                pos = cc.p(icon:getContentSize().width/2 - 50,icon:getContentSize().height/2),
            })
            icon:addChild(label)
            icon.label = label
            local caiquanbi = zc.createSprite("res/Main/morra/caiquanjifen.png")
            caiquanbi:setAnchorPoint(0,0.5)
            -- caiquanbi:setScale(0.4)
            caiquanbi:setPosition(label:getPositionX() + label:getContentSize().width,label:getPositionY())
            icon:addChild(caiquanbi)
            icon.caiquanbi = caiquanbi
            icon:setVisible(false)
            self:runAction(
                cc.CallFunc:create(function ()
                    local sp1 = self.bg:getChildByTag(304)
                    if sp1 then
                        sp1:runAction(
                            cc.Sequence:create(
                                CCSpawn:create(
                                    cc.FadeIn:create(0.4),
                                    CCMoveTo:create(0.4,cc.p(size.width*0.5,size.height*0.5 - 90))
                                ),
                                cc.CallFunc:create(function ( ... )
                                    sp1:setPositionX(size.width*0.5)
                                    sp1:setVisible(true)
                                end)
                            )
                        )
                    end
                end)
            )
        end)
        local callfunc4 = cc.CallFunc:create(function()
            win1:runAction(
                cc.Sequence:create(
                    cc.FadeOut:create(1),
                    cc.CallFunc:create(function ( ... )
                        win1:removeFromParent()        
                    end)
                )
            )
            win2:runAction(
                cc.Sequence:create(
                    cc.FadeOut:create(0.9),
                    cc.CallFunc:create(function ( ... )
                        win2:removeFromParent()        
                    end)     
                )
            )
            win3:runAction(
                cc.Sequence:create(
                    cc.FadeOut:create(0.8),
                    cc.CallFunc:create(function ( ... )
                        win3:removeFromParent()        
                    end)      
                )
            )
            icon:runAction(
                cc.Sequence:create(
                    cc.FadeOut:create(0.7)
                )
            )
            icon.label:runAction(
                cc.Sequence:create(
                    cc.FadeOut:create(0.7),
                    cc.CallFunc:create(function ( ... )
                        icon.label:removeFromParent()    
                    end)     
                )
            )
            icon.caiquanbi:runAction(
                cc.Sequence:create(
                    cc.FadeOut:create(0.7),
                    cc.CallFunc:create(function ( ... )
                        icon.caiquanbi:removeFromParent()
                        icon:removeFromParent()
                    end)     
                )
            )
<<<<<<< .mine
            -- self.isCanCaiQuan = true
            cc.DelayTime:create(0.5)
            getGuideManager():removeMaskLayer()
=======
            -- cc.DelayTime:create(1)
            
            getGuideManager():removeMaskLayer()
>>>>>>> .r32118
        end)
        local seq = cc.Sequence:create(
            call,
            cc.DelayTime:create(0.2),
            callfunc1,
            cc.DelayTime:create(0.2),
            callfunc2,
            callfunc3,
            cc.DelayTime:create(1.5),
            callfunc4
            )
        self:runAction(seq)
    else
        local lose = zc.getSpine("caiquanshibai")
        lose:setPosition(size.width*0.5, size.height*0.5)
        self.bg:addChild(lose)
<<<<<<< .mine
        lose:runAction(
            cc.Sequence:create(
                cc.CallFunc:create(
                    function ( ... )
                        lose:playAction("idle1", false)
                    end),
                cc.DelayTime:create(2),
                cc.DelayTime:create(0.5),
                cc.CallFunc:create(function ( ... )
                    getGuideManager():removeMaskLayer()
=======
        lose:runAction(cc.Sequence:create(
            cc.CallFunc:create(
                function ( ... )
                    lose:playAction("idle1", false)
                end
                ),
            cc.DelayTime:create(1.2),
            cc.CallFunc:create(
                function ( ... )
>>>>>>> .r32118
                    getGuideManager():removeMaskLayer()
                    lose:removeFromParent()
<<<<<<< .mine
                end)
=======
                end
>>>>>>> .r32118
                )
            )
    end
end
-- 主角特效
function MorraLayer:playActionRole()
    local function animationEvent(armatureBack,movementType,movementID)
        if movementType == ccs.MovementEventType.complete then
            -- for k,v in pairs(self.rollList) do
            if #self.rollList == 1 then
                local result = self:getResult()
                if result then
                    self:playWinActionRole()
                    self:playLoseActionSystem()
                    self:playIconAction(result)
                else
                    self:playWinActionSystem()
                    self:playLoseActionRole()
                    self:playIconAction(result)
                end
            else
                print("self.count::::",self.count)
                if self.rollList[self.count] then
                    dump(self.rollList[self.count])
                    if tonumber(self.rollList[self.count].winResult) == 0 then
                        print("------1")
                        self:setShoushi()
                        self.count = self.count + 1
                        self.caiquan_system = tonumber(self.rollList[self.count].computerOption)
                    else
                        print("------2")
                        local result = self:getResult()
                        if result then
                            self:playWinActionRole()
                            self:playLoseActionSystem()
                            self:playIconAction(result)
                        else
                            self:playWinActionSystem()
                            self:playLoseActionRole()
                            self:playIconAction(result)
                        end
                    end
                end
            end
        end
    end
    local callfunc1 = cc.CallFunc:create(function()
        if self._heroArmature then
            self._heroArmature:getAnimation():setMovementEventCallFunc(animationEvent)
            if self.caiquan == 1 then
                self._heroArmature:getAnimation():play("yaoyao_shitou")
            elseif self.caiquan == 2 then
                self._heroArmature:getAnimation():play("yaoyao_jiandao")
            elseif self.caiquan == 3 then
                self._heroArmature:getAnimation():play("yaoyao_bu")
            end 
        end
    end)
<<<<<<< .mine
    self._heroArmature:runAction(cc.Sequence:create(
        callfunc1))

=======
    self._heroArmature:runAction(cc.Sequence:create(
        callfunc1
        ))
>>>>>>> .r32118
    local callfunc2 = cc.CallFunc:create(function()
        if self._heroArmature_hy then
            self._heroArmature_hy:getAnimation():setMovementEventCallFunc(animationEvent)
            if self.caiquan_system == 1 then
                self._heroArmature_hy:getAnimation():play("yaoyao_shitou")
            elseif self.caiquan_system == 2 then
                self._heroArmature_hy:getAnimation():play("yaoyao_jiandao")
            elseif self.caiquan_system == 3 then
                self._heroArmature_hy:getAnimation():play("yaoyao_bu")
            end 
        end
    end)
<<<<<<< .mine
    self._heroArmature_hy:runAction(cc.Sequence:create(
        callfunc2))
    -- local spwan = CCSpawn:create(callfunc1,callfunc2)
    -- self:runAction(spwan)
=======
    self._heroArmature_hy:runAction(cc.Sequence:create(callfunc2))
    -- local spwan = CCSpawn:create(callfunc1,callfunc2)
    -- self:runAction(spwan)
>>>>>>> .r32118
end
-- 系统胜利特效
function MorraLayer:playWinActionSystem()
    if self._heroArmature_hy then
        if self.caiquan_system == 1 then
            self._heroArmature_hy:getAnimation():play("win_shitou")
        elseif self.caiquan_system == 2 then
            self._heroArmature_hy:getAnimation():play("win_jiandao")
        elseif self.caiquan_system == 3 then
            self._heroArmature_hy:getAnimation():play("win_bu")
        end 
    end
end
-- 主角失败特效
function MorraLayer:playLoseActionRole()
    if self._heroArmature then
        self._heroArmature:getAnimation():play("lose")
    end
end
-- 系统失败特效
function MorraLayer:playLoseActionSystem()
    if self._heroArmature_hy then
        self._heroArmature_hy:getAnimation():play("lose")
    end
end
-- 主角胜利特效
function MorraLayer:playWinActionRole()
    if self._heroArmature then
        if self.caiquan == 1 then
            self._heroArmature:getAnimation():play("win_shitou")
        elseif self.caiquan == 2 then
            self._heroArmature:getAnimation():play("win_jiandao")
        elseif self.caiquan == 3 then
            self._heroArmature:getAnimation():play("win_bu")
        end 
    end
end

function MorraLayer:sendMessage()
    zc.sendHttp({
        apiName = "CaiQuan_Begain",--  type:1//使用什么猜拳 1免费 2猜拳币 3元宝--  userOption:1//1石头 2剪刀 3布
        params = {type = 3,userOption = self.caiquan},
        -- 成功回调
        successCallback = function(backData)
            -- dump(backData,"----CaiQuan_Begain----")
            PlayerData.intergral = tonumber(backData.integral)
            self.rollList = backData.rollList
            self.count = 1
            self.caiquan_system = tonumber(self.rollList[self.count].computerOption)
            backData.noAnimation = true
            self.backData = backData
            -- 播放手势特效
            self:setShoushi()

            if self.freeNum == 1 then
                zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_BASEINFOCHANGE, data = {}})
            else
                PlayerData:updataData(self.backData)
            end
            -- 非首次免费
            if self.freeNum > 0 then -- 免费
                self.freeNum = self.freeNum - 1
            end
            if self.freeNum == 0 then -- 没有免费的了
<<<<<<< .mine
                PlayerData.resourcesInfo.guessingGameTicket  = 0
                if PlayerData.resourcesInfo.guessingGameTicket > 0 then -- 猜拳币
=======
                local bi_data = PlayerData:getBagInfoByID(674)
                local num
                if not bi_data then
                    num = 0
                else
                    num = tonumber(bi_data.num)
                end

                if num > 0 then -- 猜拳币
>>>>>>> .r32118
                    self.type_icon:setTexture("res/Main/morra/jiangjuan.png")
                    self._icon:setTexture("res/Main/morra/caiquanbi.png")
                    self._icon:setPosition(29,69)
                    local str = "X"..1
                    self.numlabel_:setString(str)
                    self.numlabel_:setPosition(self._icon:getPositionX() + self._icon:getContentSize().width/2,self._icon:getPositionY())
                    if self.freeLabel then
                        self.freeLabel:setVisible(false)
                    end
                else -- 元宝
                    if self.freeLabel then
                        self.freeLabel:setVisible(false)
                    end
                    print("self.buyNum:::"..self.buyNum.."self.freeNum"..self.freeNum)
                    self._icon:setTexture(zc.getImgByType(1))
                    self.type_icon:setTexture("res/Main/morra/yuanbao.png")
                    self._icon:setPosition(29,69)
                    self.buyNum = self.buyNum + 1
                    print("self.buyNum:::"..self.buyNum)
                    local data = gameData.getDataFromCache("consume_price",{type = 69})
                    local num = self.buyNum
                    if num >= #data then
                        num = #data
                    end
                    local consumeData = gameData.getDataFromCache("consume_price",{type = 69, subtype = num})
                    local str = "X"..consumeData.price
                    print("consumeData.price. ",consumeData.price)
                    self.numlabel_:setString(str)
                    self.numlabel_:setPosition(self._icon:getPositionX() + self._icon:getContentSize().width/2,self._icon:getPositionY())
                end
            end
        end
    })
end
-- 开始，商店按钮
function MorraLayer:initBtn()
    --物质底图
<<<<<<< .mine
    local _type 
    if self.freeNum == 1 then
        _type = 1 -- 免费
    else
        -- if PlayerData.resourcesInfo.guessingGameTicket > 0 then
        --     _type = 2 -- 猜拳卷
        -- else
        --     _type = 3 -- 元宝
        -- end
=======
    local _type
    local function updateType( ... )
        if self.freeNum == 1 then
            _type = 1 -- 免费
        else
            local bi_data = PlayerData:getBagInfoByID(674)
            local num
            if not bi_data then
                num = 0
            else
                num = tonumber(bi_data.num)
            end
             
            if num > 0 then
                _type = 2 -- 猜拳bi
            else
                _type = 3 -- 元宝
            end
        end
>>>>>>> .r32118
        self._type = _type
    end
    
    local bg = zc.createPushButton({
        normalFile = "res/Main/morra/wuzhidi.png",
        selectedFile = "res/Main/morra/wuzhidi.png",
        disableFile = "res/Main/morra/wuzhidi.png",
        pos = cc.p(100,60),
        endCallback = function()
            --添加屏蔽
            getGuideManager():addMaskLayer()
            if self.caiquan == 0 then
                zc.tipInfo(zc.lang("selet_shoushi"))
            else
                getGuideManager():addMaskLayer()
                updateType()
                print("self._type.......",self._type)
                self:sendMessage()
            end
        end
    })
    self.shoushi_bg:addChild(bg)
    self.btn = bg

    local bgSize = bg:getContentSize()

    local type_icon
    local _icon
    local _y
    local _icon_y
    local consumnum 
    print("_type:::",_type)
    updateType()
    if self._type == 2 then -- 猜拳币
        -- 消耗物品标志
        type_icon = zc.createSprite("res/Main/morra/jiangjuan.png")
        _y = 26
        -- 消耗物品icon
        _icon = zc.createSprite("res/Main/morra/caiquanbi.png")
        _icon_y = bgSize.height/2 + 13
        consumnum = "X"..1
    elseif self._type == 3 then -- 元宝
        type_icon = zc.createSprite("res/Main/morra/yuanbao.png")
        _y = 26
        _icon = zc.createSprite(zc.getImgByType(1))
        _icon_y = bgSize.height/2 + 13
        consumnum = "X"..self.consumeData.price
    else
        type_icon = zc.createSprite()
        _y = 30
        _icon = zc.createSprite()
        _icon_y = bgSize.height/2
        consumnum = "" 
        self.freeLabel = zc.createSprite("res/Main/morra/freecaiquan.png")
        self.freeLabel:setPosition(cc.p(bgSize.width/2,bgSize.height/2))
        bg:addChild(self.freeLabel)
    end
    _icon:setPosition(cc.p(bgSize.width/2 - 23,_icon_y))
    bg:addChild(_icon)
    self._icon = _icon
    -- 消耗数量
    local numlabel_ = zc.createLabel({
        text = consumnum,
        fontSize = 22,
        ap = cc.p(0,0.5),   
        pos = cc.p(_icon:getPositionX()+ _icon:getContentSize().width/2,_icon:getPositionY()),
    })
    bg:addChild(numlabel_)
    self.numlabel_ = numlabel_
    
    type_icon:setPosition(bgSize.width/2,_y)
    bg:addChild(type_icon)
    self.type_icon = type_icon

    local function update( ... )
        if self.type then
            self.type_sign:setTexture("res/Main/morra/shop.png")
        else
            self.type_sign:setTexture("res/Main/morra/caiquan.png")
        end
    end
    -- 灯盒按钮 -- 猜拳和商店切换
    local denghe = zc.createPushButton({
        normalFile = "res/Main/morra/denghe.png",
        selectedFile = "res/Main/morra/denghe.png",
        disableFile = "res/Main/morra/denghe.png",
        pos = cc.p(140,80),
        endCallback = function()
<<<<<<< .mine
            --添加屏蔽
            getGuideManager():addMaskLayer()

=======
            --添加屏蔽
            getGuideManager():addMaskLayer()
>>>>>>> .r32118
            if self.type then
                self.type = false
            else
                self.type = true
            end
            update()
            if self.type then
                self:backToNormal()
            else
                zc.sendHttp({
                    apiName = "CaiQuan_Shop_Main",
                    -- 成功回调
                    successCallback = function(backData)
                        -- dump("------CaiQuan_Shop_Main----",backData)
                        self.btn:setVisible(false)
                        for k,v in pairs(self.tagbtns) do
                            v:setVisible(false)
                        end
                        -- self.morra:setVisible(false)
                        -- self.muban:setVisible(false)
                        self.left:setVisible(false)
                        self.right:setVisible(false)
                        self._heroArmature:setVisible(false)
                        self._heroArmature_hy:setVisible(false)
                        -- 商城数据
                        self.shopData = backData
                        if self._tableview then
                            self._tableview:setVisible(false)
                        end
                        self:initShop()
                    end,
                    -- 失败回调
                    failCallback = function()
                        getGuideManager():removeMaskLayer()
                    end,
                    -- 错误码回调
                    errorCallback = function(errorCode, errorMsg)
                        zc.tipInfo(LANGUAGE_GETERRORTIP(errorMsg))
                        getGuideManager():removeMaskLayer()
                    end
                })
            end
        end
    })
    self.denghe = denghe
    self.bg:addChild(denghe,200,200)
    -- 猜拳icon
    local type_sign
    if self.type == true then -- 正在猜拳 此时显示的商店的icon
        type_sign = zc.createSprite("res/Main/morra/shop.png")
    else
        type_sign = zc.createSprite("res/Main/morra/caiquan.png")
    end
    type_sign:setPosition(denghe:getContentSize().width/2 - 20,denghe:getContentSize().height/2 - 23)
    denghe:addChild(type_sign)
    self.type_sign = type_sign
end
-- 初始化商店UI特效
function MorraLayer:initShop()
    self.posX = self.muban:getPositionX()
    self.posY = self.muban:getPositionY()
    self.muban:runAction(CCSpawn:create(
        -- self.muban_action:runAction(CCSpawn:create(
        cc.FadeOut:create(1),
        CCMoveBy:create(1,ccp(0,-5))
    ))
    self.morraX = self.morra:getPositionX()
    self.morraY = self.morra:getPositionY()

    self.morra:runAction(CCSpawn:create(
        -- self.morra_action:runAction(CCSpawn:create(
        CCScaleTo:create(1, 1),
        CCMoveBy:create(1,ccp(0,-3))
    ))
    self.leftposX = self.leftDoor:getPositionX()
    self.leftposY = self.leftDoor:getPositionY()

    self.rightposX = self.rightdoor:getPositionX()
    self.rightposY = self.rightdoor:getPositionY()

    self.leftDoor:runAction(
        -- self.leftDoor_action:runAction(
        cc.Sequence:create(
            CCSpawn:create(
                cc.FadeOut:create(1),
                CCMoveBy:create(1,cc.p(-100,0))
                )
        ))
    self.rightdoor:runAction(
        -- self.rightdoor_action:runAction(
        cc.Sequence:create(
            CCSpawn:create(
                cc.FadeOut:create(1),
                CCMoveBy:create(1,cc.p(100,0))
                ),
            cc.CallFunc:create(function ( ... )
                self:initTableView()
                cc.DelayTime:create(1.5)
                self.jiantou = zc.createSprite("res/Main/morra/jiantou.png")
                self.jiantou:setPosition(710,240)
                self.morra:addChild(self.jiantou,102,102)

                self.jiantou:runAction(
                    CCRepeatForever:create(
                        cc.Sequence:create(
                            cc.FadeOut:create(0.5),
                            cc.FadeIn:create(0.5)
                            )
                        )
                    )
            end)
        )
    )
end
-- 返回猜拳特效
function MorraLayer:backToNormal()
<<<<<<< .mine
    self._tableview:runAction(
=======
    -- self.leftDoor_action:runAction(
    self.leftDoor:runAction(
>>>>>>> .r32118
        cc.Sequence:create(
            CCSpawn:create(
                cc.FadeIn:create(0.8),
                CCMoveBy:create(0.8,cc.p(0,5))
                ),
            cc.CallFunc:create(function ()
                self._tableview:removeFromParent()
                self._tableview = nil
            end)
        ))
    self.leftDoor:runAction(
        -- self.leftDoor_action:runAction(
        cc.Sequence:create(
            CCSpawn:create(
                cc.FadeIn:create(1),
                CCMoveBy:create(1,cc.p(100,0))
                ),
            cc.CallFunc:create(function ()
                -- self.leftDoor_action:removeFromParent()
                -- self.leftDoor_action = nil
            end),
            cc.DelayTime:create(0.5),
            cc.CallFunc:create(function ( ... )
<<<<<<< .mine
                getGuideManager():removeMaskLayer()
=======
                 self._tableview:runAction(
                    cc.Sequence:create(
                        CCSpawn:create(
                            cc.FadeIn:create(0.3),
                            CCMoveBy:create(0.3,cc.p(0,5))
                            ),
                        cc.CallFunc:create(function ()
                            self._tableview:removeFromParent()
                            self._tableview = nil
                        end)
                    ))
>>>>>>> .r32118
                 self.jiantou:runAction(
                    cc.Sequence:create(
                        cc.FadeIn:create(0.3),
                        cc.CallFunc:create(function ()
                            self.jiantou:removeFromParent()
                            self.jiantou = nil
                        end)
                        )
                    )
            end)
        ))
<<<<<<< .mine
    self.rightdoor:runAction(
        -- self.rightdoor_action:runAction(
=======
    -- self.rightdoor_action:runAction(
    self.rightdoor:runAction(
>>>>>>> .r32118
        cc.Sequence:create(
            CCSpawn:create(
                cc.FadeIn:create(1),
                CCMoveBy:create(1,cc.p(-100,0))
                ),
            cc.CallFunc:create(function ()
                -- self.rightdoor_action:removeFromParent()
                -- self.rightdoor_action = nil
            end)
        )
    )
    self.muban:runAction(
        -- self.muban_action:runAction(
        cc.Sequence:create(
            CCSpawn:create(
                cc.FadeIn:create(1),
                CCMoveBy:create(1,cc.p(0,5))
                ),
            cc.CallFunc:create(function ()
                -- self.muban:setVisible(true)
                -- self.muban_action:removeFromParent()
                -- self.muban_action = nil
            end)
        ))
    self.morra:runAction(
        -- self.morra_action:runAction(
        cc.Sequence:create(
            CCSpawn:create(
                cc.FadeIn:create(1),
                CCScaleTo:create(1, 0.7),
                CCMoveBy:create(1,ccp(0,3))
                ),
            cc.CallFunc:create(function ()
                -- self.morra:setVisible(true)
                -- self.morra_action:removeFromParent()
                -- self.morra_action = nil
            end)
        )
    )
    self._heroArmature:runAction(
            cc.Sequence:create(
                cc.DelayTime:create(0.1),
                CCSpawn:create(
                    cc.FadeIn:create(1)
                    ),
                cc.CallFunc:create(function ()
                    self._heroArmature:setVisible(true)
                end)
            )
        )
    self._heroArmature_hy:runAction(
            cc.Sequence:create(
                CCSpawn:create(
                    cc.FadeIn:create(1)
                    ),
                cc.CallFunc:create(function ()
                    self._heroArmature_hy:setVisible(true)
                end)
            )
        )
    self.left:runAction(
            cc.Sequence:create(
                CCSpawn:create(
                    cc.FadeIn:create(1)
                    ),
                cc.CallFunc:create(function ()
                    self.left:setVisible(true)
                end)
            )
        )
    self.right:runAction(
            cc.Sequence:create(
                CCSpawn:create(
                    cc.FadeIn:create(1)
                    ),
                cc.CallFunc:create(function ()
                    self.right:setVisible(true)
                end)
            )
        )
    for k,v in pairs(self.tagbtns) do
        v:runAction(
            cc.Sequence:create(
                CCSpawn:create(
                    cc.FadeIn:create(1)
                    ),
                cc.CallFunc:create(function ()
                    v:setVisible(true)
                end)
            )
        )
    end
    self.btn:runAction(
            cc.Sequence:create(
                CCSpawn:create(
                    cc.FadeIn:create(1)
                    ),
                cc.CallFunc:create(function ()
                    self.btn:setVisible(true)
                    cc.DelayTime:create(1)
                    getGuideManager():removeMaskLayer()
                end)
            )
        )
    print("1111self.posX:",self.posX,"self.posY:",self.posY)
end
-- 创建主角、系统人物
function MorraLayer:initRole()
    -- 主角
    if self._heroArmature then
        self._heroArmature:removeFromParent()
        self._heroArmature = nil
    end
    local _armature = zc.battle.createHeroArmature({
        -- fileName = self._heroData.modelId,
        fileName = "nanzhu",
        heroDataWeaponId = 35,
        -- heroDataWeaponId = _mainWeaponData and _mainWeaponData.weaponId or 0,
        async = true,
        asyncCallback = function( _armature_ , fileName , num )
            _armature_:getAnimation():play("idle_caiquan")
        end
    })
    _armature:setPosition(self.bg:getContentSize().width - 320,45)
    _armature:setScaleX( 1 )
    _armature:setScaleY( 1 )
    self.bg:addChild( _armature, 100000000 )
    self._heroArmature = _armature
    -- _armature:setColor( cc.c3b(255,255,255))
    -- 黄月英
    if self._heroArmature_hy then
        self._heroArmature_hy:removeFromParent()
        self._heroArmature_hy = nil
    end

    local _heroArmature_hy = zc.battle.createHeroArmature({
        fileName = "hjms",
        heroDataWeaponId = 0,
        async = true,
        asyncCallback = function( _armature_ , fileName , num )
            _armature_:getAnimation():play("idle_caiquan")
        end
    })
    _heroArmature_hy:setPosition(300,50)
    _heroArmature_hy:setScaleY( 1)
    _heroArmature_hy:setScaleX(-1)
    self.bg:addChild( _heroArmature_hy, 100000000 )
    self._heroArmature_hy = _heroArmature_hy
end

function MorraLayer:sortData()
    -- dump(self.shopStoreData,"//////")
    table.sort(self.shopStoreData,function (a,b)
        if not a or not b then return end
        local abuyed = tonumber(self.shopData[tostring(a.id)]["nums"]) or 0
        local bbuyed = tonumber(self.shopData[tostring(b.id)]["nums"]) or 0
        local atotal = tonumber(a.parameter)
        local btotal = tonumber(b.parameter)
        local statea = true
        if abuyed >= atotal then
            statea = false
        end
        local stateb = true
        if bbuyed >= btotal then
            stateb = false
        end
        if statea ~= stateb then
            return statea 
        end
        return tonumber(a.id) < tonumber(b.id)
    end)
    self.firstId = self.shopStoreData[1].id
end

function MorraLayer:initTableView()
    self.shopStoreData = {}
    
    for k,v in pairs(self.shopData) do
        local data = gameData.getDataFromCacheWithPrimaryKey("guessingGameStore",v.id)
        table.insert(self.shopStoreData,data)
    end
    self:sortData()
    self._tableviewSize = cc.size(530,300)

    local tableview = zc.ZCTableView:create(self._tableviewSize)
    tableview:setBounceable( false )
    tableview:setInertia( true )
    tableview:setDirection( cc.SCROLLVIEW_DIRECTION_VERTICAL )
    tableview:setPosition( cc.p(170,210))
    tableview:setDelegate()
    tableview:setVerticalFillOrder( cc.TABLEVIEW_FILL_TOPDOWN )

    local cellWidth = 530
    local cellHeight = 105
    local function cellSizeForTable(table, index) 
        return cellHeight, cellWidth
    end
    local function tableCellAtIndex(table, index)
        local cell = table:dequeueCell()
        -- 创建模板
        if cell == nil then
            cell = zc.ZCTableViewCell:new()
            self:buildCell( cell, cellWidth, cellHeight,index + 1)
        end
        self:updateCell( cell, index + 1,cellWidth, cellHeight)
        return cell
    end
    local function numberOfCellsInTableView()
        -- return #self.shopStoreData
        return #self.shopStoreData
    end
    tableview:registerScriptHandler( cellSizeForTable, cc.TABLECELL_SIZE_FOR_INDEX )
    tableview:registerScriptHandler( tableCellAtIndex, cc.TABLECELL_SIZE_AT_INDEX )
    tableview:registerScriptHandler( numberOfCellsInTableView, cc.NUMBER_OF_CELLS_IN_TABLEVIEW )
    tableview:registerScriptHandler(function()
        if #self.shopStoreData <= 3 then
            if self.jiantou then
                self.jiantou:setVisible(false)
            end
        else
            local pos = tableview:getContainer():getPositionY()
            print("p;s. ",pos)
            if self.jiantou then
                if pos >= 0 then
                    self.jiantou:setVisible(false)
                elseif pos <= (-105*(#self.shopStoreData - 3) - (#self.shopStoreData)*2) then
                    self.jiantou:setVisible(false)
                else
                    self.jiantou:setVisible(true)
                end
            end
        end
<<<<<<< .mine
        local function numberOfCellsInTableView()
            -- return #self.shopStoreData
            return #self.shopStoreData
        end
        tableview:registerScriptHandler( cellSizeForTable, cc.TABLECELL_SIZE_FOR_INDEX )
        tableview:registerScriptHandler( tableCellAtIndex, cc.TABLECELL_SIZE_AT_INDEX )
        tableview:registerScriptHandler( numberOfCellsInTableView, cc.NUMBER_OF_CELLS_IN_TABLEVIEW )
        self.morra:addChild(tableview)
        -- self.morra_action:addChild(tableview)
        self._tableview = tableview
        tableview:reloadData()
        self:initAnimation()
    -- end
=======
    end, cc.SCROLLVIEW_SCRIPT_SCROLL)

    self.morra:addChild(tableview)
    self._tableview = tableview
    tableview:reloadData()

    self:initAnimation()
>>>>>>> .r32118
end
function MorraLayer:buildCell(cell,cellWidth, cellHeight,cellIndex)
    -- bg
    print("cellIndex::",cellIndex)
    local y = 0
    if cellIndex == 1 then
        cell.bg = zc.createSprite("res/Main/morra/mutoulan.png")
        cell.title = zc.createSprite("res/Main/morra/newduan.png")
        cell.title:setPosition(cell.bg:getContentSize().width/2,cell.bg:getContentSize().height)
        cell.title:setTag(200000)
        cell.bg:addChild(cell.title)
    else
        cell.bg = zc.createSprite("res/Main/morra/mutoulan.png")
    end
    cell.bg:setPosition(cellWidth/2,cellHeight/2 - y)
    cell:addChild(cell.bg)

    local size = cell.bg:getContentSize()

    cell.jifenbg = zc.createSprite("res/Main/hero/hero_item3.png")
    cell.jifenbg:setPosition(80, size.height*0.5 + 5)
    cell.jifenbg:setScale(0.6)
    cell.bg:addChild(cell.jifenbg)

    local cell_size = cell.jifenbg:getContentSize()

    cell.jifen = zc.createSprite("res/Main/common/common_icon_jifen_big.png")
    cell.jifen:setPosition(cell_size.width/2,cell_size.height/2)
    cell.jifenbg:addChild(cell.jifen)

    cell.jifelabel = zc.createLabel({
        text = 1,
        ap = cc.p(1,0.5),
        fontSize = 29,
        pos = cc.p(cell_size.width - 10,16),
    })
    cell.jifenbg:addChild(cell.jifelabel)
    local _icon = zc.createIconByData({
        data = {
            mainType = 1,
            type = 1,
            id = 1,
            num = 1,
        },
        scale = 0.6,
        pos = cc.p(175, size.height*0.5 + 5),
    })
    _icon:setTouchEndedShowTip()
    cell.bg:addChild(_icon)
    
    cell._icon = _icon
    -- 兑换箭头
    local _exchangeIcon = zc.createSprite("res/Main/activity/exchange/exchange_arrow.png")
    _exchangeIcon:setPosition(240,size.height/2 + 5)
    cell.bg:addChild(_exchangeIcon)
    cell._exchangeIcon = _exchangeIcon
    -- 英雄碎片
    local _objIcon = zc.createIconByData({
        data = {
            mainType = 1,
            type = 1,
            id = 2,
            num = 1,
        },
        scale = 0.6,
        pos = cc.p(310,size.height/2 + 5),
    })
    cell.bg:addChild(_objIcon)
    cell._objIcon = _objIcon

    cell.btn = zc.createCommomBtn({
        tag = 3,
        fontSize = 30,
        text = zc.lang("duihuan_2"),
        needEnableWhenMoving = true,
        needSwallow = false,
        scale = 0.7,
        pos = cc.p(size.width - 110, size.height*0.5 - 5),
        endCallback = function()
            
        end,
    })
    cell.btn:setTag(cellIndex)
    cell.bg:addChild(cell.btn)

    cell.label = zc.createLabel({
        text = "(10/12)",
        color = display.COLOR_RED,
        outLine = true,
        fontSize = 24,
        pos = cc.p(size.width - 110,size.height*0.5 + 32),
    })
    cell.bg:addChild(cell.label)
end
function MorraLayer:updateCell(cell,cellIndex,cellWidth,cellHeight)
    local data = self.shopStoreData[cellIndex]
    if not data then return end
    local list = {}
    if cellIndex == 1 then
        cell.bg:setTexture("res/Main/morra/mutoulan.png")

        local tag = cell.bg:getChildByTag(200000)
        if tag then
            tag:setVisible(true)
        end
    else
        cell.bg:setTexture("res/Main/morra/mutoulan.png")
        local tag = cell.bg:getChildByTag(200000)
        if tag then
            tag:setVisible(false)   
        end
    end
    cell.bg:setPosition(cellWidth/2,cellHeight/2 - 5)

    table.insert(list,{data.needItem2})

    local needItem1 = data.needItem1
    if needItem1 == "" then
        cell.jifenbg:setPositionX(110)
    else
        cell.jifenbg:setPositionX(90)
    end
    cell.jifen:setVisible(true)
    cell.jifelabel:setString(data.needItem2.."")

    if needItem1 == "" then
        cell._icon:setVisible(false)
    else
        cell._icon:setVisible(true)
        local _con_arr = string.split(needItem1,"|")
        zc.updateIconByData(cell._icon,{
            data = {
                mainType = _con_arr[1],
                type = _con_arr[2],
                id = _con_arr[2],
                num = _con_arr[3],
            },
            showCount = true,
        })
        cell._icon:setTouchEndedShowTip()
        table.insert(list,_con_arr)
    end
    if needItem1 == "" then
        cell._exchangeIcon:setPositionX(205)
    else
        cell._exchangeIcon:setPositionX(245)
    end
    
    local item = data.item
    local item_cor = string.split(item,"|")
    zc.updateIconByData(cell._objIcon,{
        data = {
            mainType = item_cor[1],
            type = item_cor[2],
            id = item_cor[2],
            num = item_cor[3],
        },
        showCount = true,
    })
    cell._objIcon:setTouchEndedShowTip()
    local id = data.id..""
    local shop_data = self.shopData[id]
    local nums = tonumber(shop_data.nums) or 0
    local total_num = tonumber(data.parameter)

    local str = "("..(total_num - nums).."/"..total_num..")"
    if nums < total_num then
        cell.label:setString(str)
        cell.label:setColor(display.COLOR_GREEN)
        cell.btn:setEnable(true)
    else
        str = "(".."0".."/"..total_num..")"
        cell.label:setString(str)
        cell.label:setColor(display.COLOR_RED)
        cell.btn:setEnable(false)
    end

    cell.btn:setTouchEndedCall(function ( ... )
        print("tag------ ",cell.btn:getTag())
        local params = {
            itemData = {
                itemId = item_cor[2],
                itemType = item_cor[1],
                itemNum = item_cor[3],
            },
            data = list,
            info = {
                buyNum = data.parameter - tonumber(self.shopData[id].nums or 0),
            },
            rightBtnText = zc.lang("duihuan_2"),
            rightFunc = function (nums)
                zc.sendHttp({
                    apiName = "CaiQuan_Shop_Buy",
                    params = {id = data.id,num = nums},
                    -- 成功回调
                    successCallback = function(backData)
                        -- dump(backData,"backData")
                        -- 已兑换次数
                        self.shopData[id].nums = tostring(tonumber(self.shopData[id].nums or 0) + nums)
                        backData.noAnimation = true
                        zc.createShowReward(backData)
                        self:sortData()
                        self._tableview:reloadData()
                        -- 会刷新当前的积分
                        PlayerData.intergral = PlayerData.intergral - nums * tonumber(data.needItem2)
                        PlayerData:updataData(backData)
                    end
                })
            end,
        }
        zc.createSourcePop("MorraLayerBuyPop", "src/layer/activity/MorraLayerBuyPop.lua", params or {})
    end)
end
-- 入场动画
function MorraLayer:initAnimation()
    local cellHeight = 105
    local cellNum = math.ceil( self._tableviewSize.height/cellHeight )
    for i = 1, cellNum do
        local cell = self._tableview:cellAtIndex( i - 1 )
        if cell then
            local cellPosY = cell:getPositionY()
            local cellPosX = cell:getPositionX()
            cell:stopAllActions()
            cell:setPosition(cellPosX,800)
            cell:runAction(
                cc.Sequence:create(
<<<<<<< .mine
                    cc.DelayTime:create( i*0.05 ),--math.sqrt( ( i - 1 )*0.05 ) ),
                    cc.EaseExponentialOut:create( cc.MoveTo:create( 0.5, 
                        cc.p(cellPosX,cellPosY))),
                    cc.DelayTime:create(0.5),
                    cc.CallFunc:create(function ( ... )
                        getGuideManager():removeMaskLayer()
                    end)
=======
                    cc.DelayTime:create( i * 0.05 ),--math.sqrt( ( i - 1 )*0.05 ) ),
                    cc.EaseExponentialOut:create( 
                        cc.MoveTo:create( 0.5, cc.p(cellPosX,cellPosY))
                        -- cc.FadeIn:create(5)
                    ),
                    cc.CallFunc:create(function ()
                        cc.DelayTime:create(1)
                        getGuideManager():removeMaskLayer()
                    end)
>>>>>>> .r32118
                )
            )
        end
    end
end

return MorraLayer