--[[
    猜拳商城购买弹窗
]]

local MorraLayerBuyPop = class("MorraLayerBuyPop",function()
    return ZCPopLayer:create()
end)

function MorraLayerBuyPop:create(data)
    return MorraLayerBuyPop.new(data)
end

function MorraLayerBuyPop:ctor(data)
    self:initData(data)
    self:initUI()
end

function MorraLayerBuyPop:initData( data )
    -- dump(data)
    self._info = data.itemData--物品信息
    self.list = data.data
    local timeLimit = data.info.buyNum or 1000000 --兑换数量限制
    self._rightBtnText = data.rightBtnText or LANGUAGE_SHOP.buy
    self._rightFunc = data.rightFunc or nil
    self._useNum = 1

    local _itemInfo = self._info
    local _ownNum = 0
    local _maxNum =timeLimit
    if tonumber(_itemInfo["itemType"]) == zc.mainTypeResource then
        _ownNum = PlayerData:getResourcesInfoById(_itemInfo["itemId"])
    elseif tonumber(_itemInfo["itemType"]) == zc.mainTypeWeapon then --兵器
        _ownNum = PlayerData:getWeaponNumInBagById(_itemInfo["itemId"])
    elseif tonumber(_itemInfo["itemType"]) == zc.mainTypeProp then
        local itemInfo = PlayerData:getBagInfoByID(_itemInfo["itemId"]) or {}
        _ownNum = itemInfo["num"] or 0 
    end
    self._ownNum = _ownNum
    if _maxNum > timeLimit then
        _maxNum = timeLimit
    end
    self._maxNum = _maxNum
end

function MorraLayerBuyPop:initUI()
    -- local bg = cc.Sprite:create("res/Main/common/popBg/popup_Bg_blue.png")
    local bg = ccui.Scale9Sprite:create(cc.rect(15, 15, 500, 400),"res/Main/common/popBg/popup_Bg_blue.png")
    bg:setContentSize(521,410)
    bg:setPosition(zc.width/2, zc.height/2)
    self:addContent(bg)

    local titleLab = zc.getTipPopTitle( "goumai" )
    titleLab:setPosition( bg:getContentSize().width/2, bg:getContentSize().height - 30 )
    bg:addChild(titleLab, 2)
    
    local _bgSize = bg:getContentSize()
    local contentBgSize = cc.size(460, 200)
    local contentBg = zc.getScaleNode("res/Main/common/popBg/di_1.png", contentBgSize)
    contentBg:setPosition(_bgSize.width*0.5, _bgSize.height*0.5 + 35)
    bg:addChild(contentBg)

    --道具
    local item = nil
    if tonumber(self._info["itemType"]) == zc.mainTypeWeapon then 
        item = zc.createIconByData({
            data = {
                mainType = zc.mainTypeWeapon,
                type = 1, 
                id = self._info["itemId"],
                num = 1,
                quality = 1,
            }, 
            pos = cc.p(230, 135), 
        })
    elseif tonumber(self._info["itemType"]) == zc.mainTypeProp then
        item = zc.createIconByData({
            data = {
                mainType = zc.mainTypeProp,
                type = 1, 
                id = self._info["itemId"],
                num = self._info["itemNum"],
                quality = 1,
            }, 
            pos = cc.p(230, 135), 
        }) 
    elseif tonumber(self._info["itemType"]) == zc.mainTypeResource then
        item = zc.createIconByData({
            data = {
                mainType = self._info["itemType"],
                type = self._info["itemId"], 
                id = self._info["itemId"],
                num = self._info["itemNum"],
                quality = 1,
            }, 
            pos = cc.p(230, 135), 
        })
    end
    item:setScale(0.7)
    contentBg:addChild(item)
    local list = self.list
    if list[1] then
        local pos = list[2] == nil and cc.p(_bgSize.width*0.5, 110) or cc.p(_bgSize.width*0.5 - 65, 110)

        local jifen = zc.createSprite("res/Main/common/common_icon_jifen_small.png")
        jifen:setPosition(pos)
        bg:addChild(jifen)
        local jifelabel = zc.createLabel({
            text = list[1][1],
            ap = cc.p(0.5,0.5),
            fontSize = 24,
            outLine = true,
            pixel = 2,
            color = display.COLOR_YELLOW,
            pos = cc.p(jifen:getPositionX() + jifen:getContentSize().width ,110),
        })
        bg:addChild(jifelabel)
        self.jifelabel = jifelabel
    end 
    if list[2] then
        local item,info = zc.createIconByData({
            data = {
                mainType = list[2][1],
                type = list[2][2], 
                id = list[2][2],
                num = list[2][3],
            },
            showCount = true,
            scale = 0.4,
            pos = cc.p(_bgSize.width*0.5 + 50, 110), 
        })

        local jifen = zc.createSprite(info.img)
        jifen:setPosition(cc.p(_bgSize.width*0.5 + 50, 110))
        bg:addChild(jifen)
        self.prices = list[2][3]
        local jifelabel = zc.createLabel({
            text = list[2][3],
            ap = cc.p(0.5,0.5),
            fontSize = 24,
            outLine = true,
            pixel = 2,
            color = display.COLOR_YELLOW,
            pos = cc.p(jifen:getPositionX() + jifen:getContentSize().width ,110),
        })
        bg:addChild(jifelabel)
        self.resourcesLabel = jifelabel
    end
    local num = zc.createLabel({
        text = zc.lang("curr_have")..":",
        fontSize = 18,
        ap = cc.p(0, 0.5),
        pos = cc.p(10, 170),
        outLine = true,
        color = display.COLOR_WHITE,
    })
    contentBg:addChild(num)
    local num2 = zc.createLabel({
        text = self._ownNum,
        fontSize = 18,
        ap = cc.p(0, 0.5),
        pos = cc.p(num:getPositionX() + num:getContentSize().width + 10, 170),
        outLine = true,
        color =display.COLOR_YELLOW,
    })
    contentBg:addChild(num2)
    self._num2 = num2
    
    local addBg = zc.createScale9Sprite({
        size = cc.size(360, 65),
        rect = cc.rect(50, 50, 1, 1),
        file = "res/Main/common/img_empty.png",
        pos = cc.p(contentBg:getContentSize().width/2, 40),
    })
    contentBg:addChild(addBg)
    --   -1
    local plusOneBtn = zc.createPushButton({
        normalFile = "res/Main/common/button/common_btn8_u.png",
        selectedFile = "res/Main/common/button/common_btn8_d.png",
        needSwallow = false,
        touchScale = 0.9,
        endCallback = function()
            self:addNum(-1)
        end,
        pos = cc.p(110, addBg:getContentSize().height/2), 
    })
    addBg:addChild(plusOneBtn,2)
    --   +1
    local addOneBtn = zc.createPushButton({
        normalFile = "res/Main/common/button/common_btn2_u.png",
        selectedFile = "res/Main/common/button/common_btn2_d.png",
        needSwallow = false,
        touchScale = 0.9,
        endCallback = function()
            self:addNum(1)
        end,
        pos = cc.p(addBg:getContentSize().width -  110, addBg:getContentSize().height/2), 
    })
    addBg:addChild(addOneBtn,2)
    --   +10
    local subTenBtn = zc.createPushButton({
        normalFile = "res/Main/bag/new/bag_max_btn_u.png",
        selectedFile = "res/Main/bag/new/bag_max_btn_d.png",
        needSwallow = false,
        touchScale = 0.9,
        text = "-10",
        fontSize = 22,
        endCallback = function()
            self:subTenNum()
        end,
        pos = cc.p(45, addBg:getContentSize().height/2), 
    })
    addBg:addChild(subTenBtn,2)

    local addTenBtn = zc.createPushButton({
        normalFile = "res/Main/bag/new/bag_max_btn_u.png",
        selectedFile = "res/Main/bag/new/bag_max_btn_d.png",
        needSwallow = false,
        touchScale = 0.9,
        text = "+10",
        fontSize = 22,
        endCallback = function()
            self:addTenNum()
        end,
        pos = cc.p(addBg:getContentSize().width - 45, addBg:getContentSize().height/2), 
    })
    addBg:addChild(addTenBtn,2)

    local numBg =  zc.createScale9Sprite({
            size = cc.size(120, 40),
            file = "res/Main/bag/new/bag_text_bg_s.png",
            pos = cc.p(addBg:getContentSize().width/2, addBg:getContentSize().height/2),
        })
    addBg:addChild(numBg)
    local num = zc.createLabel({
        text = self._useNum,
        fontSize = 20,
        pos = cc.p(numBg:getContentSize().width/2, numBg:getContentSize().height/2),
        outLine = true,
        color = display.COLOR_YELLOW
    })
    numBg:addChild(num)
    self._num = num
    -- 购买按钮
    local useBtn = zc.createCommomBtn({
        tag = 1,
        pos = cc.p(bg:getContentSize().width/2, 50), 
        text = self._rightBtnText,
        listener = function ()
            if tonumber(self._useNum) <= 0 then
                zc.tipInfo(zc.lang("select_num"))
                return
            end
            local _ownNum = 0
            if tonumber(self._info["itemType"]) == zc.mainTypeResource then
                _ownNum = PlayerData:getResourcesInfoById(self._info["itemId"])
            elseif tonumber(self._info["itemType"]) == zc.mainTypeWeapon then --兵器
                _ownNum = PlayerData:getWeaponNumInBagById(self._info["itemId"])
            elseif tonumber(self._info["itemType"]) == zc.mainTypeProp then
                local itemInfo = PlayerData:getBagInfoByID(self._info["itemId"]) or {}
                _ownNum = itemInfo["num"] or 0 
            end
            self._num2:setString(_ownNum)
            if self._rightFunc then 
                self._rightFunc(self._useNum)
            end
            self:hide()
        end,
    })
    bg:addChild(useBtn)
end
function MorraLayerBuyPop:refreshNum( ... )
    local str = tonumber(self._useNum) * tonumber(self.list[1][1])
    self.jifelabel:setString(str)
    local str1 = tonumber(self._useNum) * tonumber(self.prices)
    self.resourcesLabel:setString(str1)
end

function MorraLayerBuyPop:addNum(addnum)
    self._useNum = self._useNum + addnum
    if self._useNum >= tonumber(self._maxNum) then 
        self._useNum = self._maxNum
    elseif self._useNum < 1 then
        self._useNum = 0
    end
    if self._useNum <= 0 then self._useNum = 1 end
    
    self._num:setText(self._useNum)
    self:refreshNum()
end
function MorraLayerBuyPop:addTenNum()
    if self._maxNum - self._useNum >= 10 then
        self._useNum = self._useNum + 10
    else
        self._useNum = self._maxNum
    end
    self._num:setText(self._useNum)
    self:refreshNum()
end
function MorraLayerBuyPop:subTenNum()
    if self._useNum > 10 then
        self._useNum = self._useNum - 10
    else
        self._useNum = 0
    end
    if self._useNum <= 0 then self._useNum = 1 end
    self._num:setText(self._useNum)
    self:refreshNum()
end
function MorraLayerBuyPop:setMaxNum(maxNum)
    self._useNum = maxNum
    self._num:setText(self._useNum)
    self:refreshNum()
end
function MorraLayerBuyPop:setMinNum(minNum)
    self._useNum = minNum
    self._num:setText(minNum)
    self:refreshNum()
end
return MorraLayerBuyPop