--[[
	充值返利，节节高
]]
local RechargeRewardLayer = class("RechargeRewardLayer", function()
    local layer = cc.Sprite:create()
    layer:setContentSize(975,490)
	return layer
end)

function RechargeRewardLayer:create( params )
	return RechargeRewardLayer.new( params )
end

function RechargeRewardLayer:ctor( params )
	self:initData( params )
    self:initUI()
end

function RechargeRewardLayer:onEnter( ... )
    zc.addEventListener({
        name = CUSTOM_EVENT.EVENT_JIEJIEGAO,
        callback = function(data)
            self:initData(data)
            self._tableview:reloadData()
            self._bottom_tableView:reloadData()
            self:updateUI()
        end
    })
end

function RechargeRewardLayer:onExit( ... )
    zc.removeEventListener( CUSTOM_EVENT.EVENT_JIEJIEGAO )
end

function RechargeRewardLayer:updateUI()
   -- 开头元宝刷新
   local perc = tonumber(self._firstInfo.rebate) or 0  -- 用返回表中的第一个数据，init中
    local posx = 20
    if perc < 10 then
        posx = 50
    end
    self._head_gold_percent:setString(tostring(perc))
    self._head_gold_percent:setPositionX(posx)

   -- 充值总数
   self._num_label:setString(tostring(self._total_num))
end

function RechargeRewardLayer:initData( params )
    self._datas = {}
	local _datas = params.static or {}
    for k,v in pairs(_datas) do
        table.insert(self._datas,v)
    end
    table.sort(self._datas, function ( a, b )
        local id1 = tonumber(a.id) or 0
        local id2 = tonumber(b.id) or 0
        return id1 < id2
    end)

    -- 充值总数
    self._total_num = tonumber(params.totalNums) or 0
    self._received = params.received
    -- dump(self._received, "self._received")
    self._firstInfo = self._datas[1]
    table.remove(self._datas, 1)
    -- dump(self._datas, "数据：")
end

function RechargeRewardLayer:refreshUI(data)
    self:initData(data)
end

function RechargeRewardLayer:initUI( )
	local content_size = self:getContentSize()
	
	local _di = ccui.Scale9Sprite:create(cc.rect(2, 11, 14, 10), "res/Main/activity/rechargeReward/up_big_di.jpg")
    _di:setContentSize(975, 490)
    _di:setAnchorPoint(0, 0)
    _di:setPosition(-10, 19)
    self:addChild(_di)
 	-- 计算cell的大小
    local sprite = zc.createSprite("res/Main/activity/rechargeReward/content_di.png")
    local _cellHeight = sprite:getContentSize().height + 20
    local _cellWidth = sprite:getContentSize().width
    -- tableview
	local tableview = zc.ZCTableView:create(cc.size(_cellWidth, _cellHeight * 3 - 30))
    tableview:setBounceable(true)
    tableview:setInertia(true)
    tableview:setDirection(cc.SCROLLVIEW_DIRECTION_VERTICAL)
    tableview:setPosition(10, content_size.height * 0.5 - 80)
    tableview:setDelegate()
    tableview:setVerticalFillOrder(cc.TABLEVIEW_FILL_TOPDOWN)
    self._tableview = tableview
    local function cellSizeForTable(table, index) 
        return _cellHeight, _cellWidth
    end
    local function tableCellAtIndex(table, index)
        local cell = table:dequeueCell()
        -- 创建模板
        if cell == nil then
            cell = zc.ZCTableViewCell:new()
            self:buildCell( cell, _cellWidth, _cellHeight)
        end
        self:updateCell(cell, index + 1)
        return cell
    end
    local function numberOfCellsInTableView()
    	return #self._datas
    end
    tableview:registerScriptHandler(cellSizeForTable, cc.TABLECELL_SIZE_FOR_INDEX)
    tableview:registerScriptHandler(tableCellAtIndex, cc.TABLECELL_SIZE_AT_INDEX)
    tableview:registerScriptHandler(numberOfCellsInTableView, cc.NUMBER_OF_CELLS_IN_TABLEVIEW)
    _di:addChild(tableview)
    tableview:reloadData()
    self._di = _di
    -- 创建下半部分
    self:createTabForProgress()

    -- 当前充值数
    local _recharge_num_bg = ccui.Scale9Sprite:create(cc.rect(12, 11, 14, 10), "res/Main/role/common/name_bg.png")
    _recharge_num_bg:setContentSize(230,30 )
    _recharge_num_bg:setAnchorPoint(cc.p(1, 0.5))
    _recharge_num_bg:setPosition(cc.p(self:getContentSize().width - 50, -20))
    self:addChild(_recharge_num_bg)

    local _recharge_num_label = zc.createLabel({
        text = zc.lang("active_recharge"),
        fontSize = 19,
        ap = cc.p(0, 0.5),
        pos = cc.p(2, _recharge_num_bg:getContentSize().height * 0.5), 
        color = cc.c3b(255, 242, 199),
        pixel = 2,
        })
    _recharge_num_bg:addChild(_recharge_num_label)

    local num_label = zc.createLabel({
        -- text = "[b]" ..tostring(self._total_num) .. "[/b]",
        text = tostring(self._total_num),
        fontSize = 24,
        ap = cc.p(0, 0.5),
        pixel = 2,
        pos = cc.p(_recharge_num_label:getContentSize().width + _recharge_num_label:getPositionX() + 2, _recharge_num_bg:getContentSize().height * 0.5), 
        })
    _recharge_num_bg:addChild(num_label)
    self._num_label = num_label

    local _yuanbao = zc.createSprite("res/Main/common/common_icon_gold.png")
    _yuanbao:setAnchorPoint(cc.p(0, 0.5))
    _yuanbao:setPosition(cc.p(num_label:getPositionX() + num_label:getContentSize().width + 3 , _recharge_num_bg:getContentSize().height * 0.5))
    _recharge_num_bg:addChild(_yuanbao)
end

function RechargeRewardLayer:buildCell( cell, cellWidth, cellHeight)
	-- 底图
	local _di = zc.createSprite("res/Main/activity/rechargeReward/content_di.png")
    _di:setPosition(cellWidth * 0.5, cellHeight * 0.5)
    cell:addChild(_di)

    -- 元宝数
    local _label_gold = zc.createLabel({
		text = "1111",
		fontSize = 30,
		ap = cc.p(1, 0.5),
		pos = cc.p(_di:getContentSize().width * 0.5 - 180, _di:getContentSize().height * 0.5),
        outLine = true,
	})
	_di:addChild(_label_gold)
    cell._label_gold = _label_gold
	-- 元宝icon
	local _icon_gold = zc.getSprite({
		src = "res/Main/common/common_icon_gold.png",
		ap = cc.p(0, 0.5),
        pos = cc.p(_label_gold:getPositionX() + 10, _di:getContentSize().height * 0.5),
		})
	_di:addChild(_icon_gold)

	-- -- 存放奖励的scrollview
	local _icon_width = 90
    local _icon_height = 90
	-- local _tabSroll = ccui.ScrollView:create()
 --    _tabSroll:setTouchEnabled(true)
 --    _tabSroll:setBounceEnabled(true)
 --    _tabSroll:setContentSize( cc.size(_icon_width * 4, _icon_height) )
 --    _tabSroll:setPosition(cc.p(_icon_gold:getPositionX() + 130, 10 ))
 --    _tabSroll:setDirection(ccui.ScrollViewDir.horizontal)
 --    _tabSroll:setScrollBarEnabled(false)
 --    _tabSroll:setInnerContainerSize( cc.size(_icon_width * 4, _icon_height) )
 --    _di:addChild(_tabSroll)
    local node = cc.Node:create()
    node:setPosition(cc.p(_icon_gold:getPositionX() + 100, 4))
    _di:addChild(node)
    -- 奖励内容
    -- icon
	for i = 1,4 do
		local _icon = zc.createIconByData({
				 data = {
		            mainType = 1,
		            type = 1, 
		            id = 1,
		        },
		        scale = 0.7,
		        pos = cc.p(_icon_width * 0.5 - 10 + (i-1)*_icon_width, _icon_height / 2),
		        showCount = true,
			})
		_icon:setTouchEndedShowTip()
		cell["_icon_"..i] = _icon
		node:addChild(_icon)
	end

	-- -- 领奖按钮
	local _rewardBtn = zc.createCommomBtn({
    	tag = 1,
    	text = zc.lang("fetch_2"),
    	pos = cc.p(_di:getContentSize().width - 100, _di:getContentSize().height * 0.5),
    	endCallback = function() 
        end
    })
    _di:addChild(_rewardBtn)
    cell._rewardBtn = _rewardBtn

   local fetch_sprite = zc.createSprite("res/Main/activity/rechargeReward/reward_fetched.png")
   fetch_sprite:setPosition(_rewardBtn:getPosition())
   fetch_sprite:setVisible(false)
   _di:addChild(fetch_sprite)
   cell._fetch_sprite = fetch_sprite

end

function RechargeRewardLayer:updateCell(cell, index)
	local _info = self._datas[index]
    -- 刷新需要充值的元宝数
    local gold_num = _info.rebateInterval
    cell._label_gold:setString(tostring(gold_num))
    -- 刷新奖励的scrollView
    local tb_data = {}
    local _list = _info.reward
    local _reward_list = string.split(_list, ",")
    for k,v in pairs(_reward_list) do
        local item_info = string.split(v, "|")
        local tb = {}
        tb.mainType = item_info[1]
        tb.type = item_info[2]
        tb.id = item_info[2]
        tb.num = item_info[3]
        table.insert(tb_data, tb)
    end
    for i = 1, 4 do
        local _icon_data = tb_data[i]
        if _icon_data then
            zc.updateIconByData(cell["_icon_"..i], {
                    data = {
                        mainType = tonumber(_icon_data.mainType),
                        type = _icon_data.type,
                        id = tonumber(_icon_data.id),
                        num = tonumber(_icon_data.num),
                    },  
                    showCount = true
                })
            cell["_icon_"..i]:setTouchEndedShowTip()
            cell["_icon_"..i]:setVisible(true)
        else
            cell["_icon_"..i]:setVisible(false)
        end
    end
    -- 领取奖励按钮
    if self._total_num >= tonumber(gold_num) then
        cell._rewardBtn:setString(zc.lang("fetch_2"))
        local flag = false
        for k,v in pairs(self._received) do
            if tonumber(v) == tonumber(_info.id) then
                flag = true
                break
            end
        end
        if flag == false then
            cell._fetch_sprite:setVisible(false)
            cell._rewardBtn:setVisible(true)
            cell._rewardBtn:setTouchEndedCall(function()
                zc.sendHttp({
                        apiName = "rebateReceive",
                        params = {id = _info.id},
                        successCallback = function( backData )
                           -- dump(backData, "领取成功之后：")
                           backData.noAnimation = true
                           PlayerData:updataData( backData )
                           zc.createShowReward( backData )
                           table.insert(self._received,_info.id)
                           cell._fetch_sprite:setVisible(true)
                           cell._rewardBtn:setVisible(false)
                           self._tableview:reloadDataAndScrollToCurrentCell()
                           -- 刷新红点
                           self:refreshRedDot()
                        end
                    })
                    end)
        else
            cell._fetch_sprite:setVisible(true)
            cell._rewardBtn:setVisible(false)
        end
    else 
        -- 这里要将状态变回来，不然会出现前面按钮状态变化，后边也变化的混乱
        cell._fetch_sprite:setVisible(false)
        cell._rewardBtn:setVisible(true)
        cell._rewardBtn:setString(zc.lang("recharge"))
        cell._rewardBtn:setTouchEndedCall(function ()
            LayerManager.removeLayout()
            zc.createRechargePop()
        end)
    end
end

function RechargeRewardLayer:refreshRedDot()
    -- dump(self._received, "刷新红点self._received:")
    local can_fetch_tb = {}
    for k,v in pairs(self._datas) do
        if self._total_num >= tonumber(v.rebateInterval) then
            can_fetch_tb[tostring(v.id)] = 0
        end
    end
    for k,v in pairs(can_fetch_tb) do
        for k1,v1 in pairs(self._received) do
            if tonumber(k) == tonumber(v1) then
                can_fetch_tb[k] = 1
            end
        end
    end
    -- dump(can_fetch_tb, "可以领取整理后：")
    local empty = 1
    for k,v in pairs(can_fetch_tb) do
        if tonumber(v) == 0 then
            empty = 0
            break
        end
    end
    if empty == 1 then
        -- print("刷新红点")
        PlayerData:updateRedDotData(11, 0)
        zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_LIMINT_HOT,data = {id = 28 }})
    else
        -- print("还有奖励没有领取")
    end
    
   
end

function RechargeRewardLayer:createTabForProgress()

    local _bottom_di = zc.getSprite({
        src = "res/Main/activity/rechargeReward/bottom_big_di.png",
        pos = cc.p(0, 0),
        })
    _bottom_di:setAnchorPoint(cc.p(0, 0))
    self._di:addChild(_bottom_di)

    -- 充值返利sprite
    local _desc_sprite = zc.createSprite("res/Main/activity/rechargeReward/reward_disc_title.png")
    _desc_sprite:setPosition(cc.p(50, _bottom_di:getContentSize().height * 0.5 - 7))
    _bottom_di:addChild(_desc_sprite, 5)
    -- tableview
    local tableview = zc.ZCTableView:create(cc.size(820, 130))
    tableview:setBounceable(true)
    tableview:setInertia(true)
    tableview:setDirection(cc.SCROLLVIEW_DIRECTION_HORIZONTAL)
    tableview:setPosition(cc.p(90, 26))
    tableview:setDelegate()
    tableview:setVerticalFillOrder(cc.TABLEVIEW_FILL_TOPDOWN)

    local function buildCell( cell, _cellWidth, _cellHeight )
        -- progress
        local pro_bg = zc.createSprite("res/Main/activity/rechargeReward/progress_head_bg.png")
        pro_bg:setAnchorPoint(cc.p(1, 0.5))
        pro_bg:setPosition(cc.p(_cellWidth, _cellHeight * 0.5))
        cell:addChild(pro_bg)
        cell._pro_bg = pro_bg

        local progressSprite = cc.Sprite:create("res/Main/activity/rechargeReward/progress_head.png")
        local loadingProgress = cc.ProgressTimer:create(progressSprite)
        loadingProgress:setType(cc.PROGRESS_TIMER_TYPE_BAR)
        loadingProgress:setMidpoint(cc.p(0, 0))
        loadingProgress:setBarChangeRate(cc.p(1, 0))
        -- loadingProgress:setPosition(pro_bg:getPosition())
        loadingProgress:setPercentage(0)
        loadingProgress:setAnchorPoint(cc.p(0, 0))
        pro_bg:addChild(loadingProgress)
        cell._pro_gress = loadingProgress
        -- 元宝
        local icon = zc.createSprite("res/Main/vip/icon/1.png")
        icon:setPosition(cc.p(_cellWidth, _cellHeight * 0.5))
        cell:addChild(icon)
        cell._icon = icon

        -- 百分比返利
        local bg_sprite = zc.createSprite("res/Main/activity/rechargeReward/percent_di.png")
        bg_sprite:setPosition(cc.p(icon:getPositionX(), icon:getPositionY() + 45))
        bg_sprite:setScale(0.4)
        cell:addChild(bg_sprite)
        cell._label_percent_bg = bg_sprite
       
        local label_percent = zc.createFntLabel({
            fnt = "res/Main/arena/hallFame/fnt/arenaHallFame_num.fnt",
            text = 100,
            ap = cc.p(0, 0.5),
            pos = cc.p(20, bg_sprite:getContentSize().height * 0.5 + 6),
            addwidth = -6,
        })
        label_percent:setScale( 0.7 )
        bg_sprite:addChild(label_percent)
        cell._label_percent = label_percent

        local label_tag_num = zc.createLabel({
            text = "222",
            pos = cc.p(_cellWidth, 35),
            fontSize = 19,
            outLine = true,
            })
        cell:addChild(label_tag_num)
        cell._label_tag = label_tag_num
    end
    local function updateCell( cell, index )
        cell:setLocalZOrder(1000 - index)
        local _info = self._datas[index]
        if index == 1 then
            cell._pro_bg:setTexture("res/Main/activity/rechargeReward/progress_head_bg.png")
            cell._pro_gress:setSprite(zc.createSprite("res/Main/activity/rechargeReward/progress_head.png"))
        elseif index == #self._datas then
            cell._pro_bg:setTexture("res/Main/activity/rechargeReward/progress_tail_bg.png")
            cell._pro_gress:setSprite(zc.createSprite("res/Main/activity/rechargeReward/progress_tail.png"))
        else
            cell._pro_bg:setTexture("res/Main/activity/rechargeReward/progress_mid_bg.png")
            cell._pro_gress:setSprite(zc.createSprite("res/Main/activity/rechargeReward/progress_mid.png"))
        end
        -- 更新进度条
        local max_recharge_num = tonumber(_info.rechargeAmount)   -- 当前cell最大值
        if self._total_num >= max_recharge_num then
            cell._pro_gress:setPercentage(100)
        else 
            local _pre_info = self._datas[index - 1] or {}
            local _pre_max_num = tonumber(_pre_info.rechargeAmount) or 0
            local qianhou_chazhi = max_recharge_num - _pre_max_num
            local chaochu = self._total_num - _pre_max_num
            if chaochu > 0 then
                local percent = math.floor(chaochu / qianhou_chazhi * 100)
                cell._pro_gress:setPercentage(percent)
            else
                cell._pro_gress:setPercentage(0)
            end
        end
        -- 改变icon的纹理
        if index > 4 then
            cell._icon:setTexture("res/Main/activity/rechargeReward/box_big.png")
            cell._icon:setScale(0.6)
        elseif index > 2 then
            cell._icon:setTexture("res/Main/vip/icon/2.png")
            cell._icon:setScale(1)
        else
            cell._icon:setTexture("res/Main/vip/icon/1.png")
            cell._icon:setScale(1)
        end
    
        -- 将坐标全部变化
        if index == 1 then
            cell._pro_bg:setPositionX(240)
            cell._icon:setPositionX(240)
            cell._label_percent_bg:setPositionX(240)
            cell._label_tag:setPositionX(240)
        elseif index == #self._datas then
            cell._pro_bg:setPositionX(211)
            cell._icon:setPositionX(211)
            cell._label_percent_bg:setPositionX(211)
            cell._label_tag:setPositionX(211)
        else
            cell._pro_bg:setPositionX(165)
            cell._icon:setPositionX(165)
            cell._label_percent_bg:setPositionX(165)
            cell._label_tag:setPositionX(165)
        end
        
        -- 百分比
        local rebate = tonumber(_info.rebate) or 0
        local posx = 20
        if rebate < 10 then
            posx = 50
        end
        cell._label_percent:setString(tostring(rebate))
        cell._label_percent:setPositionX(posx)
        -- 充值数标识
        local rechargeAmount = _info.rechargeAmount or 0
        cell._label_tag:setString(tostring(rechargeAmount))

    end

    local _cellWidth = 165
    local _cellHeight = 130
    local function cellSizeForTable(table, index) 
        if index == (#self._datas - 1) then
            return _cellHeight, 280
        elseif index == 0 then
            return _cellHeight, 240
        end
        return _cellHeight, _cellWidth
    end
    local function tableCellAtIndex(table, index)
        local cell = table:dequeueCell()
        -- 创建模板
        if cell == nil then
            cell = zc.ZCTableViewCell:new()
            buildCell( cell, _cellWidth, _cellHeight)
        end
        updateCell(cell, index + 1)
        return cell
    end
    local function numberOfCellsInTableView()
        return #self._datas
    end
    tableview:registerScriptHandler(cellSizeForTable, cc.TABLECELL_SIZE_FOR_INDEX)
    tableview:registerScriptHandler(tableCellAtIndex, cc.TABLECELL_SIZE_AT_INDEX)
    tableview:registerScriptHandler(numberOfCellsInTableView, cc.NUMBER_OF_CELLS_IN_TABLEVIEW)
    _bottom_di:addChild(tableview)
    tableview:reloadData()
    self._bottom_tableView = tableview

    -- 在开头加一个元宝
    local _head_gold = zc.createSprite("res/Main/vip/icon/1.png")
    _head_gold:setPosition(cc.p(60, tableview:getContentSize().height * 0.5))
    _head_gold:setLocalZOrder(1111)
    tableview:addChild(_head_gold)
    local bg_sprite = zc.createSprite("res/Main/activity/rechargeReward/percent_di.png")
    bg_sprite:setPosition(cc.p(_head_gold:getContentSize().width * 0.5, 85))
    bg_sprite:setScale(0.4)
    _head_gold:addChild(bg_sprite)
    
    local perc = tonumber(self._firstInfo.rebate) or 0  -- 用返回表中的第一个数据，init中
    local posx = 20
    if perc < 10 then
        posx = 50
    end
    local label_percent = zc.createFntLabel({
        fnt = "res/Main/arena/hallFame/fnt/arenaHallFame_num.fnt",
        text = perc,
        ap = cc.p(0, 0.5),
        pos = cc.p(posx, bg_sprite:getContentSize().height * 0.5 + 6),
        addwidth = -6,
    })
    label_percent:setScale( 0.7 )
    self._head_gold_percent = label_percent
    bg_sprite:addChild(label_percent)

    -- 半透明层
    local _gradient_left = zc.createSprite("res/Main/activity/rechargeReward/left_gradient.png")
    _gradient_left:setAnchorPoint(cc.p(0, 0.5))
    _gradient_left:setPosition(cc.p(1, _bottom_di:getContentSize().height * 0.5))
    _gradient_left:setOpacity(120)
    _bottom_di:addChild(_gradient_left)

    local _gradient_right = zc.createSprite("res/Main/activity/rechargeReward/right_gradient.png")
    _gradient_right:setAnchorPoint(cc.p(1, 0.5))
    _gradient_right:setPosition(cc.p(_bottom_di:getContentSize().width - 10, _bottom_di:getContentSize().height * 0.5))
    _gradient_right:setOpacity(120)
    _bottom_di:addChild(_gradient_right)

    -- 左右按钮
   local _leftBtn = zc.createPushButton({
        normalFile = "res/Main/arena/hallFame/arrow_up.png",
        selectedFile = "res/Main/arena/hallFame/arrow_down.png",
        pos = cc.p(_gradient_right:getContentSize().width - 25, _gradient_right:getContentSize().height * 0.5),
        endCallback = function ()
            local page = tableview:getCurrentPage() - 1
            tableview:scrollToCell( page, true )
        end,
    })
    _gradient_left:addChild(_leftBtn)

    local _node1 = zc.createSprite("res/Main/arena/hallFame/arrow_up.png")
    _node1:setFlippedX(true)
    local _node2 = zc.createSprite("res/Main/arena/hallFame/arrow_down.png")
    _node2:setFlippedX(true)
    local _rightBtn = zc.createPushButton({
        normalNode = _node1,
        selectedNode = _node2,
        pos = cc.p(_gradient_right:getContentSize().width - 60, _gradient_right:getContentSize().height * 0.5 + 3),
        endCallback = function ()
            local page = tableview:getCurrentPage() + 1
            tableview:scrollToCell( page, true )
        end,
    })
    _gradient_right:addChild(_rightBtn)

    -- 提示语句
    local _tip_bg = ccui.Scale9Sprite:create(cc.rect(12, 11, 14, 10), "res/Main/role/common/name_bg.png")
    _tip_bg:setContentSize(230,30 )
    _tip_bg:setPosition(cc.p(_bottom_di:getContentSize().width * 0.5, 20))
    _bottom_di:addChild(_tip_bg)
    local tanhao = zc.createSprite("res/Main/activity/rechargeReward/tanhao.png")
    tanhao:setAnchorPoint(cc.p(0, 0.5))
    tanhao:setPosition(cc.p(1, _tip_bg:getContentSize().height * 0.5))
    _tip_bg:addChild(tanhao)

    local _tip = zc.createLabel({
        text = zc.lang("tip_jiejiegao"),
        ap = cc.p(0, 0.5),
        pos = cc.p(tanhao:getPositionX() + tanhao:getContentSize().width + 5, _tip_bg:getContentSize().height * 0.5),
        fontSize = 17,
        pixel = 2,
        color = cc.c3b(235, 210, 129),
        })
    _tip_bg:addChild(_tip)
    _tip_bg:setContentSize(cc.size(tanhao:getContentSize().width + _tip:getContentSize().width + 12, _tip_bg:getContentSize().height))
end
return RechargeRewardLayer