--[[
    FileName: SevenDayPreviewPop.lua
    Author: wangming
    Date: 2017-02-27
    Purpose: 兵器副本主界面
]]
local SevenDayPreviewPop = class( "SevenDayPreviewPop", function ()
    return ZCPopLayer:create()
end)

function SevenDayPreviewPop:create(parmas)
    return SevenDayPreviewPop.new(parmas)
end

function SevenDayPreviewPop:ctor(parmas)
	local _day = tonumber(parmas.day) or 2
	
	local bg = zc.createNormalPop({
        tag = 1,
        width = 460,
        height = 450,
        titleSrc = "res/Main/common/tipTitle/jiangliyulan.png",
    })
    bg:setPosition(zc.width*0.5, zc.height*0.5)
	self:addContent(bg)

	local _bgSize = bg:getContentSize()
	local _bottomBgSize = cc.size(_bgSize.width - 30, 300)
	local _bottomDiSize = cc.size(_bgSize.width , 80)

    local _bottomBg = zc.createGeneralPopScale({
        tag = 3,
        width = _bottomBgSize.width,
        height = _bottomBgSize.height,
    })
    _bottomBg:setAnchorPoint(0.5, 0)
    _bottomBg:setPosition(_bgSize.width*0.5, _bottomDiSize.height - 15)
    bg:addChild(_bottomBg)



    -- loginPreview
    do 
	    local _attrBg = zc.createGeneralPopScale({
	        tag = 2,
	        width = 410,
	        height = 135,
	    })
	    _attrBg:setAnchorPoint(0.5, 1)
	    _attrBg:setPosition(_bottomBgSize.width*0.5, _bottomBgSize.height - 10)
	    _bottomBg:addChild(_attrBg)

		--可能掉落
		local _attrBgSize = _attrBg:getContentSize()
	    local drop = zc.getSprite({
	        src = "res/Main/activity/sevenDay/loginPreview.png",
	        pos = cc.p(_attrBgSize.width*0.5, _attrBgSize.height - 20)
	    })
	    _attrBg:addChild(drop)

	    local _titleLabSize = drop:getContentSize()
	    local _titleLeftSp = zc.getSprite({
	        src = "res/Main/common/lace.png",
	        ap = cc.p(1, 0.5),
	        pos = cc.p(drop:getPositionX() - _titleLabSize.width*0.5 - 10, drop:getPositionY()),
	    })
	    _attrBg:addChild(_titleLeftSp)

	    local _titleRightSp = zc.getSprite({
	        src = "res/Main/common/lace.png",
	        ap = cc.p(1, 0.5),
	        pos = cc.p(drop:getPositionX() + _titleLabSize.width*0.5 + 10, drop:getPositionY()),
	    })
	    _titleRightSp:setScaleX(-1)
	    _attrBg:addChild(_titleRightSp)

	    local _dbLogin = gameData.getDataFromCache("preview", {day = _day, type = 1})
	    local _info = string.split(_dbLogin.reward or "", ",")
	    local _dropInfo = {}
	    for i=1,#_info do
	    	local _tmp = string.split(_info[i] or "", "|")
	    	table.insert(_dropInfo, _tmp)
	    end
	    
	    local dropScrollView = zc.createScrollview({
	    	pos = cc.p(0,0),
	        size = cc.size(405, 120),
	        innerSize = cc.size(90*(#_dropInfo), 120),
	        dir = ccui.ScrollViewDir.horizontal,
	        bar = false,
	        bounceEnable = true,
	    })
	    _attrBg:addChild(dropScrollView)

	    for i=1, #_dropInfo do 
	        local item = zc.createIconByData({
	            data = {
	                mainType = _dropInfo[i][1],
	                type = _dropInfo[i][2], 
	                id = _dropInfo[i][2],
	            }, 
	            pos = cc.p((i-1/2)*90, 53), 
	        })
	        item:setScale(0.68)
	        dropScrollView:addChild(item)
	        item:setTouchEndedShowTip()
	    end
	end

	do 
	    local _attrBg = zc.createGeneralPopScale({
	        tag = 2,
	        width = 410,
	        height = 135,
	    })
	    _attrBg:setAnchorPoint(0.5, 1)
	    _attrBg:setPosition(_bottomBgSize.width*0.5, _bottomBgSize.height - 152)
	    _bottomBg:addChild(_attrBg)

		--可能掉落
		local _attrBgSize = _attrBg:getContentSize()
	    local drop = zc.getSprite({
	        src = "res/Main/activity/sevenDay/taskPreview.png",
	        pos = cc.p(_attrBgSize.width*0.5, _attrBgSize.height - 20)
	    })
	    _attrBg:addChild(drop)

	    local _titleLabSize = drop:getContentSize()
	    local _titleLeftSp = zc.getSprite({
	        src = "res/Main/common/lace.png",
	        ap = cc.p(1, 0.5),
	        pos = cc.p(drop:getPositionX() - _titleLabSize.width*0.5 - 10, drop:getPositionY()),
	    })
	    _attrBg:addChild(_titleLeftSp)

	    local _titleRightSp = zc.getSprite({
	        src = "res/Main/common/lace.png",
	        ap = cc.p(1, 0.5),
	        pos = cc.p(drop:getPositionX() + _titleLabSize.width*0.5 + 10, drop:getPositionY()),
	    })
	    _titleRightSp:setScaleX(-1)
	    _attrBg:addChild(_titleRightSp)


	    local _dbTask = gameData.getDataFromCache("preview", {day = _day, type = 2})
	    local _info = string.split(_dbTask.reward or "", ",")
	    local _dropInfo = {}
	    for i=1,#_info do
	    	local _tmp = string.split(_info[i] or "", "|")
	    	table.insert(_dropInfo, _tmp)
	    end
	    local dropScrollView = zc.createScrollview({
	    	pos = cc.p(0,0),
	        size = cc.size(405, 120),
	        innerSize = cc.size(90*(#_dropInfo), 120),
	        dir = ccui.ScrollViewDir.horizontal,
	        bar = false,
	        bounceEnable = true,
	    })
	    _attrBg:addChild(dropScrollView)

	    for i=1, #_dropInfo do 
	        local item = zc.createIconByData({
	            data = {
	                mainType = _dropInfo[i][1],
	                type = _dropInfo[i][2], 
	                id = _dropInfo[i][2],
	            }, 
	            pos = cc.p((i-1/2)*90, 53), 
	        })
	        item:setScale(0.68)
	        dropScrollView:addChild(item)
	        item:setTouchEndedShowTip()
	    end
	end


    local _bottomDi = ccui.Scale9Sprite:create(cc.rect(20, 10, 549, 71), "res/Main/role/trinket/sellDi.png")
    _bottomDi:setContentSize(_bottomDiSize)
    _bottomDi:setPosition(-2, -5) 
    _bottomDi:setAnchorPoint(0, 0)
    bg:addChild(_bottomDi)

    local _leftTipSize = cc.size(380, 33)
    local _leftTipDi = zc.getScaleNode("res/Main/role/common/name_bg.png", _leftTipSize)
	_leftTipDi:setPosition(_bottomDiSize.width*0.5, _bottomDiSize.height*0.5)
	_bottomDi:addChild(_leftTipDi)

	cc.SpriteFrameCache:getInstance():addSpriteFrames("res/Main/home/homeUI.plist", "res/Main/home/homeUI.pvr.ccz")

    local _leftTipImg1 = zc.getSprite({
        src = "home_icon_info.png",
        plist = true,
        ap = cc.p(0, 0.5),
        pos = cc.p(0, _leftTipSize.height*0.5),
        scale = 0.5,
    })
    _leftTipDi:addChild(_leftTipImg1)

    local _leftTipLab1 = zc.createLabel({
		text = zc.lang("tips_sevenday"),
        fontSize = 20,
        ap = cc.p(0, 0.5),
        pos = cc.p(_leftTipImg1:getBoundingBox().width, _leftTipSize.height*0.5),
        color = cc.c3b(255, 229, 200),
        outLine = true,
    })
    _leftTipDi:addChild(_leftTipLab1)


    self:show()
end



return SevenDayPreviewPop