--[[
    FileName: GodFightListLayer.lua
    Author: wangming
    Date: 2017-03-10
    Purpose: 武神榜购买次数
]]
local GodFightBuyPop = class("GodFightBuyPop",function()
    return ZCPopLayer:create()
end)

function GodFightBuyPop:create(data)
    return GodFightBuyPop.new(data)
end

function GodFightBuyPop:ctor(data)
    self._fightTimes = tonumber(data.fightTimes) or 0
    self._times = tonumber(data.times) or 0
    self._consumeType = 59
    self._callback = data.callback
    self._cost = 0
    self._myGold = zc.getNumByTypeId(zc.mainTypeResource, zc.dataTypeGold)

    self._costDatas = gameData.getDataFromCache("consume_price", {type=self._consumeType})
    table.sort(self._costDatas, function( a, b )
        local _subtypeA = tonumber(a.subtype) or 0
        local _subtypeB = tonumber(b.subtype) or 0
        return _subtypeA < _subtypeB
    end)
    self._buyNum = 0

    self:initUI()
    self:addNum(1)
    self:show()
end

function GodFightBuyPop:initUI()
    local bg = zc.getSprite({
        src = "res/Main/common/popBg/popup_Bg_blue.png",
        pos = cc.p(zc.width/2, zc.height/2)
    })
    self:addContent(bg)
    local _bgSize = bg:getContentSize()

    local titleLab = zc.getTipPopTitle("goumai")
    titleLab:setPosition( _bgSize.width/2, _bgSize.height - 30 )
    bg:addChild(titleLab, 2)
        
    local contentBg = zc.getScaleNode("res/Main/common/popBg/di_1.png", cc.size(460, 200))
    contentBg:setPosition(_bgSize.width*0.5, _bgSize.height*0.5 + 30)
    bg:addChild(contentBg)

    local backButton = zc.createBackButton({
        pos = cc.p(bg:getContentSize().width-10, bg:getContentSize().height-10),
        listener = function () 
            self:hide({noAction = true})
        end,
    })
    bg:addChild(backButton)

    local _contentSize = contentBg:getContentSize()
   
    local name = zc.createLabel({
        text = zc.lang("godfight_nums"),
        fontSize = 28,
        pos = cc.p(_contentSize.width*0.5, _contentSize.height*0.5 + 20),
        outLine = true,
        color = display.COLOR_YELLOW,
    })
    contentBg:addChild(name)

    local ownLabel = zc.createLabel({
        text = zc.lang("curr_have")..":",
        fontSize = 20,
        ap = cc.p(0, 0.5),
        pos = cc.p(10, _contentSize.height - 20),
        outLine = true,
    })
    contentBg:addChild( ownLabel )
    local ownNum = zc.createLabel({
        text = self._fightTimes,
        fontSize = 20,
        ap = cc.p(0, 0.5),
        pos = cc.p(ownLabel:getPositionX() + ownLabel:getContentSize().width + 10, ownLabel:getPositionY()),
        outLine = true,
        color = display.COLOR_YELLOW,
    })
    contentBg:addChild( ownNum )
    self._ownNum = ownNum
    
    local addBg = cc.Node:create()
    addBg:setAnchorPoint(0.5, 0.5)
    addBg:setContentSize(360, 65)
    addBg:setPosition(bg:getContentSize().width/2, 170)
    bg:addChild( addBg )
    --   -1
        local plusOneBtn = zc.createPushButton({
        normalFile = "res/Main/common/button/common_btn8_u.png",
        selectedFile = "res/Main/common/button/common_btn8_d.png",
        needSwallow = false,
        touchScale = 0.9,
        endCallback = function()
            self:addNum(-1)
        end,
        pos = cc.p(110, addBg:getContentSize().height/2), 
    })
    addBg:addChild(plusOneBtn,2)
    local subTenBtn = zc.createPushButton({
        normalFile = "res/Main/bag/new/bag_max_btn_u.png",
        selectedFile = "res/Main/bag/new/bag_max_btn_d.png",
        needSwallow = false,
        touchScale = 0.9,
        text = "-10",
        endCallback = function()
            self:addNum(-10) 
        end,
        pos = cc.p(45, addBg:getContentSize().height/2), 
    })
    addBg:addChild(subTenBtn, 2)

    --   +1
    local addOneBtn = zc.createPushButton({
        normalFile = "res/Main/common/button/common_btn2_u.png",
        selectedFile = "res/Main/common/button/common_btn2_d.png",
        needSwallow = false,
        touchScale = 0.9,
        endCallback = function()
            self:addNum(1)
        end,
        pos = cc.p(addBg:getContentSize().width -  110, addBg:getContentSize().height/2), 
    })
    addBg:addChild(addOneBtn,2)
    --   +10
    local addTenBtn = zc.createPushButton({
        normalFile = "res/Main/bag/new/bag_max_btn_u.png",
        selectedFile = "res/Main/bag/new/bag_max_btn_d.png",
        needSwallow = false,
        touchScale = 0.9,
        text = "+10",
        endCallback = function()
            self:addNum(10) 
        end,
        pos = cc.p(addBg:getContentSize().width - 45, addBg:getContentSize().height/2), 

    })
    addBg:addChild(addTenBtn,2)

    local numBg =  zc.createScale9Sprite({
        size = cc.size(120, 40),
        file = "res/Main/bag/new/bag_text_bg_s.png",
        pos = cc.p(addBg:getContentSize().width/2, addBg:getContentSize().height/2),
    })
    addBg:addChild( numBg )
    local numLabel = zc.createLabel({
        text = self._buyNum,
        fontSize = 20,
        ap = cc.p(0.5, 0.5),
        pos = cc.p(numBg:getContentSize().width/2, numBg:getContentSize().height/2),
        outLine = true,
        color = display.COLOR_YELLOW
    })
    numBg:addChild( numLabel )
    self._numLabel = numLabel
    
    -- 价格
    local _plusW = 30
    local _plusH = 40
    local priceImg = zc.createImageView({
        src = zc.getImgByType( 1 ),
        pos = cc.p( 200 + _plusW, 75  + _plusH),
        scale = 0.9
    })
    bg:addChild( priceImg )
    local priceNum = zc.createLabel({
        text = self._cost,
        fontSize = 22,
        ttf = zc.getFont(1),
        ap = cc.p(0, 0.5),
        pos = cc.p(230 + _plusW, 75 + _plusH),
        outLine = true,
        color = display.COLOR_YELLOW,
    })
    bg:addChild( priceNum )
    self._priceNum = priceNum


    -- 购买按钮
    local buyBtn = zc.createCommomBtn({
        tag = 1,
        pos = cc.p(bg:getContentSize().width/2, 30 + _plusH), 
        text = LANGUAGE_SHOP.buy,
        listener = function()
            self._callback(self._buyNum)
            self:hide()
        end,
    })
    bg:addChild( buyBtn )
    self._buyBtn = buyBtn
end

function GodFightBuyPop:addNum(addnum)
    if self._cost > self._myGold and addnum > 0 then
        zc.tipInfo(zc.getNameById(zc.dataTypeGold) .. zc.lang("un_enough") .."！")
        return
    end
    if addnum == 10 and self._buyNum == 1 then
        addnum = 9
    end
    self._buyNum = self._buyNum + addnum
    if self._buyNum < 1 then
        self._buyNum = 1
    end
    self._numLabel:setText( self._buyNum )

    local _cost = 0
    for i = 1, self._buyNum do
        local _toBuyTime = self._times + i
        local _data = self._costDatas[_toBuyTime]
        if not _data then
            _data = self._costDatas[#self._costDatas]
        end
        _data = _data or {}
        local _price = tonumber(_data.price) or 0
        _cost = _cost + _price
    end
    self._cost = _cost
    self._priceNum:setText(self._cost)
    if self._cost > self._myGold then
        self._priceNum:setColor(display.COLOR_RED)
        self._buyBtn:setEnable(false)
    else
        self._priceNum:setColor(display.COLOR_YELLOW)
        self._buyBtn:setEnable(true)
    end
end

return GodFightBuyPop