--  Created by wangming on 17-02-24.
local shixiangnubing = class("shixiangnubing", function ( params )
	local hero = BattleHero.new(params)
	return hero
end)

function shixiangnubing:create(params)
	return shixiangnubing.new(params)
end

function shixiangnubing:doAttack(params)
	local skillType 	= params.skillType
	local process 		= params.process
	local evt     		= params.evt
	local hurtTargets   = params.hurtTargets

	local runningScene 	= cc.Director:getInstance():getRunningScene()

	if skillType == BATTLE_SKILL_TYPE.ATK then
		for k,hero in pairs(hurtTargets) do
			local point = hero:getSlotPositionInNode(BATTLE_BONE_NAME.MID, runningScene)
		    local armature = zc.battle.createBattleEffect({fileName = "shixiangnubing", actName = "atk_1", loop = true, moveCallback = function (armatureBack,movementType,movementID)
                if movementType == ccs.MovementEventType.complete and (movementID == "atk_2") then
                    xpcall(function() armatureBack:removeFromParent() end, function ()
                        print("armatureBack已被删除")
                    end)
                end
            end})
		    armature:setPosition(self:getSlotPositionInNode(BATTLE_BONE_NAME.MID, runningScene))
		    if self:getSide() == BATTLE_SIDE.LEFT then
		    	armature:setScaleX(-1 * armature:getScaleX())
		    end
		    local _arrow = armature
			--起始位置
			local _targetSlot    	= cc.p(self:getPositionX(),self:getPositionY())
			--目标位置
			local endPos 			= point
			--计算角度
			-- 判定斜率,非弓箭状态
			local deltaY = endPos.y - _targetSlot.y;
			local deltaX = endPos.x - _targetSlot.x;
			local angel = deltaX > 0 and 0 or 180;
			local K = deltaY / deltaX;
			if deltaX ~= 0 then
				_arrow:setRotation(angel-CC_RADIANS_TO_DEGREES(math.atan(K)));
			end
			local pos_delta = cc.pGetDistance(endPos, _targetSlot)
			local dt = zc.getDynamicTime(pos_delta, 4000)

			_arrow:runAction(cc.Sequence:create(cc.MoveTo:create(dt,endPos),cc.CallFunc:create(function()
				armature:getAnimation():play("atk_2")
				self:doHurt(params)
			end)))
			zc.dispatchEvent({
				name = EVENT_NAME_BATTLE_PLAY_EFFECT,
				data = {node = _arrow, zorder = hero:getLocalZOrder() + 1},
			})
		end
	else
		self:doHurt(params)
	end
end

function shixiangnubing:preAttack(params)
	local skillType 	= params.skillType
	local firstTarget   = params.firstTarget

    local runningScene = cc.Director:getInstance():getRunningScene()

	if skillType == BATTLE_SKILL_TYPE.SUPER then--3.士气技能 大招
	    local armature = zc.battle.createBattleEffect({fileName = "shixiangnubing", actName = "atk3_1", loop = false, moveCallback = function (armatureBack,movementType,movementID)
            if movementType == ccs.MovementEventType.complete and (movementID == "atk3_1") then
                xpcall(function() armatureBack:removeFromParent() end, function ()
                    print("armatureBack已被删除")
                end)
            end
        end})
	    armature:setPosition(firstTarget:getSlotPositionInNode(BATTLE_BONE_NAME.ROOT, runningScene))
	    if self:getSide() == BATTLE_SIDE.LEFT then
	    	armature:setScaleX(-1 * armature:getScaleX())
	    end
		zc.dispatchEvent({
			name = EVENT_NAME_BATTLE_PLAY_EFFECT,
			data = {node = armature, zorder = firstTarget:getLocalZOrder() + 1},
		})
    end
end

function shixiangnubing:showDefenseEffect(params)
	local hero 		= params.hero
	hero:playAction(BATTLE_ANIMATION_ACTION.DEFENSE)
end

function shixiangnubing:getSkillHurtCount(skillType)
	local count = 1
	if skillType == 1 then
		count = 1
	elseif skillType == 3 then
		count = 5
	end
	return count
end

function shixiangnubing:shouldMoveAttack(atkName)
	local ret = false
	return ret
end

return shixiangnubing




