
-- 
local yangxiu = class("yangxiu", function ( params )
	local hero = BattleHero.new(params)
	return hero
end)

function yangxiu:create(params)
	return yangxiu.new(params)
end

function yangxiu:getSkillHurtCount(skillType)
	local count = 1
	if skillType == BATTLE_SKILL_TYPE.SUPER then
		count = 7
	elseif skillType == BATTLE_SKILL_TYPE.ATK0 then
		count = 3
	end
	return count
end

 -- ATK         = 1,--[[普通攻击]]
 --    ATK0        = 2,
 --    SUPER       = 3,--[[大招]]
 --    FIT         = 4,--[[合体技开始]]

function yangxiu:getAttackPoint(skillType,targetHero)

	-- dump(self:getInitialPoint())

	print("skillType: " .. skillType)
	local rect 			= BATTLE_BONE_NAME.RECT_ATK
	if skillType == 1 then --1.普通攻击
    elseif skillType == 2 then --2.小技能 
        rect 			= BATTLE_BONE_NAME.RECT_ATK0
    elseif skillType == 3 then--3.士气技能 大招
        rect 			= BATTLE_BONE_NAME.RECT_SUPER
    elseif skillType == 4 then
        --4.合体技
    end
    local runningScene 		= cc.Director:getInstance():getRunningScene()
	local y 				= targetHero:getPositionY()
	local denfenser_point 	= targetHero:getSlotPositionInNode(BATTLE_BONE_NAME.MID,runningScene)
	-- dump(denfenser_point,"denfenser_point")
	local attackerMidBox	= self:getBoneBoundingBoxByName(rect)
	local x 				= denfenser_point.x - attackerMidBox.width/2
	if self:getSide() == BATTLE_SIDE.RIGHT then
		x 					= denfenser_point.x + attackerMidBox.width/2
	end
	local pos 				= cc.p(x,y)
	--[[大招单独处理]]
	-- if skillType == 3 then
	--     local tmp_side 	= self:getSide()
	--     local _pos		= zc.battle.getInitialMatrixPoint({side = tmp_side , position = 5})
	--     pos.y 			= _pos.y
	-- end

	return pos
end

-- function yangxiu:isSkillEventAllDone(skillType,evt)
-- 	local ret = true
-- 	-- if skillType == 3 then
-- 	-- 	if not string.find(evt,"hit3") then
-- 	-- 		ret = false
-- 	--     end 
-- 	-- end
-- 	return ret
-- en

function yangxiu:doAttack(params)
	local skillType 	= params.skillType
	local process 		= params.process
	local evt     		= params.evt
	local hurtTargets   = params.hurtTargets
	local runningScene 	= cc.Director:getInstance():getRunningScene()

	if skillType == BATTLE_SKILL_TYPE.ATK then
		for k,hero in pairs(hurtTargets) do
			local point = hero:getSlotPositionInNode(BATTLE_BONE_NAME.MID, runningScene)
		    local armature = zc.battle.createBattleEffect({fileName = "yangxiu", actName = "atk_zidan", loop = false, moveCallback = function (armatureBack,movementType,movementID)
                if movementType == ccs.MovementEventType.complete and (movementID == "atk_shouji") then
                    xpcall(function() armatureBack:removeFromParent() end, function ()
                        print("armatureBack已被删除")
                    end)
                end
            end, eventCallback = function(bone, evt, originFrameIndex, currentFrameIndex)
            	if self:isAttackEvent(evt) and hero == hurtTargets[1] then
            		params.evt = evt
					self:doHurt(params)
            	end
            end})
		    armature:setPosition(self:getSlotPositionInNode(BATTLE_BONE_NAME.MID, runningScene))
		    if self:getSide() == BATTLE_SIDE.LEFT then
		    	armature:setScaleX(-1 * armature:getScaleX())
		    end
		    local _arrow = armature
			--起始位置
			local _targetSlot    	= cc.p(self:getPositionX(),self:getPositionY())
			--目标位置
			local endPos 			= point
			--计算角度
			-- 判定斜率,非弓箭状态
			local deltaY = endPos.y - _targetSlot.y;
			local deltaX = endPos.x - _targetSlot.x;
			local angel = deltaX > 0 and 0 or 180;
			local K = deltaY / deltaX;
			if deltaX ~= 0 then
				-- _arrow:setRotation(angel-CC_RADIANS_TO_DEGREES(math.atan(K)));
			end
			local pos_delta = cc.pGetDistance(endPos, _targetSlot)
			local dt = zc.getDynamicTime(pos_delta, 4000)

			_arrow:runAction(cc.Sequence:create(cc.MoveTo:create(dt,endPos),cc.CallFunc:create(function()
				armature:getAnimation():play("atk_shouji")
			end)))
			zc.dispatchEvent({
				name = EVENT_NAME_BATTLE_PLAY_EFFECT,
				data = {node = _arrow, zorder = hero:getLocalZOrder() + 1},
			})
		end
	elseif skillType == BATTLE_SKILL_TYPE.SUPER then
		for k,hero in pairs(hurtTargets) do
			local point = hero:getSlotPositionInNode(BATTLE_BONE_NAME.ROOT, runningScene)
		    local armature = zc.battle.createBattleEffect({fileName = "yangxiu", actName = "atk3_01", loop = false, moveCallback = function (armatureBack,movementType,movementID)
                if movementType == ccs.MovementEventType.complete then
                    xpcall(function() armatureBack:removeFromParent() end, function ()
                        print("armatureBack已被删除")
                    end)
                end
            end, eventCallback = function(bone, evt, originFrameIndex, currentFrameIndex)
            	if self:isAttackEvent(evt) and hero == hurtTargets[1] then
            		params.evt = evt
					self:doHurt(params)

					if string.find(evt, "1") then
						local armature_xue = zc.battle.createBattleEffect({fileName = "yangxiu_jiaxue" , actName = "atk3_jiaxue", loop = false, autoRemove = true})
						topPoint = self:getSlotPositionInNode(BATTLE_BONE_NAME.ROOT, self:getArmature())
						armature_xue:setPosition(topPoint)
						self:getRectBuffNode():addChild(armature_xue)
					end
            	end
            end})
		    armature:setPosition(self:getSlotPositionInNode(BATTLE_BONE_NAME.ROOT, runningScene))
		    if self:getSide() == BATTLE_SIDE.LEFT then
		    	armature:setScaleX(-1 * armature:getScaleX())
		    end
		    local _arrow = armature
			-- --起始位置
			-- local _targetSlot    	= cc.p(self:getPositionX(),self:getPositionY())
			-- --目标位置
			local endPos 			= point
			-- --计算角度
			-- -- 判定斜率,非弓箭状态
			-- local deltaY = endPos.y - _targetSlot.y;
			-- local deltaX = endPos.x - _targetSlot.x;
			-- local angel = deltaX > 0 and 0 or 180;
			-- local K = deltaY / deltaX;
			-- if deltaX ~= 0 then
			-- 	-- _arrow:setRotation(angel-CC_RADIANS_TO_DEGREES(math.atan(K)));
			-- end
			-- local pos_delta = cc.pGetDistance(endPos, _targetSlot)
			-- local dt = zc.getDynamicTime(pos_delta, 4000)
			_arrow:setPosition(endPos)
			-- _arrow:runAction(cc.Sequence:create(cc.MoveTo:create(dt,endPos),cc.CallFunc:create(function()
			-- 	armature:getAnimation():play("atk_shouji")
			-- end)))
			zc.dispatchEvent({
				name = EVENT_NAME_BATTLE_PLAY_EFFECT,
				data = {node = _arrow, zorder = hero:getLocalZOrder() + 1},
			})
		end
	else
		self:doHurt(params)
	end
end

function yangxiu:showDefenseEffect(params)
	-- print("xuhaung:showDefenseEf")
	-- dump(params)

	local skillType = params.skillType
	local hero 		= params.hero

    -- if skillType == BATTLE_SKILL_TYPE.ATK0 then
    -- 	-- hero:playAction(BATTLE_ANIMATION_ACTION.DEFENSE)
    -- else
	    hero:playAction(BATTLE_ANIMATION_ACTION.DEFENSE)
	-- end
end

function yangxiu:shouldMoveAttack(atkName)
	local ret = true
	if atkName == BATTLE_ANIMATION_ACTION.ATK or atkName == BATTLE_ANIMATION_ACTION.SUPER then
		ret = false
	end
	return ret
end


return yangxiu