--  Created by zhangchao on 16-08-04.
local zhangzhao = class("zhangzhao", function ( params )
	local hero = BattleHero.new(params)
	return hero
end)

function zhangzhao:create(params)
	return zhangzhao.new(params)
end

function zhangzhao:shouldMoveAttack(atkName)
	local ret = true
	if atkName == BATTLE_ANIMATION_ACTION.ATK then
		ret = false
	elseif atkName == BATTLE_ANIMATION_ACTION.FIT_START then
		ret = false
	end
	return ret
end

function zhangzhao:getSkillHurtCount(skillType)
	local count = 1
	if skillType == 2 then
		count = 4
	elseif skillType == 3 then
		count = 15
	elseif skillType == 4 then
		count = 12
	end
	return count
end

function zhangzhao:doAttack(params)
	local skillType 	= params.skillType
	local evt     		= params.evt
	local hurtTargets   = params.hurtTargets

	local runningScene 	= cc.Director:getInstance():getRunningScene()
	if skillType == BATTLE_SKILL_TYPE.ATK then
		if evt == "do_atk_hit" then
			local flag = 0
			local ret = self:isSkillEventAllDone(skillType,evt)
			for k,hero in pairs(hurtTargets) do
				local point  		= hero:getSlotPositionInNode(BATTLE_BONE_NAME.MID,runningScene)
				local armature = zc.battle.createBattleEffect({
					fileName = "zhangzhao",
					actName = "atk_1",
					autoRemove = false,
					moveCallback = function (armatureBack,movementType,movementID)
		                if movementType == ccs.MovementEventType.complete and (movementID == "atk_2" ) then
		                    xpcall(function() armatureBack:removeFromParent() end, function ()
		                            print("armatureBack已被删除")
		                        end)
		                end
		            end
				})
			    armature:setPosition(self:getSlotPositionInNode(BATTLE_BONE_NAME.MID,runningScene))
			    local _arrow = armature
				--起始位置
				local _targetSlot    	= cc.p(self:getPositionX(),self:getPositionY())
				--目标位置
				local endPos 			= point
				--计算角度
				-- 判定斜率,非弓箭状态
				local deltaY = endPos.y - _targetSlot.y;
				local deltaX = endPos.x - _targetSlot.x;
				local angel = deltaX > 0 and 0 or 180;
				local K = deltaY / deltaX;
				if deltaX ~= 0 then
					_arrow:setRotation(angel-CC_RADIANS_TO_DEGREES(math.atan(K)));
				end
				local pos_delta = cc.pGetDistance(endPos, _targetSlot)
				local dt = zc.getDynamicTime(pos_delta, 2000)
				flag = flag + 1
				local _tmp_ = flag
				_arrow:runAction(
					cc.Sequence:create(
						cc.MoveTo:create(dt,endPos),
						cc.CallFunc:create(function()
							_arrow:getAnimation():play( "atk_2" )
				    		if ret and _tmp_ == table.nums(hurtTargets) then
				    			self:doHurt(params)
				    		end
			    		end)
		    		)
				)
				zc.dispatchEvent({
					name = EVENT_NAME_BATTLE_PLAY_EFFECT,
					data = {node = _arrow, zorder = hero:getLocalZOrder() + 1},
				})
			end
		else
			self:doHurt(params)
		end
	else
		self:doHurt(params)
	end
end

function zhangzhao:getFitSkillSrc()
	local fitSrc = {
		-- 技能名动画
		beijing = "cybejing",
		skeletonActName = "zhangzhao",
		name = "zhangzhao",
		-- 合体技特效
		fileName = "zhangzhao_fit2",
		actName = "Fit_2",
	}
	return fitSrc
end

function zhangzhao:getFitSkillPos( params )
	local armature = params.armature
	local firstTarget = params.firstTarget
	
    local tmp_side 	= self:getSide()
    if tmp_side == BATTLE_SIDE.LEFT then
    	tmp_side = BATTLE_SIDE.RIGHT
    else
    	tmp_side = BATTLE_SIDE.LEFT
    end
    local position = 5
    if firstTarget then
    	position = firstTarget:getBattlePosition()
    end
	local pos 		= zc.battle.getInitialMatrixPoint({side = tmp_side , position = position})
	pos.y 			= zc.battle.getInitialMatrixPoint({side = tmp_side , position = 5}).y
    armature:setPosition(pos)
    if self:getSide() == BATTLE_SIDE.RIGHT then
    	armature:setScaleX(-1 * armature:getScaleX())
    end
end

function zhangzhao:showDefenseEffect(params)
	local skillType = params.skillType
	local hero 		= params.hero
	if skillType == 2 then
		self:showCommonDefenseEffect(params)
	elseif skillType == 4 then
		local armature = zc.battle.createBattleEffect({fileName = "zhangzhao_fit2", actName = "hit"})
		local runningScene 	= cc.Director:getInstance():getRunningScene()
		armature:setPosition(hero:getSlotPositionInNode(BATTLE_BONE_NAME.MID,runningScene))
		zc.dispatchEvent({
			name = EVENT_NAME_BATTLE_PLAY_EFFECT,
			data = {node = armature, zorder = hero:getLocalZOrder() + 100},
		})
		hero:playAction(BATTLE_ANIMATION_ACTION.DEFENSE)
	else
		hero:playAction(BATTLE_ANIMATION_ACTION.DEFENSE)
	end
end

return zhangzhao