--[[
	通用的规则说明
	唐实聪
	2016.3.24
	传入{inde = }，在language里配置标题和说明文字
	1 	演武榜
	2 	武将升星
	3 	群雄
	4 	押镖
]]
local RulePop = class("RulePop", function()
	return ZCPopLayer:create()
end)

function RulePop:create( params )
	return self.new( params )
end

function RulePop:ctor( params )
	self:show()
	self:initData( params )
	self:initUI()
end
function RulePop:initData( params )
	local index = params.index or 1
	local data = gameData.getDataFromCacheWithPrimaryKey("instructions", index) or {}
	
	self._title = data.name
	self._desc = string.split( data.content, "#" )
	self._width = tonumber( data.wide ) or 397
	self._height = tonumber( data.long ) or 397

	if index == 6 then
		local optherInfo = params.otherInfo or {}
		self._desc = LANGUAGE_GET_RULE_SHULIANDU(self._desc,optherInfo.str1,optherInfo.str2,optherInfo.str3)
	end
end

function RulePop:initUI()
	-- 背景
	local ruleBg = ccui.Scale9Sprite:create( cc.rect( 15, 15, 70, 70 ), "res/Main/common/common_inner17.png" )
	ruleBg:setContentSize( self._width, self._height )
	ruleBg:setPosition( self:getContentSize().width/2, self:getContentSize().height/2 )
	self:addContent( ruleBg )
	
	-- 标题
	local title = zc.createRichLabel({
		text = self._title,
		fontSize = 22,
        color = display.COLOR_YELLOW,
        stroke = true,
        pixel = 3,
        pos = cc.p( ruleBg:getContentSize().width/2, ruleBg:getContentSize().height - 33 ),
	})
	ruleBg:addChild( title )

	-- 分隔线
	local ruleSplit = ccui.Scale9Sprite:create( cc.rect( 0, 0, 1, 2 ), "res/Main/common/spline.png" )
	ruleSplit:setContentSize( ruleBg:getContentSize().width - 18, 5 )
	ruleSplit:setPosition( ruleBg:getContentSize().width/2, ruleBg:getContentSize().height - 65 )
	ruleBg:addChild( ruleSplit )

	-- 说明
	local descHeight = 0
	local descInfo = {}
	for i = #self._desc, 1, -1 do
		descInfo[i] = {}
		-- 文字
		local descLabel = zc.createRichLabel({
			text = self._desc[i],
			fontSize = 20,
	        stroke = true,
	        pixel = 3,
	        alignment = cc.TEXT_ALIGNMENT_LEFT,
	        width = self._width - 47,
	        ap = cc.p( 0, 1 ),
		})
        descLabel:setDimensions(cc.size(self._width - 40, 0))
		descLabel:setAnchorPoint( 0, 1 )
		descInfo[i].descLabel = descLabel
		-- 位置
		descHeight = descHeight + descLabel:getContentSize().height + 3
		descLabel:setPosition( 0, descHeight )
	end
	-- scrollview
	local descSize = cc.size( self._width - 41, self._height - 87 )
	descSize.height = descHeight > descSize.height and descSize.height or descHeight
	local descPos = cc.p( ( ruleBg:getContentSize().width - descSize.width )/2, ruleBg:getContentSize().height - 73 - descSize.height )
	local descScrollview = zc.createScrollview({
        pos = descPos,
        size = descSize,
        innerSize = cc.size( descSize.width, descHeight ),
        touchEnable = true,
        bounceEnable = descHeight > descSize.height,
        dir = ccui.ScrollViewDir.vertical,
	})
	ruleBg:addChild( descScrollview )
	for i, v in ipairs( descInfo ) do
		descScrollview:addChild( v.descLabel )
	end
end
return RulePop