--[[
引导分为 开始强制引导 和 各功能引导
新手引导--对话无需手动设置下一步guideID
非对话需要传入点击对象的的无需手动设置下一步guideID
其他每一步都需手动设置下一步guideID  需要服务端记录步骤
---各功能引导 
统一使用 zc.setGuideFuncNextStep(_currentGID) 进行下一步不需要服务端记录步骤
]]
requires("src/layer/guide/GuideScriptLayer.lua")
requires("src/layer/guide/GuideContent.lua")
local GuideManager = class("GuideManager")

function GuideManager:ctor()
	--点击区域
	self.area_x = 200
    self.area_y = 50
    self.area_w = 50
    self.area_h = 50
    self.zorderHighLight = 30 
    self.zorderTouchLayer = 40 --触摸层 
    self.zorderHandLayer = 50 --小手
    self.touchOffSet = cc.p(0,0)
    self.handOffSet = cc.p(0,0)
    self._isGuiding = false
    self.ObjTargert = nil
    self._maskLayer = nil
    self._guideTaklBar = nil
end

--设置引导开始
function GuideManager:preGuideStep()
    local _guideId = PlayerData:getBaseInfo()["guideSteps"]
    -- print("----_guideId----",_guideId)
    if tonumber(_guideId) == 0 then
       _guideId = 1001 
    elseif tonumber(_guideId) == GuideKey.KEY_OVER then
        self:setCurrentGID(1)
    end
    local _currentGID = self:getBackId(_guideId)
    if tonumber(_currentGID) ~= _guideId then
        self:setCurrentGID(_currentGID, true)
    else
        self:setCurrentGID(_currentGID)
    end
    -----如果级别大于30级不再执行引导
    -- local _level = PlayerData:getBaseInfo().level
    -- if tonumber(_level) >= 30 then
    --     self:setNextGID(GuideKey.KEY_OVER)
    -- end
    -------新手引导用于手动设置步骤-------------
    -- getGuideManager():setCurrentGID(3010)  --7003
    -------新手引导用于手动设置步骤-------------
    local _currentGID = getGuideManager():getCurrentGID()
    -- print("----当前_currentGID-----",_currentGID)
end


--开始引导
function GuideManager:startGuide(guideId, params)
    --显示引导页面
    if self._currentGID == -1 then
        return
    end
    self:startViewGuide()
end


function GuideManager:startViewGuide()
    self.gWordIndex = 0
    self.dBoxView = nil

    self:checkGuideNode()
    self.guideNode:removeAllChildren()
    self:createTouchLayer()
    self:createHandLayer()
    self:checkShowDBox()
    self:checkTalkBar()
    -- self:createJumpView()
    self:showHighLightArea()
end

--显示高亮区域
function GuideManager:showHighLightArea()
    if self.clipNode then
        self.clipNode = nil
        self.colerlayer = nil
    end
    if self.currentGID == GuideKey.KEY_5004 then
        return
    end
    -- print("----self.ObjTargert---",self.ObjTargert)
    if tolua.isnull(self.ObjTargert) then return end
    local _data = self:getObjTargetInfo()

    local area_x = _data.x + (0.5-_data.apx) *  _data.width
    local area_y = _data.y + (0.5-_data.apy) *  _data.height
    local area_w = _data.width 
    local area_h = _data.height 
    -- local area_apx = _data.apx
    -- local area_apy = _data.apy 
    if  area_x == 0 and area_y == 0 and area_w == 0 and area_h == 0 then
        -- print("no____________showHighLightArea")
        return
    end

    self.clipNode = cc.ClippingNode:create()
    self.guideNode:addChild(self.clipNode, self.zorderHighLight)
    self.clipNode:setContentSize(cc.size(zc.width, zc.height))
    self.clipNode:setAnchorPoint(cc.p(0,0))
    self.clipNode:setInverted(true)
    -- self.colorlayer = cc.LayerColor:create(cc.c4b(0, 0, 0, 150), zc.width, zc.height)   --测试
    self.colorlayer = zc.getScaleNode("res/image/guide/guideBg.png", cc.size(zc.width,zc.height))
    self.colorlayer:setAnchorPoint(cc.p(0,0))
    self.clipNode:addChild(self.colorlayer)
    -- self.boxSpriteStencil = zc.getScaleNode("res/Main/common/img_empty.png", cc.size(area_w,area_h))  --测试
    self.boxSpriteStencil = cc.Sprite:create("res/image/guide/guideCircle.png")
    self.boxSpriteStencil:setAnchorPoint(cc.p(0.5,0.5))
    self.clipNode:setStencil(self.boxSpriteStencil)
    self.boxSpriteStencil:setPosition(area_x , area_y )
    local _sp = cc.Sprite:create("res/image/guide/guideCircle.png")
    _sp:setAnchorPoint(cc.p(0.5,0.5))
    _sp:setPosition(area_x , area_y )
    self.guideNode:addChild(_sp,self.zorderHighLight+9)
    -- self.boxSpriteStencil:setPosition(area_x + area_w / 2, area_y + area_h / 2)  
    
    local _lightSpine = zc.getSpine("shou")
    _lightSpine:playAction("quan", true)
    _lightSpine:setPosition(area_x , area_y )
    self.guideNode:addChild(_lightSpine,self.zorderHighLight+9)
    
end

--创建点击区域
function GuideManager:createTouchLayer()
    if self.touchLayer then
        self.touchLayer = nil
    end

    if not self.ObjTargert then return end
    local _data = self:getObjTargetInfo()
    self.touchLayer = cc.Layer:create() 

    local function onTouchEvent(eventType, x, y)
        if eventType == "began" then
            local target = self.touchLayer:getParent()

            local locationInNode = target:convertToNodeSpace(cc.p(x, y))
            local touch_x =  _data.x - (_data.apx) *  _data.width     
            local touch_y =  _data.y - (_data.apy) *  _data.height           
            local touch_w = _data.width 
            local touch_h = _data.height

            local rectArea = cc.rect(touch_x, touch_y, touch_w, touch_h)
            local isInRect = cc.rectContainsPoint(rectArea, locationInNode)

            if isInRect then
                -- print("guide:onTouchEvent=============================>", self.currentGID)
                return false
            else
                return true
            end

        elseif eventType == "moved" then

        elseif eventType == "ended" then
        
        end
    end
    self.touchLayer:registerScriptTouchHandler(onTouchEvent)
    self.guideNode:addChild(self.touchLayer, 40)
    self.touchLayer:setTouchEnabled(true)

    self.touchOffSet = cc.p(0,0)
end

--创建小手
function GuideManager:createHandLayer()
    -- print("NewGManager:createHandLayer===================>")
    -- print("---self.guideItem--",self.guideItem)
    -- dump(self.guideItem, "---self.guideItem---")
    if self.handSprite then
        self.handSprite = nil
    end 
    if not self.ObjTargert or (not self.guideItem) then  return end
    local _data = self:getObjTargetInfo()
    local hand_start_point_x = _data.x - (_data.apx-0.5) *  _data.width 
    local hand_start_point_y = _data.y - (_data.apy-0.5) *  _data.height 
    local hand_end_point_x = 0
    local hand_end_point_y = 0

    if self.currentGID == GuideKey.KEY_5004 then
        self.handSprite = zc.createSprite("res/image/guide/guideHand.png")
        self.handSprite.isSprite = true
    else
        self.handSprite = zc.getSpine("zhiyinxiaoren")
        self.handSprite:setContentSize(100, 200)
        self.handSprite.isSprite = false
    end
    self.guideNode:addChild(self.handSprite, 50)
    self.handSprite:setAnchorPoint(cc.p(0.5,0.5))

    local hand_direction = self.guideItem["touch"] or 4 --手指方向
    -- print("handY: ",hand_start_point_y)
    -- 左上：1    idle_1
    -- 左下：2    idle_3
    -- 右中：3    idle_2
    -- 左中：4
    -- 右上：5
    -- 右下：6
    local contentSize = self.handSprite:getContentSize()

    local tempStartX = hand_start_point_x - contentSize.width/2  - _data.width/2
    local tempStartY = hand_start_point_y + contentSize.height / 4

    -- print("小手的方向 -====================- ", hand_direction)
    if hand_direction == 1 then     -- 左上
        if not self.handSprite.isSprite then
            self.handSprite:playAction("idle_1", true )
        end
        tempStartX = hand_start_point_x - contentSize.width /2 - _data.width/2
        tempStartY = hand_start_point_y - contentSize.height / 8
    elseif hand_direction == 2 then  -- 左下
        if not self.handSprite.isSprite then
            self.handSprite:playAction("idle_3", true )
        end
        tempStartX = hand_start_point_x - contentSize.width /2 - _data.width/2
        tempStartY = hand_start_point_y + contentSize.height / 4
    elseif hand_direction == 3 then  --右中
        if not self.handSprite.isSprite then
            self.handSprite:playAction("idle_2", true )
        end
        self.handSprite:setScaleX(-1)
        tempStartX = hand_start_point_x + _data.width/2 + contentSize.width/2
        tempStartY = hand_start_point_y + contentSize.height / 4
    elseif hand_direction == 4 then  -- 左中
        if not self.handSprite.isSprite then
            self.handSprite:playAction("idle_2", true )
        end
    elseif hand_direction == 5 then  --右上
        if not self.handSprite.isSprite then
            self.handSprite:playAction("idle_1", true )
        end
        self.handSprite:setScaleX(-1) 
        tempStartX = hand_start_point_x + contentSize.width/2 + _data.width/2
        tempStartY = hand_start_point_y - contentSize.height / 8
    elseif hand_direction == 6 then  --右下
        if not self.handSprite.isSprite then
            self.handSprite:playAction("idle_3", true )
        end
        self.handSprite:setScaleX(-1) 
        tempStartX = hand_start_point_x + contentSize.width/2 + _data.width/2
        tempStartY = hand_start_point_y + contentSize.height / 4
    end

    self.handSprite:setPosition(tempStartX, tempStartY)
    self.handOffSet = cc.p(0,0)
end

--创建引导基础的node
function GuideManager:checkGuideNode()
    self.runningScene = cc.Director:getInstance():getRunningScene()
    if not tolua.isnull(self.adapterLayer) then
        self.adapterLayer:removeFromParent()
        self.adapterLayer = nil
    end

    self.adapterLayer = cc.Layer:create()
    self.adapterLayer:setContentSize(cc.size(zc.width,zc.height))
    self.adapterLayer:setAnchorPoint(cc.p(0,0))
    self.adapterLayer:setPosition(cc.p(0,0))
    self.guideNode = cc.Node:create()
    self.adapterLayer:addChild(self.guideNode)
    self.runningScene:addChild(self.adapterLayer, 100)                   
    -- print("guide node runningScene ", self.runningScene)
end


function GuideManager:checkTalkBar()
    if not self.guideItem then
        return
    end
    local _bubble = self.guideItem.bubble
    if not _bubble or string.len(_bubble) == 0 then
        return
    end
    local _dir = tonumber(self.guideItem.direction) or 1
    _dir = _dir > 2 and 2 or _dir
    local _bar = zc.getSprite({
        src = "res/image/guide/talkBar" .. _dir .. ".png"
    })
    self._guideTaklBar = _bar
    self.guideNode:addChild(_bar, 50)
    local _size = _bar:getContentSize()
    local _label = zc.createRichLabel({
        text = _bubble,
        fontSize = 20,
        color = cc.c3b(110, 63, 69),
    })
    local _width = 185
    if _label:getContentSize().width > _width then
        _label:setFontSize(18)
        _label:setDimensions(cc.size(_width, 0))
    end
    _bar:addChild(_label)
    local _posX, _posY = 0, 0
    local _labelPos = cc.p(_size.width*0.5 - 5, _size.height*0.5 + 5)
    if self.handSprite then
        _posX, _posY = self.handSprite:getPosition()
    end
    local hand_direction = self.guideItem["touch"] or 4 --手指方向
         -- 左上：1    idle_1
    -- 左下：2    idle_3
    -- 右中：3    idle_2
    -- 左中：4
    -- 右上：5
    -- 右下：6
    local _flag = 1
    if hand_direction == 3 or
      hand_direction == 5 or 
      hand_direction == 6 then
        _flag = -1
    end
    if _dir == 1 then
        _bar:setAnchorPoint(0.5, 0)
        _posX = _posX - 200*_flag
        _posY = _posY + 60
        _bar:setScaleX(_flag)
        _label:setScaleX(_flag)
        if _flag == 1 then
            _labelPos.x = _labelPos.x + 5
            _labelPos.y = _labelPos.y - 5
        end
    elseif _dir == 2 then
        _bar:setAnchorPoint(1, 0.5)
        _posX = _posX - 120*_flag
        _posY = _posY - 40
        _bar:setScaleX(_flag)
        _label:setScaleX(_flag)
    end
    _label:setPosition(_labelPos)
    _bar:setPosition(_posX, _posY)
end

--检测是否显示
function GuideManager:checkShowDBox()
    if self.guideItem then
        local _talkId = self.guideItem.talkid
        if _talkId and _talkId ~= "" then
            self:showDBox(tonumber(_talkId))
        end
    end
end


--显示对话框
function GuideManager:showDBox(_talkId)
    local function _callBack()
        self:setNextGID(self.currentGID)
        if self._heroFuncCallBack then   --特殊处理对话完成 战斗 英雄进入
            self._heroFuncCallBack()
        end
        self._heroFuncCallBack = nil
    end
    -- print("wm----_talkId : ", _talkId)
    local guideScriptLayer = GuideScriptLayer:createWithParams({storyId = _talkId,callback = _callBack})
    self.guideNode:addChild(guideScriptLayer)
end

--对应奖励黄金小兵
function GuideManager:setHeroFuncCallBack(_callBack)
    self._heroFuncCallBack = _callBack
end

--处理引导步骤
function GuideManager:GuideCallBack(guideid, params)
    if self._currentGID == -1 then
        return
    end
    self:startGuideForGuideId(guideid, params)
end

--新手引导，参数传入引导id, 附加参数用于判断
function GuideManager:startGuideForGuideId(guideid, params)
    --获取引导数据
    self:guideOver() 
    self.guideItem = self:getNewBeeConfigById(tonumber(guideid))
    if not self.guideItem then 
        -- print("============startGuideForGuideId, guideItem = null=============", self.currentGID)  
        return 
    end
    --检查引导的触发条件
    self:startGuide(guideid, params)   
end

--设置触摸区域偏离位置
function GuideManager:setTouchOffSet(offPosition)
   self.touchOffSet = offPosition
   -- print("set touch ", self.touchOffSet.y)
end

--设置小手偏离位置
function GuideManager:setHandOffSet(offPosition)
    self.handOffSet = offPosition
end

function GuideManager:getObjTargetInfo()
    if tolua.isnull(self.ObjTargert) then
        return nil
    end
    -- print("-----self.currentGID----",self.currentGID)
    local _data = {}
    local _size = self.ObjTargert:getBoundingBox()
    local _posx,_posy = self.ObjTargert:getPosition()
    local _pos = self.ObjTargert:convertToWorldSpaceAR(cc.p(0,0))
    -- local _pos = self.guideNode:convertToNodeSpace(_pos)

    local _ap = self.ObjTargert:getAnchorPoint()
    _data.width = _size.width * self._scale
    _data.height = _size.height * self._scale
    _data.apx = _ap.x
    _data.apy = _ap.y
    _data.x = _pos.x
    _data.y = _pos.y 
    -- print("---_data.x,_data.y----",_data.x,  _data.y)
    -- print("---_data.apx,_data.apy----",_data.apx,  _data.apy)
    -- print("---_data.width,_data.height----",_data.width,  _data.height)
    ----------
    if self.currentGID == GuideKey.KEY_6007 then
        _data.width = _size.width * 0.5
        _data.height = _size.height * 0.2
        _data.y = _data.y + 50
    elseif self.currentGID == GuideKey.KEY_12210 or self.currentGID == GuideKey.KEY_14502 then
        _data.y = _data.y + 100
        _data.width = _size.width * 0.5
        _data.height = _size.height * 0.2
    elseif inArray(self.currentGID, GuideGroup.HOUSE_CHOOSE_TIEJIANGPU)  then  --铁匠铺大小特殊处理
        _data.width = _size.width * 0.8
        _data.height = _size.height * 0.8
    elseif inArray(self.currentGID, GuideGroup.HOUSE_CHOOSE_FARM) then
        _data.width = _size.width * 0.5
        _data.x = _data.x - 60
    elseif inArray(self.currentGID, GuideGroup.HOUSE_CHOOSE_TIAOZHAN) then
        _data.y = _data.y + 50
        _data.width = _size.width * 0.5
        _data.height = _size.height * 0.5
    end
    --处理不确定因素导致坐标出屏结束引导
    if _data.y < 0 then 
        self:setNextGID(GuideKey.KEY_OVER)
        return nil
    end
    return _data
end

--传入当前对象
function GuideManager:setObjTarget(obj,scale)
    self.ObjTargert = obj
    self._scale = scale or 1.0
end

--设置当前步骤
function GuideManager:setCurrentGID(currentGID, isSend)
    if not currentGID then
        return
    end
    print("GuideManager:setCurrentGID========", currentGID)
    self.guideItem = self:getNewBeeConfigById(currentGID)
    if self.currentGID == currentGID then return end
    -- print("GuideManager:setCurrentGID========", currentGID)
    self.currentGID = currentGID
    if isSend then
        zc.sendHttp({
            apiName = "User_setGuideSteps",
            params = {step = self.currentGID},
            isSilent = true,
        })
    end
end

--设置下一步引导
function GuideManager:setNextGID(currentGID)
    local _guideItem = self:getNewBeeConfigById(currentGID)
    if _guideItem then
        self.currentGID = _guideItem.fanalstep
    end
    self.guideItem = self:getNewBeeConfigById(self.currentGID)
    print("GuideManager:setCurrentGID2========", currentGID) 
    if tonumber(self.currentGID) == 1 or self.guideItem then
        --引导结束
        if tonumber(self.currentGID) == 1 then
            self:guideOver()
        end
        zc.sendHttp({
            apiName = "User_setGuideSteps",
            params = {step = self.currentGID}, 
        })
    end 
end

--设置下一步引导(功能引导)
function GuideManager:setNextFuncGID(currentGID)
    local _guideItem = self:getNewBeeConfigById(currentGID)
    if _guideItem then
        self.currentGID = _guideItem.fanalstep
    end
    self.guideItem = self:getNewBeeConfigById(self.currentGID)
end

--记录功能引导触发
function GuideManager:sendFuncGuideTrigger(_id)
    PlayerData:setFuncGuideInfo(_id)
    zc.sendHttp({
        apiName = "User_setFuncGuide",
        params = {id = _id},
    })
end


function GuideManager:setFuncGuideOver()
    self:setCurrentGID(1, true)
    self.guideItem = nil
    self:guideOver()
end

--获取当前步骤
function GuideManager:getCurrentGID() 
    -- ISSHOW_GUIDE = false
    if not ISSHOW_GUIDE then
        return -1
    end
    -- print("wm----gID : ", self.currentGID)
    return self.currentGID
end
--获取当前引导信息
function GuideManager:getCurrentInfo()
    return self.guideItem
end
--从引导表中获取引导信息
function GuideManager:getNewBeeConfigById(_id)
	-- body
    local _data = gameData.getDataFromCacheWithPrimaryKey("guidelist", _id)
    if next(_data) ~= nil then
        return _data
    end
    return nil
end

--获取引导中断的跳转的步骤
function GuideManager:getBackId(id)
    local gItem = self:getNewBeeConfigById(id)
    if gItem == nil or tonumber(gItem["parameter"]) == 0 or tonumber(gItem["parameter"]) == 1 then
        return 1
    end
    return  gItem["parameter"]
end

--创建遮罩层
function GuideManager:getMaskLayer(par, time, callback)   
    local layer = cc.Layer:create()
    local function onTouchEvent(eventType, x, y)
        if eventType == "began" then
            return true
        end
    end
    layer:setTouchEnabled(true)
    layer:registerScriptTouchHandler(onTouchEvent)
    if par then
        par:addChild(layer, 100)
        if time then
            performWithDelay(layer, function()
                layer:removeFromParent()
                if callback then
                    callback()
                end
            end, time)
        end
    end
    return layer  
end

--添加遮罩
function GuideManager:addMaskLayer()
    print("----addMaskLayer-----")
    local _scene = cc.Director:getInstance():getRunningScene()
    if not self._maskLayer then
        self._maskLayer = self:getMaskLayer()
        _scene:addChild(self._maskLayer,1000)
    end
end

--移除遮罩
function GuideManager:removeMaskLayer()
    print("---removeMaskLayer---")
    if not tolua.isnull(self._maskLayer) then
        self._maskLayer:removeFromParent()
    end
    self._maskLayer = nil
end

--判断强制引导是否完成 true完成 false 未完成
function GuideManager:guideIsOver()
    if self.currentGID then
        if self.currentGID == 1 or self.currentGID == GuideKey.KEY_OVER then
            return true
        end
    else
        return true
    end
    return false
end

--引导结束，如需开始需要重新调用startGuide()
function GuideManager:guideOver()
    self:clearView() --清理view
end

--清除view
function GuideManager:clearView()
    self:removeMaskLayer()
    if not tolua.isnull(self.adapterLayer) then
        self.adapterLayer:removeFromParent(true)
    end
    self._isGuiding = false
    self.adapterLayer = nil
    self.clipNode = nil
    self.guideNode = nil
    self.touchLayer = nil
    self.handSprite = nil
    self._jumpBg = nil
    self.colerlayer = nil
    self.runningScene = nil
    self.ObjTargert = nil
    self._guideTaklBar = nil
end

return GuideManager
