--[[
	将魂选择弹窗
	wangming
	2017.4.12
]]
local HeroSoulSelectedPop = class("HeroSoulSelectedPop", function()
	return zc.createNormalDialog({
        src = "res/Main/heroSoul/bg.jpg",
        showYun = true,
        yunTag = 2,
        yunType = 2,
        yunOffY = {0, -40},
        showFlowerFlag = {1, 0, 1, 1},
        closeCallBack = function()
            LayerManager.removeLayout(true)
        end
    })
end)

function HeroSoulSelectedPop:create( params )
	return HeroSoulSelectedPop.new( params )
end

function HeroSoulSelectedPop:onEnter()
    self:addGuide()
end

function HeroSoulSelectedPop:ctor( params )
	self._idx = tonumber(params.index) or 1
	self._heroId = params.heroId
	self._heroSoul = params.heroSoul or {}
	self._freshCallback = params.freshCallback

	self._gemList = {}
	self._gemIndex = 1
	self._cellIconNum = 5

	self:initUI()
	self:refreshListLayer()
	self:refreshInfoLayer()
end

-- 初始化界面
function HeroSoulSelectedPop:initUI()
	self:initInfoLayer()
	self:initListLayer()
end

-- 创建信息弹窗
function HeroSoulSelectedPop:initInfoLayer()
    local _baseBg = self:getChildByName("background")
    if _baseBg then
        _baseBg:setScaleX(_baseBg:getScaleX()*-1)
    end
	-- 背景
	local _bgWidth = zc.width*0.5
	local _bgHeight = zc.height
    local _bg = cc.Node:create()
    _bg:setContentSize(_bgWidth, _bgHeight)
	_bg:setPosition(0, 0)
	self:addChild( _bg )
	self._infoLayer = _bg

    -- 顶部
    local _topBg = zc.createSprite("res/Main/heroSoul/leftDi.png")
    _topBg:setAnchorPoint(0.5, 0)
    _topBg:setPosition(_bgWidth*0.5 + 15, _bgHeight*0.5 - 80)
    _bg:addChild(_topBg)
    local _topBgWidth = _topBg:getContentSize().width
    local _topBgHeight = _topBg:getContentSize().height

    local _gemIcon = zc.createHeroSoulSpine()
    _gemIcon:setPosition( _topBgWidth*0.5 - 15, _topBgHeight*0.5 - 40 )
    _topBg:addChild( _gemIcon )
    _bg._gemIcon = _gemIcon
    --等级bg 
    local _justY = 15 
    local _level_bg = zc.getSprite({
        src = "res/Main/country/main/country_level_bg.png",
        ap = cc.p(0, 0.5),
        pos = cc.p(_bgWidth*0.5 - 160, _bgHeight*0.5 - 50) 
    })
    _bg:addChild(_level_bg, 1)
    --等级
    local _level_label = zc.createLabel({
        fontSize = 22,
        pos = cc.p(23, 23),
        outLine = true,
    })
    _level_bg:addChild(_level_label)
    _bg._level_label = _level_label
    -- 进度条
    _bg._progress = zc.createProgressWithParams({
        bg = _bg,
        src1 = "res/Main/drillField/drillField_heroExp_bg_1.png",
        src2 = "res/Main/drillField/drillField_heroExp_1.png",
        pos = cc.p(_bgWidth*0.5, _level_bg:getPositionY()),
    })

    -- 经验值
    local _expNum = zc.createLabel({
        fontSize = 18,
        color = zc.COLOR_YELLOW,
        pos = cc.p( _bg._progress:getContentSize().width/2, _bg._progress:getContentSize().height/2 ),
        outLine = true,
    })
    _bg._progress:addChild( _expNum )
    _bg._expNum = _expNum

    -- 底部
	-- 属性背景
	local _attrBg = zc.createSprite("res/Main/heroSoul/attributeDi.png")
	_attrBg:setAnchorPoint( 0.5, 1 )
    _attrBg:setPosition( _bgWidth*0.5, _level_bg:getPositionY() - 20 )
	_bg:addChild( _attrBg )
    local _attrBgWidth = _attrBg:getContentSize().width
    local _attrBgHeight = _attrBg:getContentSize().height

    -- 属性
    local _attrText = zc.createLabel({
        fontSize = 18,
        color = cc.c3b( 203, 183, 123 ),
        pos = cc.p( 100, _attrBgHeight*0.5 + 50 ),
        outLine = true,
    })
    _attrText:setAnchorPoint( 0, 0.5 )
    _attrBg:addChild( _attrText )
    -- 属性值
    local _attrNum = zc.createLabel({
        fontSize = 18,
        pos = cc.p( _attrBgWidth/2 - 40, _attrText:getPositionY() ),
        outLine = true,
    })
    _attrNum:setAnchorPoint( 0, 0.5 )
    _attrBg:addChild( _attrNum )

    _bg._attrLabel = {
        _attrText = _attrText,
        _attrNum = _attrNum,
    }

    -- 左按钮，合成
    local _leftBtn = zc.createCommomBtn({
		tag = 2,
		text = "",
        pos = cc.p( 160, 75 ),
        endCallback = function()
        	self:clickLeftBtn()
    	end
	})
	_attrBg:addChild( _leftBtn )
	_bg._leftBtn = _leftBtn

	-- 右按钮，卸下
    local _rightBtn = zc.createCommomBtn({
        tag = 1,
        text = zc.lang("equip"),
        pos = cc.p( _attrBgWidth - _leftBtn:getPositionX(), _leftBtn:getPositionY() ),
        endCallback = function()
            local _currentGID = getGuideManager():getCurrentGID()
            if _currentGID == GuideKey.KEY_14714 then
                getGuideManager():setFuncGuideOver()
            end
        	self:clickRightBtn()
    	end
	})
	_attrBg:addChild( _rightBtn )
	self._rightBtn = _rightBtn
end

-- 创建列表弹窗
function HeroSoulSelectedPop:initListLayer()
	-- 背景
	local _bgWidth = 510
	local _bgHeight = 560
	local _bg = zc.createNormalPop({
		width = _bgWidth,
		height = _bgHeight,
	})
	_bg:setPosition( zc.width*0.5 + 220, zc.height*0.5 - 20 )
	self:addChild( _bg )
    self._listLayer = _bg

    local _innerW = _bgWidth - 30
    local _innerH = _bgHeight - 60 - 50
	-- 上层背景
	local _topBg = zc.getScaleNode("res/Main/common/popBg/di_4.png", cc.size(_innerW, _innerH))
	_topBg:setPosition( _bgWidth/2, _bgHeight/2 )
	_bg:addChild( _topBg )

	-- tableview
    local _gemTableview = zc.ZCTableView:create( cc.size( _innerW, _innerH ) )
    _gemTableview:setBounceable( true )
    _gemTableview:setInertia( true )
    _gemTableview:setDirection( cc.SCROLLVIEW_DIRECTION_VERTICAL )
    _gemTableview:setPosition( 0, 0 )
    _gemTableview:setDelegate()
    _gemTableview:setVerticalFillOrder( cc.TABLEVIEW_FILL_TOPDOWN )
    local cellWidth = _innerW
    local cellHeight = 105
    local function cellSizeForTable(table, index) 
        return cellHeight, cellWidth
    end
    local function tableCellAtIndex(table, index)
        local cell = table:dequeueCell()
        -- 创建模板
        if cell == nil then
            cell = zc.ZCTableViewCell:new()
            self:buildCell( cell, index, cellWidth, cellHeight )
        end
        self:updateCell( cell, index )

        return cell
    end
    local function numberOfCellsInTableView()
        return math.ceil( #self._gemList/self._cellIconNum )
    end
    _gemTableview:registerScriptHandler(cellSizeForTable, cc.TABLECELL_SIZE_FOR_INDEX)
    _gemTableview:registerScriptHandler(tableCellAtIndex, cc.TABLECELL_SIZE_AT_INDEX)
    _gemTableview:registerScriptHandler(numberOfCellsInTableView, cc.NUMBER_OF_CELLS_IN_TABLEVIEW)
    _topBg:addChild( _gemTableview )
    self._gemTableview = _gemTableview

    -- 数量
    local _totalNum = zc.createLabel({
        outLine = true,
        fontSize = 18,
        ap = cc.p(1, 0.5),
        pos = cc.p(_bgWidth - 30, 30),
        color = display.COLOR_GREEN,
    })
    _bg:addChild( _totalNum )
    self._totalNum = _totalNum

    -- 数量
    local _equipTip = zc.createLabel({
        text = zc.lang("include_equiped"),
        fontSize = 18,
        ap = cc.p(0, 0.5),
        pos = cc.p(_bgWidth - 240, _totalNum:getPositionY()),
        color = cc.c3b(222, 188, 141),
    })
    _bg:addChild( _equipTip )
    local _equipNum = zc.createLabel({
        outLine = true,
        fontSize = 18,
        ap = cc.p(0, 0.5),
        pos = cc.p(_equipTip:getPositionX() + _equipTip:getContentSize().width + 2, _totalNum:getPositionY()),
        color = display.COLOR_RED,
    })
    _bg:addChild( _equipNum )
    self._equipNum = _equipNum
end

function HeroSoulSelectedPop:clickLeftBtn()
	local _gemInfo = self._gemList[self._gemIndex]
	if not _gemInfo then
		return
	end
	local _status = tonumber(_gemInfo.status) or 0
	zc.sendHttp({
        apiName = "HeroSoul_soulLock",
        params = {soulId = _gemInfo.id, type = _status + 1},
        successCallback = function( backData )
        	self._gemList[self._gemIndex].status = _status == 0 and 1 or 0
            PlayerData:updateHeroSoul(self._gemList[self._gemIndex])
            self._infoLayer._leftBtn:setText(_status == 1 and LANGUAGE_ROLE.lock or LANGUAGE_ROLE.unlock)
            local _icon = self._selectedCell._icon[( self._gemIndex - 1 )%self._cellIconNum + 1]
            _icon:doLockImg()
        end
    })
end

function HeroSoulSelectedPop:clickRightBtn()
	local _gemList = self._gemList[self._gemIndex]
    if not _gemList then
        return
    end
    zc.sendHttp({
        apiName = "HeroSoul_equipHeroSoul",
        params = {
            heroId = self._heroId,
            soulIds = _gemList.id,
            index = self._idx,
        },
        successCallback = function( backData )
            PlayerData:updateGeneralInfo(backData.heroEtt)
            _gemList.heroId = self._heroId
            _gemList.index = self._idx 
            PlayerData:updateHeroSoul(_gemList)
            if self._freshCallback then
            	self._freshCallback()
            end
            LayerManager.removeLayout(true)
        end
    })
end

-- 刷新信息弹窗
function HeroSoulSelectedPop:refreshInfoLayer()
	local _gemInfo = self._gemList[self._gemIndex]
	if not _gemInfo then
		return
	end
	local _bg = self._infoLayer
	-- 图标
    local _data = gameData.getDataFromCacheWithPrimaryKey("heroSoul", _gemInfo.heroSoulId)
    zc.createHeroSoulSpine({
        spine = _bg._gemIcon,
        quality = _data.quality,
        iconId = _data.pictureId,
    })
    -- 名字
    -- _bg._name:setText( _gemInfo.name )
	_bg._leftBtn:setText(tonumber(_gemInfo.status) == 0 and LANGUAGE_ROLE.lock or LANGUAGE_ROLE.unlock)

	_bg._attrLabel._attrText:setString( LANGUAGE_getAttributeTextById( _gemInfo.attributeType ) )
	_bg._attrLabel._attrNum:setString( "+" .. zc.getAttributeNumById(_gemInfo.attributeType, _gemInfo.attributeValue) )

    _bg._level_label:setString(_gemInfo.level)
	local _nxtInfo = gameData.getDataFromCacheWithPrimaryKey("heroSoul", _gemInfo.nextLevel)
    if next(_nxtInfo) then
        -- 没到满级
        local _expNow = tonumber(_gemInfo.exp) or 0
        local _gemExpData = gameData.getDataFromCache("heroSoul_Exp",{id=_gemInfo.level})
        local _expMax = tonumber(_gemExpData["needExp" .. _gemInfo.quality]) or 0
        local _pct = 1
        if _expMax ~= 0 then
            _pct = _expNow/_expMax
        end
        -- local _progressWidth = _bg._progress:getContentSize().width
        _bg._progress:stopAllActions()
        _bg._progress:runAction(cc.ProgressTo:create( 0.2, _pct*100 ))
        -- _bg._progress:runAction(
        --     cc.MoveTo:create( 0.2, cc.p( _progressWidth*_pct, -2 ) )
        -- )
        _bg._expNum:setText( _expNow.."/".._expMax )
    else
        -- 满级
        -- local _progressWidth = _bg._progress:getContentSize().width
        _bg._progress:stopAllActions()
        _bg._progress:runAction(cc.ProgressTo:create( 0.2, 100 ))
        -- _bg._progress:runAction(
        --     cc.MoveTo:create( 0.2, cc.p( _progressWidth, -2 ) )
        -- )
        _bg._expNum:setText( "Max" )
    end
end

-- 创建cell
function HeroSoulSelectedPop:buildCell( cell, index, cellWidth, cellHeight )
	-- 两边
	local cellSide = 8
	local cellDisX = ( cellWidth - cellSide*2 )/self._cellIconNum
	cell._icon = {}
	for i = 1, self._cellIconNum do
		local _posX = ( i - 0.5 )*cellDisX + cellSide
		-- icon
		local _icon = zc.createIconByData({
	        data = {
	            mainType=zc.mainTypeHeroSoul,
	            type=1,
	            id=1,
	        },
	        pos = cc.p( _posX, cellHeight/2 ), 
	    })
	    _icon:setScale( 0.65 )
		cell:addChild( _icon )
		cell._icon[i] = _icon
		-- 选中
	    local _selected = zc.getItemClickEffect( 2 )
	    _selected:setPosition( _icon:getContentSize().width/2, _icon:getContentSize().height/2 )
	    _icon:addChild( _selected )
	    _icon._selected = _selected
	end
end

-- 更新cell
function HeroSoulSelectedPop:updateCell( cell, index )
	cell._index = index
	for i = 1, self._cellIconNum do
		local _gemIndex = index*self._cellIconNum + i
		local _gemInfo = self._gemList[_gemIndex]
		local _icon = cell._icon[i]
		if _gemInfo then
			-- cellBg
			_icon:setVisible( true )
			if self._gemIndex == _gemIndex then
				_icon._selected:setVisible( true )
				self._selectedCell = cell
			else
				_icon._selected:setVisible( false )
			end
			-- icon
			zc.updateIconByData(_icon, {
				data = {
		            mainType = zc.mainTypeHeroSoul,
		            type = _gemInfo.heroSoulId,
		            id = _gemInfo.heroSoulId,
		            level = zc.getLevelTipShow().._gemInfo.level,
		        },
                primaryId = _gemInfo.id,
		        showLevel = true,
		        listener = function()
		        	if self._gemIndex ~= _gemIndex then
		        		if self._selectedCell then
							self._selectedCell._icon[( self._gemIndex - 1 )%self._cellIconNum + 1]._selected:setVisible( false )
						end
						self._gemIndex = _gemIndex
						_icon._selected:setVisible( true )
						self._selectedCell = cell
						self:refreshInfoLayer()
		        	end
		        end
			})
		else
			_icon:setVisible( false )
		end
	end
end

-- 刷新列表弹窗
function HeroSoulSelectedPop:refreshListLayer()
    local _equipNum = self:buildListData()
	self._gemTableview:reloadData()
    local _nums = table.nums(PlayerData:getHeroSoul())
    self._totalNum:setString(_nums .. "/200")
    self._equipNum:setString(_equipNum)
end

-- 构造列表数据，相同类型相同等级相同经验值的宝石堆叠
function HeroSoulSelectedPop:buildListData()
    local _allGem = PlayerData:getHeroSoul()

    local _tonumber = tonumber
    local _equipNum = 0

    local _tb1, _tb2 = {}, {}
    for k,v in pairs(self._heroSoul) do
    	if not _tb2[v.attributeType] then
            _tb2[v.attributeType] = true
    		_tb1[#_tb1 + 1] = v.attributeType
    	end
    end
    
    local _gemList = {}
    for k, _gemData in pairs( _allGem ) do
        local _place = _tonumber(_gemData.heroId) or 0
        if _place == 0 then
            if not inArray(_gemData.attributeType, _tb1) then
    		  _gemList[#_gemList + 1] = _gemData
            end
        else
            _equipNum = _equipNum + 1
        end
    end

    table.sort(_gemList, function(a, b)
    	local _numA = _tonumber(a.quality) or 0
    	local _numB = _tonumber(b.quality) or 0
    	if _numA ~= _numB then
    		return _numA > _numB
    	end
    	_numA = _tonumber(a.level) or 0
    	_numB = _tonumber(b.level) or 0
    	if _numA ~= _numB then
    		return _numA > _numB
    	end
    	_numA = _tonumber(a.exp) or 0
    	_numB = _tonumber(b.exp) or 0
        if _numA ~= _numB then
            return _numA > _numB
        end
        _numA = _tonumber(a.heroSoulId) or 0
        _numB = _tonumber(b.heroSoulId) or 0
        return _numA < _numB
    end)
    self._gemList = _gemList
    return _equipNum
end

function HeroSoulSelectedPop:addGuide()
    local _currentGID = getGuideManager():getCurrentGID()
    if _currentGID == GuideKey.KEY_14712 then
        zc.setGuideFuncNextStep(_currentGID, false)
        self:addGuide()
    elseif _currentGID == GuideKey.KEY_14713 then
        local function _callBack()
            getGuideManager():setObjTarget(self._rightBtn)
            getGuideManager():startGuide()
        end
        getGuideManager():setHeroFuncCallBack(_callBack)
        getGuideManager():startGuide()
    end
end

return HeroSoulSelectedPop