--[[
	羁绊属性总加成
	唐实聪
	2016.4.1
]]
local RoleFetterAttrPop = class("RoleFetterAttrPop", function()
	return ZCPopLayer:create()
end)

function RoleFetterAttrPop:create(params)
	return RoleFetterAttrPop.new(params)
end
function RoleFetterAttrPop:ctor(params)
	local _fetterData = params.fetterData or {}
	-- 背景
	local _bg = ccui.Scale9Sprite:create(cc.rect(8, 8, 4, 4), "res/Main/role/fetter/popDi.png")
	_bg:setContentSize(500, 340)
	_bg:setPosition(zc.width*0.5, zc.height*0.5)
	self:addContent(_bg)
	local _bgSize = _bg:getContentSize()

	-- 标题
	local _title = zc.createSprite("res/Main/role/fetter/title.png")
	_title:setAnchorPoint(0.5, 0)
	_title:setPosition(_bgSize.width*0.5, _bgSize.height - 11)
	_bg:addChild(_title)

	local _costLab = zc.createRichLabel({
		anchor = cc.p(1, 1),
		color = cc.c3b(230, 217, 173),
		pos = cc.p(_bgSize.width - 30, _bgSize.height - 15),
		fontSize = 24,
	})
	_bg:addChild(_costLab)

	local _upgradData = _fetterData.upgradeInfo or {}
	local _nextLevelInfo = _fetterData.nextLevelInfo or {}
	if next(_nextLevelInfo) == nil then
		_costLab:setString(zc.lang("max_level"))
	elseif next(_upgradData) == nil then
		_costLab:setString(zc.lang("fetter_unactive"))
	else
		local _costInfo = string.split(_upgradData.stuff, "|")
		local _type = tonumber(_costInfo[2]) or 1
		local _num = tonumber(_costInfo[3]) or 0
		_costLab:setString(zc.lang("next_level_need") .. " [image=" .. zc.getImgByType(_type) .. " offsety=-10][/image]" .. _num)
	end

	local _tipSize = cc.size(360, 30)
    local _tipDi = zc.getScaleNode("res/Main/role/common/name_bg.png", _tipSize)
	_tipDi:setPosition(_bgSize.width*0.5, 20)
	_bg:addChild(_tipDi)

	cc.SpriteFrameCache:getInstance():addSpriteFrames("res/Main/home/homeUI.plist", "res/Main/home/homeUI.pvr.ccz")
    local _pScale = 0.4
    local _tipImg = zc.getSprite({
        src = "home_icon_info.png",
        plist = true,
        ap = cc.p(0, 0.5),
        pos = cc.p(-5, _tipSize.height*0.5),
        scale = _pScale,
    })
    _tipDi:addChild(_tipImg)
	local _tipLab = zc.createRichLabel({
		text = zc.lang("attribute_plus_for_all") .. "[color=ffff0000]" .. LANGUAGE_getTargetTextById(3) .. "[/color]",
		anchor = cc.p(0, 0.5),
		color = cc.c3b(184, 148, 115),
		pos = cc.p(_tipImg:getPositionX() + _tipImg:getContentSize().width*_pScale - 5, _tipImg:getPositionY()),
		fontSize = 18,
	})
	_tipDi:addChild(_tipLab)
	
	self._valueDatas = gameData.getDataFromCache("fetters_upgrade", {fettersId = _fetterData.fettersId})
	local _length = #self._valueDatas
	if _length > 0 then
		table.sort(self._valueDatas, function( a, b )
			if not a or not b then
				return false
			end
			local _levelA = tonumber(a.color) or 0
			local _levelB = tonumber(b.color) or 0
			return _levelA > _levelB
		end)
		local _scrollviewSize = cc.size(_bgSize.width, 255)
		local _scrollView = zc.createScrollview({
	        pos = cc.p(0, 40),
	        size = _scrollviewSize,
	        innerSize = _scrollviewSize,
	        dir = ccui.ScrollViewDir.vertical,
	    })
	    _bg:addChild(_scrollView)

	    local _y, _height = 5, 50
	    local _names = {
	    	"C", "B", "A", "S", "SS"
		} 
		local function _getColorByLevel( id )
			local _id = tonumber(id)
		    if _id == 2 then 
		        return cc.c3b(91, 167, 214)
		    elseif _id == 3 then 
		        return cc.c3b(98, 192, 50)
		    elseif _id == 4 then 
		        return cc.c3b(221, 89, 221)
		    elseif _id == 5 then 
		        return cc.c3b(255, 126, 0)
		    elseif _id == 6 then 
		        return display.COLOR_RED
		    end
	        return cc.c3b(197, 195, 197)
		end
	    for i=1, _length do
	    	local _data = self._valueDatas[i]
	    	local _level = tonumber(_data.color) or 1
	    	local _color = _getColorByLevel(_level)
	    	local _di = zc.getSprite({
	    		src = "res/Main/role/fetter/lineDi" .. _level .. ".png",
	    		ap = cc.p(0.5, 0),
	    		pos = cc.p(_scrollviewSize.width*0.5, _y),

    		})
    		_scrollView:addChild(_di)

    		local _diSize = _di:getContentSize()
    		local _line1 = zc.getSprite({
    			src = "res/Main/role/fetter/line.png",
    			ap = cc.p(0.5, 0),
    			pos = cc.p(_diSize.width*0.5, _diSize.height + 1)
			})
			_di:addChild(_line1)
			local _line2 = zc.getSprite({
    			src = "res/Main/role/fetter/line.png",
    			ap = cc.p(0.5, 1),
    			pos = cc.p(_diSize.width*0.5, -1)
			})
			_di:addChild(_line2)

			for j=3, 1, -1 do
				local _effId = tonumber(_data["effectId" .. j]) or 0
				if _effId ~= 0 then
					local _num = tonumber(_data["effectValue" .. j]) or 0
	                local _effLab = zc.createLabel({
						text = LANGUAGE_getAttributeTextById(_effId) .. "+" .. zc.getAttributeNumById(_effId, _num),
						fontSize = 20,
						ap = cc.p(0, 0.5),
						pos = cc.p(125 + (j-1)*120, _diSize.height*0.5),
						color = _color,
					})
					_di:addChild(_effLab)
				end
			end
			local _nameLab = zc.createLabel({
				text = _names[tonumber(_data.color)] .. zc.lang("level_1"),
				fontSize = 20,
				ap = cc.p(0, 0.5),
				pos = cc.p(20, _diSize.height*0.5),
				color = _color,
			})
			_di:addChild(_nameLab)

    		_y = _y + _height
	    end
	    if _y > _scrollviewSize.height then
	    	_scrollviewSize.height = _y
			_scrollView:setInnerContainerSize(_scrollviewSize)
	    end
	end
	
	self:show()
end

return RoleFetterAttrPop