--[[
FileName        RoleFetterLayer.lua
ProjectName     HJ2
Created by wangming on 16-10-19 重新开发
]]
local RoleFetterLayer = class("RoleFetterLayer", function()
    local layer = cc.Sprite:create()
    layer:setContentSize(629, 539)
    return layer
end)

function RoleFetterLayer:create( params )
    return RoleFetterLayer.new(params)
end

function RoleFetterLayer:ctor( params )
    local _size = self:getContentSize()
    self._width = _size.width
    self._height = _size.height
    self._middleX = 307
    self._nodeList = {}
    self._nowTag = 1

    local function onNodeEvent(event)
        if "enter" == event then
            self:onEnter()
        elseif "cleanup" == event then
            self:onCleanup()
        elseif "exit" == event then
            -- self:onExit()
        end
    end
    self:registerScriptHandler(onNodeEvent)

    self:initUI()
    self:refreshHero(params)
end

function RoleFetterLayer:onEnter()
    -- 顶部信息栏
    LayerManager.getTopInfoLayer():setPopInfo("RoleFetterLayer")
    if self._haveInit then
        self:freshData()
        self:freshTypeUI(nil, false)
    end
    self._haveInit = true
end

function RoleFetterLayer:onCleanup()
    self._exist = false
end

function RoleFetterLayer:initUI()
	-- 背景
    local _bg = cc.Sprite:create( "res/Main/role/common/role_bg.png" )
    _bg:setPosition(self._width*0.5, self._height*0.5)
    self:addChild(_bg)
    self._bg = _bg

    -- 顶部
    local _topNode = cc.Node:create()
    _bg:addChild(_topNode, 1)
    _topNode:setPosition(self._middleX, self._height - 5)

    local _topWidth = 594
    local _topBg = zc.getSprite({
    	src = "res/Main/role/common/top_bg.jpg",
    	ap = cc.p(0.5, 1),
    })
    _topNode:addChild(_topBg)
    local _topBgSize = _topBg:getContentSize()
    _topBg:setScaleX(_topWidth/_topBgSize.width)

    -- 名字
    local _nameBgSize = cc.size(280, 33)
    local _nameBg = ccui.Scale9Sprite:create(cc.rect(12, 11, 14, 10), "res/Main/role/common/name_bg.png")
    _nameBg:setContentSize(_nameBgSize)
    _nameBg:setPosition(0, -_topBgSize.height*0.5)
    _topNode:addChild(_nameBg)
    local _name = zc.createLabel({
        fontSize = 24,
        color = cc.c3b(226, 225, 168),
        pos = cc.p(_nameBgSize.width*0.5, _nameBgSize.height*0.5)
    })
    _nameBg:addChild(_name)
    self._nameLabel = _name

    local _detailBtn = zc.createPushButton({
        normalFile = "res/Main/common/button/exclamation_u.png",
        selectedFile = "res/Main/common/button/exclamation_d.png",
        pos = cc.p(_topWidth*0.5 - 30, _nameBg:getPositionY()),
        endCallback = function()
            zc.createRulePop(8)
        end,
    })
    _topNode:addChild(_detailBtn)		

    -- 底部
    local _cultureBgSize = cc.size(594, 80)
    local _cultureBg = ccui.Scale9Sprite:create(cc.rect( 20, 10, 549, 71), "res/Main/role/trinket/sellDi.png")
    _cultureBg:setContentSize(_cultureBgSize)
    _cultureBg:setAnchorPoint(0.5, 0)
    _cultureBg:setPosition(self._middleX, 35)
    _bg:addChild(_cultureBg, 1)

    local _btnInfoTb = {
	    {
		    name = zc.lang("general_fetter"),
		    px = 0.3,
		    endCall = function()
		    	self:freshTypeUI(1)
		    end,
		},
		{
		    name = zc.lang("regional_map"),
		    px = 0.7,
		    endCall = function() 
                zc.createRoleFettersRegionalMapLayer({region = self._heroData.region})
            end,
		},
	}
	for i=1, 2 do
	    local _typeBtn = zc.createCommomBtn({
			tag = 1,
			text = _btnInfoTb[i].name,
			pos = cc.p(_cultureBgSize.width*_btnInfoTb[i].px, _cultureBgSize.height*0.5),
			endCallback = _btnInfoTb[i].endCall,
		})
		_cultureBg:addChild(_typeBtn)
	end


    local _frame = ccui.Scale9Sprite:create(cc.rect(16, 0, 32, 511), "res/Main/common/frame.png")
    _frame:setContentSize(611, 513)
    _frame:setAnchorPoint(0, 1)
    _frame:setPosition(2, self._height)
    _bg:addChild(_frame, 1)

    local _kong = zc.createSprite("res/Main/common/empty.png")
    _kong:setPosition(self._width*0.5, self._height*0.5 + _cultureBgSize.height*0.5)
    _bg:addChild(_kong, 1)
    self._kong = _kong

    self._name = _name
end

--羁绊
function RoleFetterLayer:freshType1(freshIdx)
    local _typeNode1 = self._nodeList[1]
	if not _typeNode1 then
		local _bg = self._bg

	    local _middleX = self._middleX
		-- 武将阴影层
	    local _shadowHeroWidth = 572
	    local _shadowHeroHeight = 365
	    local _shadowHero = ccui.Scale9Sprite:create(cc.rect(11, 10, 30, 30), "res/Main/role/common/shadow_bg.png")
	    _shadowHero:setContentSize(_shadowHeroWidth, _shadowHeroHeight)
	    _shadowHero:setAnchorPoint(0.5, 0)
	    _shadowHero:setPosition(_middleX, self._height - 416)
	    _bg:addChild(_shadowHero)
        _typeNode1 = _shadowHero
        self._nodeList[1] = _shadowHero

        local _tipDiSize = cc.size(320, 25)
        local _tipDi = zc.getScaleNode("res/Main/role/common/name_bg.png", _tipDiSize)
        _tipDi:setPosition(_shadowHeroWidth*0.5, 15)
        _shadowHero:addChild(_tipDi)

        cc.SpriteFrameCache:getInstance():addSpriteFrames("res/Main/home/homeUI.plist", "res/Main/home/homeUI.pvr.ccz")
        local _pScale = 0.5
        local _tipImg = zc.getSprite({
            src = "home_icon_info.png",
            plist = true,
            ap = cc.p(0, 0.5),
            pos = cc.p(-5, _tipDiSize.height*0.5),
            scale = _pScale,
        })
        _tipDi:addChild(_tipImg)
        local _width = _tipImg:getContentSize().width*_pScale - 10
        local _tipLab = zc.createLabel({
            text = zc.lang("fetters_up_tips"),
            fontSize = 18,
            ap = cc.p(0, 0.5),
            pos = cc.p(_tipImg:getPositionX() + _width, _tipImg:getPositionY()),
            color = cc.c3b(176, 145, 115),
        })
        _tipDi:addChild(_tipLab)
        _width = _width + _tipLab:getContentSize().width
        _tipDi:setContentSize(_width, _tipDiSize.height)

        local _line = zc.getSprite({
            src = "res/Main/activity/rechargeFirst/cutLine.png",
            pos = cc.p(_shadowHeroWidth*0.5, _shadowHeroHeight*0.5)
        })
        _line:setOpacity(255*0.4)
        _line:setRotation(90)
        _shadowHero:addChild(_line)

        local _leftArrow = zc.createPushButton({
            normalFile = "res/Main/weaponCopy/arrow.png",
            pos = cc.p(20, _shadowHeroHeight*0.5),
            endCallback = function()
                local _leftNum = tonumber(_typeNode1["attrDi1"].idx) or 1
                if _leftNum > 1 then
                    self:freshFetterCell(_typeNode1["attrDi1"], _leftNum - 1)
                    self:freshFetterCell(_typeNode1["attrDi2"], _leftNum)
                end

                if self._fetterDatas[_leftNum - 2] then
                    _typeNode1.leftArrow:setVisible(true)
                else
                    _typeNode1.leftArrow:setVisible(false)
                end 
                if self._fetterDatas[_leftNum + 1] then
                    _typeNode1.rightArrow:setVisible(true)
                else
                    _typeNode1.rightArrow:setVisible(false)
                end 
            end
        })
        _shadowHero:addChild(_leftArrow)
        _typeNode1.leftArrow = _leftArrow

        local _sp = zc.createSprite("res/Main/weaponCopy/arrow.png")
        _sp:setScaleX(-1)
        local _rightArrow = zc.createPushButton({
            normalNode = _sp,
            pos = cc.p(_shadowHeroWidth - _leftArrow:getPositionX(), _leftArrow:getPositionY()),
            endCallback = function()
                local _rightNum = tonumber(_typeNode1["attrDi2"].idx) or #self._fetterDatas
                if _rightNum < #self._fetterDatas then
                    self:freshFetterCell(_typeNode1["attrDi1"], _rightNum)
                    self:freshFetterCell(_typeNode1["attrDi2"], _rightNum + 1)
                end

                if self._fetterDatas[_rightNum - 1] then
                    _typeNode1.leftArrow:setVisible(true)
                else
                    _typeNode1.leftArrow:setVisible(false)
                end 
                if self._fetterDatas[_rightNum + 2] then
                    _typeNode1.rightArrow:setVisible(true)
                else
                    _typeNode1.rightArrow:setVisible(false)
                end 
            end
        })
        _shadowHero:addChild(_rightArrow)
        _typeNode1.rightArrow = _rightArrow

        for i=1, 2 do
            local _attrDiSize = cc.size(200, 165)
            local _attrDi = zc.getScaleNode("res/Main/role/common/name_bg.png", _attrDiSize)
            _attrDi:setAnchorPoint(0.5, 0)
            _shadowHero:addChild(_attrDi)
            _attrDi:setPosition(_shadowHeroWidth*0.25 + (i-1)*_shadowHeroWidth*0.5, 35)
            
            local _flowerDi = zc.createSprite("res/Main/common/popBg/bgFlower.png")
            _flowerDi:setPosition(_attrDiSize.width*0.5, _attrDiSize.height + _flowerDi:getContentSize().height*0.5 - 5)
            _attrDi:addChild(_flowerDi)
            local _headDi = zc.createSprite("res/Main/role/fetter/fetterItemBg.png")
            _headDi:setPosition(_flowerDi:getPositionX(), _flowerDi:getPositionY())
            _attrDi:addChild(_headDi)
            local _headIcon = zc.createIconByData({
                data = {
                    mainType = zc.mainTypeSoldier,
                    type = 1,
                    id = 1,
                }, 
                pos = cc.p(_headDi:getPositionX(), _headDi:getPositionY() + 3), 
            })
            _headIcon:setScale(0.8)
            _attrDi:addChild(_headIcon)
            _attrDi.headIcon = _headIcon

            local _nameDi = zc.createSprite("res/Main/role/fetter/nameDi.png")
            _attrDi:addChild(_nameDi)
            _nameDi:setPosition(_headIcon:getPositionX(), _headIcon:getPositionY() - 65)
            _nameDi:setScaleX(1.2)

            local _nameLab = zc.createLabel({
                fontSize = 18,
                pos = cc.p(_nameDi:getContentSize().width*0.5, _nameDi:getContentSize().height*0.5),
            })
            _nameLab:setScaleX(1/1.2)
            _nameDi:addChild(_nameLab)
            _attrDi.nameLab = _nameLab


            for i = 1, 5 do 
                local _star = zc.getSprite({
                    src = "res/Main/common/common_hero_star_1.png",
                    pos = cc.p(-10 + 20*i, 15),
                    scale = 0.8,
                })
                _headIcon:addChild(_star, 1)
                _headIcon["star" .. i] = _star
            end

            local _valueDiSize = cc.size(180, 32)
            for i=1, 4 do
                local _valueDi = zc.getScaleNode("res/Main/role/common/name_bg.png", _valueDiSize)
                _valueDi:setPosition(_attrDiSize.width*0.5, 140 - 38*(i-1))
                _attrDi:addChild(_valueDi)
                _attrDi["valueDi"..i] = _valueDi

                local _typeLab = zc.createRichLabel({
                    fontSize = 18,
                    anchor = cc.p(0, 0.5),
                    pos = cc.p(5, _valueDiSize.height*0.5),
                })
                _typeLab:setGradientColor(cc.c4b(244, 159, 8, 255), cc.c4b(255, 255, 124, 255), cc.p(0, -1))
                _valueDi:addChild(_typeLab)
                _valueDi.typeLab = _typeLab

                local _valueLab = zc.createLabel({
                    fontSize = 18,
                    ap = cc.p(1, 0.5),
                    pos = cc.p(_valueDiSize.width - 5, _valueDiSize.height*0.5),
                })
                _valueDi:addChild(_valueLab)
                _valueDi.valueLab = _valueLab
            end

            _typeNode1["attrDi"..i] = _attrDi
        end
	end

	self._nameLabel:setString(zc.lang("fetter_list"))
	if #self._fetterDatas == 0 then
        _typeNode1:setVisible(false)
        self._kong:setVisible(true)
        return
    end
    _typeNode1:setVisible(true)
    self._kong:setVisible(false)
    if freshIdx then
        self:freshFetterCell(_typeNode1["attrDi1"], 1)
        self:freshFetterCell(_typeNode1["attrDi2"], 2)
        _typeNode1.leftArrow:setVisible(false)
        if self._fetterDatas[3] then
            _typeNode1.rightArrow:setVisible(true)
        else
            _typeNode1.rightArrow:setVisible(false)
        end
    else
        if _typeNode1["attrDi1"].idx then
            self:freshFetterCell(_typeNode1["attrDi1"], _typeNode1["attrDi1"].idx)
        end
        if _typeNode1["attrDi2"].idx then
            self:freshFetterCell(_typeNode1["attrDi2"], _typeNode1["attrDi2"].idx)
        end
    end
end

function RoleFetterLayer:freshFetterCell( di, idx )
    local data = self._fetterDatas[idx]
    if not data then
        di:setVisible(false)
    end
    di.idx = idx
    zc.updateIconByData(di.headIcon, {
        data = {
            mainType = zc.mainTypeSoldier,
            type = 1,
            id = data.heroDb.id,
        }, 
        listener = function()
            if data.heroData then
                zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_ROLE_SELECT_HERO_TAB, data = {heroId = data.heroData.id, tabId = 4}})
            else
                zc.createPubLayer(data.heroDb.id)
            end 
        end,
    })
    zc.doFuncForAllChild(di.headIcon, function( child )
        zc.setGray(child, not data.heroData)
    end)
    local _reincarnate = data.heroData and data.heroData.reincarnate or 0
    _reincarnate = tonumber(_reincarnate) or 0

    local _heroLevel = data.heroData and data.heroData.level or 1

    local _reincarnateLevel = 0
    if _reincarnate > 0 then
        local _data = gameData.getDataFromCache("hero_reincarnate", {level = _reincarnate, heroType = data.heroData.type})
        local _tmpLevel = tonumber(_data.needLevel) or 0
        _heroLevel = _heroLevel < _tmpLevel and _tmpLevel or _heroLevel
    end
    local _heroStar = data.heroData and data.heroData.star or 0

    if data.heroData then
        local _str = zc.getLevelTipShow() .. data.heroData.level .. " " .. data.heroDb.name
        if _reincarnate ~= 0 then
            _str = _reincarnate .. zc.lang("turn") .. _str
        end
        di.nameLab:setString(_str)
        di.nameLab:setColor(display.COLOR_WHITE)
    else
        di.nameLab:setString(data.heroDb.name)
        di.nameLab:setColor(display.COLOR_GRAY)
    end

    local _tmpStar = 0
    if _heroStar ~= 0 then
        _tmpStar = ((_heroStar - 1)%5) + 1
    end
    for i=1, 5 do
        local _file = "res/Main/common/common_hero_star_1.png"
        if _heroStar > 10 then
            _file = "res/Main/role/starup/star_purple.png"
        elseif _heroStar > 5 then
            _file = "res/Main/role/starup/star_blue.png"
        end
        if i <= _tmpStar then
            di.headIcon["star" .. i]:setTexture(_file)
            di.headIcon["star" .. i]:setVisible(true)
        else
            di.headIcon["star" .. i]:setVisible(false)
        end
    end

    for i=1,4 do
        local _di = di["valueDi" .. i]
        local _linkData = data.linkData[i]
        if _linkData then
            _di:setVisible(true)
            _di.typeLab:setString(LANGUAGE_getAttributeTextById(_linkData.effectId) .. "：")
            local _str = ""
            local _color = display.COLOR_GRAY
            local _num = _linkData.unlockCondition == 1 and _heroLevel or _heroStar
            if data.heroData and _num >= _linkData.needLevel then
                _color = display.COLOR_GREEN
                local __num = _linkData.effectGrow
                if _linkData.unlockCondition == 1 then
                    __num = __num + _linkData.turnEffectgrow*_reincarnate
                end
                __num = _linkData.effectValue + (_num - _linkData.needLevel)*__num
                _str = "+" .. zc.getAttributeNumById(_linkData.effectId, __num)
            else
                local _checkNum = _linkData.unlockCondition == 1 and 1 or 0
                if _linkData.needLevel <= _checkNum then
                    _str = zc.lang("un_deblocking")
                else
                    _str = _linkData.unlockCondition == 1 and zc.lang("level_unlock") or zc.lang("star_unlock")
                    _str = _linkData.needLevel .. _str
                end
            end
            _di.valueLab:setColor(_color)
            _di.valueLab:setString(_str)
        else
            _di:setVisible(false)
        end
    end
end

function RoleFetterLayer:freshTypeUI( tag, freshIdx )
	local _tag = tag or self._nowTag
    local _freshIdx  = freshIdx == nil and true or freshIdx
	if tag and _tag == self._nowTag then
		return
	end
	self._nowTag = _tag
	if #self._nodeList > 0 then
		for i=1, #self._nodeList do
			if i ~= tag then
				self._nodeList[i]:setVisible(false)
			end
		end
	end
	if _tag == 1 then
		self:freshType1(_freshIdx)
	elseif _tag == 2 then
	end
end

function RoleFetterLayer:refreshHero( params )
	-- 数据
    local _id = tonumber(params.id) or 1
    -- 武将数据
    self._heroData = PlayerData:getGeneralInfoById(_id) or {}
    self._heroId = tonumber( self._heroData.heroId ) or 0
    self:freshData()
    self:freshTypeUI()
end

function RoleFetterLayer:freshData()
	self._fetterDatas = gameData.getDataFromCache("fetters", {mainHeroId = self._heroId})
	if table.nums(self._fetterDatas) > 0 then
		local _table = {}
		for k,v in pairs(self._fetterDatas) do
			if not _table[v.heroId] then
				_table[v.heroId] = {}
			end
			table.insert(_table[v.heroId], v)
		end
		self._fetterDatas = {}
		for k,v in pairs(_table) do
            local _heroId = v[1].heroId
			table.insert(self._fetterDatas, {
                heroDb = gameData.getDataFromCacheWithPrimaryKey("hero", _heroId),
                heroData = PlayerData:getGeneralInfoByHeroId(_heroId),
                linkData = v
            })
		end
	end
end

return RoleFetterLayer