--[[
-- 饰品
-- @author wangming
-- Creation  2016-08-19
]]
local RoleTrinketLayer = class("RoleTrinketLayer", function()
    return zc.createNormalDialog()
end)

function RoleTrinketLayer:create( params )
    return RoleTrinketLayer.new( params )
end

function RoleTrinketLayer:ctor( params )
	self._heroData = PlayerData:getPlayerHero() or {}
	self._trinketList = gameData.getAllDataWithNoClone("trinket")
	self._rNum = 5
    self._trinkets = {}
    self._mainData = {}
    self._roleTrinketData = {}
    self._bagTrinketData = {}
    self._bagTrinketAttr = {}

    self:initUI()
end

function RoleTrinketLayer:initUI()
    local _nodeHeight = 550
	-----------left-------------
    local _leftNode = zc.createNormalPop({
        srcTag = 3,
        height = _nodeHeight,
    })
    _leftNode:setAnchorPoint(1, 0.5)
    _leftNode:setPosition(zc.width*0.5 - 100, zc.height*0.5 - 20)
	self:addChild(_leftNode)

	local _leftSize = _leftNode:getContentSize()

	local _topBg = zc.getSprite({
		src = "res/Main/role/common/top_bg.jpg",
    	ap = cc.p(0.5, 1),
    	pos = cc.p(_leftSize.width*0.5, _leftSize.height - 5)
	})
	local _scaleX = _leftSize.width/_topBg:getContentSize().width
	_topBg:setScaleX(_scaleX)
	_leftNode:addChild(_topBg, 1)

	local _nameDi = zc.getScaleNode("res/Main/role/common/name_bg.png", cc.size(410, 30))
	_nameDi:setPosition(_topBg:getPositionX(), _topBg:getPositionY() - _topBg:getContentSize().height*0.5)
	_leftNode:addChild(_nameDi, 1)

	local _level = tonumber(self._heroData.level) or 0
	local _name = PlayerData:getBaseInfoByTag("userName")
	local _godName = PlayerData:getBaseInfoByTag("godName")
	local _nameLabel = zc.createRichLabel({
		text = zc.getLevelTipShow() .. _level .. " " .. _name .. "  [color=ffe105fb]" .. zc.getGodNameById( _godName ) .. "[/color]",
		fontSize = 20,
		pos = cc.p(_nameDi:getPosition()),
	})
	_leftNode:addChild(_nameLabel, 1)

    local _spine = zc.createSpine({
        fileName = "jsxxyxg",
        actName = "animation",
    })
    _spine:setPosition(_nameDi:getPositionX(), _leftSize.height*0.5 + 50)
    _leftNode:addChild(_spine)

	local _showHeroSize = cc.size(400, 400)
	local _view = zc.createScrollview({
        size = _showHeroSize,
        innerSize = _showHeroSize,
        touchEnable = false,
        ap = cc.p(0.5, 0.5),
        pos = cc.p(_nameDi:getPositionX() - _showHeroSize.width*0.5, _leftSize.height*0.5 - _showHeroSize.height*0.5),
    }) 
    _leftNode:addChild(_view)



	local _heroArmature = zc.battle.createHeroArmatureWithResId(self._heroData.modelId, self._heroData.weaponId)
    _heroArmature:getAnimation():play("idle")
    _heroArmature:setPosition(_showHeroSize.width*0.5, _showHeroSize.height*0.5)
	_heroArmature:setScaleX(-1)
	_view:addChild(_heroArmature)
	zc.soldierChangeWeapon(_heroArmature, self._heroData.weaponId or 0 )
	self._armature = _heroArmature
	local function animationEvent(armatureBack,movementType,movementID)
        if movementType == ccs.MovementEventType.complete then
            _heroArmature:getAnimation():play("idle")
        end
    end
    _heroArmature:getAnimation():setMovementEventCallFunc(animationEvent)
    local heroBtn = zc.createPushButton({
    	pos = cc.p(_heroArmature:getPosition()),
        touchSize = _showHeroSize,
        endCallback = function()
            local _action = zc.random(1, 3)
            if self._action == _action then
                if _action < 3 then
                    _action = _action + 1
                else 
                   _action = 1 
                end
            end
            self._action = _action
            local _actions = {"atk3", "atk", "atk0"}
            if self._armature then
                self._armature:getAnimation():play( _actions[_action], -1, 0 )
            end
        end
    })
    _view:addChild( heroBtn )


	self._trinkets = {}
    local _starX, _width, _startY, _height = 60, 310, 410, 110
	for i=1, 8 do
		local _r = math.modf((i - 1)/2)
		local _l = (i - 1)%2
        local _spine = zc.getSpine("jiemianshengzi")
        _spine:setPosition(_starX + _l*_width, _startY - (_r-1)*_height)
        _leftNode:addChild(_spine)
        if i <= 6 then
    		local _sp = zc.createPushButton({
            	normalFile = "res/Main/role/trinket/di_0.png",
            	pos = cc.p(cc.p(_starX + _l*_width, _startY - _r*_height)),
            	endCallback = function()
    	        	local data = self._roleTrinketData[tostring( i )]
                    if data then
                        zc.createSourcePop("RoleTrinketInfoPop", "src/layer/role/RoleTrinketInfoPop.lua", {curItem = data})
                    else
                        zc.tipInfo(zc.lang("position_un_equip_trinket"))
                    end
            	end
            })
    		_leftNode:addChild(_sp, 1)
    		table.insert(self._trinkets, _sp)

    		local _icon = zc.getSprite({
    	    	src = "res/Main/role/trinket/icon_" .. i .. ".png",
    	    	pos = cc.pMul(cc.pFromSize(_sp:getContentSize()), 0.5)
    		})
    		_icon:setName("icon")
    		_sp:addChild(_icon)
        else
            _spine:playAction("animation", true)
        end
	end

	local _attrBg = zc.getSprite({
    	src = "res/Main/role/trinket/attrBg.png",
    	ap = cc.p(0, 0),
    	pos = cc.p(0, 0)
	})
	_leftNode:addChild(_attrBg, 1)
	local _attrBgSize = _attrBg:getContentSize()

	local _attrTitle = zc.getSprite({
    	src = "res/Main/role/trinket/attrTitle.png",
    	ap = cc.p(0.5, 0),
    	pos = cc.p(_attrBgSize.width*0.5, _attrBgSize.height + 5)
	})
	_attrBg:addChild(_attrTitle)

	local _arrTexts = {30, 12, 8, 4}
	self._attrLabels = {}
	for i=1, 4 do
		local _r = math.modf((i - 1)/2)
		local _l = (i - 1)%2
		local _attrDi = zc.getSprite({
			src = "res/Main/role/trinket/attrDi.png",
	    	pos = cc.p(_attrBgSize.width*0.5 - 100 + _l*200, 80 - _r*45),
		})
		_attrBg:addChild(_attrDi)

		local _label = zc.createRichLabel({
			text = LANGUAGE_getGemAttrByType(_arrTexts[i]) .. ":",
			fontSize = 20,
			anchor = cc.p(0, 0.5),
			pos = cc.p(5, _attrDi:getContentSize().height*0.5),
		})
		_label:setGradientColor(cc.c4b(244, 159, 8, 255), cc.c4b(255, 255, 124, 255), cc.p(0, -1))
		_attrDi:addChild(_label)

		local _numberLabel = zc.createLabel({
			text = 0,
			fontSize = 20,
			ap = cc.p(1, 0.5),
			pos = cc.p(_attrDi:getContentSize().width - 5, _attrDi:getContentSize().height*0.5),
            outLine = true,
		})
		_attrDi:addChild(_numberLabel)
		table.insert(self._attrLabels, _numberLabel)
	end


	-----------right-------------
	local _rightNode = zc.createNormalPop({
        srcTag = 2,
        height = _nodeHeight,
    })
	_rightNode:setAnchorPoint(0, 0.5)
	_rightNode:setPosition(zc.width*0.5 - 70, _leftNode:getPositionY())
	self:addChild(_rightNode)
    local _rightSize = _rightNode:getContentSize()

	local notOwnTrinket = zc.getSprite({
		src = "res/Main/common/empty.png",
		pos = cc.p(_rightSize.width*0.5 - 20, _rightSize.height*0.5 + 50),
	})
	_rightNode:addChild(notOwnTrinket)
	notOwnTrinket:setVisible(false)
	self._notOwnTrinket = notOwnTrinket
	
    -- tableview
    local trinketTableviewSize = cc.size(580, _nodeHeight - 130)
    local trinketTableview = zc.ZCTableView:create(trinketTableviewSize)
    trinketTableview:setBounceable(true)
    trinketTableview:setInertia(true)
    trinketTableview:setDirection(cc.SCROLLVIEW_DIRECTION_VERTICAL)
    trinketTableview:setPosition(0, 90)
    trinketTableview:setDelegate()
    trinketTableview:setVerticalFillOrder(cc.TABLEVIEW_FILL_TOPDOWN)
    local cellSize = cc.size( trinketTableviewSize.width,  110)
    local function cellSizeForTable(table, index) 
        return cellSize.height, cellSize.width
    end
    local function tableCellAtIndex(table, index)
        local cell = table:dequeueCell()
        -- 创建模板
        if cell == nil then
            cell = zc.ZCTableViewCell:new()
            self:buildCell( cell, index, cellSize )
        end
        self:updateCell( cell, index )

        return cell
    end
    local function numberOfCellsInTableView()
        return math.ceil( #self._bagTrinketData/self._rNum )
    end
    trinketTableview:registerScriptHandler(cellSizeForTable, cc.TABLECELL_SIZE_FOR_INDEX)
    trinketTableview:registerScriptHandler(tableCellAtIndex, cc.TABLECELL_SIZE_AT_INDEX)
    trinketTableview:registerScriptHandler(numberOfCellsInTableView, cc.NUMBER_OF_CELLS_IN_TABLEVIEW)
    _rightNode:addChild( trinketTableview )
    self._trinketTableview = trinketTableview


	local _sellBg = zc.getSprite({
    	src = "res/Main/role/trinket/sellDi.png",
    	ap = cc.p(0, 0),
    	pos = cc.p(0, 0)
	})
	_rightNode:addChild(_sellBg, 1)

	local _sellSize = _sellBg:getContentSize()

	local _numberDi = zc.getScaleNode("res/Main/role/trinket/attrDi.png", cc.size(240, 32))
	_numberDi:setAnchorPoint(0, 0.5)
    _numberDi:setPosition(60, _sellSize.height*0.5)
	_sellBg:addChild(_numberDi)

	local _descBtn = zc.createPushButton({
		normalFile = "res/Main/common/button/exclamation_u.png",
		selectedFile = "res/Main/common/button/exclamation_d.png",
		pos = cc.p(0, _numberDi:getContentSize().height*0.5),
		endCallback = function()
			-----玩法说明
            zc.createRulePop(5)
		end
	})
	_numberDi:addChild(_descBtn)

	local _numberDescLab = zc.createLabel({
		text = zc.lang("trinket_totle_num") .. "：",
		fontSize = 20,
		ap = cc.p(0, 0.5),
    	pos = cc.p(20, _numberDi:getContentSize().height*0.5),
        outLine = true,
	})
	_numberDi:addChild(_numberDescLab)

	local _numberLab = zc.createLabel({
		text = "0",
		fontSize = 20,
		ap = cc.p(1, 0.5),
    	pos = cc.p(_numberDi:getContentSize().width - 5, _numberDi:getContentSize().height*0.5),
        outLine = true,
	})
	_numberDi:addChild(_numberLab)
	self._trinketNum = _numberLab

	-- 一键出售
    local oneKeyBtn = zc.createCommomBtn({
        tag = 1,
        text = zc.lang("one_key_sell"),
        pos = cc.p(_sellSize.width - 100, _sellSize.height*0.5),
        endCallback = function()
            -- 一键出售
            zc.createPop("sellConfirmOther", {title = "yijianchushou",rightFunc = function()
                self:refresh()
            end})
        end
    })
    _sellBg:addChild(oneKeyBtn)

end

function RoleTrinketLayer:buildCell( cell, index, cellSize )
    cell._trinkets = {}
    for i = 1, self._rNum do
        -- 饰品
        local trinket = cc.Sprite:create()
        trinket:setPosition( ( cellSize.width - 30 )/(self._rNum*2)*( 2*i - 1 ) + 22, cellSize.height/2 )
        trinket:setScale( 0.8 )
        cell:addChild( trinket )
        cell._trinkets[i] = trinket
        local trinketSp = cc.Sprite:create()
        trinketSp:setPosition( trinket:getPosition() )
        trinketSp:setScale( 0.8 )
        cell:addChild( trinketSp )
        trinket._sp = trinketSp
        local btn = zc.createPushButton({
            touchSize = cc.size( 60, 60 ),
            pos = cc.p( trinket:getPosition() ),
            needSwallow = false,
            needEnableWhenMoving = true,
            endCallback = function()
                --新手引导
                local _currentGID = getGuideManager():getCurrentGID()
                if _currentGID == GuideKey.KEY_11511 or _currentGID == GuideKey.KEY_11513 then
                    getGuideManager():guideOver()
                    getGuideManager():setNextGID(_currentGID)
                end
                self:clickTrinket( self._bagTrinketData[cell._index*self._rNum + i] )
            end
        })
        cell:addChild( btn )
        trinket._btn = btn
        -- 可装备
        local canEquip = cc.Sprite:create( "res/Main/role/trinket/can_equip.png" )
        canEquip:setAnchorPoint( 0, 1 )
        canEquip:setPosition( trinket:getPositionX() - 48, trinket:getPositionY() + 48 )
        cell:addChild( canEquip )
        trinket._canEquip = canEquip
        -- 可洗练
        local canReplace = cc.Sprite:create( "res/Main/role/trinket/can_replace.png" )
        canReplace:setAnchorPoint( 0, 1 )
        canReplace:setPosition( canEquip:getPosition() )
        cell:addChild( canReplace )
        trinket._canReplace = canReplace
    end
end

function RoleTrinketLayer:updateCell( cell, index )
    cell._index = index
    for i = 1, self._rNum do
        local _index = index*self._rNum + i
        local data = self._bagTrinketData[_index]
        if data then
            local status = self._bagTrinketAttr[_index]
            if not status then
                status = self:buildBagTrinketAttr( data )
                self._bagTrinketAttr[_index] = status
                data["NowState"] = status
            end
            -- 有饰品
            cell._trinkets[i]:setVisible( true )
            cell._trinkets[i]._sp:setVisible( true )
            local _info = self._trinketList[tostring( data.trinketId )]
            cell._trinkets[i]:setTexture( string.format("res/Main/hero/hero_item%d.png", _info.color)  )
            cell._trinkets[i]._sp:setTexture( string.format("res/Main/ornaments/icon/%d.png", _info.icon)  )
            if not status.isCanEquip then
                -- 不可装备
                cell._trinkets[i]._canEquip:setVisible( false )
                -- 检查是否可洗练
                local _isCanReplace = status.isCanReplace
                cell._trinkets[i]._canReplace:setVisible(_isCanReplace)
                
                if _isCanReplace then
                    --新手引导
                    if i == 1 and index == 0 then
                        local _currentGID = getGuideManager():getCurrentGID()
                        if _currentGID == GuideKey.KEY_11513 then
                            self._guideBtn_replace = cell._trinkets[i]
                            self._guideBtn_replace._btn:setSwallowTouches(true)
                        end
                    end
                end
            else
                -- 可装备
                cell._trinkets[i]._canEquip:setVisible( true )
                cell._trinkets[i]._canReplace:setVisible( false )
                --新手引导
                if i == 1 and index == 0 then
                    local _currentGID = getGuideManager():getCurrentGID()
                    if _currentGID == GuideKey.KEY_11511 then
                        self._guideBtn_triket = cell._trinkets[i]
                        self._guideBtn_triket._btn:setSwallowTouches(true)
                    end
                end
            end
        else
            -- 没有饰品
            cell._trinkets[i]:setVisible( false )
            cell._trinkets[i]._sp:setVisible( false )
            cell._trinkets[i]._canEquip:setVisible( false )
            cell._trinkets[i]._canReplace:setVisible( false )
        end
    end
end

function RoleTrinketLayer:clickTrinket( trinketData )
    if not trinketData then return end
    -- 当前饰品对应位置上的已装备饰品
    local roleTrinketData = self._roleTrinketData[tostring( trinketData.position )]
    -- 装备
    local function sureClick()
        getGuideManager():guideOver()
        zc.sendHttp({
            apiName = "Trinket_equip",
            params = {id = trinketData.id},
            successCallback = function (data) 
                --新手引导
               local _currentGID = getGuideManager():getCurrentGID()
               if _currentGID == GuideKey.KEY_11512 then
                  getGuideManager():setNextGID(_currentGID)
                  performWithDelay(self, function ()
                        local _par = self:getParent()
                        if _par then
                           _par:onEnter()
                        end
                  end,0.3)
               end
               PlayerData:updateTrinketStatus(trinketData.id, data.status)
               if roleTrinketData then
                    PlayerData:updateTrinketStatus( roleTrinketData.id, 0 )
               end
               self:refresh(trinketData.id)
               self:addGuide()
            end,
        })
    end
    -- 饰品洗练处理
    local function replaceAttrSuccessFunc()
        --新手引导
        local _currentGID = getGuideManager():getCurrentGID()
        if _currentGID == GuideKey.KEY_11514 then
            getGuideManager():guideOver()
            getGuideManager():setNextGID(_currentGID)
        end
        --撤销洗练 
        local leftFuncConfirm = function ()
            zc.sendHttp({
                apiName = "Trinket_replaceAttributeRecovery",
                params = {id = roleTrinketData.id},
                successCallback = function (data)
                    PlayerData:updataData(data)
                    PlayerData:subTrinketsInfo(trinketData.id)
                    self:refresh()
                end,
            })
        end
        --洗练完成
        local rightFuncConfirm = function (replaceData)
            PlayerData:updataData(replaceData)
            PlayerData:updateTrinketsInfo(roleTrinketData.id,replaceData)
            PlayerData:subTrinketsInfo(trinketData.id)
            self:refresh()
        end
        zc.createSourcePop("trinketReplaceAttr", "src/layer/role/TrinketReplaceAttrLayer.lua", {
            _type = 1,
            item = trinketData,
            curItem = roleTrinketData,
            replaceAttrFunc = replaceAttrFuncConfirm,
            leftFunc = leftFuncConfirm,
            rightFunc = rightFuncConfirm,
            fightCallback = function()
                self:fightChange()
            end,
        })

    end
    -- 饰品属性转移处理
    local function transferAttrFunc()
        local function transferAttrSuccessFunc(costMoney)
            PlayerData:updateResourcesInfo("money",costMoney,"sub")
            PlayerData:updateTrinketsTransferInfo(roleTrinketData,trinketData)
            self:refresh()
        end
        zc.createSourcePop("trinketReplaceAttr", "src/layer/role/TrinketReplaceAttrLayer.lua", {
            _type = 2,
            item = trinketData,
            curItem = roleTrinketData,
            transferAttrFunc = transferAttrSuccessFunc,
            fightCallback = function()
                self:fightChange()
            end,
        })
    end
    -- 出售
    local function _sellCallBack()
        self:refresh()
    end
    zc.createSourcePop("RoleTrinketInfoPop", "src/layer/role/RoleTrinketInfoPop.lua", {
        confirmFunc = sureClick,
        replaceAttrFunc = replaceAttrSuccessFunc,
        transferAttrFunc = transferAttrFunc,
        item = trinketData,
        curItem = roleTrinketData,
        sellCallBack = _sellCallBack,
    })
end

-- 刷新
function RoleTrinketLayer:refresh( equipId )
    -- 数据
    self._roleTrinketData = {}
    self._bagTrinketData = {}
    local _trinketsInfo = PlayerData:getTrinketsInfo() or {}
    for i, v in ipairs(_trinketsInfo) do
        if tonumber( v.status or 0 ) == 5 then
            -- 已穿戴
            v.icon = self._trinketList[tostring( v.trinketId )].icon
            v.color = tonumber( self._trinketList[tostring( v.trinketId )].color ) or 0
            v.position = tonumber( self._trinketList[tostring( v.trinketId )].position ) or 0
            v.name = self._trinketList[tostring( v.trinketId )].name
            self._roleTrinketData[tostring( v.position )] = v
        elseif tonumber( v.status or 0 ) == 0 then
            -- 未穿戴
            v.icon = self._trinketList[tostring( v.trinketId )].icon
            v.color = tonumber( self._trinketList[tostring( v.trinketId )].color ) or 0
            v.position = tonumber( self._trinketList[tostring( v.trinketId )].position ) or 0
            v.name = self._trinketList[tostring( v.trinketId )].name
            self._bagTrinketData[#self._bagTrinketData + 1] = v
        end
    end
    
    table.sort(self._bagTrinketData, function( a, b )
        if a.color ~= b.color then
            return a.color > b.color
        else
            return tonumber( a.trinketId or 0 ) > tonumber( b.trinketId or 0 )
        end
    end)

    -- 刷新饰品数量
    local _num = #self._bagTrinketData
    if _num > 0 then
    	self._trinketNum:setColor(display.COLOR_GREEN)
    else
    	self._trinketNum:setColor(display.COLOR_WHITE)	
    end
    self._trinketNum:setText(_num .. "/200")

    -- 刷新已穿戴的饰品
    local _numsTb = {}
    local _taozhuangId = {} --已经增加的套装属性

    local function _countNum( _data, key )
    	if not _data then
    		return
    	end
    	local _db = self._trinketList[tostring( _data.trinketId )]
    	if _db then
            --基础属性
    		local _id = tonumber(_db.effectId) or 0
    		local _num = tonumber(_db.effectValue) or 0
            if not _numsTb[_id] then _numsTb[_id] = 0 end
			_numsTb[_id] = _numsTb[_id] + _num

            --套装属性
    		local _suitId = tonumber(_db.suitId) or 0
    		if _suitId ~= 0 and not _taozhuangId[_suitId] then
    			local _suitDb = gameData.getDataFromCacheWithPrimaryKey("trinket_suit", _suitId)
    			if _suitDb then
                    _taozhuangId[_suitId] = _suitId
    				local _suitIds = {}
    				for i=1, 6 do
                        local _rinkId = tonumber(_suitDb["trinketId" .. i]) or 0
                        if _rinkId > 0 then
						  _suitIds[_rinkId] = _rinkId
                        end
	    			end
	    			local _count = 0
	    			for k,v in pairs(self._roleTrinketData) do
	    				local ___id = tonumber(v.trinketId) or 0
	    				if ___id ~= 0 and _suitIds[___id] then
	    					_count = _count + 1
	    				end
	    			end
	    			if _count >= 2 then
	    				for i= 2, _count do
				    		local _id = tonumber(_suitDb["effectId" .. i]) or 0
				    		local _num = tonumber(_suitDb["effectValue" .. i]) or 0

                            local _id2
                            if _id == 31 then --防御力需要增加物防 8 、策防 12
                                _id = 8
                                _id2 = 12
                            end
                            if not _numsTb[_id] then _numsTb[_id] = 0 end
                            _numsTb[_id] = _numsTb[_id] + _num
                            if _id2 then
                                if not _numsTb[_id2] then _numsTb[_id2] = 0 end
                                _numsTb[_id2] = _numsTb[_id2] + _num
                            end
	    				end
	    			end
    			end
    		end

    	end
        --附加属性(effectId对应附加属性表中id)

    	for i=1, 6 do
    		local _id = tonumber(_data["effectId" .. i]) or 0
    		local _num = tonumber(_data["effectValue" .. i]) or 0
            local _addEffInfo = gameData.getDataFromCacheWithPrimaryKey("trinket_effectType", _id)
            local _addEffId = tonumber(_addEffInfo.effectType) or 0
            if not _numsTb[_addEffId] then _numsTb[_addEffId] = 0 end
			_numsTb[_addEffId] = _numsTb[_addEffId] + _num

    	end
    end


    for k,v in pairs(self._trinkets) do
    	local _data = self._roleTrinketData[tostring(k)]
    	local _icon = v:getChildByName("icon")
        local _star = 0
    	if _data then
    		_countNum(_data, k)

    		local _info = zc._getIconInfo({
	            data = {
	                type = 1, 
	                id = _data.trinketId,
	                hideCount = true,
	                mainType = zc.mainTypeTrinket,
	                quality = _data.color,
	                plistType = true,
	            },
	        })
	        _star = _info.star or 1
			local _src = "res/Main/role/trinket/di_" .. _star ..".png"
    		v:getStateNormal():setTexture(_src)
    		if equipId == _data.id then
                local _spine = zc.createSpine({
                    fileName = "shilianchou",
                    actName = "start_4",
                    loop = false,
                    needInit = false,
                    autoRemove = true,
                })
                _spine:setPosition( v:getContentSize().width/2, v:getContentSize().height/2 )
                v:addChild( _spine )
                _spine:registerSpineEventHandler(function( event )
                    if event.eventData.name == "hit" then
                        if _icon then
                            _icon:setScale(0.6)
                            _icon:setTexture(_info.img)
                        end
                    end
                end, sp.EventType.ANIMATION_EVENT)
            else
                if _icon then
                    _icon:setScale(0.6)
                    _icon:setTexture(_info.img)
                end
            end
    	else
    		local _src = "res/Main/role/trinket/di_" .. _star ..".png"
    		v:setTexture(_src)
            if _icon then
                _icon:setScale(1.0)
                _icon:setTexture("res/Main/role/trinket/icon_" .. k .. ".png")
            end
    	end
    end

    local _eIdToIndex = {[1]=30,[2]=8,[3]=12,[4]=4}

    for i=1, 4 do
    	local _s = _numsTb[_eIdToIndex[i]] or 0 
    	if _s > 0 then
    		_s = "+" .. _s
    		self._attrLabels[i]:setColor(display.COLOR_GREEN)
    	else
    		self._attrLabels[i]:setColor(display.COLOR_WHITE)
    	end
    	self._attrLabels[i]:setString(_s)
    end



    -- -- 已穿戴饰品的属性
    self:buildRoleTrinketAttr()

    self._bagTrinketAttr = {}
    -- 刷新tableview
    self._trinketTableview:reloadDataAndScrollToCurrentCell()

    if #self._bagTrinketData == 0 then
        self._notOwnTrinket:setVisible( true )
    else
        self._notOwnTrinket:setVisible( false )
    end
    -- 刷新饰品红点
    zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_ROLELAYER_CHANGE, data = {id = 5}})
end

-- 计算已穿戴饰品的最小属性
function RoleTrinketLayer:buildRoleTrinketAttr()
    self._roleTrinketAttr = {}
    for k, v in pairs( self._roleTrinketData ) do
        local _trinketId = tonumber( v.trinketId )
        local _min = nil
        if v.color >= 3 then
            -- 计算已穿戴饰品的最小战斗力属性
            for i = 1, 6 do
                if tonumber(v["effectId"..i]) ~= 0 then
                    local _value = zc.attrCompareFormula(v["effectId"..i], v["effectValue"..i])
                    if _min then
                        _min = _min > _value and _value or _min
                    else
                        _min = _value
                    end
                else
                    _min = 0
                    break
                end
            end
        end
        -- 主属性
        local _main = self._mainData[_trinketId]
        if not self._mainData[_trinketId] then
            local _data = gameData.getDataFromCacheWithPrimaryKey("trinket", _trinketId)
            _main = zc.attrCompareFormula(_data.effectId, _data.effectValue, true)
            self._mainData[_trinketId] = _main
        end
        self._roleTrinketAttr[v.position] = {
            _min = _min,
            _main = _main,
        }
    end
end
function RoleTrinketLayer:buildBagTrinketAttr( data )
    -- dump(data,"data")
    local _isCanReplace = false
    local _isCanEquip = false
    if self._roleTrinketAttr[data.position] then
        -- 判断饰品列表的饰品能否洗练
        if data.color >= 3 then
            local _roleValue = self._roleTrinketAttr[data.position]._min
            if _roleValue then
                if _roleValue == 0 then
                    -- 已穿戴装备属性不够6条
                    _isCanReplace = true
                else
                    _isCanReplace = self:buildReplaceData( data, _roleValue )
                end
            end
        end

        -- 判断饰品列表的饰品能否装备
        local _roleValue = self._roleTrinketAttr[data.position]._main
        local _bagValue = self._mainData[tonumber( data.trinketId )]
        if not _bagValue then
            local _data = gameData.getDataFromCacheWithPrimaryKey("trinket", data.trinketId)
            _bagValue = zc.attrCompareFormula(_data.effectId, _data.effectValue, true)
            self._mainData[tonumber( data.trinketId )] = _bagValue
        end
        _isCanEquip = _bagValue > _roleValue
    else
        -- 可装备
        _isCanEquip = true
    end
    local _result = {isCanReplace = _isCanReplace, isCanEquip = _isCanEquip}
    return _result
end
-- 计算饰品属性
function RoleTrinketLayer:buildReplaceData( data, min )
    for i = 1, 6 do
        if tonumber(data["effectId"..i]) ~= 0 then
            local _value = zc.attrCompareFormula(data["effectId"..i], data["effectValue"..i])
            if _value > min then
                return true
            end
        end
    end
    return false
end

-- 战斗力变化响应
function RoleTrinketLayer:onFightChange( data )
    self._fightChangeData = data
end
function RoleTrinketLayer:fightChange()
    if self._fightChangeData then
        zc.numChangeAnimation({
            label = self._fightNum,
            pos = cc.p( self._fightNum:getContentSize().width/2, 20 ),
            callback = function()
                self._fightNum:setString( self._fightChangeData.fight )
                self._fightChangeData = nil
            end
        })
    end
end

function RoleTrinketLayer:onEnter()
	self:refresh()
    --新手引导
    self:addGuide()
end

function RoleTrinketLayer:addGuide()
    local _currentGID = getGuideManager():getCurrentGID()
    if _currentGID == GuideKey.KEY_11511 then
        getGuideManager():setObjTarget(self._guideBtn_triket, 0.7)
        getGuideManager():startGuide()
    elseif _currentGID == GuideKey.KEY_11513 then
        getGuideManager():setObjTarget(self._guideBtn_replace, 0.7)
        getGuideManager():startGuide()
    end
end


return RoleTrinketLayer