local ZhanFaRoleList = class("ZhanFaRoleList", function()
	return ZCDialog:create()
end)

function ZhanFaRoleList:create( params )
	return ZhanFaRoleList.new( params )
end

function ZhanFaRoleList:ctor( params )
	self:initData( params )
	self:initUI()
	self:refreshData()
	self:refreshTab()
end

function ZhanFaRoleList:selfFresh()
	self:refreshData()
	-- 构造当前界面数据
	self:buildTabData()
	-- 清空cell，重新创建
	self:removeCell()
	self._heroTableview:reloadDataAndScrollToCurrentCell()
end

function ZhanFaRoleList:onEnter()
	if self._init then
		-- 重新取数据
		-- self:selfFresh()
	end
	self:guideFun_c()
	self._init = true
end
function ZhanFaRoleList:guideFun_c()
    local _currentGID = getGuideManager():getCurrentGID()
    print("_currentGID:",_currentGID)
    if _currentGID == GuideKey.KEY_14805 then
        local function _callBack()
            getGuideManager():addMaskLayer()
            performWithDelay(self, function()
                zc.setGuideFuncNextStep(_currentGID, true)
                getGuideManager():guideOver()
            end, 0.3)
        end
        getGuideManager():setHeroFuncCallBack(_callBack)
        getGuideManager():startGuide()
    end
end
function ZhanFaRoleList:onCleanup()
	self:removeCell()
	self:removeAllChildren()
    helper.collectMemory()
end

function ZhanFaRoleList:initData( params )
	-- 拥有武将
	self._ownCell = {}
	-- 未拥有武将
	self._buyCell = {}
	
	self._tabIndex = 1

	self.params = params
	-- 主角的id
	self._mainHeroId = tonumber( PlayerData.info.heroId ) or 0

	-- tab数据
	self._tabData = {
		[1] = {
			name = zc.lang("all"),
			weaponType = 0,
		},
		[2] = {
			name = zc.lang("long_handle"),
			weaponType = 1,
		},
		[3] = {
			name = zc.lang("single_hand"),
			weaponType = 2,
		},
		[4] = {
			name = zc.lang("staff"),
			weaponType = 3,
		},
		[5] = {
			name = zc.lang("sword"),
			weaponType = 4,
		},
		[6] = {
			name = zc.lang("fan"),
			weaponType = 5,
		},
		[7] = {
			name = zc.lang("magic_ball"),
			weaponType = 6,
		},
	}

	self._ownHeroType = {}
	self._buyHeroType = {}

	self._size = self:getContentSize()
	-- tab宽度
	self._tabWidth = self._size.width - 1024
	-- 所有商店武将
	-- self._shopHeroList = params or {}
	self.select_index = params.index
	self.seletToCell = params.seletToCell
end

function ZhanFaRoleList:initUI()
    -- 通用背景
    local _commonBg = cc.Sprite:create( "res/Main/common/common_bg.jpg" )
    _commonBg:setPosition( self._size.width/2, self._size.height/2 )
    self:addChild( _commonBg )
    zc.setBgSize( _commonBg )

	-- 背景
	local _bgWidth = 980
	local _bgHeight = 530
	local _bg = zc.createNormalPop({
        tag = 2,
        src = "res/Main/role/list/bg.jpg",
        width = _bgWidth,
        height = _bgHeight,
        showSide = true,
    })
    _bg:setScaleX( _bgWidth/_bg:getContentSize().width )
    _bg:setScaleY( _bgHeight/_bg:getContentSize().height )
	_bg:setPosition( self._size.width/2 - 40, self._size.height/2 )
	self:addChild( _bg )

	local bg_black = ccui.Scale9Sprite:create(cc.rect(12, 11, 14, 10), "res/Main/common/popBg/di_properties.png")
    bg_black:setContentSize(910,445)
	bg_black:setPosition(_bg:getPositionX(),_bg:getPositionY() - 30)
	self:addChild(bg_black)

	local bg = cc.Sprite:create()
	bg:setContentSize( _bgWidth, _bgHeight )
	bg:setPosition( _bg:getPosition() )
	self:addChild( bg )
	self._bg = bg
	self._bgSize = bg:getContentSize()

	-- 标签
	self:initTab()

	-- tableview
	self:initTableview()

    -- 花
    local _flower_l_u = cc.Sprite:create( "res/Main/common/flower_l_u.png" )
    _flower_l_u:setAnchorPoint( 0, 1 )
    _flower_l_u:setPosition( 0, self._size.height )
    self:addChild( _flower_l_u )
    local _flower_r_u = cc.Sprite:create( "res/Main/common/flower_r_u.png" )
    _flower_r_u:setAnchorPoint( 1, 1 )
    _flower_r_u:setPosition( self._size.width, self._size.height )
    self:addChild( _flower_r_u )
    local _flower_r_d = cc.Sprite:create( "res/Main/common/flower_r_d.png" )
    _flower_r_d:setAnchorPoint( 1, 0 )
    _flower_r_d:setPosition( self._size.width, 0 )
    self:addChild( _flower_r_d )

	-- 空
	local empty = cc.Sprite:create( "res/Main/common/empty.png" )
	empty:setPosition( ( self._size.width - self._tabWidth )/2, self._bgSize.height/2 )
	bg:addChild( empty )
	self._empty = empty
	empty:setVisible( false )

	-- title
	local title = cc.Sprite:create( "res/Main/role/list/title.png" )
	title:setAnchorPoint( 0, 0.5 )
	title:setPosition( 0, self._size.height/2 + 250 )
    self:addChild( title )

	-- 返回
    local back = zc.createTopBackButton({
        pos = cc.p(zc.width - 40, zc.height - 40), 
        listener = function ()
            zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_ZHANFA_CHANGE, data = {
					isBack = true,
					seletToCell = self.seletToCell
				}
			})
			LayerManager.removeLayout()
        end,
    })
    self:addChild( back )
    self._closeButton = back
end
function ZhanFaRoleList:initTab()
	-- tab
	for i, v in ipairs( self._tabData ) do
        -- 兵器图标类型
        local weaponType = v.weaponType == 0 and 1 or v.weaponType
        local _normal = cc.Sprite:create( "res/Main/common/button/tab_btn_noraml.png" )
        local _normal_label = zc.createLabel({
        	text = v.name,
            color = cc.c3b( 122, 42, 0 ),
            color2 = cc.c3b( 255, 232, 128 ),
            outLine = true,
            pixel = 0,
            fontSize = 24,
            pos = cc.p( _normal:getContentSize().width/2 + 12, _normal:getContentSize().height/2 ),
        })
        _normal:addChild( _normal_label )
        local _selected = cc.Sprite:create( "res/Main/common/button/tab_btn_select.png" )
        local _selected_label = zc.createLabel({
        	text = v.name,
            color = display.COLOR_WHITE,
            color2 = cc.c3b( 72, 37, 0 ),
            outLine = true,
            pixel = 1,
            fontSize = 24,
            pos = cc.p( _selected:getContentSize().width/2 + 12, _selected:getContentSize().height/2 ),
        })
        _selected:addChild( _selected_label )
        local btn = zc.createPushButton({
        	normalNode = _normal,
        	selectedNode = _selected,
            pos = cc.p(self._bg:getPositionX() + self._bg:getContentSize().width/2 + 1, self._bg:getPositionY() + 275 - 70*i ),
            anchor = cc.p(0, 0.5),
            endCallback = function() end,
        })
		btn:setTouchEndedCall(function()
			if self._tabIndex ~= i then
				if self._tabBtn then
					self._tabBtn:setSelected( false )
				end
				self._tabBtn = btn
				self._tabBtn:setSelected( true )
				self._tabIndex = i
				self:refreshTab()
			end
		end)
		self:addChild( btn, 1 )
        local icon_normal = cc.Sprite:create( zc.getHeroTypeImg( weaponType ) )
        icon_normal:setAnchorPoint( 0, 0.5 )
        icon_normal:setPosition( 1, btn:getContentSize().height/2 )
        btn:addChild( icon_normal )

		if self._tabIndex == i then
			btn:setSelected( true )
			self._tabBtn = btn
		end
	end
end

function ZhanFaRoleList:initTableview()
	local _tableviewWidth = 910
	local _tableviewHeight = 425
	local heroTableview = zc.ZCTableView:create( cc.size( _tableviewWidth, _tableviewHeight ) )
    heroTableview:setBounceable( true )
    heroTableview:setInertia( true )
    heroTableview:setDirection( cc.SCROLLVIEW_DIRECTION_VERTICAL )
    heroTableview:setPosition( cc.p( 6, 13 ) )
    heroTableview:setDelegate()
    heroTableview:setVerticalFillOrder( cc.TABLEVIEW_FILL_TOPDOWN )
    local cellWidth = _tableviewWidth
    -- local cellWidth = 190
    local titleHeight = 48
    -- local cellHeight = 145
    local cellHeight = 170
    local function cellSizeForTable(table, index)
    	if index == 0 or index == math.ceil( #self._ownHeroData/2 ) + ( #self._ownHeroData == 0 and 0 or 1 ) then
    		-- 标题
        	return titleHeight, cellWidth
        else
        	-- 武将
        	return cellHeight, cellWidth
        end
    end
    local function tableCellAtIndex(table, index)
        local cell = table:dequeueCell()
        -- 创建模板
        if cell == nil then
            cell = zc.ZCTableViewCell:new()
        end
        cell:removeAllChildren()

        if #self._ownHeroData > 0 and index == 0 then
    	elseif #self._ownHeroData > 0 and index <= math.ceil( #self._ownHeroData/5 ) then
    		-- 已拥有武将
    		for i = 1, 5 do
    			local data = self._ownHeroData[( index - 1 )*5 + i]
    			if data then
    				local heroCell = nil
    				if not heroCell then
    					heroCell = self:buildOwnCell( data,cellWidth,cellHeight,i)
    					self._ownCell[tonumber( data.id )] = heroCell
    					heroCell:retain()
    				end
					heroCell:setPosition( cellWidth/10*(2*i - 1 ), cellHeight/2 - 20)
					cell:addChild( heroCell )
    			end
    		end
		end

        return cell
    end
    local function numberOfCellsInTableView()
    	local num = 0
    	if #self._ownHeroData ~= 0 then
    		num = num + math.ceil( #self._ownHeroData/5 ) + 1
    	end
    	-- if #self._buyHeroData ~= 0 then
    	-- 	num = num + math.ceil( #self._buyHeroData/2 ) + 1
    	-- end
        return num
    end
    heroTableview:registerScriptHandler(cellSizeForTable, cc.TABLECELL_SIZE_FOR_INDEX)
    heroTableview:registerScriptHandler(tableCellAtIndex, cc.TABLECELL_SIZE_AT_INDEX)
    heroTableview:registerScriptHandler(numberOfCellsInTableView, cc.NUMBER_OF_CELLS_IN_TABLEVIEW)
    self._bg:addChild( heroTableview )
    self._heroTableview = heroTableview

    local posX = { - cellHeight/2 ,_tableviewHeight + cellHeight/2}
    for i = 1,2 do
    	local btn1 = zc.createPushButton({
			touchSize = cc.size(_tableviewWidth,cellHeight),
	        pos = cc.p(heroTableview:getPositionX() + _tableviewWidth / 2,heroTableview:getPositionY() + posX[i]),
	        endCallback = function()
	        	print("i::::::",i)
	        	return
	        end
		})
		self._bg:addChild(btn1)
    end
end

-- 重新从player中取数据
function ZhanFaRoleList:refreshData()
	-- 已拥有武将
	local ownHero = {}
	self._ownHeroList = {}
	-- 主角
	self._mainHeroData = {}
	local _houseData = PlayerData:getHouseInfoByHouseId(9) or {}
	local _houseLevel = tonumber(_houseData.level) or 1
	local _myLevel = tonumber(PlayerData.info.level) or 1
	local _bookList = gameData.getAllDataWithNoClone("hero_handbook_card")
	local _openLevel = 0
	for k,v in pairs(_bookList) do
		local _level = tonumber(v.level) or 1
		local _plevel = tonumber(v.plevel) or 1
		if _level <= _houseLevel and _plevel <= _myLevel then
			local _pid = tonumber(v.id) or 1
			_openLevel = _openLevel < _pid and _pid or _openLevel
		end
	end
	
	for i, v in ipairs( PlayerData:getGeneralInfo()) do
		-- print("------------test-------------:v.id  ",v.id)
		if tonumber( v.id ) ~= self._mainHeroId and tonumber( v.id ) ~= tonumber(self.params.heroData.id) then
			-- print("self._mainHeroId:      ",self._mainHeroId,"self.params.heroData.id    ",self.params.heroData.id)
			self._ownHeroList[#self._ownHeroList + 1] = v
			ownHero[tonumber( v.heroId )] = true
		else
			-- 主角
			self._mainHeroData = v
		end
	end
	local _mainWeaponData = PlayerData:getWeaponsInfoById( self._mainHeroData.id ) or {}
	self._mainWeaponType = tonumber( _mainWeaponData.type ) or 1
	self._ownHeroType = {}
	self._buyHeroType = {}

	-- 上阵武将
    local _upMatrix = {}
    for i, v in pairs( PlayerData:getFormationsInfo() ) do
        if ( tonumber( v.status ) or 0 ) == 1 then
            for j = 1, 9 do
                _upMatrix[tonumber( v["location"..j])] = true
            end
        end
    end
    self._upMatrix = _upMatrix
    table.sort(self._ownHeroList,function (a,b)
    	local idA = tonumber(a.id)
    	local idB = tonumber(b.id)
    	if self._upMatrix[idA] ~= self._upMatrix[idB] then
    		return self._upMatrix[idA]
    	end

    	if tonumber( a.fighting ) ~= tonumber( b.fighting) then
    		return tonumber( a.fighting ) > tonumber( b.fighting)
    	end

		local tacticsA = tonumber(a.tactics.tactics)
    	local tacticsB = tonumber(b.tactics.tactics)
    	-- print("tacticsA:",tacticsA,"tacticsB:",tacticsB,"a.name:",a.name,"b.name:",b.name)
    	if tacticsA ~= tacticsB then
    		return tacticsA > tacticsB
    	end
    end)
end

-- 构造当前tab的数据
function ZhanFaRoleList:buildTabData()
	-- 兵器类型
	local weaponType = self._tabData[self._tabIndex].weaponType
	-- 拥有武将
	self._ownHeroData = self._ownHeroType[weaponType]
	if not self._ownHeroData then
		self._ownHeroData = {}
		if weaponType == 0 then
			self._ownHeroData = self._ownHeroList
		else
			for i, v in ipairs( self._ownHeroList ) do
				if tonumber( v.weaponType ) == weaponType
				  or (v.db and tonumber( v.db.weaponType ) == weaponType) then
					self._ownHeroData[#self._ownHeroData + 1] = v
				end
			end
		end
		table.sort(self._ownHeroData, function( a, b )
			local id_A = tonumber(a.id)
			local id_B = tonumber(b.id)
			if self._upMatrix[id_A] ~= self._upMatrix[id_B] then
				return self._upMatrix[id_A]
			end
			local _canComposeA = tonumber(a.canCompose) or 0
			local _canComposeB = tonumber(b.canCompose) or 0
			if _canComposeA ~= _canComposeB then
				return _canComposeA > _canComposeB
			end
			if _canComposeA == 1 then
				local _dbA = a.db or {}
				local _dbB = b.db or {}
				local _qualificationsA = tonumber(_dbA.qualifications) or 0
				local _qualificationsB = tonumber(_dbB.qualifications) or 0
				if _qualificationsA ~= _qualificationsB then
					return _qualificationsA > _qualificationsB
				end
				local _idA = tonumber( _dbA.id ) or 0
				local _idB = tonumber( _dbB.id ) or 0
				return _idA < _idB
			end
			local tacticsA = tonumber(a.tactics.tactics)
	    	local tacticsB = tonumber(b.tactics.tactics)
	    	if tacticsA ~= tacticsB then
	    		return tacticsA < tacticsB
	    	end
	    	return tonumber( a.fighting ) > tonumber( b.fighting )
		end)
		self._ownHeroType[weaponType] = self._ownHeroData
	end

end

-- 刷新当前tab
function ZhanFaRoleList:refreshTab()
	self:buildTabData()
	self._heroTableview:reloadData()

	if #self._ownHeroData == 0 and #self._buyHeroData == 0 then
		self._empty:setVisible( true )
	else
		self._empty:setVisible( false )
	end
	--新手引导
	zc.addGuideBtn(self._heroCell)
end

-- 构造已有武将
function ZhanFaRoleList:buildOwnCell( _data,_cellWidth,_cellHeight,index)
	-- dump( data, "data" )
	local cellBg = cc.Sprite:create()

	local icon_bg = ccui.Scale9Sprite:create( cc.rect( 15, 12, 8, 8 ), "res/Main/role/role_faguang.png" )
	icon_bg:setContentSize(115,115)
	icon_bg:setPosition((index - 1) * 3 + 20, _cellHeight*0.5)
	cellBg:addChild(icon_bg)

	local icon_bg_1 = zc.createSprite("res/Main/role/role_di.png")
	icon_bg_1:setPosition((index - 1) * 3 + 20, _cellHeight*0.5)
	cellBg:addChild(icon_bg_1)

	local _item,info = zc.createIconByData({
        data = {
            mainType = zc.mainTypeSoldier,
            type = 1, 
            id = _data.heroId,
            level = zc.getLevelTipShow() .. _data.level,
            reincarnate = _data.reincarnate,
        }, 
        quality = _data.quality,
        showQuality = true,
        scale = 0.8,
        pos = cc.p((index - 1) * 3 + 20, _cellHeight*0.5), 
        listener = function ( ... )
        	-- 上阵的武将处理
        	if self._upMatrix[tonumber(_data.id)] == true then
        		local formationInfo = PlayerData:getFormationsInfo()
                local formationId 
                local heroString = ""
                -- 10:0_0_0_0_1466_0_0_6492_0
                for k,v in pairs(formationInfo) do
                    --当前开启
                    if v.status == 1 then
                        local roleID = tonumber(_data.id)
                        formationId = v.formationId
                        for j = 1, 9 do
                            local locationID = tonumber(v["location"..j])
                            if j == 9 then
                                if locationID == roleID then
                                    heroString = heroString.."0"
                                else
                                    heroString = heroString..locationID
                                end
                            else
                                if locationID == roleID then
                                    heroString = heroString.."0".."_"
                                else
                                    heroString = heroString..locationID.."_"
                                end
                            end
                        end
                    end
                end
                local infoData = tostring(formationId)..":"..heroString
	        	local comfirm = ZCConfirmDialog:createWithParams({
	                title = zc.lang("prompt"),
	                msg = zc.lang("zhanfa_xiazhen"),
	                showDi = true,
	                rightCallback = function()
	                    zc.sendHttp({
	                        apiName = "Formation_saveFormation",
	                        params = {info = infoData,type=MatrixType.Default},
	                        successCallback = function(data)
	                            PlayerData:setFormationsInfo(data.formations)
	                            self:selfFresh()
	                            self._upMatrix[tonumber(_data.id)] = false
	                            self._heroTableview:reloadData()
	                        end,
	                    })
	                end
	            })
	            self:addChild(comfirm,11)
	            return
        	end
        	-- 被镶嵌到其他武将
        	if tonumber(_data.tactics.tactics) == 1 then
        		-- zc.tipInfo(zc.lang("already1")..zc.lang("use")) 已使用
        		-- xx<xx的称号>已被装备与xxx<xxx的称号>，是否前往卸下
        		local _heroList = PlayerData:getGeneralInfo()
        		local heroData 
        		local str_index = ""
        		for k,v in pairs(_heroList) do
        			local tactics = v.tactics
        			for key,data in pairs(tactics) do
        				-- print("key:",key,"data:",data)
        				if tonumber(data) == tonumber(_data.id) then
        					heroData = v
        					str_index = key
        					break
        				end
        			end
        		end
        		local num_index = tonumber(string.sub(str_index,-2,-1))
        		print("num_index0:",num_index,"str_index:",str_index)
        		local combineSkillId = tonumber(heroData.combineSkillId)
        		local combineSkillId2 = tonumber(heroData.combineSkillId2)
        		local seletToCell_num = 1
        		if combineSkillId2 ~= 0 then
        			if combineSkillId ~= 0 then
	        			if num_index >= 11 and num_index <= 14 then
	        				seletToCell_num = 3
	        			elseif num_index >= 21 and num_index <= 28 then
	        				if tonumber(heroData.tactics.isUseCombine) == 2 then
	        					seletToCell_num = 2
	        				else
	        					seletToCell_num = 1
	        				end
	        			end
	        		else
	        			seletToCell_num = 1
	        		end
        		else
        			if combineSkillId ~= 0 then
	        			if num_index >= 11 and num_index <= 14 then
	        				seletToCell_num = 2
	        			else
	    					seletToCell_num = 1
	        			end
	        		else
	        			seletToCell_num = 1
	        		end
        		end
        		-- 主角
				local mainRoleId = tonumber( PlayerData.info.heroId )
				local heroname
				local herotitle

				if mainRoleId == tonumber(heroData.id) then
					heroname = PlayerData.info.userName
					herotitle = "<"..heroData.title..">" or "" -- 昵称
				else
					heroname = heroData.name or "" -- 这里是吃武将的武将名
					herotitle = "<"..heroData.title..">" or "" -- 昵称
				end

				local name = _data.name
				local title =_data.title

				local herostr = "[color=ffFF0000]"..heroname.."[/color]"
				herostr = herostr.."[color=ffFF6EC7]".."<"..herotitle..">".."[/color]"

				local str = "[color=ffFF0000]"..name.."[/color]"
				str = str.."[color=ffFF6EC7]".."<"..title..">".."[/color]"

				local desc1 = "[color=ff4c1212]"..zc.lang("zhaungbeied").."[/color]"
				local desc2 = "[color=ff4c1212]"..zc.lang("isXiexia").."[/color]"

				local all_desc = str..desc1..herostr..desc2
				local data = {
	                		isTiaoZhaun = true,
	                		id = heroData.id,
	                		seletToCell = seletToCell_num
		                }
        		local comfirm = ZCConfirmDialog:createWithParams({
	                title = zc.lang("prompt"),
	                msg = all_desc,
	                showDi = true,
	                isRich = true,
	                isHide = false,
	                rightText = zc.lang("qianwang"),
	                leftCallback = function ()
	                	local layer = self:getChildByTag(3000000)
	                	if layer then
	                		self:removeChildByTag(3000000)
	                	end
	                end,
	                rightCallback = function()
	                	zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_ZHANFA_CHANGE, data = data})
	            		LayerManager.removeLayout() 
	                end
	            })
	            comfirm:setTag(3000000)
	            self:addChild(comfirm,11)
	            return
        	else
        		-- local _heroList = PlayerData:getGeneralInfo()
        		local tactics = _data.tactics
        		local flag = false
        		local list_
        			list_ = {
        			"tplace11","tplace12","tplace13","tplace14",
        			"tplace21","tplace22","tplace23","tplace24","tplace25","tplace26","tplace27","tplace28"}
        		local str_index = ""
        		for i=1,#list_ do
        			if tonumber(tactics[list_[i]]) ~= 0 then
        				flag = true
        				str_index = list_[i]
        				break
        			end
        		end
        		
        		if flag == true then
        			local num_index = tonumber(string.sub(str_index,-2,-1))
	        		print("num_index1:",num_index,"str_index:",str_index)
	        		local combineSkillId = tonumber(_data.combineSkillId)
	        		local combineSkillId2 = tonumber(_data.combineSkillId2)
	        		local seletToCell_num = 1
	        		if combineSkillId2 ~= 0 then
	        			if combineSkillId ~= 0 then
		        			if num_index >= 11 and num_index <= 14 then
		        				seletToCell_num = 3
		        			elseif num_index >= 21 and num_index <= 28 then
		        				if tonumber(_data.tactics.isUseCombine) == 2 then
		        					seletToCell_num = 2
		        				else
		        					seletToCell_num = 1
		        				end
		        			end
		        		else
		        			seletToCell_num = 1
		        		end
	        		else
	        			if combineSkillId ~= 0 then
		        			if num_index >= 11 and num_index <= 14 then
		        				seletToCell_num = 2
		        			else
		    					seletToCell_num = 1
		        			end
		        		else
		        			seletToCell_num = 1
		        		end
	        		end
        			-- xx<xx的称号>已经装备了其他将领战法，是否前往卸下？
        			local name = _data.name
					local title =_data.title

					local str = "[color=ffFF0000]"..name.."[/color]"
					str = str.."[color=ffFF6EC7]".."<"..title..">".."[/color]"

        			local all_desc = str.."[color=ff4c1212]"..zc.lang('other_role').."[/color]"
        			local data = {
	                		isTiaoZhaun = true,
	                		id = _data.id,
	                		seletToCell = seletToCell_num
		                }
        			local comfirm = ZCConfirmDialog:createWithParams({
		                title = zc.lang("prompt"),
		                msg = all_desc,
		                showDi = true,
		                isRich = true,
		                isHide = false,
		                rightText = zc.lang("qianwang"),
		                leftCallback = function ()
		                	local layer = self:getChildByTag(3000000)
		                	if layer then
		                		self:removeChildByTag(3000000)
		                	end
		                end,
		                
		                rightCallback = function()
		                	zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_ZHANFA_CHANGE, data = data })
		            		LayerManager.removeLayout() 
		                end
		            })
		            comfirm:setTag(3000000)
		            self:addChild(comfirm,11)
		            return
        		end
        		local key = tostring(_data.weaponType)
	        	local list_weapType = self.params.list_weapType

	        	if list_weapType[tostring(key)] and list_weapType[tostring(key)] >= 2 then
	        		zc.tipInfo(zc.lang("sameRole"))
	        		return
	        	end
	        	local function RemoveLayer()
	        		self:removeChildByTag(100000)
	        	end
	        	local function update( ... )
	        		self._heroTableview:reloadData()
	        	end
	        	local params = {
	        		roleData = _data, -- 被吃武将数据
	        		skillData = self.params.skillData, -- 技能数据
	        		removeLayer = RemoveLayer, -- 删除装备层
	        		activityType = 1,-- 暂时区分装备或者卸下 1 装备 0 卸下
	        		index = self.select_index, -- 装备位置
	        		heroData = self.params.heroData, -- 要吃武将数据
	        		update = update,
	        		seletToCell = self.seletToCell
	        	}
	        	local layer_ = requires("src/layer/role/ZhanFaZhaungBei.lua"):create(params or {})
	        	layer_:setTag(100000)
	        	self:addChild(layer_)
        	end
        end
    })
    cellBg:addChild(_item)

    local namebg = ccui.Scale9Sprite:create( cc.rect( 15, 12, 8, 8 ), "res/Main/common/popBg/di_properties.png" )
    namebg:setContentSize(80,25)
    namebg:setPosition(icon_bg:getPositionX(),icon_bg:getPositionY() - 73)
    cellBg:addChild(namebg)

    local nameLabel = zc.createLabel({
    		text = info.name,
            outLine = true,
            fontSize = 22,
            pos = cc.p( namebg:getContentSize().width/2, namebg:getContentSize().height/2 ),
    	})
    namebg:addChild(nameLabel)

    local role_zhen = zc.createSprite("res/Main/role/role_zhen.png")
    role_zhen:setPosition(_item:getContentSize().width - 20,20)
    _item:addChild(role_zhen)

    if self._upMatrix[_data.id] == true then
    	role_zhen:setVisible(true)
    else
    	role_zhen:setVisible(false)
	end

    local weaponType
    local _mainRoleId = tonumber( PlayerData.info.heroId ) or 0
    if _data.id == _mainRoleId  then
    	local mainData = PlayerData:getWeaponsInfoById(_mainRoleId)
    	weaponType = mainData.type
    else
    	weaponType = _data.weaponType
    end
    local x = _item:getPositionX()
    local y = _item:getPositionY()
    local size = _item:getContentSize()
    local weaponIcon_ = zc.createSprite("res/Main/role/common/weapon_icon_"..weaponType..".png" )
    weaponIcon_:setScale(0.6)
    local weaponIcon_size = weaponIcon_:getContentSize()
   	weaponIcon_:setPosition(size.width - 20,size.height - 20)
   	_item:addChild(weaponIcon_)

   	local tiao_bg = ccui.Scale9Sprite:create( cc.rect( 15, 12, 8, 8 ), "res/Main/common/popBg/di_properties.png" )
   	tiao_bg:setContentSize(85,25)
   	tiao_bg:setPosition(_item:getContentSize().width/2 + 16,15)
   	_item:addChild(tiao_bg)

   	local useedLabel = zc.createLabel({
    		text = zc.lang("already1")..zc.lang("use"),
            outLine = true,
            fontSize = 22,
            pos = cc.p( tiao_bg:getContentSize().width/2, tiao_bg:getContentSize().height/2 ),
            outLine = true,
            color = cc.c3b(235,204,160),
    	})
    tiao_bg:addChild(useedLabel)

    tiao_bg:setVisible(tonumber(_data.tactics.tactics) == 1 and true or false)
	return cellBg
end

-- 移除所有的cell
function ZhanFaRoleList:removeCell()
	for k, v in pairs( self._ownCell ) do
		v:release()
	end
	self._ownCell = {}
	for k, v in pairs( self._buyCell ) do
		v:release()
	end
	self._buyCell = {}
end


--新手引导点击武将响应
function ZhanFaRoleList:guideFunc()
    local _currentGID = getGuideManager():getCurrentGID()
    if inArray(_currentGID, GuideGroup.BTN_SELECT_HERO)
      or _currentGID == GuideKey.KEY_11402
      or _currentGID == GuideKey.KEY_12309
      or _currentGID == GuideKey.KEY_14303
      then
	    zc.setGuideFuncNextStep(_currentGID)
    end
end

function ZhanFaRoleList:refreshRedDot( data, isMain )
	-- 装备
	if zc.getEquipRedDotStatus({ data }) then
		return true
	end
	-- 武器
	if isMain then
		-- 主角
		if PlayerData:getGodWeaponRedDotState() then
			return true
		end
	else
		-- 武将
		if zc.getChangeWeaponRedDotStatus({ data }) then
			return true
		elseif PlayerData:checkCanClearWeaponsByHeroId( data.id ) then
			return true
		end
	end
	-- 羁绊
	if zc.getFetterRedDotStatus({ data }) then
		return true
	end
	-- 升星
	if zc.getStarupRedDotStatus({ data }) then
		return true
	end
	-- 宝石
	if zc.getGemSetRedDotStatusByHero({ data }) then
		return true
	end

	return false
end

return ZhanFaRoleList