local ZhanFaUnLoad = class("ZhanFaUnLoad", function()
	return ZCPopLayer:create()
end)

function ZhanFaUnLoad:create( params )
	return ZhanFaUnLoad.new( params )
end

function ZhanFaUnLoad:ctor( params )
    self._activityType = params.activityType
    self.type = params.type
    self.skillData = params.skillData
	self:initData( params )
	self:initUI(params)
end

function ZhanFaUnLoad:initData(params)
	self.skillData = params.skillData or {}
	if self.skillData.skillType == 3 then -- 必杀
		self.Type = 1
	elseif self.skillData.skillType == 4 then -- 奥义
		self.Type = 2
	end
	self.select_index = params.index or 1
	self.seletToCell = params.seletToCell or 1
	self.heroData = params.heroData or {}
	self.removeLayer = params.removeLayer or nil
	self.removeZhuangLayer = params.removeZhuangLayer or nil
	self.roleData = params.roleData or {}
	dump(self.heroData)
end

function ZhanFaUnLoad:setLayerContent(params)
	
end

function ZhanFaUnLoad:initUI(params)
	local _bg = zc.createSprite("res/Main/common/popBg/popup_Bg_blue.png")
	_bg:setPosition(520, 400)
	self:addChild(_bg )
	local bgSize = _bg:getContentSize()

	local title = zc.createSprite("res/Main/common/tipTitle/zhanfa.png")
	title:setAnchorPoint(0.5,1)
	title:setPosition(bgSize.width/2,bgSize.height)
	_bg:addChild(title)

	local bg_yellow = ccui.Scale9Sprite:create(cc.rect(12, 11, 14, 10), "res/Main/common/popBg/di_1.png")
	bg_yellow:setContentSize(470,162)
	bg_yellow:setPosition(bgSize.width/2,bgSize.height/2 + 50)
	_bg:addChild(bg_yellow)

	local desc_ = zc.lang("confirm")..zc.lang("jiang")
	local name = self.roleData.name or "" -- 这里是镶嵌的武将名
	local title = "<"..self.roleData.title..">" or "" -- 昵称
	local des = zc.lang("cjnxx")

	local str = "[color=ff4c1212]"..desc_.."[/color]".."[color=ffFF0000]"..name.."[/color]"
	str = str.."[color=ffFF6EC7]"..title.."[/color]"
	str = str.."[color=ff4c1212]"..des.."[/color]"
	local desc = zc.createRichLabel({
	        text = str,
	        width = 400,
	        fontSize = 24,
	        ap = cc.p(0.5,1),
	        pos = cc.p( bg_yellow:getContentSize().width/2,bg_yellow:getContentSize().height - 50),
	        outLine = true,
	    })
	if desc:getContentSize().width > 400 then
        desc:setDimensions(cc.size(400, 200))
        desc:setPosition(bg_yellow:getContentSize().width/2,bg_yellow:getContentSize().height - 120)
    end
	bg_yellow:addChild(desc)

	local bg_tiao = ccui.Scale9Sprite:create(cc.rect(12, 11, 14, 10), "res/Main/role/common/name_bg.png")
	bg_tiao:setContentSize(470,36)
	bg_tiao:setPosition(bgSize.width/2,bg_yellow:getPositionY() - bg_yellow:getContentSize().height/2 - 30)
	_bg:addChild(bg_tiao)

	local desc_ = zc.lang("xxfh")
	local num = "80%"
	local des = zc.lang("sjzy")

	local str = "[color=ffe6e0a3]"..desc_.."[/color]".."[color=ffFF0000]"..num.."[/color]"
	str = str.."[color=ffe6e0a3]"..des.."[/color]"

	local gantanhao = zc.createSprite("res/Main/role/gantanhao.png")
	gantanhao:setPosition(20,20)
	bg_tiao:addChild(gantanhao)
	local desc = zc.createRichLabel({
	        text = str,
	        height = 0,
	        width = bg_tiao:getContentSize().width,
	        fontSize = 18,
	        pos = cc.p( bg_tiao:getContentSize().width/2 + 20,bg_tiao:getContentSize().height/2),
	        outLine = true,
	    })
	bg_tiao:addChild(desc)

	local cancellBtn = zc.createCommomBtn({
	        tag = 1,
			text = zc.lang("cancel"),
			pos = cc.p(130, 70),
			outLine = true,
			endCallback = function() 
				if self.removeLayer then
					self.removeLayer()
				end
			end
   		})
	_bg:addChild(cancellBtn)

	local sureBtn = zc.createCommomBtn({
			tag = 2,
			text = zc.lang("confirm"),
	        pos = cc.p(cancellBtn:getPositionX()+cancellBtn:getContentSize().width + 120, 70),
	        outLine = true,
	        endCallback = function()
				zc.sendHttp({
					apiName = "Role_UnLoad",
					params = {
						heroId = self.heroData.id,
						type = self.Type,
						index = self.select_index,
					},
					successCallback = function(backData)
						PlayerData:updataData(backData,self.roleData)

						zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_ZHANFA_CHANGE, data = {
							index = self.type,
							isUnLoad = true,
							id = self.heroData.id,
							seletToCell = self.seletToCell,
						}})
						print("self.removeLayer:",self.removeLayer)
						if self.removeLayer then
							self.removeLayer()
						end
						-- LayerManager.removeLayout()
					end,
				})
			end
   		})
	_bg:addChild(sureBtn)
end

return ZhanFaUnLoad