--[[
    神兵界面
    by andong
]]
local SmithyGodWeaponLayer = class("SmithyGodWeaponLayer", function ()
    return zc.createNormalDialog({
        closeCallBack = function()
            local _currentGID = getGuideManager():getCurrentGID()
            if inArray(_currentGID, GuideGroup.BTN_BACK_MAINCITY)  then
                getGuideManager():setObjTarget(nil)
                getGuideManager():setNextGID(_currentGID)
            end
            LayerManager.removeLayout()
        end
    })
end)
function SmithyGodWeaponLayer:create( params )
    return SmithyGodWeaponLayer.new( params )
end
function SmithyGodWeaponLayer:onCleanup()
    -- 刷新总览红点
    zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_ROLELAYER_CHANGE, data = {id = 1}})
    zc.removeEventListener(CUSTOM_EVENT.EVENT_REFRESH_FORM_SWEEP)
    zc.removeEventListener( CUSTOM_EVENT.EVENT_DAZAO_SUCCESS )
    
    ccs.ArmatureDataManager:getInstance():removeArmatureFileInfo("res/animation/qianghua_duanzao/qianghua_duanzao.csb", true)
    ccs.ArmatureDataManager:getInstance():removeArmatureFileInfo("res/image/battle/hero/nanzhu.csb")
    ccs.ArmatureDataManager:getInstance():removeArmatureFileInfo("res/image/battle/hero/nanzhu_shan.csb")
    ccs.ArmatureDataManager:getInstance():removeArmatureFileInfo("res/image/battle/hero/nvzhujue.csb")
    ccs.ArmatureDataManager:getInstance():removeArmatureFileInfo("res/image/battle/hero/nvzhuqiang.csb")
end
function SmithyGodWeaponLayer:ctor( params )
    self:initData( params )
    self:initUI()
end
function SmithyGodWeaponLayer:onEnter()
    self:addGuide()
    if self._secondIn then
        self:refreshConsumeOfFaile()
    end
    self._secondIn = true
end

function SmithyGodWeaponLayer:initData(params)
    self._callback = params.callback
    self._targetId = params.id --目标兵器id
    -- 获取所有的神器
    self._allWeapon = {}
    local allWeapon = gameData.getAllDataWithNoClone("weapon")
    for k,v in pairs(allWeapon) do
        if tonumber(v.id) > 1000 then
            local id = tonumber(v.id)
            if tonumber(id % 1000) == 1 then
                table.insert(self._allWeapon, v)
            end
            
        end
    end
    table.sort(self._allWeapon, function ( a,b )
        return tonumber(a.id) < tonumber(b.id)
    end)
    -- dump(self._allWeapon, "self._allWeapon::==")
    -- self._houseInfo = PlayerData:getHouseInfoByHouseId(11)
    -- --主角兵器
    -- local roleWeapons = table.copy(PlayerData:getRoleWeapons())

    -- local useWeapon = PlayerData:getRoleUserWeapons()
    -- -- dump(PlayerData:getRoleUserWeapons(), "player roleWeapons:")
    -- self._heroNowHeroID = useWeapon.heroId
    -- -- print("初始化id:"..self._heroNowHeroID)
    -- --获取当前主角模型的兵器
    -- self._roleWeapons = {}
    -- local nowRoleWeaponId = {[1]=1001,[5]=2001} --1长柄、5扇子
    -- for i = 1, #roleWeapons do
    --     local idx = #self._roleWeapons+1
    --     self._roleWeapons[idx] = roleWeapons[i]
    --     self._roleWeapons[idx]["ISOPEN"] = true
    --     nowRoleWeaponId[tonumber(roleWeapons[i]["type"])] = nil
    --     if tonumber(self._roleWeapons[idx]["weaponId"]) == self._heroNowHeroID then
    --         self._roleWeapons[idx]["iscarry"] = true
    --     else
    --         self._roleWeapons[idx]["iscarry"] = false
    --     end
    -- end

    -- self._newRoleWeapons = table.copy(self._roleWeapons)
    -- if table.nums(nowRoleWeaponId) > 0 then --说明还有兵器没有打开
    --     for k,v in pairs(nowRoleWeaponId) do
    --         local _id = v
    --         local static = gameData.getDataFromCacheWithPrimaryKey("weapon", _id)
    --         local idx = #self._newRoleWeapons+1
    --         self._newRoleWeapons[idx] = static
    --         self._newRoleWeapons[idx]["ISOPEN"] = false
    --         self._newRoleWeapons[idx]["weaponId"] = tonumber(static["id"])
    --         self._newRoleWeapons[idx]["heroId"] = 0
    --         if tonumber(self._newRoleWeapons[idx]["weaponId"]) == self._heroNowHeroID then
    --             self._roleWeapons[idx]["iscarry"] = true
    --         else
    --             self._roleWeapons[idx]["iscarry"] = false
    --         end
    --     end
    -- end

    -- for i = 1, #self._roleWeapons do
    --     self:calcAttribute(self._roleWeapons[i])
    --     if self._roleWeapons[i]["id"] and self._targetId and tonumber(self._targetId) == tonumber(self._roleWeapons[i]["id"]) then
    --         self._targetId = nil
    --         self._targetIndx = i
    --     end

    --     self._roleWeapons[i]["weaponId"] = tonumber(self._roleWeapons[i]["weaponId"])
    --     self._roleWeapons[i]["beforeStrengthen"] = tonumber(self._roleWeapons[i]["beforeStrengthen"])
    --     self._roleWeapons[i]["beforeStrengthenGroup"] = tonumber(self._roleWeapons[i]["beforeStrengthenGroup"])
    -- end

    -- -- 先排个序
    -- table.sort(self._roleWeapons, function(a,b)
    --     return tonumber(a.heroId) > tonumber(b.heroId)
    -- end)
    -- table.sort(self._newRoleWeapons, function(a,b)
    --     return tonumber(a.heroId) > tonumber(b.heroId)
    -- end)
    

    -- local baseInfo = PlayerData:getBaseInfo()
    -- local _sexId = tonumber(baseInfo["seigniorId"]) or 1
    -- local _initModel = {[1]="nanzhu",[2]="nvzhujue"}
    -- local _nowModel = _initModel[_sexId]
    -- self._nowModel = _nowModel --当前玩家的模型
    -- if _nowModel == "nanzhu" then
    --     zc.createArmature({fileName = "nanzhu_shan" , async = true, asyncCallback = function() end})
    -- elseif _nowModel == "nvzhujue" then
    --     zc.createArmature({fileName = "nvzhuqiang", async = true, asyncCallback = function() end})
    -- end
    self:refreshData()
    zc.addEventListener({
        name = CUSTOM_EVENT.EVENT_REFRESH_FORM_SWEEP ,
        callback = function()
            self:refreshConsumeOfFaile()
        end,
    })
    -- dump(self._newRoleWeapons, "self._roleWeapons:")

    --武器状态信息
    self._weaponStateInfo = {}

    -- 增加打造成功后的event_listener
    zc.addEventListener({
        name = CUSTOM_EVENT.EVENT_DAZAO_SUCCESS,
        callback = function(data)
            -- dump(data.data, "event data:")
            self._nowWeaponIdx = tonumber(data.data.idx)
            -- print("self._nowWeponIndex:"..self._nowWeaponIdx)
            self:refreshData()
            self._leftTableView:reloadData()
            self._leftTableView:scrollToCell(self._nowWeaponIdx)
            self:setNowWeaponInfo(self._nowWeaponIdx)
            self:refreshRight(self._nowWeaponIdx, true)
        end
        })

end
function SmithyGodWeaponLayer:refreshData( )
    print("enter refreshData!!!!!")
    self._houseInfo = PlayerData:getHouseInfoByHouseId(11)
     --主角兵器
    local roleWeapons = table.copy(PlayerData:getRoleWeapons())
    -- dump(roleWeapons, "player roleWeapons:")
    local useWeapon = PlayerData:getRoleUserWeapons()
    -- dump(useWeapon, "user useweapon:")
    self._heroUserWeaponId = tonumber(useWeapon.weaponId)  -- 其实是weaponId
    self._heroNowHeroID = tonumber(useWeapon.heroId)
    -- print("初始化id:"..self._heroNowHeroID)
    --获取当前主角模型的兵器
    self._roleWeapons = {}
    local nowRoleWeaponId = {[1]=1001,[5]=2001} --1长柄、5扇子
    -- local nowRoleWeaponId = {}
    -- for k,v in pairs(self._allWeapon) do
    --     nowRoleWeaponId[v.type] = v.id
    -- end

    for i = 1, #roleWeapons do
        local idx = #self._roleWeapons+1
        self._roleWeapons[idx] = roleWeapons[i]
        self._roleWeapons[idx]["ISOPEN"] = true
        nowRoleWeaponId[tonumber(roleWeapons[i]["type"])] = nil
        -- print("_roleWeapons Id :"..self._roleWeapons[idx]["heroId"])
        if tonumber(self._roleWeapons[idx]["weaponId"]) == self._heroUserWeaponId then
            self._roleWeapons[idx]["iscarry"] = true
        else
            self._roleWeapons[idx]["iscarry"] = false
        end
    end

    self._newRoleWeapons = table.copy(self._roleWeapons)
    if table.nums(nowRoleWeaponId) > 0 then --说明还有兵器没有打开
        for k,v in pairs(nowRoleWeaponId) do
            local _id = v
            local static = gameData.getDataFromCacheWithPrimaryKey("weapon", _id)
            local idx = #self._newRoleWeapons+1
            self._newRoleWeapons[idx] = static
            self._newRoleWeapons[idx]["ISOPEN"] = false
            self._newRoleWeapons[idx]["weaponId"] = tonumber(static["id"])
            self._newRoleWeapons[idx]["heroId"] = 0
            -- print("_newRoleWeapons Id :"..self._newRoleWeapons[idx]["heroId"])
            if tonumber(self._newRoleWeapons[idx]["weaponId"]) == self._heroUserWeaponId then
                self._newRoleWeapons[idx]["iscarry"] = true
            else
                self._newRoleWeapons[idx]["iscarry"] = false
            end
        end
    end

    for i = 1, #self._roleWeapons do
        self:calcAttribute(self._roleWeapons[i])
        if self._roleWeapons[i]["id"] and self._targetId and tonumber(self._targetId) == tonumber(self._roleWeapons[i]["id"]) then
            self._targetId = nil
            self._targetIndx = i
        end

        self._roleWeapons[i]["weaponId"] = tonumber(self._roleWeapons[i]["weaponId"])
        self._roleWeapons[i]["beforeStrengthen"] = tonumber(self._roleWeapons[i]["beforeStrengthen"])
        self._roleWeapons[i]["beforeStrengthenGroup"] = tonumber(self._roleWeapons[i]["beforeStrengthenGroup"])
    end

    -- 先排个序
    table.sort(self._roleWeapons, function(a,b)
        return tonumber(a.heroId) > tonumber(b.heroId)
    end)
    -- dump(self._roleWeapons, "self.神兵weapon:")
    table.sort(self._newRoleWeapons, function(a,b)
        return tonumber(a.heroId) > tonumber(b.heroId)
    end)
    

    local baseInfo = PlayerData:getBaseInfo()
    local _sexId = tonumber(baseInfo["seigniorId"]) or 1
    local _initModel = {[1]="nanzhu",[2]="nvzhujue"}
    local _nowModel = _initModel[_sexId]
    self._nowModel = _nowModel --当前玩家的模型
    if _nowModel == "nanzhu" then
        zc.createArmature({fileName = "nanzhu_shan" , async = true, asyncCallback = function() end})
    elseif _nowModel == "nvzhujue" then
        zc.createArmature({fileName = "nvzhuqiang", async = true, asyncCallback = function() end})
    end
end
--计算属性，强化的属性没加
function SmithyGodWeaponLayer:calcAttribute(_weaponInfo)
    if not _weaponInfo or not _weaponInfo["ISOPEN"] then
        return
    end
    local skillTa = {}
    for i = 1,6 do
        local effectInfo = _weaponInfo["effectInfo"..i] 
        if effectInfo and effectInfo["effectId"] then
            skillTa[tonumber(effectInfo["effectId"])] = i
        end
    end
    for i = 1, tonumber(_weaponInfo["beforeStrengthen"]) do
        local effectInfo = gameData.getDataFromCacheWithPrimaryKey("weapon_beforestrengthen", i)
        if effectInfo and effectInfo["effectType"] then
            local effectIdx = skillTa[tonumber(effectInfo["effectType"])]
            if effectIdx then
                _weaponInfo["effectValue"..effectIdx] = tonumber(_weaponInfo["effectValue"..effectIdx]) + tonumber(effectInfo["effectValue"]) 
            end
        end
    end
end
function SmithyGodWeaponLayer:initUI()
    local ink_bottom = zc.createSprite("res/Main/role/common/ink_bottom.png")
    ink_bottom:setAnchorPoint(0.5, 1)
    ink_bottom:setPosition(cc.p(150,zc.height))
    self:addChild(ink_bottom)
    --节点背景
    local bgSize = cc.size(1115, 570)

    local myScale9 = zc.createSprite()
    myScale9:setContentSize(bgSize)
    myScale9:setAnchorPoint(cc.p(0.5, 0.5))
    myScale9:setPosition(cc.p(zc.width/2, zc.height/2-20))
    self:addChild(myScale9, 6)
    self._bgImg = myScale9

    self._nowViewIndex = 1

    local leftSize = cc.size(496, bgSize.height)
    local leftBg = zc.createSprite()
    leftBg:setContentSize(leftSize)
    leftBg:setAnchorPoint(cc.p(0, 0.5))
    leftBg:setPosition(cc.p(0, bgSize.height/2))
    self._bgImg:addChild(leftBg,1)
    self._leftBg = leftBg

    --初始化右信息
    self:initRightInfo()
    --初始化左侧信息
    self:initLeft()
end
--初始化右信息
function SmithyGodWeaponLayer:initRightInfo()
    local right_bg = zc.createNormalPop({
        width = 594+0,
        height = 520+31,
        srcTag = 2,
    })
    -- 改背景
    local _spine = zc.getSpine( "jsxxyxg" )
    _spine:setPosition( 130,350 )
    -- _spine:setScale(0.8)
    _spine:playAction( "animation", true )
    right_bg:addChild( _spine )

    right_bg:setAnchorPoint(cc.p(0, 0.5))
    right_bg:setPosition(cc.p(self._leftBg:getPositionX()+self._leftBg:getContentSize().width, self._bgImg:getContentSize().height/2))
    self._bgImg:addChild(right_bg)
    self._infoBg = right_bg
    -- 顶部
    local _topBg = cc.Sprite:create( "res/Main/role/common/top_bg.jpg" )
    _topBg:setAnchorPoint( 0.5, 1 )
    _topBg:setPosition( cc.p(right_bg:getContentSize().width/2,right_bg:getContentSize().height-5 ) )
    right_bg:addChild( _topBg )
    _topBg:setScaleX( 586/_topBg:getContentSize().width )
    local nameBg = zc.getScaleNode("res/Main/role/common/name_bg.png", cc.size(410, 32))
    nameBg:setPosition(cc.p(_topBg:getPositionX(), _topBg:getPositionY()- _topBg:getContentSize().height/2))
    right_bg:addChild(nameBg)
    self._nameBg = nameBg
    local heroInfo = PlayerData:getGeneralInfoById(PlayerData.info["heroId"])
    -- 英雄的星级
    -- zc.createHeroStar( right_bg, heroInfo.star, cc.p( 48, 426 ) )

    -- local nameLab = zc.createLabel({
    --     text = PlayerData.info["userName"],
    --     outLine = true,
    --     fontSize = 22,
    --     pos = cc.p(51, nameBg:getContentSize().height/2 ),
    -- })
    -- nameBg:addChild(nameLab)
    -- local titleName = zc.createLabel({
    --     text = "<"..zc.getGodNameById( PlayerData:getBaseInfoByTag( "godName" ) )..">",
    --     outLine = true,
    --     fontSize = 22,
    --     ap = cc.p(0, 0.5),
    --     pos = cc.p(0, nameLab:getPositionY()),
    --     color = zc.COLOR_PURPLE,
    -- })
    -- nameBg:addChild(titleName)
    -- nameLab:setPositionX(nameBg:getContentSize().width/2-titleName:getContentSize().width/2)
    -- titleName:setPositionX(nameLab:getPositionX()+nameLab:getContentSize().width/2 )
    local _weponName = zc.createLabel({
        text = "aaa",
        fontSize = 22,
        pos = cc.p(nameBg:getContentSize().width / 2, nameBg:getContentSize().height / 2),
        })
    nameBg:addChild(_weponName)
    self._weponName = _weponName
    -- 修改后的进阶预览入口按钮
    local _previewBtn = zc.createPushButton({
        normalFile = "res/Main/common/button/exclamation_u.png",
        selectedFile = "res/Main/common/button/exclamation_d.png",
        pos = cc.p(right_bg:getContentSize().width - 30, right_bg:getContentSize().height - 30),
        endCallback = function ()
            local weaponInfo = self._roleWeapons[self._nowWeaponIdx]
            local _nowJinjieTable = gameData.getDataFromCacheWithPrimaryKey("weapon_advanced", weaponInfo["weaponId"])
            -- dump(_nowJinjieTable, "_nowJinjieTable:")
            local newIdx = tonumber(_nowJinjieTable["newId"])
            if newIdx == 0 then
                zc.tipInfo(zc.lang("already_full_level"))
            else
                zc.createSourcePop("SmithyGodPreView", "src/layer/smithyHouse/SmithyGodPreViewPop.lua", {weaponId=weaponInfo["weaponId"]})
            end
            
        end
    })
    right_bg:addChild(_previewBtn)
    
    -- 武器图标
    local _weaponIconBg = cc.Sprite:create( "res/Main/role/common/weapon_icon_bg.png" )
    _weaponIconBg:setAnchorPoint( 0, 0 )
    _weaponIconBg:setPosition( 4, _topBg:getPositionY()-_topBg:getContentSize().height+2)
    right_bg:addChild( _weaponIconBg ,1)
    -- 设置为不可见
    _weaponIconBg:setVisible(false)
    local _weaponIcon = cc.Sprite:create()
    _weaponIcon:setPosition( _weaponIconBg:getContentSize().width/2 + 2, -10 )
    _weaponIconBg:addChild( _weaponIcon )
    self._weaponIcon = _weaponIcon
    local heroTypeImg = zc.getHeroTypeBigImg( self._roleWeapons[1]["type"] )
    self._weaponIcon:setTexture(heroTypeImg)

    -----------------------
    self._skillItemList = {}
    self._effectBgList = {}
    self._costItemList = {}
    -----------------------
    --技能
    local skilltitle = zc.createSprite("res/Main/smithy/shenbing/skilltitle.png")
    skilltitle:setPosition(418, 440)
    right_bg:addChild(skilltitle)
    self._skillMiddlePos = cc.p(426, 370) --技能中间位置
    self._skillNums = 3
    self._skillDistance = 110
    local skillPos = zc.sortFromMiddle( self._skillMiddlePos, self._skillNums, self._skillDistance )


    for i = 1, 3 do
        local item = zc.createIconByData({
            data = {
                mainType = zc.mainTypeSkill,
                type = 1, 
                id = 1,
            }, 
            pos = skillPos[i], 
        })
        item:setScale(0.7)
        right_bg:addChild(item)
        self._skillItemList[#self._skillItemList+1] = item

        local bisha = zc.createSprite("res/Main/pub/critical.png")
        bisha:setAnchorPoint(0.5, 1)
        bisha:setPosition( item:getContentSize().width/2 , 10 )
        item:addChild(bisha)
        item.bisha = bisha
    end

    --属性背景
    local attrtitle = zc.createSprite("res/Main/smithy/shenbing/attrtitle.png")
    attrtitle:setPosition(418, 300)
    right_bg:addChild(attrtitle)
    local _attrInfoBg = ccui.Scale9Sprite:create( cc.rect( 11, 10, 30, 30 ), "res/Main/common/img_empty.png" )
    _attrInfoBg:setContentSize( cc.size(300, 150) )
    _attrInfoBg:setAnchorPoint( 0.5, 0 )
    _attrInfoBg:setPosition( right_bg:getContentSize().width/2, 160 )
    right_bg:addChild( _attrInfoBg )

    local posDis = _attrInfoBg:getContentSize().width / 2 + 10
    for i = 1, 6 do
        local modI = i <= 2 and (i-1) or ((i-1)%2)
        local posX = 128 + posDis * modI
        local posY = 100-42*( math.floor((i-1)/2))
        local effectBg = zc.getScaleNode("res/Main/smithy/attribute_di.png", cc.size(140, 33))
        effectBg:setAnchorPoint(cc.p(0, 0.5))
        effectBg:setPosition(posX,posY)
        _attrInfoBg:addChild(effectBg)
        self._effectBgList[#self._effectBgList+1] = effectBg
        local _effecttext = zc.createLabel({
            fontSize = 20,
            color = cc.c3b(255,198,57),
            outLine = true,
        })
        _effecttext:enableOutline(cc.c4b(112,42,42, 255), 2)
        _effecttext:setAnchorPoint(0, 0.5)
        _effecttext:setPosition( cc.p(3, effectBg:getContentSize().height/2) )
        -- _effecttext:setGradientColor(cc.c4b(244, 159, 8, 255), cc.c4b(255, 255, 124, 255), cc.p(0, -1))
        effectBg:addChild(_effecttext)
        local _valueLabel = zc.createLabel({
            fontSize = 18,
            ap = cc.p(1, 0.5),
            pos = cc.p(effectBg:getContentSize().width-3,effectBg:getContentSize().height/2),
            outLine = true,
            color = display.COLOR_GREEN
        })
        effectBg:addChild(_valueLabel)
        effectBg._effect = _effecttext
        effectBg._effectValue = _valueLabel
    end

    -- 神兵特性text
    local _shengbingtexing_txt = zc.createSprite("res/Main/smithy/shenbing/shenbingtexing.png")
    _shengbingtexing_txt:setPosition(cc.p(150, 210))
    right_bg:addChild(_shengbingtexing_txt)

    local _decBg = zc.getScaleNode("res/Main/role/common/shadow_bg.png", cc.size(50, 100) )
    _decBg:setContentSize(cc.size(550, 120))
    _decBg:setAnchorPoint(cc.p(0.5, 1))
    _decBg:setPosition(cc.p(right_bg:getContentSize().width / 2, _shengbingtexing_txt:getPositionY() - 20))
    right_bg:addChild(_decBg)
    self._describeBg = _decBg
    -- 武器的描述
    local describe = zc.createLabel({
        text = "aaaa",
        width = 540,
        ap = cc.p(0.5, 0.5),
        pos = cc.p(5, _decBg:getContentSize().height - 5),
        fontSize = 18,
        color = cc.c3b(214,193,150),
        align = cc.TEXT_ALIGNMENT_LEFT,
        })
    _decBg:addChild(describe)
    self._describe = describe

    --下方信息
    local attr_bg = zc.getScaleNode("res/Main/role/trinket/sellDi.png", cc.size(586, 130))
    attr_bg:setAnchorPoint(cc.p(0.5, 0))
    attr_bg:setPosition(cc.p(right_bg:getContentSize().width/2-1, 0))
    right_bg:addChild(attr_bg,1)

    self._attr_bg = attr_bg

    local bottomInfobg = zc.createSprite()
    bottomInfobg:setContentSize(cc.size(560, 130))
    bottomInfobg:setAnchorPoint(cc.p(0.5, 0.5))
    bottomInfobg:setPosition(cc.p(attr_bg:getContentSize().width/2, attr_bg:getContentSize().height/2))
    attr_bg:addChild(bottomInfobg)

    self._bottomInfobg = bottomInfobg
    
    local bottomHeadInfobg = zc.createSprite()
    bottomHeadInfobg:setContentSize(cc.size(561, 70))
    bottomHeadInfobg:setAnchorPoint(cc.p(0.5, 1))
    bottomHeadInfobg:setPosition(cc.p(bottomInfobg:getContentSize().width/2, bottomInfobg:getContentSize().height))
    bottomInfobg:addChild(bottomHeadInfobg)

    self._bottomHeadInfobg = bottomHeadInfobg

    local advanceLab = zc.createLabel({
        text = zc.lang("tips_after_advance_godweapon_tip"),
        outLine = true,
        fontSize = 22,
        pos = cc.p(bottomInfobg:getContentSize().width/2, bottomInfobg:getContentSize().height-25),
    })
    bottomInfobg:addChild(advanceLab)
    
    self._advanceLab = advanceLab

    --成功率
    local successBg = ccui.Scale9Sprite:create( cc.rect( 11, 10, 30, 30 ), "res/Main/role/common/shadow_bg.png" )
    successBg:setContentSize( cc.size(225, 32) )
    successBg:setAnchorPoint( 0, 0.5 )
    successBg:setPosition( 2, bottomHeadInfobg:getContentSize().height / 2 + 15)
    bottomHeadInfobg:addChild( successBg )

    local curSucessLab = zc.createLabel({
        text = zc.lang("now_strength_success_rate") .. "：",
        outLine = true,
        fontSize = 18,
        ap = cc.p(0, 0.5),
        pos = cc.p(3, successBg:getContentSize().height/2),
    })
    successBg:addChild(curSucessLab)
    self._curSucessLab = curSucessLab

    local curSucessNumLab = zc.createLabel({
        outLine = true,
        fontSize = 20,
        ap = cc.p(1, 0.5),
        pos = cc.p(successBg:getContentSize().width-5, curSucessLab:getPositionY() ),
        color = display.COLOR_GOLD,
    })
    successBg:addChild(curSucessNumLab)
    self._curSucessNumLab = curSucessNumLab
    

    local _size = cc.size(323, 45)
    local _normalNode = zc.createSprite("res/Main/smithy/shenbing/text_bg_s.png")
    local _selectedNode = zc.createSprite("res/Main/smithy/shenbing/text_bg_s.png")

    -- 右边按钮变为
    local tishengBg = ccui.Scale9Sprite:create( cc.rect( 11, 10, 30, 30 ), "res/Main/role/common/shadow_bg.png" )
    tishengBg:setContentSize( cc.size(200, 32) )
    tishengBg:setAnchorPoint( 0, 0.5 )
    tishengBg:setPosition(cc.p(successBg:getPositionX() + successBg:getContentSize().width + 10, successBg:getPositionY()))
    bottomHeadInfobg:addChild(tishengBg)
    local checkBox = zc.createPushButton({
        normalNode = _normalNode,
        selectedNode = _selectedNode,
        pos = cc.p(tishengBg:getPositionX()+tishengBg:getContentSize().width + 1, tishengBg:getPositionY()),
        endCallback = function()
            self._selectGold = not self._selectGold
            self._checkBox._selectedImg:setVisible(self._selectGold)
        end
    })
    checkBox:setAnchorPoint(cc.p(0, 0.5))
    checkBox:setScale(0.85)
    bottomHeadInfobg:addChild(checkBox)
    self._checkBox = checkBox

    local _selectedImg = zc.createSprite("res/Main/home/home_reachCondition.png")
    checkBox:addChild(_selectedImg)
    _selectedImg:setPosition(26, _selectedNode:getContentSize().height*0.5)
    self._checkBox._selectedImg = _selectedImg

    --消耗元宝
    local goldImg = zc.createSprite( zc.getImgByType(1) )
    goldImg:setAnchorPoint(0, 0.5)
    goldImg:setPosition(checkBox:getPositionX() + checkBox:getContentSize().width-2, checkBox:getPositionY() )
    bottomHeadInfobg:addChild(goldImg)

    local goldNum = zc.createLabel({
        fontSize = 20,
        ap = cc.p(0, 0.5),
        pos = cc.p(checkBox:getContentSize().width - 2, goldImg:getContentSize().height / 2 ),
        outLine = true,
    })
    goldImg:addChild(goldNum)
    self._goldNum = goldNum

    local addSuccessLab = zc.createLabel({
        text = zc.lang("up_strength_success_rate"),
        outLine = true,
        fontSize = 18,
        ap = cc.p(0, 0.5),
        pos = cc.p(5, tishengBg:getContentSize().height / 2 ),
    })
    tishengBg:addChild(addSuccessLab)

    local addSuccessNumLab = zc.createLabel({
        text = "100%",
        outLine = true,
        fontSize = 20,
        ap = cc.p(0, 0.5),
        pos = cc.p(addSuccessLab:getPositionX()+addSuccessLab:getContentSize().width+10, addSuccessLab:getPositionY() ),
        color = display.COLOR_GREEN,
    })
    tishengBg:addChild(addSuccessNumLab)
    
    local arrow = zc.createSprite("res/Main/common/arrow_green.png")
    arrow:setAnchorPoint(0.5, 0.5)
    arrow:setPosition(addSuccessNumLab:getPositionX()+addSuccessNumLab:getContentSize().width+10, addSuccessNumLab:getPositionY() )
    tishengBg:addChild(arrow)
    arrow:setRotation(-90)

    local distance = 100
    local consumePos = zc.sortFromMiddle( cc.p(195, 50), 4, distance )
 
    for i = 1, 4 do
        local consumeItemBg = zc.createSprite("res/Main/smithy/shenbing/item_bg.png")
        consumeItemBg:setAnchorPoint(0.5, 0.5)
        consumeItemBg:setPosition(consumePos[i])
        bottomInfobg:addChild(consumeItemBg)

        local item = zc.createIconByData({
            data = {
                mainType = 4,
                type = 80, 
                id = 80,
            }, 
            pos = cc.p(consumeItemBg:getContentSize().width/2,consumeItemBg:getContentSize().height/2), 
        })
        item:setScale(76/120)
        consumeItemBg:addChild(item)
        self._costItemList[#self._costItemList+1] = item

        local costItemsmNum = zc.createLabel({
            text = "0/0",
            fontSize = 26,
            ap = cc.p(1, 0.5),
            pos = cc.p(item:getContentSize().width-10, 15),
            outLine = true,
            color = display.COLOR_RED,
        })
        costItemsmNum:setName("costItemsmNum")
        item:addChild(costItemsmNum)
    end
    local touchBtn = zc.createCommomBtn({
        tag = 1,
        btnText = zc.lang("strength_2"),
        needSwallow = true,
        touchScale = 0.9,
        pos = cc.p(484, 55),
        endCallback = function() end,
    })
    bottomInfobg:addChild(touchBtn)

    self._touchBtn = touchBtn
    advanceLab:setVisible(false)

    -- 神兵改增加的按钮和label
    local posY = 60
    local _changge_shenbing_node = cc.Node:create()
    right_bg:addChild(_changge_shenbing_node, 10)
    _changge_shenbing_node:setVisible(false)
    self._changge_shenbing_node = _changge_shenbing_node
    local _cost_label_txt = zc.createLabel({
        text = zc.lang("change_shenbing_cost"),
        ap = cc.p(0, 0.5),
        pos = cc.p(30, posY), 
        fontSize = 24,
        })
    _changge_shenbing_node:addChild(_cost_label_txt)

    local cost_bg = zc.getScaleNode("res/Main/role/common/shadow_bg.png", cc.size(210, 30))
    cost_bg:setAnchorPoint(cc.p(0, 0.5))
    cost_bg:setPosition(cc.p(_cost_label_txt:getPositionX() + _cost_label_txt:getContentSize().width + 30, posY))
    _changge_shenbing_node:addChild(cost_bg)

    -- 获取花费
    local consume_price = gameData.getDataFromCache("consume_price", {type = 70})
    local cost = tonumber(consume_price.price)
    local _cost_num = zc.createLabel({
        text = cost,
        fontSize = 20,
        pos = cc.p(cost_bg:getContentSize().width / 2, cost_bg:getContentSize().height / 2),
        })
    cost_bg:addChild(_cost_num)

    local _yuanbao = zc.createSprite("res/Main/common/common_icon_gold.png")
    _yuanbao:setAnchorPoint(cc.p(1, 0.5))
    _yuanbao:setPosition(cc.p(cost_bg:getContentSize().width - 1, cost_bg:getContentSize().height / 2))
    cost_bg:addChild(_yuanbao)
    -- 切换神兵按钮
    local _change_shenbing = zc.createCommomBtn({
        tag = 1,
        btnText = zc.lang("change_shenbing"),
        needSwallow = true,
        touchScale = 0.9,
        pos = cc.p(484, posY),
        endCallback = function() 
            -- local confirm =  ZCConfirmDialog:createWithParams({
            --         title = zc.lang("prompt"),
            --         msg = string.format(zc.lang("change_shenbing_tip"), cost),
            --         showDi = true,
            --         leftVisible = false,
            --         rightCallback = function()
            --             print("切换神兵")
            --             -- 切换神兵
            --             zc.sendHttp({
            --                 apiName = "Weapon_equip",
            --                 params = {heroId = self._id,weaponId = self._weaponShowData.id},
            --                 -- 成功回调
            --                 successCallback = function(backData)
            --                     -- 成功之后需要变成正常的升级

            --                 end
            --             })
            --         end
            --     })
            -- cc.Director:getInstance():getRunningScene():addChild(confirm, 11)
        end,
    })
    _changge_shenbing_node:addChild(_change_shenbing)
    self._changge_shenbing_btn = _change_shenbing

end
function SmithyGodWeaponLayer:initLeft()
    local leftBg = self._leftBg
    local leftSize = leftBg:getContentSize()
    leftBg:removeAllChildren()
    local circle2 = zc.createSprite("res/Main/smithy/shenbing/new_circle2.png")
    circle2:setAnchorPoint(0.5, 0.5)
    circle2:setPosition(leftSize.width/2, leftSize.height/2)
    leftBg:addChild(circle2)
    circle2:runAction(cc.RepeatForever:create(cc.Sequence:create(cc.RotateBy:create(40, 360))))
    
    local circle1 = zc.createSprite("res/Main/smithy/shenbing/new_circle1.png")
    circle1:setAnchorPoint(0.5, 0.5)
    circle1:setPosition(circle2:getPositionX(),circle2:getPositionY())
    leftBg:addChild(circle1)

    -- 解锁新神兵按钮
    local _unlock_shenbing_btn = zc.createCommomBtn({
        tag = 2,
        btnText = zc.lang("unlock_shenbing"),
        needSwallow = true,
        endCallback = function()
            -- local weaponInfo = self._roleWeapons[self._nowWeaponIdx]
            -- zc.createSourcePop("SmithyGodPreView", "src/layer/smithyHouse/SmithyGodPreViewPop.lua", {weaponId=weaponInfo["weaponId"]})
            zc.createSourceScene("UnlockGodWeponLayer", "src/layer/smithyHouse/UnlockGodWeponLayer.lua", {_roleWeapons = self._newRoleWeapons})
        end,
        anchor = cc.p(0.5, 0.5),
        pos = cc.p(self._leftBg:getContentSize().width/2, 22)
    })
    leftBg:addChild(_unlock_shenbing_btn, 100)
    self._unLockShenbing = _unlock_shenbing_btn

    local levelBgSize = cc.size(159, 37)
    local levelBg = zc.getScaleNode("res/Main/copy/copy_di.png", levelBgSize)
    levelBg:setAnchorPoint(cc.p(0.5, 0))
    levelBg:setPosition(cc.p(self._leftBg:getContentSize().width/2, 151))
    leftBg:addChild(levelBg, 100)
    self._levelBgSize = levelBgSize
    local advancedLevel = zc.createSprite("res/Main/research/bingfa/advance_1.png")
    advancedLevel:setAnchorPoint(0.5, 0.5)
    advancedLevel:setPosition(levelBgSize.width/2, levelBgSize.height/2)
    levelBg:addChild(advancedLevel)

    local strengLevel = zc.createLabel({
        text = "1",
        outLine = true,
        fontSize = 25,
        pos = cc.p(0, levelBgSize.height/2),
    })
    levelBg:addChild(strengLevel)
    local strengLevelJi = zc.createLabel({
        text = zc.lang("level_1"),
        outLine = true,
        fontSize = 24,
        ap = cc.p(0, 0.5),
        pos = cc.p(strengLevel:getContentSize().width+5, strengLevel:getContentSize().height/2),
        color = display.COLOR_BTNFONTYELLOW,
    })
    strengLevel:addChild(strengLevelJi)
    strengLevel.strengLevelJi = strengLevelJi

    leftBg._advancedLevel = advancedLevel
    leftBg._strengLevel = strengLevel

    --tableview
    self:initLeftTable()
end

--初始化tableview
function SmithyGodWeaponLayer:initLeftTable()
    local leftBg = self._leftBg
    local leftSize = leftBg:getContentSize() 

    local weaponList = {[1]=1002,[2]=34}
    self._weaponList = weaponList
    local tableSize = cc.size(leftSize.width-20, leftSize.height-20)
    local tableNode = leftBg
    self._tableSize = tableSize
    
    local myTableBg = zc.getScaleNode("res/Main/common/img_empty.png", tableSize)
    myTableBg:setAnchorPoint(cc.p(0.5, 0.5))
    myTableBg:setPosition(cc.p(tableNode:getContentSize().width/2, tableNode:getContentSize().height/2))
    tableNode:addChild(myTableBg, 1)
    
    local myTable = zc.ZCTableView:create(cc.size(myTableBg:getContentSize().width-4,myTableBg:getContentSize().height-4))
    myTable:setPosition(2,2)
    myTable:setInertia(true) --设置惯性
    myTable:setBounceable(false)
    myTable:setAutoAlign(true)
    myTable:setDirection(zctech.SCROLLVIEW_DIRECTION_HORIZONTAL) --设置横向纵向
    myTable:setDelegate()
    myTable:setVerticalFillOrder(zctech.TABLEVIEW_FILL_TOPDOWN)
    self._leftTableView = myTable
    myTableBg:addChild(myTable, 1)
    
    local function cellSizeForTable(table,idx)
        return tableSize.height-4, tableSize.width-4
    end
    local function numberOfCellsInTableView(table)
        return #self._roleWeapons
    end
    local function tablePageAfterSliding(table, cell)
        LayerManager.addShieldLayout(nil,0.05)
        local currentPage = table:getCurrentPage()
        --每次改变兵器的时候需要做的处理，每个处理中判断是否重复的处理
        self:changWeaponDo(currentPage+1)
    end
    local function tableCellAtIndex(table,idx)
        local nowIdx = idx + 1
        local cell = table:dequeueCell()
        if cell == nil then
            cell = zc.ZCTableViewCell:new()
            cell:setContentSize(cc.size(tableSize.width-4, tableSize.height-4))
        else
            cell:removeAllChildren()
        end
        self:updateCell(cell, nowIdx)
        return cell
    end
    myTable:registerScriptHandler(numberOfCellsInTableView,cc.NUMBER_OF_CELLS_IN_TABLEVIEW)
    myTable:registerScriptHandler(cellSizeForTable,cc.TABLECELL_SIZE_FOR_INDEX)
    myTable:registerScriptHandler(tableCellAtIndex,cc.TABLECELL_SIZE_AT_INDEX)
    myTable:registerScriptHandler(tablePageAfterSliding,zctech.TABLECELL_AFTER_SLIDING)
    self._myTable = myTable

    --左右 button
    local leftBtn = zc.createPushButton({
        normalFile = "res/Main/common/arrow_left.png",
        selectedFile = "res/Main/common/arrow_left.png",
        needSwallow = true,
        needEnableWhenMoving = true,
        touchSize = cc.size(60, 70),
        anchor = cc.p(0, 0.5),
        pos = cc.p(0-50, tableSize.height/2),
        endCallback = function() end,
    })
    myTableBg:addChild(leftBtn,11) 
    self._leftBtn = leftBtn

    local rightBtn = zc.createPushButton({
        normalFile = "res/Main/common/arrow_right.png",
        selectedFile = "res/Main/common/arrow_right.png",
        needSwallow = true,
        needEnableWhenMoving = true,
        touchSize = cc.size(60, 70),
        anchor = cc.p(1, 0.5),
        pos = cc.p(tableSize.width + 50, tableSize.height/2),
        endCallback = function() end,
    })
    self._rightBtn = rightBtn
    myTableBg:addChild(rightBtn, 11) 

    leftBtn:getStateNormal():setOpacity(0)
    rightBtn:getStateNormal():setOpacity(0)

    leftBtn:runAction(cc.Sequence:create(
        cc.Spawn:create(cc.MoveBy:create(0.4, cc.p(50+60, 0)),cc.CallFunc:create(function()
            leftBtn:getStateNormal():runAction(cc.Sequence:create(cc.FadeIn:create(0.4)))
        end))
    ))
    rightBtn:runAction(cc.Sequence:create(
        cc.Spawn:create(cc.MoveBy:create(0.4, cc.p(-50-60, 0)),cc.CallFunc:create(function()
            rightBtn:getStateNormal():runAction(cc.Sequence:create(cc.FadeIn:create(0.4)))
        end)),
        cc.DelayTime:create(0.1),
        cc.CallFunc:create(function()
            leftBtn:runAction(
                cc.RepeatForever:create(cc.Sequence:create(
                    cc.MoveBy:create(0.8, cc.p(10,0)),
                    cc.MoveBy:create(0.8, cc.p(-10,0))
                ))
            )
            rightBtn:runAction(
                cc.RepeatForever:create(cc.Sequence:create(
                    cc.MoveBy:create(0.8, cc.p(-10,0)),
                    cc.MoveBy:create(0.8, cc.p(10,0))
                ))
            )
        end)
    ))

    leftBtn:setTouchEndedCall(function()
        local nowIdx = myTable:getCurrentPage()
        if nowIdx > 0 then
            myTable:scrollToCell(nowIdx-1, true)
        end
    end)
    rightBtn:setTouchEndedCall(function()
        local nowIdx = myTable:getCurrentPage()
        if nowIdx < (#self._roleWeapons - 1) then
            myTable:scrollToCell(nowIdx+1, true)
        end
    end)
    
    myTable:reloadData()
    self._myTable = myTable
    if not self._targetIndx then self._targetIndx = 1 end

    if self._targetIndx then
        myTable:scrollToCell(self._targetIndx - 1, false)
    end
end
function SmithyGodWeaponLayer:updateCell(cell, nowIdx)
    local cellSize = cell:getContentSize()
    local weaponInfo = self._roleWeapons[nowIdx]

    if weaponInfo then
        -- 1001、1002、1003、1004
        -- 2001、2002、2003、2004
        local weaponToPath = {
            [1001]="qiang_1",[1002]="qiang_1",[1003]="qiang_2",[1004]="qiang_2",[1005]="qiang_3",[1006]="qiang_3",
            [2001]="shanzi_1",[2002]="shanzi_1",[2003]="shanzi_2",[2004]="shanzi_2",[2005]="shanzi_3",[2006]="shanzi_3",[2007]="shanzi_4",
        }
        local weaponPath = weaponToPath[tonumber(weaponInfo.iconId)]
        if not weaponPath then
            weaponPath = tonumber(weaponInfo.iconId) > 1500 and "shanzi_2" or "qiang_2"
        end

        local shenbingzhanshi

        --美术突然出了俩csb文件，以后跟美术对清楚，要出成spine，然后走上面的逻辑就行了。
        if tonumber(weaponInfo.iconId) == 1007  then
            -- if tonumber(weaponInfo.iconId) == 1007 or tonumber(weaponInfo.iconId) == 2007 then
            local _actName = "idle"
            if tonumber(weaponInfo.iconId) == 1007 then
                _actName = "Animation1"
            end

            local path_ = "res/animation/" .. weaponInfo.iconId .. "/"
            local params = {
                fileName = weaponInfo.iconId,
                actName = _actName,
                parentPath = path_,
                loop = true,
            }
            shenbingzhanshi = zc.createArmature(params)
            shenbingzhanshi:getAnimation():play("idle", -1, 1)
            
        else
            shenbingzhanshi = zc.createSpine({
                path = "res/Main/smithy/shenbing/show/",
                fileName = weaponPath,
                actName = ""..weaponInfo.iconId,
            })
        end
        
        shenbingzhanshi:setPosition(cellSize.width/2, cellSize.height/2)
        cell:addChild(shenbingzhanshi)
        shenbingzhanshi:setVisible(false)
        
        if tonumber(weaponInfo.iconId) == 2007 then
            shenbingzhanshi:setScale(2.3)
        else
            shenbingzhanshi:setScale(0.8)
        end
        shenbingzhanshi:runAction(cc.RepeatForever:create(cc.Spawn:create(
            cc.Sequence:create(
                cc.MoveBy:create(1.4, cc.p(0, 10)),
                cc.MoveBy:create(1.4, cc.p(0, -10))
            )
        )))
        performWithDelay(shenbingzhanshi,function()
            shenbingzhanshi:setVisible(true)
        end,0.05)
    end
end
--每次改变兵器的时候需要做的处理，每个处理中判断是否重复的处理
function SmithyGodWeaponLayer:changWeaponDo(nowIdx)
    if nowIdx <= 1 and nowIdx >= #self._roleWeapons then
        self._leftBtn:setVisible(false)
        self._rightBtn:setVisible(false)
    elseif nowIdx <=1 then
        self._leftBtn:setVisible(false)
        self._rightBtn:setVisible(true)
    elseif nowIdx >= #self._roleWeapons then
        self._leftBtn:setVisible(true)
        self._rightBtn:setVisible(false)
    end
    self:setNowWeaponInfo(nowIdx)
    --初始广点（进入游戏、升级后需要处理）
    self:initDot(nowIdx)
    --初始化人物（进入游戏、进阶后需要处理）
    self:reloadArmature(nowIdx)
    --刷新右边
    self:refreshRight(nowIdx,nil,true)
end
--设置人物动画
function SmithyGodWeaponLayer:reloadArmature(nowIdx, _force)
    if not _force then
        if self._nowArmatureIdx and self._nowArmatureIdx == nowIdx then
            return
        end
    end
    self._nowArmatureIdx = nowIdx
    local weaponInfo = self._roleWeapons[nowIdx]
    local bgImg = self._bgImg 
    local bgSize = bgImg:getContentSize()

    if self._armature then
        self._armature:removeFromParent()
        self._armature = nil
    end
    -- 动画
    local armature = zc.battle.createHeroArmature({
        fileName = self._nowModel , 
        async = true, 
        actName = "idle",
        loop = true,
        heroDataWeaponId = weaponInfo["weaponId"],
        asyncCallback = function ( _armature )
            if not tolua.isnull(bgImg)  then
                if _armature then
                    _armature:setOpacity(0)
                    _armature:runAction(cc.Sequence:create(cc.FadeIn:create(0.2),cc.CallFunc:create(function()
                        _armature:getAnimation():play("idle", -1, 1)
                    end)))
                    --换兵器
                    print("换兵器：weaponId:"..weaponInfo["weaponId"])
                    zc.soldierChangeWeapon(_armature, weaponInfo["weaponId"])
                end
            end
        end,
    })
    armature:setPosition(cc.p(bgSize.width-480, bgSize.height-290))
    armature:setScaleX( -1.0 )
    bgImg:addChild(armature, 100)
    self._armature = armature

    if self._weaponIcon then
        local heroTypeImg = zc.getHeroTypeBigImg( weaponInfo["type"] )
        self._weaponIcon:setTexture(heroTypeImg)
    end

    -- 按钮
    if not self._heroBtn then
        local scaleSize = cc.size(120, 150)
        local myScale9 = zc.getScaleNode("res/Main/setting/scale9_1.png", scaleSize)
        local heroBtn = zc.createPushButton({
            touchSize = cc.size( 120, 150 ),
            -- normalNode = myScale9,
            pos = cc.p(  armature:getPositionX() , armature:getPositionY()+60 ),
            endCallback = function()
                local _action = zc.random(1, 3)
                if self._action and self._action == _action then
                    if _action < 3 then
                        _action = _action + 1
                    else 
                       _action = 1 
                    end
                end
                self._action = _action
                local _actions = {"atk3", "atk", "atk0"}
                self._armature:getAnimation():play( _actions[_action], -1, 0 )
                self._armature:getAnimation():setMovementEventCallFunc(function(_armature, movementType, movementID)
                    if 1 == tonumber(movementType) then
                        if not tolua.isnull(_armature) then
                            _armature:getAnimation():play("idle", -1, 1)
                        end
                    end
                end)
            end
        })
        bgImg:addChild( heroBtn )
        self._heroBtn = heroBtn
    end
end
--初始化亮点
function SmithyGodWeaponLayer:initDot(nowIdx, _force)
    if not _force then
        if self._nowChooseDotIdx and self._nowChooseDotIdx == nowIdx then
            return
        end
    end
    self._nowChooseDotIdx = nowIdx
    local leftBg = self._leftBg
    local leftSize = leftBg:getContentSize()
    local weaponInfo = self._roleWeapons[nowIdx]
    -- dump(weaponInfo, "initDot---")
    local stateInfo = self:getNowStateInfo(weaponInfo["weaponId"])
    local nextStrInfo = stateInfo.nextStrInfo
    local _isQinghua = stateInfo.isQianghua
    local _nowDotIdx = tonumber(stateInfo.nowIdx) or 0 --当前两点的位置 
    local _dotNum = tonumber(stateInfo.dotNum) or 1

    self._dotNum = _dotNum
    print("dotnum:".._dotNum.."nowIdx:".._nowDotIdx)
    local _angel = 360/_dotNum

    --如果没有进度条，就初始化
    if not leftBg:getChildByName("progressBg") then
        self:initProgressBg()
    end

    for i = 1, self._dotNum do
        local _light_dot = self._lishgt_dot[i]
        if i <= _nowDotIdx then
            _light_dot:setVisible(true)
            _light_dot:playAction("idle", true)
        else
            _light_dot:setVisible(false)
        end
    end
    self._progress:setPercentage( _angel*(_nowDotIdx) / 360 * 100 )
    self._progress:setVisible(true)

    --初始化
    if not self._preAttrBg then
        self:initPreAttrBg()
    end

    --属性显示
    if _isQinghua and nextStrInfo then
        local _prePos = cc.p(self._gray_dotList[_nowDotIdx+1]:getPositionX(),self._gray_dotList[_nowDotIdx+1]:getPositionY())
        self._preAttrBg:setVisible(true)
        self._preAttrBg:setPosition( _prePos )
        local _preAttr = LANGUAGE_getAttributeTextById(nextStrInfo["effectType"])
        local _preAttrNum = zc.getAttributeNumById(nextStrInfo["effectType"],nextStrInfo["effectValue"])
        local _effLab = self._preAttrBg._effLab
        local _effNum = self._preAttrBg._effNum
        _effLab:setText(_preAttr)
        _effNum:setText("+".._preAttrNum)
        _effLab:setPositionX(101/2-_effNum:getContentSize().width/2)
        _effNum:setPositionX(_effLab:getPositionX()+_effLab:getContentSize().width/2)
    else
        self._preAttrBg:setVisible(false)
    end

end
function SmithyGodWeaponLayer:initPreAttrBg()
    local _preAttrSize = cc.size(101, 41)
    local _preAttrBg = zc.getScaleNode("res/Main/setting/scale9_1.png", _preAttrSize)
    _preAttrBg:setAnchorPoint(cc.p(0, 1))
    self._progressBg:addChild(_preAttrBg)
    self._preAttrBg = _preAttrBg

    local _preAttrLab = zc.createLabel({
        text = "",
        outLine = true,
        fontSize = 20,
        pos = cc.p(0, _preAttrSize.height/2),
    })
    _preAttrBg:addChild(_preAttrLab)
    local _preAttrNumLab = zc.createLabel({
        text = "",
        outLine = true,
        fontSize = 20,
        ap = cc.p(0, 0.5),
        pos = cc.p(0, _preAttrLab:getPositionY() ),
        color = display.COLOR_GREEN,
    })
    _preAttrBg:addChild(_preAttrNumLab)
    _preAttrBg._effLab = _preAttrLab
    _preAttrBg._effNum = _preAttrNumLab
end
function SmithyGodWeaponLayer:initProgressBg()

    local leftBg = self._leftBg
    local leftSize = leftBg:getContentSize()
    if not leftBg:getChildByName("progressBg") then
        local progressBg = zc.createSprite("res/Main/smithy/shenbing/new_progressBg.png")
        progressBg:setAnchorPoint(cc.p(0.5, 0.5))
        progressBg:setPosition(leftSize.width/2,leftSize.height/2)
        leftBg:addChild(progressBg)
        progressBg:setName("progressBg")
        self._progressBg = progressBg

        --添加动画
        local armature = zc.createAnimationArmature({
            fileName = "qianghua_duanzao",
            autoRelease = true
        })
        armature:getAnimation():play("idle")
        armature:setPosition(cc.p(progressBg:getContentSize().width/2, progressBg:getContentSize().height/2))
        armature:setScale(1.7)
        progressBg:addChild(armature)

        local progress = cc.ProgressTimer:create(zc.createSprite("res/Main/smithy/shenbing/new_progress.png"))
        progress:setAnchorPoint(cc.p(0.5, 0.5))
        progress:setType(cc.PROGRESS_TIMER_TYPE_RADIAL)
        progress:setReverseProgress( false )
        progress:setPosition(cc.p(progressBg:getContentSize().width/2, progressBg:getContentSize().height/2))
        progressBg:addChild( progress )
        progress:setName("progress")
        progress:setPercentage(0)
        self._progress = progress

        local _dotNum = 9 --暂定为9，可能会改变，再刷新
        local _angel = 360/_dotNum
        --光点列表
        self._lishgt_dot = {}
        self._gray_dotList = {}
        local middlePos = cc.p(self._progressBg:getContentSize().width/2,self._progressBg:getContentSize().height/2)
        local _r = 210 --半径
        local lishgt_dot_list = {}
        for i = 1, _dotNum do
            local _an = _angel * i
            local _x = middlePos.x + math.sin(math.rad(_an)) * _r
            local _y = middlePos.y + math.cos(math.rad(_an)) * _r
            
            local _gray_dot = zc.createSprite("res/Main/smithy/shenbing/new_dot_gray.png")
            _gray_dot:setAnchorPoint(0.5, 0.5)
            _gray_dot:setPosition(_x-2, _y)
            _gray_dot:setName("_gray_dot"..i)
            progressBg:addChild(_gray_dot)
            self._gray_dotList[#self._gray_dotList+1] = _gray_dot

            local lishgt_dot = zc.getSpine("shenbing_huoqiu")
            lishgt_dot:playAction("idle", true)
            lishgt_dot:setPosition(_gray_dot:getContentSize().width/2+5, _gray_dot:getContentSize().height/2+15)
            _gray_dot:addChild(lishgt_dot)
            lishgt_dot:setName("huoqiu")

            lishgt_dot_list[#lishgt_dot_list+1] = lishgt_dot
        end
        self._lishgt_dot = lishgt_dot_list
    end
end

function SmithyGodWeaponLayer:refreshRight(nowIdx, _force, _needFreshSkill)
    if not _force then
        if self._nowWeaponIdx and self._nowWeaponIdx == nowIdx then
            return
        end
    end
    self._nowWeaponIdx = nowIdx
    local weaponInfo = self._roleWeapons[nowIdx]
    local stateInfo = self:getNowStateInfo(weaponInfo["weaponId"])
    local btnType = stateInfo.btnType --1强化 2升级 3进价 4打造 5达到满级
    if _needFreshSkill then
        --设置技能状态
        self:refresSkillState(weaponInfo)
    end
    --设置左边按钮状态
    self:refreshLeftBtnState(weaponInfo)
    --设置属性状态
    self:refreshAttributeState(weaponInfo)
    --设置消耗状态
    self:refreshConsumeState(stateInfo["comsume"])
    --设置成功率
    self:refreshSuccessState(stateInfo,weaponInfo)
    --设置右按钮状态
    self:refreshTouchState(weaponInfo)
end

--设置按钮点击状态
function SmithyGodWeaponLayer:refreshTouchState(weaponInfo)
     -- 设置属性的描述
    -- dump(weaponInfo, "btn weaponInfo:")
    local _weaponId_chushi = tonumber(weaponInfo["weaponId"])
    local descInfo = gameData.getDataFromCacheWithPrimaryKey("weapon", _weaponId_chushi).desc
    -- descInfo = "阿里的房间辣坚实的疯狂拉升剪短发的类似飞机啊两地分居拉丝机打发第三方就拉屎的附加按时间段发牢骚"
    self._describe:setString(descInfo)
    --判断状态
    local stateInfo = self:getNowStateInfo(weaponInfo["weaponId"])
    print("refreshTouch中的判断是否是拿着的武器："..tonumber(weaponInfo["weaponId"]).."=="..self._heroUserWeaponId)
    if tonumber(weaponInfo["weaponId"]) ~= tonumber(self._heroUserWeaponId) then
        print("不等于吗？")
        self._bottomInfobg:setVisible(false)
        self._changge_shenbing_node:setVisible(true)
        self._attr_bg:setContentSize(cc.size(self._attr_bg:getContentSize().width, 120))
        local y = self._describeBg:getPositionY() - 120
        local posy = y / 2
        self._describe:setPosition(cc.p(self._describeBg:getContentSize().width / 2, self._attr_bg:getContentSize().height - posy))
        self._changge_shenbing_btn:setTouchEndedCall(function ( )
            local hand = self._changge_shenbing_node:getChildByName("guidHand")
            if hand then 
                hand:removeFromParent()
            end
            -- 获取花费
            local consume_price = gameData.getDataFromCache("consume_price", {type = 70})
            local cost = tonumber(consume_price.price)
            local confirm =  ZCConfirmDialog:createWithParams({
                    title = zc.lang("prompt"),
                    msg = string.format(zc.lang("change_shenbing_tip"), cost),
                    showDi = true,
                    leftVisible = false,
                    rightCallback = function()
                        -- 切换神兵
                        zc.sendHttp({
                            apiName = "Weapon_equip",   -- 切换神兵和装备用同一个接口
                            params = {heroId = self._heroNowHeroID, weaponId = weaponInfo["id"]},
                            -- 成功回调
                            successCallback = function(backData)
                                -- 成功之后需要变成正常的升级
                                -- dump(backData, "切换神兵：")

                                PlayerData:updateWeaponsByHeroIdAndWeaponId(self._heroNowHeroID, weaponInfo["id"])
                                PlayerData:updateWeaponsInfoById(backData.weaponEtt)
                                PlayerData:updataData(backData)
                                PlayerData:setGeneralInfoById(self._heroNowHeroID, backData.hero)
                                self._bottomInfobg:setVisible(true)
                                self._changge_shenbing_node:setVisible(false)
                                self._attr_bg:setContentSize(cc.size(self._attr_bg:getContentSize().width, 135))
                                local y = self._describeBg:getPositionY() - 100
                                local posy = y / 2
                                self._describe:setPosition(cc.p(self._describeBg:getContentSize().width / 2, self._attr_bg:getContentSize().height - posy))
                                self:refreshData()
                                self._leftTableView:reloadData()
                                self._nowWeaponIdx = 0
                                self._leftTableView:scrollToCell(self._nowWeaponIdx)
                                self:setNowWeaponInfo(self._nowWeaponIdx)
                                self:refreshRight(self._nowWeaponIdx, true)
                                
                                PlayerData:setMainRole()
                                zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_CHANGE_USER_HEAD})

                                PlayerData:updateGeneralInfo(backData)

                                local id = backData.hero.id
                                local info = PlayerData:getGeneralInfo()

                                for i, v in pairs(info) do
                                    if tonumber( v.id ) == id then
                                        v.attribute = backData.hero.attribute
                                    end
                                end
                            end
                        })
                    end
                })
            cc.Director:getInstance():getRunningScene():addChild(confirm, 11)
        end)
        return
    else
        self._bottomInfobg:setVisible(true)
        self._changge_shenbing_node:setVisible(false)
        self._attr_bg:setContentSize(cc.size(self._attr_bg:getContentSize().width, 135))
        local y = self._describeBg:getPositionY() - 100
        local posy = y / 2
        self._describe:setPosition(cc.p(self._describeBg:getContentSize().width / 2, self._attr_bg:getContentSize().height - posy))
    end 

    local btnType = stateInfo.btnType --1强化 2升级 3进价 4打造 5达到满级 

    local nextStrGroup = stateInfo.nextStrGroup

    local touchConsume = stateInfo.comsume --消耗
    local btnText = stateInfo.btnText
    self._touchBtn:setText(btnText)
    self._touchBtn.btnText = btnText
    self._guideBtn = self._touchBtn


    --是否满级
    if btnType == 5 then
        self._bottomInfobg:setVisible(false)
        if not self._maxLevelTip then
            local fullLevel = zc.createLabel({
                text = zc.lang("tips_congratulation_godweapon_full_level"),
                outLine = true,
                fontSize = 25,
                pos = cc.p(self._attr_bg:getContentSize().width/2, 102),
            })
            self._attr_bg:addChild(fullLevel)
            self._maxLevelTip = fullLevel
        else
            self._maxLevelTip:setVisible(true)
        end
        return
    else
        if self._maxLevelTip then
            self._maxLevelTip:setVisible(false)
        end
    end

    --检查兵器是否打造成功
    if weaponInfo["ISOPEN"] then
        if weaponInfo["status"] and tonumber(weaponInfo["status"]) == 1 then
            self._bottomInfobg:setVisible(false)
            local timeDiff = tonumber(weaponInfo["createTime"]) - PlayerData:getTime()
            if timeDiff > 0 then --说明还没有打造成功
                self:checkIsMaking(weaponInfo)
            else --说明还没有领取
                if not self._quickBtn then
                    local getBtn = zc.createCommomBtn({
                        tag = 1,
                        text = zc.lang("fetch_2"),
                        needSwallow = true,
                        endCallback = function()
                            zc.createSourcePop("SmithyGodAdvance", "src/layer/smithyHouse/SmithyGodMakePop.lua", {
                                before={},
                                info=weaponInfo,
                                callback = function()     
                                    weaponInfo["status"] = 0
                                    self:setNowWeaponInfo(self._nowWeaponIdx)
                                    self:refreshRight(self._nowWeaponIdx, true)
                                end,        
                            })
                        end,
                        anchor = cc.p(0.5, 0.5),
                        pos = cc.p(self._attr_bg:getContentSize().width/2, 60)
                    })
                    self._attr_bg:addChild(getBtn)
                    self._quickBtn = getBtn
                else
                    self._quickBtn:setVisible(true)
                end
            end
            return
        else
            if self._quickBtn then
                self._quickBtn:setVisible(false)
            end
        end
    end
    local  function refreshALL()
        -- 不管点击那个按钮，刷新全部数据，刷新所有界面
        self:refreshData()
        self._leftTableView:reloadData()
        self._nowWeaponIdx = 0
        self._leftTableView:scrollToCell(self._nowWeaponIdx)
        self:setNowWeaponInfo(self._nowWeaponIdx)
        self:refreshRight(self._nowWeaponIdx, true)
    end
    -- 1强化 2升级 3进价 4打造 5达到满级 
    self._touchBtn:setTouchEndedCall(function()
        LayerManager.addShieldLayout(nil, 0.3)
        local useGold = self._selectGold and 2 or 1
        if btnType == 1 then
            zc.sendHttp({
                apiName = "Weapon_preStrengthen",
                params = {id=weaponInfo.id,type=useGold},
                successCallback = function (net_data)
                    if tonumber(net_data.success) == 1 then
                        musicManager.playEffect(zc.effect["shengbingqianghua"])
                        -- 先刷新全部的数据
                        PlayerData:updataData(net_data)
                        local changeWeapons = net_data.weapon
                        -- 刷新所有武器的属性
                        local needData = {}
                        for k,v in pairs(changeWeapons) do
                            print("heroId:"..v.heroId.."self._heroNowHeroID==="..self._heroNowHeroID)
                            if tonumber(v.heroId) == self._heroNowHeroID then
                                needData = v
                            end
                            local needRefreshData = {
                               id = v["id"],
                               beforeStrengthen = v["beforeStrengthen"],
                               beforeStrengthenGroup = v["beforeStrengthenGroup"]
                            }
                            PlayerData:updateWeaponsInfoById(v)
                        end

                        -- weaponInfo["beforeStrengthen"] = needData["beforeStrengthen"]
                        -- weaponInfo["beforeStrengthenGroup"] = needData["beforeStrengthenGroup"]

                        local _nowIdx = stateInfo.nowIdx + 1
                        -- dump(net_data, "强化后的返回：")
                        -- print(weaponInfo["id"])
                        --由于后端返回数据有问题，只更新这几个数据
                        -- local needRefreshData = {
                        --     id = weaponInfo["id"],
                        --     beforeStrengthen = weaponInfo["beforeStrengthen"],
                        --     beforeStrengthenGroup = weaponInfo["beforeStrengthenGroup"]
                        -- }
                        -- PlayerData:updateWeaponsInfoById(needRefreshData)
                        
                        --叠加属性
                        local _nowWeaponAttr = table.copy(weaponInfo)
                        local _nowtInfo = nextStrGroup[_nowIdx]
                        if _nowtInfo and _nowtInfo["effectType"] then
                            for i = 1, 3 do
                                local _v = weaponInfo["effectInfo"..i]
                                if _v and _v["effectId"] then
                                    if tonumber(_nowtInfo["effectType"]) == tonumber(_v["effectId"]) then
                                        weaponInfo["effectValue"..i] = tonumber(weaponInfo["effectValue"..i]) + tonumber(_nowtInfo["effectValue"])
                                        --刷新属性
                                        local effectBg = self._effectBgList[i]
                                        local effectNum = zc.getAttributeNumById( _v["effectId"], weaponInfo["effectValue"..i])
                                        effectBg._effectValue:setString("+"..effectNum)
                                        break
                                    end
                                end
                            end
                        end
                        self:showAttrAction(_nowWeaponAttr, weaponInfo)
                        --刷新消耗数据
                        if _nowIdx and _nowIdx < self._dotNum then
                            --状态没有改变、只刷新基本数据 （属性、消耗、成功率）
                            --属性
                            local nextStrInfo = nextStrGroup[_nowIdx+1]
                            stateInfo.nextStrInfo = nextStrInfo
                            if nextStrInfo then
                                --消耗
                                local _consumeRes = {[1]={name="constMoney",type=2},[2]={name="constOre",type=10}}
                                local touchConsume = {}
                                for i = 1, #_consumeRes do
                                    local _curRes = _consumeRes[i]["name"]
                                    if nextStrInfo[_curRes] and tonumber(nextStrInfo[_curRes]) and tonumber(nextStrInfo[_curRes]) > 0 then
                                        local idx = #touchConsume + 1
                                        touchConsume[idx] = {}
                                        touchConsume[idx].mainType = 1 
                                        touchConsume[idx].type = _consumeRes[i]["type"]
                                        touchConsume[idx].id = 1 
                                        touchConsume[idx].num = nextStrInfo[_curRes]
                                    end 
                                end
                                self:refreshConsumeState(touchConsume)
                                --成功率
                                local success = tonumber(nextStrInfo.success) * 100 
                                self._curSucessNumLab:setString(success.."%")
                                self._goldNum:setString(nextStrInfo["successGold"])
                            end
                            self:setDotAnimation(weaponInfo)
                        else
                            --升级的处理
                            local _arr = {}
                            _arr[#_arr+1] = cc.ProgressTo:create(0.2, 100)
                            _arr[#_arr+1] = cc.CallFunc:create(function()
                                local _light_dot = self._lishgt_dot[#self._lishgt_dot]
                                _light_dot:setVisible(true)
                                _light_dot:playAction("start", false)
                                _light_dot:registerSpineEventHandler( function ( event )
                                    _light_dot:playAction("idle",true)
                                end, sp.EventType.ANIMATION_COMPLETE)
                            end)
                            _arr[#_arr+1] = cc.CallFunc:create(function()
                                self._preAttrBg:setVisible(false)
                            end)
                            self._progress:runAction(cc.Sequence:create(_arr))
                            --刷新数据
                            self:setNowWeaponInfo(self._nowWeaponIdx)
                            self:refreshRight(self._nowWeaponIdx, true)
                        end
                    else
                        zc.tipInfo(zc.lang("tips_godweapon_strength_fail"))
                        PlayerData:updataData(net_data)
                        --刷新消耗
                        self:refreshConsumeOfFaile()
                    end
                    -- 在这里刷新所有数据才行
                    refreshALL()
                end,
            })
        elseif  btnType == 2 then
            zc.sendHttp({
                apiName = "Weapon_strengthen",
                params = {
                    type = useGold,
                    id = weaponInfo["id"]
                },
                successCallback = function (data) 
                    dump(data, "强化：")
                    if data["succeed"] and tonumber(data["succeed"]) == 1 then
                        musicManager.playEffect(zc.effect["shengbingshengji"])
                        local attrTab = table.copy(weaponInfo)
                        local weapons = data.weapon
                        local needData = {}
                        for k,v in pairs(weapons) do
                            if tonumber(v.heroId) == self._heroNowHeroID then
                                needData = v
                            end
                            PlayerData:updateWeaponsInfoById(v)
                        end
                        PlayerData:updataData(data)
                        --更新兵器数据，
                        for k,v in pairs(needData) do
                            weaponInfo[k] = v
                        end
                        --重新计算属性
                        self:calcAttribute(weaponInfo)
                        --
                        self._guideBtn:setTouchEndedCall(function() end)
                        local progressBg = self._progressBg
                        local shenbing_shengji = zc.getSpine("shenbing_jinjie")
                        shenbing_shengji:setPosition(progressBg:getPositionX(), progressBg:getPositionY())
                        self._leftBg:addChild(shenbing_shengji, 10)
                        shenbing_shengji:setRotation( -3 )
                        shenbing_shengji:playAction("done",false)

                        shenbing_shengji:registerSpineEventHandler( function ( event )
                            performWithDelay(self,function()
                                shenbing_shengji:removeSelf()
                            end,0.2)
                        end, sp.EventType.ANIMATION_COMPLETE)

                        performWithDelay(self,function()
                            self:showAttrAction(attrTab, weaponInfo)
                            self:setNowWeaponInfo(self._nowWeaponIdx)
                            self:initDot(self._nowWeaponIdx, true)
                            self:refreshRight(self._nowWeaponIdx, true)

                        end,0.5)
                        performWithDelay(self,function()
                            self._progress:setVisible(false)
                            for i = 1, #self._lishgt_dot do
                                self._lishgt_dot[i]:setVisible(false)
                            end
                        end,0.2)
                    else
                        zc.tipInfo(zc.lang("tips_godweapon_levelup_fail"))
                        PlayerData:updataData(data)
                        --刷新消耗
                        self:refreshConsumeOfFaile()
                    end
                    -- 在这里刷新数据才行
                    refreshALL()
                end,
                failCallback = function()
                    getGuideManager():removeMaskLayer()
                end, 
                errorCallback = function(_errorCode,_msg)
                    zc.tipInfo(_msg)
                    getGuideManager():removeMaskLayer()
                end,
            })
        elseif btnType == 3 then
            zc.sendHttp({
                apiName = "Weapon_advanced",
                params = {id = weaponInfo.id},
                successCallback = function (data)
                    local masklayer = getGuideManager():getMaskLayer()
                    masklayer:setPosition(cc.p(0, 0))
                    self:addChild(masklayer, 10000)

                    local _currentGID = getGuideManager():getCurrentGID()
                    if _currentGID == GuideKey.KEY_3009 then
                        zc.setGuideFuncNextStep(_currentGID)
                        getGuideManager():addMaskLayer()
                    end
                    
                    self._guideBtn:setTouchEndedCall(function() end)
                    local attrTab = table.copy(weaponInfo)
                    local needData = {}
                    dump(data, "进阶返回：")
                    local weapons = data.weapon
                    for k,v in pairs(weapons) do
                        if tonumber(v.heroId) == self._heroNowHeroID then
                            needData = v
                        end
                        if not v["iconId"] then
                            v["iconId"] = v["weaponId"]
                        end
                        PlayerData:updateWeaponsInfoById(v)
                    end
                    local weaponData = gameData.getDataFromCacheWithPrimaryKey("weapon", needData.weaponId)
                    for k,v in pairs(weaponData) do
                        if k ~= "id" then
                            needData[k] = v
                        end
                    end
                    
                    PlayerData:updataData(data)
                    
                    --更新数据
                    for k,v in pairs(needData) do
                        weaponInfo[k] = v
                    end
                    --重新计算属性
                    self:calcAttribute(weaponInfo)

                    local _arr = {}
                    local _totalNum = self._dotNum * 10
                    for i = 1, self._dotNum do
                        _arr[#_arr+1] = cc.ProgressTo:create(0.15, i*100/self._dotNum) 
                        _arr[#_arr+1] = cc.CallFunc:create(function()
                            self._lishgt_dot[i]:setVisible(true)
                            local _light_dot = self._lishgt_dot[i]
                            _light_dot:playAction("start", false)
                            _light_dot:registerSpineEventHandler( function ( event )
                                _light_dot:playAction("idle", true)
                            end, sp.EventType.ANIMATION_COMPLETE)
                        end)
                    end
                    _arr[#_arr+1] = cc.CallFunc:create(function()
                        local progressBg = self._progressBg
                        local shenbing_shengji = zc.getSpine("shenbing_jinjie")
                        shenbing_shengji:setPosition(progressBg:getContentSize().width/2, progressBg:getContentSize().height/2)
                        shenbing_shengji:setPosition(progressBg:getPositionX(), progressBg:getPositionY())
                        self._leftBg:addChild(shenbing_shengji, 10)
                        shenbing_shengji:setRotation( -3 )
                        shenbing_shengji:playAction("done",false)
                        self:runAction(cc.Sequence:create(
                            cc.CallFunc:create(function()
                                self:showAttrAction(attrTab, data.weapon)
                            end),
                            cc.CallFunc:create(function()
                                self:reloadArmature(self._nowWeaponIdx, true)
                                self:setNowWeaponInfo(self._nowWeaponIdx)
                                self:initDot(self._nowWeaponIdx, true)
                                self:refreshRight(self._nowWeaponIdx, true, true)
                                self._myTable:reloadDataAndScrollToCurrentCell()
                            end)))
                        shenbing_shengji:registerSpineEventHandler( function ( event )
                            performWithDelay(self,function()
                                shenbing_shengji:removeSelf()
                            end,0.2)
                        end, sp.EventType.ANIMATION_COMPLETE)
                        performWithDelay(self,function()
                            self._progress:setVisible(false)
                            for i = 1, #self._lishgt_dot do
                                self._lishgt_dot[i]:setVisible(false)
                            end
                            self:initDot(self._nowWeaponIdx, true)
                        end,0.2)
                        performWithDelay(self,function()
                            --进阶展示
                            getGuideManager():removeMaskLayer()
                            if masklayer then
                                masklayer:removeFromParent()
                            end
                            zc.createSourcePop("SmithyGodAdvance", "src/layer/smithyHouse/SmithyGodAdvancePop.lua", {
                                callback=function()  
                                    local _currentGID = getGuideManager():getCurrentGID()
                                    if _currentGID == GuideKey.KEY_3010 then
                                        self:addGuide()
                                    end     
                                end,
                                before=attrTab,
                                info=weaponInfo,
                            })
                        end,0.3)
                    end)
                    self._progress:runAction(cc.Sequence:create(_arr))
                    -- 在这里刷新数据才行
                    refreshALL()
                    dump(self._roleWeapons, "进阶后刷新的数据：")
                end,
            })
        elseif btnType == 4 then
            zc.sendHttp({
                apiName = "Weapon_foundry", 
                params = {                            
                    houseId = self._houseInfo["id"], 
                    id = weaponInfo["weaponId"], 
                    type = 1,
                    synthInfo = paTrsSynthInfo
                },
                successCallback = function (net_data)
                    PlayerData:updataData(net_data)
                    --打造成功
                    weaponInfo["ISOPEN"] = true
                    for k,v in pairs(net_data["weapon"][#net_data["weapon"]]) do
                        weaponInfo[k] = v
                    end
                    
                    zc.createSourcePop("SmithyGodAdvance", "src/layer/smithyHouse/SmithyGodMakePop.lua", {
                        before={},
                        info=weaponInfo,
                        callback = function()     
                            weaponInfo["status"] = 0
                            self:setNowWeaponInfo(self._nowWeaponIdx)
                            self:refreshRight(self._nowWeaponIdx, true)
                        end,        
                    })
                    --
                    if self._callback then
                        self._callback()
                    end

                end,
            })
        end     
    end)
    

end
--刷新失败消耗
function SmithyGodWeaponLayer:refreshConsumeOfFaile()
    --刷新消耗
    if self._nowConsume then
        for i = 1, #self._nowConsume do
            local item = self._costItemList[i]
            local _ownNumStr,_color = self:getConsumeAndOwn(self._nowConsume[i])
            local costItemsmNum = item:getChildByName("costItemsmNum")
            costItemsmNum:setString(_ownNumStr)
            costItemsmNum:setColor(_color)
        end
    end
end
--设置进度条
function SmithyGodWeaponLayer:setDotAnimation(weaponInfo)
    local stateInfo = self:getNowStateInfo(weaponInfo["weaponId"])
    local nextStrInfo = stateInfo.nextStrInfo or {}
    local _isQinghua = stateInfo.isQianghua
    local _nowIndx = stateInfo.nowIdx --当前两点的位置 
    local _dotNum = stateInfo.dotNum
    _nowIndx = _nowIndx + 1
    stateInfo.nowIdx = _nowIndx

    --如果到达顶级
    if not nextStrInfo["id"] then
        self._progress:setVisible(false)
        local progressBg = self._progress:getParent()
        for i = 1, #self._lishgt_dot do
            self._lishgt_dot[i]:setVisible(false)
        end
        for i = 1, self._dotNum do
            if progressBg:getChildByName("_gray_dot"..i) then
                progressBg:getChildByName("_gray_dot"..i):setVisible(false)
            end
        end
        self._preAttrBg:setVisible(false)
        return
    end
    local _angel = 360/_dotNum
    local function showNextAttr()
        if not weaponInfo["ISOPEN"] then
            self._preAttrBg:setVisible(false)
            return
        end
        if not _isQinghua then
            self._preAttrBg:setVisible(false)
            return
        end
        if _nowIndx >= self._dotNum then
            self._preAttrBg:setVisible(false)
            return
        end
        --属性显示
        if nextStrInfo then
            self._preAttrBg:setVisible(true)
            local _preAttr = LANGUAGE_getAttributeTextById(nextStrInfo["effectType"])
            local _preAttrNum = zc.getAttributeNumById(nextStrInfo["effectType"],nextStrInfo["effectValue"])
            local _effLab = self._preAttrBg._effLab
            local _effNum = self._preAttrBg._effNum
            local _prePos = cc.p(self._gray_dotList[_nowIndx+1]:getPositionX(),self._gray_dotList[_nowIndx+1]:getPositionY())
            self._preAttrBg:setPosition( _prePos )
            _effLab:setText(_preAttr)
            _effNum:setText("+".._preAttrNum)
            _effLab:setPositionX(101/2-_effNum:getContentSize().width/2)
            _effNum:setPositionX(_effLab:getPositionX()+_effLab:getContentSize().width/2)
        end
    end
    -- self._progress:setPercentage( _angel*(_nowIndx) / 360 * 100 )
    local progress = self._progress
    local _nowPercent = progress:getPercentage()
    local _totalPercent = _angel*(_nowIndx) / 360 * 100
    local _arr = {}
    _arr[#_arr+1] = cc.ProgressTo:create(0.2, _totalPercent)
    _arr[#_arr+1] = cc.CallFunc:create(function()
        local _light_dot = self._lishgt_dot[_nowIndx]
        _light_dot:setVisible(true)
        _light_dot:playAction("start", false)
        _light_dot:registerSpineEventHandler( function ( event )
            _light_dot:playAction("idle",true)
        end, sp.EventType.ANIMATION_COMPLETE)
    end)
    _arr[#_arr+1] = cc.CallFunc:create(function()
        showNextAttr()
    end)
    progress:runAction(cc.Sequence:create(_arr))
    return _nowIndx
end

--重置信息
function SmithyGodWeaponLayer:resetAllInfo(btnType)

    --主角兵器
    local roleWeapons = PlayerData:getRoleWeapons()
    self._roleWeapons = {}
    local nowRoleWeaponId = {[1]=1001,[5]=2001} --1长柄、5扇子
    for i = 1, #roleWeapons do
        local idx = #self._roleWeapons+1
        self._roleWeapons[idx] = roleWeapons[i]
        self._roleWeapons[idx]["ISOPEN"] = true
        nowRoleWeaponId[tonumber(roleWeapons[i]["type"])] = nil
    end
    if table.nums(nowRoleWeaponId) > 0 then --说明还有兵器没有打开
        for k,v in pairs(nowRoleWeaponId) do
            local _id = v
            local static = gameData.getDataFromCacheWithPrimaryKey("weapon", _id)
            local idx = #self._roleWeapons+1
            self._roleWeapons[idx] = static
            self._roleWeapons[idx]["ISOPEN"] = false
            self._roleWeapons[idx]["weaponId"] = static["id"]
            self._roleWeapons[idx]["heroId"] = 0
        end
    end
    table.sort(self._roleWeapons,function(a,b)
        return tonumber(a.heroId) > tonumber(b.heroId)
    end)

    if btnType == 1 then

    elseif  btnType == 2 then

    elseif  btnType == 3 then --进阶
        self._myTable:reloadData()

    elseif  btnType == 4 then

    end

end
--设置消耗状态
function SmithyGodWeaponLayer:refreshConsumeState(_consume)
    self._nowConsume = _consume or {} --记录消耗
    for i = 1, 4 do
        local item = self._costItemList[i]
        if _consume[i] then
            item:setVisible(true)
            --消耗和拥有
            local _consumeNum = tonumber(_consume[i]["num"])
            local _ownNumStr,_color = self:getConsumeAndOwn(_consume[i])
            local _showTip = tonumber(_consume[i]["mainType"]) == zc.mainTypeResource and true or false
            local _listener
            if not _showTip then
                _listener = function ()
                    --信息框  如果能合成，就显示合成界面
                    zc.createItemSynthesisPop({
                        itemType = _consume[i]["mainType"],
                        itemId = _consume[i]["id"],
                        costNum = tonumber(_consumeNum), --需要花费的数量
                        callback = function() 
                            self:refreshConsumeOfFaile()
                        end,
                    })
                end
            end
            local newParmas = {
                data = {
                    mainType = _consume[i]["mainType"],
                    type = _consume[i]["type"], 
                    id = _consume[i]["id"],
                    quality = 1,
                },
                showDetailPop = _showTip,
                listener = _listener,
            }
            zc.updateIconByData(item,newParmas)

            local costItemsmNum = item:getChildByName("costItemsmNum")
            costItemsmNum:setString(_ownNumStr)
            costItemsmNum:setColor(_color)
        else
            item:setVisible(false)
        end
    end
end
--消耗和拥有
function SmithyGodWeaponLayer:getConsumeAndOwn(_consume)
    --消耗和拥有
    local _ownNum = 0
    local _color = display.COLOR_WHITE
    local _ownNumStr = ""
    local _consumeNum = tonumber(_consume["num"])
    local _needNum = 0

    if tonumber(_consume["mainType"]) == zc.mainTypeResource then
        _ownNum = PlayerData:getResourcesInfoById(_consume["type"])
        _ownNumStr = _consume["num"]
    elseif tonumber(_consume["mainType"]) == zc.mainTypeProp then
        local bagInfo = PlayerData:getBagInfoByID(_consume["id"]) or {}
        _ownNum = bagInfo["num"] or 0
        _ownNumStr = _ownNum.."/".._consume["num"]
    end
    if tonumber(_ownNum) < tonumber(_consumeNum) then
        _color = display.COLOR_RED
        _needNum = tonumber(_consumeNum) - tonumber(_ownNum)
        if _needNum <= 0 then
            _needNum = 0
        end
    end
    return _ownNumStr,_color
end
--设置属性状态
function SmithyGodWeaponLayer:refreshAttributeState(weaponInfo)
    -- 武器名
    self._weponName:setString(weaponInfo.name)
    local attributeInfo = {}
    if weaponInfo["ISOPEN"] then
        for i = 1, 6 do
            -- print("weaponInfo[effectInfo..i] ",weaponInfo["effectInfo"..i],weaponInfo["effectInfo"..i]["effectId"])
            if weaponInfo["effectInfo"..i] and weaponInfo["effectInfo"..i]["effectId"] then
                local idx = #attributeInfo + 1
                attributeInfo[idx] = {}
                attributeInfo[idx].effectId = weaponInfo["effectInfo"..i]["effectId"]
                attributeInfo[idx].effectValue = weaponInfo["effectValue"..i]
            end
        end
    else

        local attrInfo = gameData.getDataFromCache("weapon_effect", {weaponId=weaponInfo["weaponId"]} )
        if attrInfo and attrInfo["effectId"] then
            attrInfo = {attrInfo}
        end
        for i = 1, table.nums(attrInfo) do
            attributeInfo[i] = {}
            attributeInfo[i].effectId = attrInfo[i]["effectId"]
            attributeInfo[i].effectValue = attrInfo[i]["valueMin"] --基础值下限
        end
    end
    for i = 1, 6 do
        local effectBg = self._effectBgList[i]
        local v = attributeInfo[i]
        if v and v["effectId"] then
            effectBg:setVisible(true)
            local effect = effectBg._effect
            local effectValue = effectBg._effectValue
            local effectStr = LANGUAGE_getAttributeTextById(v["effectId"])
            local effectNum = zc.getAttributeNumById( v["effectId"], v["effectValue"])

            effect:setString(effectStr..":")
            effectValue:setString("+"..effectNum)
        else
            effectBg:setVisible(false)
        end
    end
end
--设置成功率
function SmithyGodWeaponLayer:refreshSuccessState(stateInfo, weaponInfo)
    --1强化 2升级 3进价 4打造
    local btnType = stateInfo.btnType
    local nextStrInfo = stateInfo.nextStrInfo

    local curSucessTitleStr = ""
    local _curSuccess = 0
    local _successGold = 0
    if btnType == 1 then
        self._bottomInfobg:setVisible(true)
        self._bottomHeadInfobg:setVisible(true)
        self._advanceLab:setVisible(false) 
        curSucessTitleStr = zc.lang("cur_strength_success_rate") .. "："
        if nextStrInfo and nextStrInfo["success"] then
            _curSuccess = tonumber(nextStrInfo["success"]) * 100
            _successGold = nextStrInfo["successGold"]
        end
    elseif  btnType == 2 then
        self._bottomInfobg:setVisible(true)
        self._bottomHeadInfobg:setVisible(true)
        self._advanceLab:setVisible(false)
        curSucessTitleStr = zc.lang("cur_level_up_success_rate") .. "："
        local curLevel = tonumber(weaponInfo["strengthenLevel"])
        local _strdata = gameData.getDataFromCacheWithPrimaryKey("weapon_strengthen", curLevel+1)
        _curSuccess = tonumber(_strdata["rate"]) * 100
        _successGold = _strdata["must"]
    elseif  btnType == 3 then
        self._bottomInfobg:setVisible(true)
        self._bottomHeadInfobg:setVisible(false)
        self._advanceLab:setVisible(true)
    elseif  btnType == 4 then
        self._bottomInfobg:setVisible(true)
        self._bottomHeadInfobg:setVisible(false)
        self._advanceLab:setVisible(false)
    end
    self._curSucessLab:setString(curSucessTitleStr)
    self._curSucessNumLab:setString(_curSuccess.."%")
    self._goldNum:setString(_successGold)

    self._selectGold = false
    self._checkBox._selectedImg:setVisible(self._selectGold and true or false)
end
--设置左边进阶按钮
function SmithyGodWeaponLayer:refreshLeftBtnState(weaponInfo)
    --左边预览按钮
    local advancedLevel = self._leftBg._advancedLevel 
    local strengLevel = self._leftBg._strengLevel
    --进阶等级改变
    if weaponInfo["advancedNum"] and tonumber(weaponInfo["advancedNum"]) > 0 then
        if tonumber(weaponInfo["advancedNum"]) > 10 then
            weaponInfo["advancedNum"] = 10
        end
        local advancePath = "res/Main/research/bingfa/advance_"..weaponInfo["advancedNum"]..".png"
        advancedLevel:setTexture(advancePath)
        advancedLevel:setVisible(true)
    else
        advancedLevel:setVisible(false)
    end
    strengLevel:setString(weaponInfo["strengthenLevel"] or 0)
    strengLevel.strengLevelJi:setPositionX(strengLevel:getContentSize().width)

    if advancedLevel:isVisible() then
        advancedLevel:setPositionX(self._levelBgSize.width/2-10-27/2-strengLevel:getContentSize().width/2)
        strengLevel:setPositionX(20+advancedLevel:getPositionX()+advancedLevel:getContentSize().width/2)
    else
        strengLevel:setPositionX(self._levelBgSize.width/2-27/2-3)
    end
end
--设置技能状态
function SmithyGodWeaponLayer:refresSkillState(weaponInfo)
    local skillInfo = self:getSkllInfo(weaponInfo)
    local skillPos = zc.sortFromMiddle( self._skillMiddlePos, #skillInfo, self._skillDistance )
    for i = 1, #self._skillItemList do
        local skillItem = self._skillItemList[i]
        if i <= #skillInfo then
            skillItem:setVisible(true)
            local newParmas = {
                data = {
                    mainType = zc.mainTypeSkill,
                    type = 1, 
                    id = skillInfo[i].skillid,
                }, 
                pos = skillPos[i], 
                listener = function ()
                    zc.createSkillInfoPop({id = skillInfo[i].skillid, level=skillInfo[i].skillLevel})
                end
            }
            zc.updateIconByData(skillItem,newParmas)

            if skillInfo[i].isBisha then
                skillItem.bisha:setVisible(true)
            else
                skillItem.bisha:setVisible(false)
            end
        else
            skillItem:setVisible(false)
        end
    end
end
function SmithyGodWeaponLayer:getSkllInfo(weaponInfo)
    local skillInfo = {}
    if weaponInfo["ISOPEN"] then
        for i = 1, 3 do
            if weaponInfo["commonSkillId"..i] and tonumber(weaponInfo["commonSkillId"..i]) > 0 then
                local static = gameData.getDataFromCacheWithPrimaryKey("skill", weaponInfo["commonSkillId"..i] )
                if static["subType"] and tonumber(static["subType"]) ~= 1 then
                    local idx = #skillInfo + 1
                    skillInfo[idx] = {}
                    skillInfo[idx].skillid = tonumber(weaponInfo["commonSkillId"..i])
                    skillInfo[idx].skillname = static["name"] or ""
                    skillInfo[idx].skillLevel = tonumber(weaponInfo["commonSkillLevel"..i])
                    skillInfo[idx].isBisha = false
                end
            end
        end
        if tonumber(weaponInfo["moraleSkillId"]) ~= 0 then 
            local _data = gameData.getDataFromCacheWithPrimaryKey("skill", weaponInfo["moraleSkillId"])
            if next(_data) ~= nil then
                local idx = #skillInfo + 1
                skillInfo[idx] = {}
                skillInfo[idx].skillid = tonumber(weaponInfo["moraleSkillId"])
                skillInfo[idx].skillname = _data["name"] or ""
                skillInfo[idx].skillLevel = tonumber(weaponInfo["moraleSkillLevel"])
                skillInfo[idx].isBisha = true
            end
        end
    else
        if not weaponInfo["skillInfo"] then
            skillInfo[1] = {}
            local static = gameData.getDataFromCache("weapon_skill", {weaponId=weaponInfo["weaponId"]} )
            if static then 
                skillInfo[1].skillid = static["skillId"]
                local skilldata = gameData.getDataFromCacheWithPrimaryKey("skill", static["skillId"])
                -- dump(skilldata, "skilldata = ")
                skillInfo[1].skillname = skilldata["name"] or ""
                skillInfo[1].skillLevel = 0
                skillInfo[1].isBisha = false

            end
            if tonumber(weaponInfo["moraleSkillId"]) ~= 0 then 
                local _data = gameData.getDataFromCacheWithPrimaryKey("skill", weaponInfo["moraleSkillId"])
                if next(_data) ~= nil then
                    local idx = #skillInfo + 1
                    skillInfo[idx] = {}
                    skillInfo[idx].skillid = tonumber(weaponInfo["moraleSkillId"])
                    skillInfo[idx].skillname = _data["name"] or ""
                    skillInfo[idx].skillLevel = 0
                    skillInfo[idx].isBisha = true
                end
            end
            weaponInfo["skillInfo"] = skillInfo
        else
            skillInfo = weaponInfo["skillInfo"]
        end
    end
    return skillInfo
end
--属性显示动画
function SmithyGodWeaponLayer:showAttrAction(_befoInfo, _newInfo)
    if not _befoInfo or not _newInfo then
        return
    end
    local beforeEffect = {}
    for i = 1, 6 do
        if _befoInfo["effectInfo"..i] and _befoInfo["effectInfo"..i]["effectId"] then
            beforeEffect[tonumber(_befoInfo["effectInfo"..i]["effectId"])] =tonumber(_befoInfo["effectValue"..i])
        end
    end
    local _attr = {}
    for i = 1, 6 do
        if _newInfo["effectInfo"..i] and _newInfo["effectInfo"..i]["effectId"] then
            local effid = tonumber(_newInfo["effectInfo"..i]["effectId"])
            local beforeNum = beforeEffect[effid] or 0 
            local effAdd = tonumber(_newInfo["effectValue"..i]) - beforeNum
            if tonumber(effAdd) > 0 then
                local effText = LANGUAGE_getAttributeTextById(effid)    
                local effNum  = zc.getAttributeNumById(effid, effAdd)
                _attr[#_attr + 1] = effText.." +"..effNum 
            end
        end
    end
    if not _attr then
        _attr = {
            [1] = zc.lang("physics_attack") .. " +100",
            [2] = zc.lang("physics_defense") .. " +100",
            [3] = zc.lang("hp_1") .. " +100",
            [4] = zc.lang("attack") .. " 100%",
        }
    end
    for i = 1, #_attr do
        local myLab = zc.createLabel({
            text = _attr[i],
            outLine = true,
            fontSize = 30,
            pos = cc.p(self._leftBg:getContentSize().width/2, self._leftBg:getContentSize().height/2+40),
            color = display.COLOR_GREEN,
            pixel = 1.3
        })
        self._leftBg:addChild(myLab, 100)

        myLab:setScale(0.01)
        local _seq = nil
         _seq = cc.Sequence:create(
            cc.DelayTime:create((i-1)*0.4),
            cc.Spawn:create(
                cc.ScaleTo:create(0.3, 1.2),
                cc.MoveBy:create(0.3, cc.p(0, 15))
            ),
            cc.Spawn:create(
                cc.MoveBy:create(0.4, cc.p(0, 20)),
                cc.ScaleTo:create(0.2, 1.0)   
            ),
            cc.Spawn:create(
                cc.MoveBy:create(0.5, cc.p(0, 50)),
                cc.FadeOut:create(0.4)
            ),
            cc.RemoveSelf:create(true)
        )
        myLab:runAction(_seq)
    end
end
--设置信息
function SmithyGodWeaponLayer:setNowWeaponInfo(nowIdx, _force)
    self._nowSetWeaponInfoIdx = nowIdx
    local weaponInfo = self._roleWeapons[nowIdx] or {}
    -- dump(weaponInfo, "setNowWeaponInfo----")
    local weaponId = tonumber(weaponInfo["weaponId"])
    --状态信息
    local stateInfo = {
        btnType = 1,
        comsume = {},
        nowStrId = 0,
        nowStrInfo = {},
        nowStrGroup = {},
        nextStrId = 0,
        nextStrInfo = {},
        nextStrGroup = {},
        nowIdx = 0,
        dotNum = 0,
        btnText = "",
        isQianghua = false,
    }
    --信息改变-->初始、打造、升级、进阶、切换(来回切换不变)
    --当前已经强化到的位置
    local _nowStrId = 0
    local _nowStrInfo = {}
    local _nowStrGroup = {}
    --接下来要强化的位置
    local _nextStrId = 1
    local _nextStrInfo = 0
    local _nextStrGroup = {}

    if weaponInfo and weaponInfo["ISOPEN"] then --如果是已经开启的神兵
        _nowStrId = tonumber(weaponInfo["beforeStrengthen"]) or 0
        _nowStrInfo = gameData.getDataFromCacheWithPrimaryKey("weapon_beforestrengthen", _nowStrId )
        _nowStrGroup = gameData.getDataFromCache("weapon_beforestrengthen", {group=_nowStrInfo["group"] or 1} )
        _nextStrId = _nowStrId + 1
        _nextStrInfo = gameData.getDataFromCacheWithPrimaryKey("weapon_beforestrengthen", _nextStrId )
        _nextStrGroup = gameData.getDataFromCache("weapon_beforestrengthen", {group=_nextStrInfo["group"]} )
    else
        _nextStrInfo = gameData.getDataFromCacheWithPrimaryKey("weapon_beforestrengthen", 1 )
        _nextStrGroup = gameData.getDataFromCache("weapon_beforestrengthen", {group=1} )

    end

    -- 当前的信息
    -- 接下来的信息
    local _nowDotIdx = 0 --当前两点的位置 
    local _isQianghua = false
    local btnType = 1 --1强化 2升级 3进阶 4打造 5达到满级
    local touchConsume = {} --消耗
    local btnText = ""
    if not weaponInfo["ISOPEN"] then
        print("not open")
        btnText = zc.lang("daozao")
        btnType = 4
        local weaponCost = gameData.getDataFromCacheWithPrimaryKey( "weapon_foundry", weaponInfo["weaponId"] )
        if weaponCost and weaponCost.id then
            for i =5,1,-1 do
                local itemId = weaponCost["itemId"..i]
                local itemNum =  weaponCost["itemNum"..i]
                if i < 5 then
                    itemId = weaponCost["itemId"..i]
                    itemNum =  weaponCost["itemNum"..i]
                else
                    itemId = weaponCost["itemId"]
                    itemNum =  weaponCost["itemNum"]
                end
                if itemId and tonumber(itemId) > 0 then
                    local idx = #touchConsume + 1
                    touchConsume[idx] = {}
                    touchConsume[idx].mainType = 4 
                    touchConsume[idx].type = itemId
                    touchConsume[idx].id = itemId 
                    touchConsume[idx].num = itemNum
                end
            end
            for i = 1, 2 do
                local itemType = tonumber(weaponCost["resourceType"..i])
                if itemType > 0 then
                    local idx = #touchConsume + 1
                    touchConsume[idx] = {}
                    touchConsume[idx].mainType = 1 
                    touchConsume[idx].type = itemType
                    touchConsume[idx].id = itemType 
                    touchConsume[idx].num = weaponCost["resourceNum"..i]
                end
            end
        end        
    else
        local jinjieTable = gameData.getDataFromCacheWithPrimaryKey("weapon_advanced", weaponInfo["weaponId"]) or {}
        if not jinjieTable["needStrengthen"] then
            jinjieTable["needStrengthen"] = 1000000
        end
        print("needStrengthen 进阶：".. jinjieTable["needStrengthen"].."表中的needStrengthen："..jinjieTable["needStrengthen"])
        if tonumber(weaponInfo["strengthenLevel"]) < tonumber(jinjieTable["needStrengthen"]) then
            --如果升级等级小于进价需要的等级就去强化或者升级
            if not _nextStrInfo["id"] then
                btnType = 5
            else
                if tonumber(weaponInfo["beforeStrengthen"]) == tonumber(_nowStrGroup[table.nums(_nowStrGroup)]["id"]) and
                    tonumber(weaponInfo["beforeStrengthenGroup"]) ~= 0 then
                    print("-----------log--------ad------------- is level up ......... " )
                    --已经强化够了，就需要升级了
                    btnText = zc.lang("upgrade_2")
                    btnType = 2
                    local curLevel = tonumber(weaponInfo["strengthenLevel"])
                    local _strdata = gameData.getDataFromCacheWithPrimaryKey("weapon_strengthen", curLevel+1)
                    local _levelUPConsume = _strdata["item"..(tonumber(weaponInfo["advancedNum"])+1)]
                    if _levelUPConsume and _levelUPConsume ~= 0 then
                        local _levelUPConsumeTable = string.split(_levelUPConsume, ",")
                        for i = 1, #_levelUPConsumeTable do
                            local _v = _levelUPConsumeTable[i]
                            local _conTa = string.split(_v, "|")
                            if _conTa and _conTa[2] then
                                local idx = #touchConsume + 1
                                touchConsume[idx] = {}
                                touchConsume[idx].mainType = _conTa[1] 
                                touchConsume[idx].type = _conTa[2] 
                                touchConsume[idx].id = _conTa[2]
                                touchConsume[idx].num = _conTa[3]
                            end
                        end
                    end

                    _nowDotIdx = table.nums(_nowStrGroup)
                else
                    --强 化
                    btnText = zc.lang("strength_2")
                    btnType = 1
                    local _consumeRes = {[1]={name="constMoney",type=2},[2]={name="constOre",type=10}}
                    for i = 1, #_consumeRes do
                        local _curRes = _consumeRes[i]["name"]
                        if _nextStrInfo[_curRes] and tonumber(_nextStrInfo[_curRes]) and tonumber(_nextStrInfo[_curRes]) > 0 then
                            local idx = #touchConsume + 1
                            touchConsume[idx] = {}
                            touchConsume[idx].mainType = 1 
                            touchConsume[idx].type = _consumeRes[i]["type"]
                            touchConsume[idx].id = 1 
                            touchConsume[idx].num = _nextStrInfo[_curRes]
                        end 
                    end
                    -- print("_nowStrId:".._nowStrId)
                    -- dump(_nextStrGroup, "setNowWeaponInfo===")
                    _nowDotIdx = tonumber(_nowStrId)+1-tonumber(_nextStrGroup[1]["id"])
                    _isQianghua = true

                end
            end
        else
            --需要进价
            btnText = zc.lang("advanced_2")
            btnType = 3
            for i = 1, 7 do
                if jinjieTable["stuff"..i] and jinjieTable["stuff"..i] ~= 0 and jinjieTable["stuff"..i] ~= "" then
                    local _conTa = string.split(jinjieTable["stuff"..i], "|")
                    if _conTa and _conTa[2] then
                        local idx = #touchConsume + 1
                        touchConsume[idx] = {}
                        touchConsume[idx].mainType = _conTa[1] 
                        touchConsume[idx].type = _conTa[2] 
                        touchConsume[idx].id = _conTa[2] 
                        touchConsume[idx].num = _conTa[3] 
                    end
                end
            end
        end
    end

    stateInfo.btnType       = btnType
    stateInfo.comsume       = touchConsume
    stateInfo.nowIdx        = _nowDotIdx
    stateInfo.btnText       = btnText
    stateInfo.dotNum        = table.nums(_nextStrGroup)
    stateInfo.isQianghua    = _isQianghua
    stateInfo.nowStrId = _nowStrId
    stateInfo.nowStrInfo = _nowStrInfo
    stateInfo.nowStrGroup = {}
    stateInfo.nextStrId = _nextStrId
    stateInfo.nextStrInfo = _nextStrInfo
    stateInfo.nextStrGroup = _nextStrGroup
    self._weaponStateInfo[weaponId] = stateInfo
end
--获取当前状态信息
function SmithyGodWeaponLayer:getNowStateInfo(_weaponId)
    local _weaponId = tonumber(_weaponId)
    if not self._weaponStateInfo then
        self._weaponStateInfo = {}
    end
    local stateInfo = self._weaponStateInfo[_weaponId]
    if not stateInfo or not stateInfo.dotNum then
        self._weaponStateInfo[_weaponId] = nil
    end
    if not self._weaponStateInfo[_weaponId] then
        --切换武器 设置信息
        local idx = 1
        for i = 1, table.nums(self._roleWeapons) do
            local v = self._roleWeapons[i]
            if tonumber(_weaponId) == tonumber(v["weaponId"]) then
                idx = i
                break
            end
        end
        self:setNowWeaponInfo(idx)
    end
    stateInfo = self._weaponStateInfo[_weaponId]
    return stateInfo
end
--检查是否正在打造中
function SmithyGodWeaponLayer:checkIsMaking(weaponInfo)
    local rightBg = self._attr_bg
    local rightSize = rightBg:getContentSize()
    ---正在打造背景
    local making_bg = zc.createImageView({
        src = "res/Main/smithy/smithy_making_bg.png",
        ap  = cc.p(0.5,0.5),
        pos = cc.p(rightSize.width/2, 155)
    })
    rightBg:addChild(making_bg)

    --正在打造的兵器
    local curMake =  zc.createLabel({
        text = zc.lang("daozao_ing") .. ":",
        fontSize = 22,
        ap = cc.p(0, 0.5),
        pos = cc.p(80, 55),
        shadow = true,
        color = display.COLOR_BTNFONTYELLOW
    })
    making_bg:addChild(curMake)
    --打造的兵器名字
    local curMakeLabel =  zc.createLabel({
        text = weaponInfo["name"],
        fontSize = 22,
        ap = cc.p(0, 0.5),
        pos = cc.p(curMake:getPositionX()+curMake:getContentSize().width, 55),
        shadow = true,
        color = zc.getColorByQuality(weaponInfo["color"])
    })
    making_bg:addChild(curMakeLabel)
    --打造进度条
    local makeProBg = zc.createImageView({
        src = "res/Main/home/avator_expbarbg.png",
        pos = cc.p(125, 20),
    })
    making_bg:addChild(makeProBg)
    local makePro = cc.ProgressTimer:create(zc.createSprite("res/Main/home/avator_expbar.png"))
    makePro:setType(cc.PROGRESS_TIMER_TYPE_BAR)
    makePro:setMidpoint(cc.p(0, 0))
    makePro:setBarChangeRate(cc.p(1, 0))
    makePro:setPosition(cc.p(makeProBg:getContentSize().width/2, makeProBg:getContentSize().height/2))
    makeProBg:addChild(makePro)
    makePro:setPercentage(0)
    --锤子
    local armature = zc.createAnimationArmature({
        fileName = "tiejianpu_dazao",
        autoRelease = true
    })
    armature:getAnimation():play("idle")
    armature:setPosition(cc.p(10, 7))
    makePro:addChild(armature)
    --打造倒计时
    local djsLabel =  zc.createLabel({
        fontSize = 22,
        pos = cc.p(makePro:getContentSize().width/2, makePro:getContentSize().height/2),
        shadow = true,
        color = display.COLOR_WHITE
    })
    makePro:addChild(djsLabel)

    local _data = gameData.getDataFromCacheWithPrimaryKey("weapon_foundry", weaponInfo.weaponId)
    local _allTime = 0
    if next(_data) ~= nil then
        _allTime = _data.time
    end
    local timeDiff = tonumber(weaponInfo["createTime"]) - PlayerData:getTime()
    local needTime = timeDiff
    local jindu = needTime / tonumber(_allTime) * 100
    makePro:setPercentage(jindu)
    djsLabel:setText(zc.getTimeHMS(needTime))

    -- needTime = 30

    schedule(making_bg,function()
        needTime = needTime - 1
        djsLabel:setText(zc.getTimeHMS(needTime))
        if needTime <= 0 then
            --打造成功了
            if zc.getPop("makeGodWeapon") == nil then 
                zc.createPop("makeGodWeapon", {info = weaponInfo})--兵器
            end
            making_bg:removeFromParent()
        end
    end, 1)

    local _sjxs = 10000
    local _pData = gameData.getDataFromCache("consume_price", {type = 22, subtype = self._houseInfo.level})
    if next(_pData) ~= nil then
        if _pData.price then
            _sjxs = _pData.price
        else
            _sjxs = _pData[#_pData].price
        end
    end
    
    --立即完成   铁匠铺立即购买花费=打造兵器的时间（分钟）*3*衰减系数/10000  self._consumepriceDB
    local quickBtn = zc.createCommomBtn({
        tag =1,
        btnText = zc.lang("immediately_complete"),
        needSwallow = false,
        endCallback = function()
            zc.sendHttp({
                apiName = "Weapon_foundryFinish",
                params = {id = weaponInfo.id},
                successCallback = function (data)
                    PlayerData:updataData(data)
                    PlayerData:updateWeaponsInfoById({id = weaponInfo.id, createTime = PlayerData:getTime()})
                    --打造成功 弹出框
                    if making_bg then
                        making_bg:removeFromParent()
                    end
                    if zc.getPop("makeGodWeapon") == nil then 
                        zc.createPop("makeGodWeapon", {info = weaponInfo})--兵器
                    end
                    --刷新父界面
                    if self._callback then
                        self._callback()
                    end
                    --刷新数据
                    self:resetAllInfo()
                end,
            })
        end,
        pos = cc.p(making_bg:getContentSize().width/2 , -65)
    })
    self._quickBtn = quickBtn
    making_bg:addChild(quickBtn, 11)

    local getimg1 = zc.createImageView({
        src = zc.getImgByType(1),
        pos = cc.p(quickBtn:getPositionX(), quickBtn:getPositionY()+quickBtn:getContentSize().height  -10 ),
    }) 
    making_bg:addChild(getimg1)
    local minute = math.ceil(needTime/60) --上取整
    local getnum1 = zc.createLabel({
        text = math.ceil(minute*3*_sjxs/10000),
        fontSize = 22,
        ap = cc.p(0, 0.5),
        pos = cc.p(getimg1:getPositionX()+getimg1:getContentSize().width/2, getimg1:getPositionY() ),
        shadow = true,
        color = display.COLOR_WHITE,
    })
    making_bg:addChild(getnum1)
    getimg1:setPositionX(quickBtn:getPositionX()-getnum1:getContentSize().width/2)
    getnum1:setPositionX(getimg1:getPositionX()+getimg1:getContentSize().width/2)
            

end
function SmithyGodWeaponLayer:addGuide()
    local _currentGID = getGuideManager():getCurrentGID()
    print("SmithyGodWeaponLayer:addGuide _currentGID:".._currentGID)
    if _currentGID == GuideKey.KEY_3009 then
        if self._guideBtn.btnText ~= zc.lang("advanced_2") then
            getGuideManager():setCurrentGID(GuideKey.KEY_3010)
            self:addGuide()
            return
        end
        getGuideManager():setObjTarget(self._guideBtn)
        getGuideManager():startGuide()
    elseif inArray(_currentGID, GuideGroup.BTN_BACK_MAINCITY) then
        getGuideManager():setObjTarget(self._closeBtn)
        getGuideManager():startGuide()
    elseif _currentGID == GuideKey.KEY_15104 then
        zc.setGuideFuncNextStep(_currentGID, true)
        print("15105")
        -- getGuideManager():setCurrentGID(GuideKey.KEY_15105)
        local function _callback()
            print("轮到15106")
            _currentGID = getGuideManager():getCurrentGID()
            print("curId :" .. _currentGID)
            -- zc.setGuideFuncNextStep(_currentGID, true)
            getGuideManager():setObjTarget(self._unLockShenbing)
            getGuideManager():startGuide()
        end
        getGuideManager():setHeroFuncCallBack(_callback)
        getGuideManager():startGuide()
    elseif _currentGID == GuideKey.KEY_15109 then
        -- zc.setGuideFuncNextStep(_currentGID, true)
        local function _callback()
            _currentGID = getGuideManager():getCurrentGID()
            zc.setGuideFuncNextStep(_currentGID, true)
            _currentGID = getGuideManager():getCurrentGID()
            getGuideManager():setCurrentGID(_currentGID, true)
            local _guideHand = zc.createSpine({
                                fileName = "shou",
                                actName = "shou",
                            })
            _guideHand:setPosition(self._changge_shenbing_btn:getPosition())
            _guideHand:setName("guidHand")
            self._changge_shenbing_node:addChild(_guideHand, 111)
        end
        getGuideManager():setHeroFuncCallBack(_callback)
        getGuideManager():startGuide()
    end
end

return SmithyGodWeaponLayer