--[[
    FileName: SmithyPracticeLayer.lua
    Author: andong
    Date: 2016-03-23
    Purpose: xx界面
]]
local SmithyPracticeLayer = class( "SmithyPracticeLayer", function ()
    return zc.createNormalDialog({
        src = "res/Main/smithy/practice/bg.jpg"
    })
end)
function SmithyPracticeLayer:create(parmas)
    return SmithyPracticeLayer.new(parmas)
end
function SmithyPracticeLayer:ctor(parmas)
    self:initData(parmas)
    self:initUI()
end

function SmithyPracticeLayer:initData(parmas)
    if parmas and parmas.callback then
        self._callback = parmas.callback
    end
    local houseInfo = PlayerData:getHouseInfoByHouseId(11)
    self._houseInfo = houseInfo
    self._perAddExp = 10 --每使用一次增加的exp
    self._perItemUsetNum = 1 --每次道具使用的数量
    local skillInfo = PlayerData:getBaseInfoByTag("skilful") or {}
    self._nowSkillInfo = {
        ["exp1"] = 0,
        ["exp2"] = 0,
        ["exp3"] = 0,
        ["exp4"] = 0,
        ["exp5"] = 0,
        ["exp6"] = 0,
        ["lv1"]  = 0,
        ["lv2"]  = 0,
        ["lv3"]  = 0,
        ["lv4"]  = 0,
        ["lv5"]  = 0,
        ["lv6"]  = 0,
    }
    if next(skillInfo) then
        for k,v in pairs(self._nowSkillInfo) do
            self._nowSkillInfo[k] = skillInfo[k]
        end
    end
end
function SmithyPracticeLayer:initUI()

    --左背景
    local left_bg = cc.Node:create()
    left_bg:setContentSize(585, zc.height)
    left_bg:setAnchorPoint(1, 0.5)
    left_bg:setPosition(zc.width*0.5, zc.height*0.5)
    self:addChild(left_bg)
    self._left_bg = left_bg
    --右背景
    local right_bg = zc.createNormalPop({
        width = 600,
    })
    right_bg:setPosition(zc.width*0.5 - 70, zc.height*0.5 - 20)
    right_bg:setAnchorPoint(0, 0.5)
    self:addChild(right_bg)
    self._right_bg = right_bg

    --
    self:initInfo() --初始代信息数据
    self:createPracticeList() --创建练习列表
end

function SmithyPracticeLayer:createPracticeList()

    local infoList = {
        [1] = {
            id = 1,
            bg = "res/Main/smithy/practice/base_attack_bg.png",
            img = "res/Main/smithy/practice/base_attack.png",
            nameBg = "res/Main/smithy/practice/base_name_bg.png",
            name = zc.lang("base_attack"),
            level = 0,
            color = cc.c3b(240,28,34),
        },
        [2] = {
            id = 4,
            bg = "res/Main/smithy/practice/addition_attack_bg.png",
            img = "res/Main/smithy/practice/addition_attack.png",
            nameBg = "res/Main/smithy/practice/addition_name_bg.png",
            name = zc.lang("append_attack"),
            level = 0,
            color = cc.c3b(222,48,222),
        },
        [3] = {
            id = 2,
            bg = "res/Main/smithy/practice/base_defend_bg.png",
            img = "res/Main/smithy/practice/base_defend.png",
            nameBg = "res/Main/smithy/practice/base_name_bg.png",
            name = zc.lang("base_defence"),
            level = 0,
            color = cc.c3b(64,176,235),
        },
        [4] = {
            id = 5,
            bg = "res/Main/smithy/practice/addition_defend_bg.png",
            img = "res/Main/smithy/practice/addition_defend.png",
            nameBg = "res/Main/smithy/practice/addition_name_bg.png",
            name = zc.lang("append_defence"),
            level = 0,
            color = cc.c3b(45,223,255),
        },
        [5] = {
            id = 3,
            bg = "res/Main/smithy/practice/base_life_bg.png",
            img = "res/Main/smithy/practice/base_life.png",
            nameBg = "res/Main/smithy/practice/base_name_bg.png",
            name = zc.lang("base_hp"),
            level = 0,
            color = cc.c3b(223,189,51),
        },
        [6] = {
            id = 6,
            bg = "res/Main/smithy/practice/addition_life_bg.png",
            img = "res/Main/smithy/practice/addition_life.png",
            nameBg = "res/Main/smithy/practice/addition_name_bg.png",
            name = zc.lang("append_hp"),
            level = 0,
            color = cc.c3b(69,233,48),
        },
    }
    self._infoList = infoList
    local left_bg = self._left_bg

    local lightBg1 = zc.createSprite("res/Main/smithy/practice/lightBg.png")
    lightBg1:setPosition(cc.p(183, left_bg:getContentSize().height/2))
    left_bg:addChild(lightBg1)

    local lightBg2 = zc.createSprite("res/Main/smithy/practice/lightBg.png")
    lightBg2:setPosition(cc.p(183+185, left_bg:getContentSize().height/2))
    left_bg:addChild(lightBg2)

    self._leftSkillLevel = {}
    local _nums = table.nums(infoList)
    for i = 1, _nums do
        local modI = i <= 2 and (i-1) or ((i-1)%2)
        local posX = 183+(modI)*185
        -- local posY = 470-170*( math.floor((i-1)/2) )
        local posY = left_bg:getContentSize().height/2+155 -170*( math.floor((i-1)/2) )
        local info = infoList[i]

        local skillBg = zc.createSprite(info["bg"])
        skillBg:setPosition(posX, posY)
        left_bg:addChild(skillBg)

        local skill
        skill = zc.createPushButton({
            normalNode = zc.createSprite(info["img"]),
            needSwallow = false,
            touchScale = 0.9,
            endCallback = function()
                if self._nowEffectId == info["id"] then
                    return
                end
                self._nowEffectId = info["id"]
                if self._effect then
                    self._effect:removeFromParent()
                end
                self._effect = nil
                local effect = zc.getItemClickEffect(2)
                effect:setPosition( cc.p(skill:getContentSize().width/2, skill:getContentSize().height/2) )
                skill:addChild(effect)
                effect:setScale(88/126)
                self._effect = effect
                self._nowInfo = info
                self:refreshInfoList()

            end,
            pos = cc.p(posX, posY)
        })
        left_bg:addChild(skill)

        local level = zc.createLabel({
            text = zc.getLevelTipShow()..self._nowSkillInfo["lv"..info["id"]],
            outLine = true,
            fontSize = 18,
            ap = cc.p(0, 0),
            pos = cc.p(2, 2),
        })
        skill:addChild(level)
        self._leftSkillLevel[#self._leftSkillLevel+1] = level

        local nameBg = zc.createSprite(info["nameBg"])
        nameBg:setAnchorPoint(0.5, 0.5)
        nameBg:setPosition(skillBg:getContentSize().width/2, 20)
        skillBg:addChild(nameBg)
        if math.floor((i-1)/3) == 0 then
            nameBg:setPositionY(23)
        end

        local name = zc.createLabel({
            text = info["name"],
            outLine = true,
            fontSize = 20,
            pos = cc.p(nameBg:getContentSize().width/2, nameBg:getContentSize().height/2),
            color = info["color"],
        })
        nameBg:addChild(name)

        if i == 1 then
            local effect = zc.getItemClickEffect(2)
            effect:setPosition( cc.p(skill:getContentSize().width/2, skill:getContentSize().height/2) )
            skill:addChild(effect)
            effect:setScale(88/126)

            self._effect = effect
            self._nowEffectId = info["id"]
            self._nowInfo = info
            self:refreshInfoList()
        end
    end

end
function SmithyPracticeLayer:initInfo()
    self._refreshList = {}
    local right_bg = self._right_bg
    local right_size = right_bg:getContentSize()

    local _topBg = zc.getSprite({
        src = "res/Main/role/common/top_bg.jpg",
        ap = cc.p(0.5, 1),
        pos = cc.p(right_size.width*0.5, right_size.height)
    })
    local _scaleX = right_size.width/_topBg:getContentSize().width
    _topBg:setScaleX(_scaleX)
    right_bg:addChild(_topBg)
    local _nameDi = zc.getScaleNode("res/Main/role/common/name_bg.png", cc.size(right_size.width*0.7, 30))
    _nameDi:setPosition(_topBg:getPositionX(), _topBg:getPositionY() - _topBg:getContentSize().height*0.5)
    right_bg:addChild(_nameDi)

    local titleName = zc.createLabel({
        text = zc.lang("base_hp"),
        outLine = true,
        fontSize = 22,
        ap = cc.p(0.5, 0.5),
        pos = cc.p(_nameDi:getContentSize().width*0.5 - 20, _nameDi:getContentSize().height*0.5),
    })
    _nameDi:addChild(titleName)

    local levelLimit = zc.createLabel({
        text = zc.lang("level_limit"),
        outLine = true,
        fontSize = 18,
        ap = cc.p(1, 0.5),
        pos = cc.p(_nameDi:getContentSize().width - 65, titleName:getPositionY()),
        color = cc.c3b(222,176,93),
    })
    _nameDi:addChild(levelLimit)


    --能够升级的最大等级（不超过铁匠铺等级*3、不超过主角等级）
    self._nowMaxUpLevel = tonumber(self._houseInfo["level"]) * 3
    local maxLevelNum2 = PlayerData:getUserLevel()
    if maxLevelNum2 < self._nowMaxUpLevel then
        self._nowMaxUpLevel = maxLevelNum2
    end
    local maxLevel = zc.createLabel({
        text = zc.getLevelTipShow()..self._nowMaxUpLevel,
        outLine = true,
        fontSize = 18,
        ap = cc.p(0, 0.5),
        pos = cc.p(levelLimit:getPositionX() + 5, levelLimit:getPositionY()),
        color = display.COLOR_RED,
    })
    _nameDi:addChild(maxLevel)
    self._tipmaxLevel = maxLevel
    
    local exclamationBtn = zc.createPushButton({
        normalFile = "res/Main/common/button/exclamation_u.png",
        selectedFile = "res/Main/common/button/exclamation_d.png",
        needSwallow = true,
        touchScale = 0.9,
        endCallback = function()
            zc.createRulePop(6,{str1=PlayerData:getUserLevel(),str2=tonumber(self._houseInfo["level"])*3,str3=self._nowMaxUpLevel})
        end,
        anchor = cc.p(0.5, 0.5),
        pos = cc.p(right_size.width - 35, _nameDi:getPositionY())
    })
    right_bg:addChild(exclamationBtn)

    --
    local _width = 575
    local _height = 200
    local des_bg = zc.getSprite({
        src = "res/Main/smithy/practice/infoBg.png",
        ap = cc.p(0.5, 1),
        pos = cc.p(right_size.width*0.5, right_size.height - 54)
    })
    right_bg:addChild(des_bg)

    local head_bg = zc.getSprite({
        src = "res/Main/weaponCopy/head_bg.png",
        pos = cc.p(100, 100),
    })
    des_bg:addChild(head_bg)

    local head = zc.getSprite({
        src = "res/Main/smithy/practice/base_life.png",
        pos = cc.pMul(cc.pFromSize(head_bg:getContentSize()), 0.5),
    })
    head_bg:addChild(head)

    local levelDi = zc.getSprite({
        src = "res/Main/smithy/practice/levelDi.png",
        pos = cc.p(220, 160),
    })
    des_bg:addChild(levelDi, 1)
    local curLevel = zc.createLabel({
        text = "1",
        fontSize = 22,
        pos = cc.pMul(cc.pFromSize(levelDi:getContentSize()), 0.5),
    })
    levelDi:addChild(curLevel)
    
    --进度条
    self._progressMoveX = 290
    local progressBg = ccui.Scale9Sprite:create(cc.rect(9, 0, 1, 26 ), "res/Main/smithy/practice/progressBg.png")
    progressBg:setContentSize(cc.size(290, 26))
    progressBg:setAnchorPoint(0, 0.5)
    progressBg:setPosition(levelDi:getPositionX() + 20, levelDi:getPositionY())
    des_bg:addChild(progressBg)
    --模板
    local template = ccui.Scale9Sprite:create(cc.rect(9, 0, 1, 26 ), "res/Main/smithy/practice/progressBg.png")
    template:setContentSize(cc.size(290, 26))
    template:setAnchorPoint(cc.p(0,0))
    --底板
    local progress = ccui.Scale9Sprite:create(cc.rect(3, 0, 1, 23 ), "res/Main/smithy/practice/progress.png")
    progress:setContentSize(cc.size(290, 23))
    progress:setAnchorPoint(cc.p(1, 0.5))
    --ClippingNode
    local pic = cc.ClippingNode:create()
    pic:setStencil(template)
    pic:addChild(progress)
    pic:setInverted(false)
    pic:setAlphaThreshold(0.5)
    pic:setPosition(cc.p(0, 0.5))
    progressBg:addChild(pic)
    progress:setPosition(cc.p(0, 12))


    local expLab = zc.createLabel({
        outLine = true,
        fontSize = 18,
        pos = cc.p(progressBg:getPositionX()+progressBg:getContentSize().width/2,progressBg:getPositionY()),
        color = cc.c3b(255,251,130),
    })
    des_bg:addChild(expLab,1)
    
    local addLab = zc.createRichLabel({
        text = zc.lang("hp") .. "：",
        fontSize = 20,
        anchor = cc.p(0, 0.5),
        pos = cc.p(235, 92),
    })
    addLab:setGradientColor(cc.c4b(244, 159, 8, 255), cc.c4b(255, 255, 124, 255), cc.p(0, -1))
    des_bg:addChild(addLab)

    local addLabNum1 = zc.createLabel({
        outLine = true,
        fontSize = 20,
        ap = cc.p(0, 0.5),
        pos = cc.p(addLab:getPositionX()+addLab:getContentSize().width+10, addLab:getPositionY() ),
    })
    des_bg:addChild(addLabNum1)

    local arrow_green = zc.createSprite("res/Main/common/arrow_green.png")
    arrow_green:setAnchorPoint(0.5, 0.5)
    arrow_green:setPosition(addLabNum1:getPositionX()+addLabNum1:getContentSize().width+20, addLab:getPositionY())
    des_bg:addChild(arrow_green)

    local addLabNum2 = zc.createLabel({
        outLine = true,
        fontSize = 20,
        ap = cc.p(0, 0.5),
        pos = cc.p(arrow_green:getPositionX()+arrow_green:getContentSize().width, addLab:getPositionY() ),
    })
    des_bg:addChild(addLabNum2)


    local tipLab = zc.createLabel({
        text = zc.lang("tips_practice_desc"),
        fontSize = 18,
        ap = cc.p(0, 0.5),
        pos = cc.p(264, 52),
        color = cc.c3b(216, 198, 156),
    })
    des_bg:addChild(tipLab)
    
    --下面部分
    local middleLine = zc.getSprite({
        src = "res/Main/smithy/practice/right_bg.png",
        ap = cc.p(0.5, 0),
        pos = cc.p(right_size.width*0.5, 10),
    })
    right_bg:addChild(middleLine)

    local itemDi1 = zc.createSprite("res/Main/common/popBg/di_2.png")
    itemDi1:setPosition(right_size.width/4 + 10, 152)
    right_bg:addChild(itemDi1)
    local itemDi2 = zc.createSprite("res/Main/common/popBg/di_2.png")
    itemDi2:setPosition(right_size.width/4*3 - 10, 152)
    right_bg:addChild(itemDi2)

    --使用心得
    local useItemInfo = {
        itemType = zc.mainTypeProp,
        itemId = 460,
    }
    self._useItemInfo = useItemInfo
    local coseItem = zc.createIconByData({
        data = {
            mainType = useItemInfo["itemType"],
            type = useItemInfo["itemId"],
            id = useItemInfo["itemId"],
        }, 
        showDetailPop = true,
        pos = cc.p(itemDi1:getContentSize().width/2, itemDi1:getContentSize().height/2+2),
    })
    itemDi1:addChild(coseItem)
    coseItem:setScale(80/120)
    local bagInfo = PlayerData:getBagInfoByID(useItemInfo["itemId"]) or {}
    local ownNum = tonumber(bagInfo["num"]) or 0
    local costItemsmNum = zc.createLabel({
        text = ownNum.."/"..self._perItemUsetNum,
        fontSize = 24,
        ap = cc.p(1, 0.5),
        pos = cc.p(coseItem:getContentSize().width-10, 15),
        outLine = true,
    })
    coseItem:addChild(costItemsmNum)
    self._costItemsmNum = costItemsmNum
    if ownNum == 0 then
        costItemsmNum:setColor(display.COLOR_RED)
    end

    local useResInfo = {
        itemType = zc.mainTypeResource,
        itemId = 2, 
    }
    local costRes = zc.createIconByData({
        data = {
            mainType = useResInfo["itemType"],
            type = useResInfo["itemId"],
            id = useResInfo["itemId"],
        }, 
        showDetailPop = true,
        pos = cc.p(itemDi2:getContentSize().width/2, itemDi2:getContentSize().height/2+2),
    })
    costRes:setScale(80/120)
    itemDi2:addChild(costRes)
    local ownRes = PlayerData:getResourcesInfoById(useResInfo["itemId"]) or 0
    local resNum = zc.createLabel({
        text = 1000,
        outLine = true,
        fontSize = 24,
        ap = cc.p(1, 0.5),
        pos = cc.p(costRes:getContentSize().width-10, 15),
    })
    costRes:addChild(resNum)

    --按钮
    local useBtn1 = zc.createCommomBtn({
        tag = 2,
        text = zc.lang("use_xinde"),
        touchScale = 0.9,
        pos = cc.p( right_size.width/4, 50),
        needSwallow = false,
        needEnableWhenMoving = true,
        endCallback = function() end,
    })
    right_bg:addChild(useBtn1)

    local useBtn2 = zc.createCommomBtn({
        tag = 1,
        text = zc.lang("yanxi_2"),
        touchScale = 0.9,
        pos = cc.p( right_size.width/4*3, 50),
        needSwallow = false,
        needEnableWhenMoving = false,
        needEnableWhenOut = true,
        endCallback = function() end,
    })
    self._userBtn2 = useBtn2
    right_bg:addChild(useBtn2)

    local touchTip = zc.createLabel({
        text = zc.lang("long_press_can_yanxi"),
        outLine = true,
        fontSize = 17,
        pos = cc.p(right_size.width*0.5, 35),
        color = display.COLOR_RED,
    })
    right_bg:addChild(touchTip)
    


    --需要刷新的对象
    self._refreshList["titleName"] = titleName
    self._refreshList["maxLevel"] = maxLevel
    self._refreshList["exclamationBtn"] = exclamationBtn
    self._refreshList["head_bg"] = head_bg
    self._refreshList["head"] = head
    self._refreshList["curLevel"] = curLevel
    self._refreshList["expLab"] = expLab
    self._refreshList["progress"] = progress
    self._refreshList["addLab"] = addLab
    self._refreshList["addLabNum1"] = addLabNum1
    self._refreshList["arrow_green"] = arrow_green
    self._refreshList["addLabNum2"] = addLabNum2
    self._refreshList["tipLab"] = tipLab
    self._refreshList["useBtn1"] = useBtn1
    self._refreshList["useBtn2"] = useBtn2

    self._refreshList["resNum"] = resNum
    self._refreshList["costItemsmNum"] = costItemsmNum
    self._refreshList["useResInfo"] = useResInfo
    self._refreshList["useItemInfo"] = useItemInfo
end
function SmithyPracticeLayer:refreshInfoList()
    local info = self._nowInfo
    if not info["levelInfo"] then
        local skilful = gameData.getDataFromCache( "skilful",{effect=info.id} )
        info["levelInfo"] = skilful
        info["maxLevel"] = table.nums(skilful)

        local _maxCanLevel = info["maxLevel"]
        if self._nowMaxUpLevel > _maxCanLevel then
            self._nowMaxUpLevel = _maxCanLevel
            self._tipmaxLevel:setString(zc.getLevelTipShow().._maxCanLevel)
        end
    end
    self._refreshList["tipLab"]:setString(zc.lang("tips_practice_desc"))
    self._refreshList["titleName"]:setString(info["name"])
    self._refreshList["titleName"]:stopAllActions()
    self._refreshList["titleName"]:setOpacity(0)
    self._refreshList["titleName"]:runAction(cc.Sequence:create(cc.FadeIn:create(0.4)))
    self._refreshList["head_bg"]:setTexture(info["bg"])
    self._refreshList["head"]:setTexture(info["img"])
    self._refreshList["head"]:stopAllActions()
    self._refreshList["head"]:setOpacity(0)
    self._refreshList["head"]:runAction(cc.Sequence:create(cc.FadeIn:create(0.4)))
    local nowSkillLevel = self._nowSkillInfo["lv"..info.id] or 0
    self._refreshList["curLevel"]:setString(nowSkillLevel)
    local nowSkillExp = self._nowSkillInfo["exp"..info.id] or 0
    local nowLevelInfo = info["levelInfo"][nowSkillLevel] or {}
    local levelInfo = info["levelInfo"][nowSkillLevel+1]
    local nextLevelInfo = info["levelInfo"][nowSkillLevel+1] or {}

    local levelExp = nextLevelInfo["experience"] or 1
    self._refreshList["expLab"]:setString(nowSkillExp.."/"..levelExp)
    local effectType = nowLevelInfo["effectType"] or nextLevelInfo["effectType"]
    self._refreshList["addLab"]:setString(LANGUAGE_getAttributeTextById(effectType))
    local addLabNum1 = self._refreshList["addLabNum1"]
    local arrow_green = self._refreshList["arrow_green"]
    local addLabNum2 = self._refreshList["addLabNum2"]
    addLabNum1:setString(nowLevelInfo["effectValue"] or 0)
    addLabNum2:setString(nextLevelInfo["effectValue"] or 1)
    arrow_green:setPositionX(addLabNum1:getPositionX()+addLabNum1:getContentSize().width+20)
    addLabNum2:setPositionX(arrow_green:getPositionX()+arrow_green:getContentSize().width)

    local cost = nextLevelInfo["cost"] or ""
    local costInfo = string.split(cost, "|")
    self._refreshList["resNum"]:setString(costInfo[3] or "")
    local ownMoney = tonumber(PlayerData:getResourcesInfoById(2)) or 0 
    if ownMoney < (tonumber(costInfo[3]) or 0) then
        self._refreshList["resNum"]:setColor(display.COLOR_RED)
    else
        self._refreshList["resNum"]:setColor(display.COLOR_WHITE)
    end
    
    --进度条
    local width = tonumber(nowSkillExp)/tonumber(levelExp) * self._progressMoveX
    local progress = self._refreshList["progress"]
    progress:setPositionX(width)

    --如果达到最大等级
    if not nextLevelInfo.cost then
        addLabNum2:setVisible(false)
        arrow_green:setVisible(false)
        self._refreshList["expLab"]:setVisible(false)
        progress:setPositionX(self._progressMoveX)
    else
        addLabNum2:setVisible(true)
        arrow_green:setVisible(true)
        self._refreshList["expLab"]:setVisible(true)

    end

    local function resetNowExp(_now,_next,_level)
        nowSkillExp = _now
        levelExp = _next
        nowSkillLevel = _level
    end
    --
    local function scheduleDoAction(_type, _money,_itemnum)
        local ownMoney = _money
        local ownItemNum = _itemnum

        self._beginSchedule = true
        schedule(self,function()
            --最重要的操作在这里完成
            if nowSkillExp >= levelExp then --如果升级了
                local _currentGID = getGuideManager():getCurrentGID()
                if _currentGID == GuideKey.KEY_13504 then
                    getGuideManager():setFuncGuideOver()
                end
                self._canLevel = self._canLevel - 1
                nowSkillLevel = nowSkillLevel + 1
                self._refreshList["curLevel"]:setString(nowSkillLevel)
                local _nowLevelInfo = info["levelInfo"][nowSkillLevel] or {}
                local _nextLevelInfo = info["levelInfo"][nowSkillLevel+1] or {}
                nowSkillExp = 0 
                levelExp = _nextLevelInfo["experience"] or 0
                progress:setPositionX( 0 )
                self._refreshList["expLab"]:setString(nowSkillExp.."/"..levelExp)
                --属性增加
                addLabNum1:setString(_nowLevelInfo["effectValue"] or 0)
                addLabNum2:setString(_nextLevelInfo["effectValue"] or 1)
                arrow_green:setPositionX(addLabNum1:getPositionX()+addLabNum1:getContentSize().width+20)
                addLabNum2:setPositionX(arrow_green:getPositionX()+arrow_green:getContentSize().width)

                --如果达到最大等级
                if not _nextLevelInfo["experience"] then
                    self._canLevel = 0
                    addLabNum2:setVisible(false)
                    arrow_green:setVisible(false)
                    self._refreshList["expLab"]:setVisible(false)
                    progress:setPositionX(self._progressMoveX)
                end

                --升级之后，速度提高
                self._interval = self._interval / 2
                self:stopActionByTag(102030)
                performWithDelay(self,function()
                    scheduleDoAction(_type,ownMoney,ownItemNum)
                end,0.01)
            end
            nowSkillExp = nowSkillExp + self._perAddExp

            if self._canLevel <= 0 then
                nowSkillExp = nowSkillExp - self._perAddExp
                self._dontGoEnd = true
                self:stopTimer()
                local _currentGID = getGuideManager():getCurrentGID()
                if _currentGID == GuideKey.KEY_13504 then
                    getGuideManager():setFuncGuideOver()
                end
                if self._useNum > 0 then
                    if nowSkillLevel >= tonumber(info["maxLevel"]) then
                        zc.tipInfo(zc.lang("tips_practice_reach_full_level"))
                    elseif nowSkillLevel >= self._nowMaxUpLevel then
                        zc.tipInfo(zc.lang("tips_practice_up_house_can_yanxiu"))
                    else
                        zc.tipInfo(zc.lang("all_pactice_reach_level")..tostring(nowSkillLevel).. zc.lang("can_goon_yanxi"))--这一次是能够升级的
                    end
                end
                self:gotoUse(resetNowExp, _type)
                return
            end

            --物资减少
            if _type == 1 then
                if ownMoney < tonumber(costInfo[3]) then --银币不足
                    nowSkillExp = nowSkillExp - self._perAddExp
                    self._dontGoEnd = true
                    self:stopTimer()
                    if self._useNum > 0 then
                        zc.tipInfo(zc.lang("tips_money_deficiency"))
                        local _currentGID = getGuideManager():getCurrentGID()
                        if _currentGID == GuideKey.KEY_13504 then
                            getGuideManager():setFuncGuideOver()
                        end
                    end
                    self:gotoUse(resetNowExp, _type)
                    return
                end
                ownMoney = ownMoney - tonumber(costInfo[3])
            elseif _type == 2 then
                if ownItemNum <= 0 then
                    nowSkillExp = nowSkillExp - self._perAddExp
                    self._dontGoEnd = true
                    self:stopTimer()
                    if self._useNum > 0 then
                        zc.tipInfo(zc.lang("tips_goods_unenough"))
                    end
                    self:gotoUse(resetNowExp, _type)
                    return
                end
                ownItemNum = ownItemNum - self._perItemUsetNum
                self._costItemsmNum:setString(ownItemNum.."/"..self._perItemUsetNum)
                if ownItemNum <= 0 then
                    self._costItemsmNum:setColor(display.COLOR_RED)
                end
            end
            --使用数量增加
            self._useNum = self._useNum + 1
            --进度条修改
            self._refreshList["expLab"]:setString(nowSkillExp.."/"..levelExp)
            local _key = tonumber(nowSkillExp)/tonumber(levelExp)
            if _key >= 1 then _key = 1 end
            local posx = _key * self._progressMoveX
            self:progressAction(posx)

        end,self._interval,102030)
    end

    local function beginFunction(_type) -- 1使用银币、2使用道具
        self._recordeInfo = {}
        self._recordeInfo["nowSkillExp"] = nowSkillExp
        self._recordeInfo["levelExp"] = levelExp
        self._recordeInfo["curLevel"] = nowSkillLevel
        self._recordeInfo["nowLevelInfo"] = info["levelInfo"][nowSkillLevel] or {}
        self._recordeInfo["nextLevelInfo"] = info["levelInfo"][nowSkillLevel+1] or {}

        --计算时间间隔
        local _exp = tonumber(self._recordeInfo["nextLevelInfo"].experience) or 1
        local _key = (_exp/600)
        if _key > 1 then
            _key = 1
        end
        self._interval = 0.15 - _key*0.135
        -- self._interval = 0.005

        self:stopTimer()
        self:refreshCanlevel()
        self._useNum = 1
        self._dontGoEnd = false
        self._beginSchedule = false
        performWithDelay(self,function()
            self._useNum = 0

            local ownMoney = 0
            local ownItemNum = 0
            if _type == 1 then
                ownMoney = tonumber(PlayerData:getResourcesInfoById(2))
            else
                local bagInfo = PlayerData:getBagInfoByID(self._useItemInfo["itemId"]) or {}
                ownItemNum = tonumber(bagInfo["num"]) or 0
            end

            if nowSkillLevel >= tonumber(info["maxLevel"]) then
                self._dontGoEnd = true
                zc.tipInfo(zc.lang("tips_practice_reach_full_level"))
                return
            elseif nowSkillLevel >= self._nowMaxUpLevel then
                self._dontGoEnd = true
                zc.tipInfo(zc.lang("tips_practice_up_house_can_yanxiu"))
                return
            end
            scheduleDoAction(_type,ownMoney,ownItemNum)
        end,0.5,102031)
    end

    -- 按钮点击效果
    -------------------------------------------------------------------------------------------------------- 1 
    --使用道具按钮
    local useBtn1 = self._refreshList["useBtn1"]
    useBtn1:setTouchBeganCall(function()
        beginFunction(2)
    end)
    useBtn1:setTouchEndedCall(function()
        self:stopTimer()
        if not self._dontGoEnd then
            if nowSkillLevel >= tonumber(info["maxLevel"]) then
                zc.tipInfo(zc.lang("tips_practice_reach_full_level"))
                return
            elseif nowSkillLevel >= self._nowMaxUpLevel then
                zc.tipInfo(zc.lang("tips_practice_up_house_can_yanxiu"))
                return
            end
            self:gotoUse(resetNowExp, 2)
        end
    end)
    useBtn1:setTouchCancelledCallback(function()
        self:stopTimer()
        self:gotoUse(resetNowExp, 2)
    end)
    -------------------------------------------------------------------------------------------------------- 2
    --使用资源按钮
    local useBtn2 = self._refreshList["useBtn2"]
    useBtn2:setTouchBeganCall(function()
        --记录
        beginFunction(1)
    end)
    useBtn2:setTouchEndedCall(function()
        self:stopTimer()
        if not self._dontGoEnd then
            if nowSkillLevel >= tonumber(info["maxLevel"]) then
                zc.tipInfo(zc.lang("tips_practice_reach_full_level"))
                return
            elseif nowSkillLevel >= self._nowMaxUpLevel then
                zc.tipInfo(zc.lang("tips_practice_up_house_can_yanxiu"))
                return
            end
            self:gotoUse(resetNowExp, 1)
        end
    end)
    useBtn2:setTouchCancelledCallback(function()
        self:stopTimer()
        self:gotoUse(resetNowExp, 1)
    end)
end

function SmithyPracticeLayer:gotoUse(_refrsh, _type) -- _type:1使用资源、2使用道具
    local _params
    if self._useNum == 0 then
        self._useNum = 1
    end
    if _type == 1 then -- 1使用资源
        local _resType = 1
        if self._useNum > 1 then
            _resType = 2
        end
        _params = {type=_resType,times=self._useNum,id=self._nowInfo.id,houseId=self._houseInfo.id}
    elseif _type == 2 then -- 2使用道具
        local bagInfo = PlayerData:getBagInfoByID(self._useItemInfo["itemId"]) or {}
        ownItemNum = tonumber(bagInfo["num"]) or 0
        self._itemBagInfo = bagInfo
        if ownItemNum <= 0 then
            zc.tipInfo(zc.lang("tips_goods_unenough"))
            return
        end
        _params = {type=3,times=self._useNum,itemNum=self._useNum,id=self._nowInfo.id,houseId=self._houseInfo.id,itemId=self._itemBagInfo["id"]}
    end
    zc.sendHttp({
        apiName = "Weapon_practice",
        params = _params,
        successCallback = function (net_data)
            musicManager.playEffect(zc.effect["yanxi"])
            PlayerData:updataData(net_data)
            PlayerData:setSkilful(net_data["info"])
            local nowSkillExp = net_data["info"]["exp"..self._nowInfo["id"]]
            local nowSkillLevel = net_data["info"]["lv"..self._nowInfo["id"]]
            local _hasLevelUp = false
            if tonumber(nowSkillLevel) > tonumber(self._nowSkillInfo["lv"..self._nowInfo["id"]]) then
                _hasLevelUp = true
                local _currentGID = getGuideManager():getCurrentGID()
                if _currentGID == GuideKey.KEY_13504 then
                    getGuideManager():setFuncGuideOver()
                end
            end
            self._nowSkillInfo["exp"..self._nowInfo["id"]] = nowSkillExp
            self._nowSkillInfo["lv"..self._nowInfo["id"]] = nowSkillLevel

            self._refreshList["curLevel"]:setString(nowSkillLevel)
            -- self._refreshList["nextLevel"]:setString(zc.getLevelTipShow()..(nowSkillLevel+1))
            local _nowLevelInfo = self._nowInfo["levelInfo"][nowSkillLevel] or {}
            local _nextLevelInfo = self._nowInfo["levelInfo"][nowSkillLevel+1] or {}

            local addLabNum1 = self._refreshList["addLabNum1"]
            addLabNum1:setString(_nowLevelInfo["effectValue"] or 0)
            local arrow_green = self._refreshList["arrow_green"]
            local addLabNum2 = self._refreshList["addLabNum2"]
            local progress = self._refreshList["progress"]
            progress:stopAllActions()
            --判断是否达到最大等级
            if _nextLevelInfo.cost then
                levelExp = _nextLevelInfo["experience"] or 1
                self._refreshList["expLab"]:setString(nowSkillExp.."/"..levelExp)
                local width = tonumber(nowSkillExp)/tonumber(levelExp) * self._progressMoveX
                if width == 0 then
                    LayerManager.addShieldLayout(nil, 0.2)
                    if not self._dontGoEnd then --self._dontGoEnd 为true表示长按效果，false表示单次点击
                        progress:runAction(cc.Sequence:create(cc.MoveTo:create(0.2, cc.p(self._progressMoveX, 12)),
                            cc.CallFunc:create(function() 
                                progress:setPositionX(0) 
                            end)))
                    else
                        progress:setPositionX(0)
                    end
                else
                    progress:runAction(cc.Sequence:create(cc.MoveTo:create(0.5, cc.p(width, 12))))
                end
                addLabNum2:setString(_nextLevelInfo["effectValue"] or 1)
                arrow_green:setPositionX(addLabNum1:getPositionX()+addLabNum1:getContentSize().width+20)
                addLabNum2:setPositionX(arrow_green:getPositionX()+arrow_green:getContentSize().width)
                local cost = _nextLevelInfo["cost"] or ""
                local costInfo = string.split(cost, "|")
                local ownMoney = tonumber(PlayerData:getResourcesInfoById(costInfo[2]))
                if ownMoney < (tonumber(costInfo[3]) or 0) then
                    self._refreshList["resNum"]:setColor(display.COLOR_RED)
                end
            else
                addLabNum2:setVisible(false)
                arrow_green:setVisible(false)
                self._refreshList["expLab"]:setVisible(false)
                self._refreshList["resNum"]:setString("")
                progress:setPositionX(self._progressMoveX)
            end

            --如果不是走schedule升级的,升级之后，canlevel - 1
            if not self._beginSchedule then
                if tonumber(self._recordeInfo["curLevel"]) < tonumber(nowSkillLevel) then
                    self._canLevel = self._canLevel - 1
                end
            end

            self:setLeftLevel(_hasLevelUp, self._nowInfo["id"])
            if _refrsh then
                _refrsh(nowSkillExp, levelExp, nowSkillLevel)
            end
            --恢复道具数量
            self:setUsetItemNum()
        end,
        failCallback = function()
            local _currentGID = getGuideManager():getCurrentGID()
            if _currentGID == GuideKey.KEY_13504 then
                getGuideManager():setFuncGuideOver()
            end
        end,
        errorCallback = function(_errorCode,_msg)
            zc.tipInfo(_msg)
            local _currentGID = getGuideManager():getCurrentGID()
            if _currentGID == GuideKey.KEY_13504 then
                getGuideManager():setFuncGuideOver()
            end
            if tonumber(_errorCode) == 100 or tonumber(_errorCode) == 2 then
                self._canLevel = 0
                if _refrsh then
                    _refrsh(self._recordeInfo["nowSkillExp"], self._recordeInfo["levelExp"],self._recordeInfo["curLevel"])
                end
            end
            --如果失败，则恢复
            self._refreshList["curLevel"]:setString(self._recordeInfo["curLevel"])
            -- self._refreshList["nextLevel"]:setString(zc.getLevelTipShow()..(self._recordeInfo["curLevel"]+1))
            local addLabNum1 = self._refreshList["addLabNum1"]
            local arrow_green = self._refreshList["arrow_green"]
            local addLabNum2 = self._refreshList["addLabNum2"]
            addLabNum1:setString(self._recordeInfo["nowLevelInfo"]["effectValue"] or "")
            addLabNum2:setString(self._recordeInfo["nextLevelInfo"]["effectValue"] or "")
            arrow_green:setPositionX(addLabNum1:getPositionX()+addLabNum1:getContentSize().width+20)
            addLabNum2:setPositionX(arrow_green:getPositionX()+arrow_green:getContentSize().width)
            self._refreshList["expLab"]:setString(self._recordeInfo["nowSkillExp"].."/"..self._recordeInfo["levelExp"])
            self._refreshList["progress"]:setPositionX(tonumber(self._recordeInfo["nowSkillExp"])/tonumber(self._recordeInfo["levelExp"]) * self._progressMoveX)

            local nextLevelInfo = self._recordeInfo["nextLevelInfo"]
            --如果达到最大等级
            if not nextLevelInfo.cost then
                addLabNum2:setVisible(false)
                arrow_green:setVisible(false)
                self._refreshList["expLab"]:setVisible(false)
                self._refreshList["progress"]:setPositionX(self._progressMoveX)
            else
                addLabNum2:setVisible(true)
                arrow_green:setVisible(true)
                self._refreshList["expLab"]:setVisible(true)

            end
            --恢复道具数量
            self:setUsetItemNum()
        end,
    })

end
--设置使用心得道具数量
function SmithyPracticeLayer:setUsetItemNum()
    --恢复道具数量
    local bagInfo = PlayerData:getBagInfoByID(self._useItemInfo["itemId"]) or {}
    local ownItemNum = tonumber(bagInfo["num"]) or 0
    self._costItemsmNum:setString(ownItemNum.."/"..self._perItemUsetNum)
    if ownItemNum <= 0 then
        self._costItemsmNum:setColor(display.COLOR_RED)
    end
end
--检查可升级次数
function SmithyPracticeLayer:refreshCanlevel()
    local info = self._nowInfo
    local _maxLevel = 0
    local _minLevel = 100000000
    for i = 1, 6 do
        local _level = tonumber(self._nowSkillInfo["lv"..i])
        if _level > _maxLevel then
            _maxLevel = _level
        end
        if _minLevel > _level then
            _minLevel = _level
        end
    end
    local nowSkillLevel = tonumber(self._nowSkillInfo["lv"..info["id"]])
    local _canLevel = 0
    if _maxLevel == _minLevel then
        _canLevel = 1
        if _maxLevel >= tonumber(self._nowMaxUpLevel) then
            _canLevel = 0
        end
    else
        if nowSkillLevel == _maxLevel then
            _canLevel = 0
        elseif nowSkillLevel == _minLevel then
            _canLevel = 1
            local _minNum = 0
            for i = 1,6 do
                local _level = tonumber(self._nowSkillInfo["lv"..i])
                if _level == _minLevel then
                    _minNum = _minNum + 1
                end
            end
            if  _minNum == 1 then
                _canLevel = 2
            end
        end
    end
    self._canLevel = _canLevel
    print("-----------log--------ad-------------_canLevel1", self._canLevel)
    if _canLevel == 2 and _maxLevel >= tonumber(self._nowMaxUpLevel) then
        self._canLevel = self._canLevel - 1
    end
    print("-----------log--------ad-------------_canLevel2 ", self._canLevel)
end
function SmithyPracticeLayer:setLeftLevel(_levelUp, _id)
    for i = 1,6 do
        local levelLab = self._leftSkillLevel[i]
        local skill = levelLab:getParent()
        local skillInfo = self._infoList[i]
        levelLab:setString(zc.getLevelTipShow()..self._nowSkillInfo["lv"..skillInfo["id"]])
        if _levelUp and tonumber(_id) == tonumber(skillInfo["id"]) then
            self:leveUpEffect(skill)
            self:leveUpEffect(self._refreshList["head"])
        end
    end
end
function SmithyPracticeLayer:leveUpEffect(_node)
    local armature = zc.createAnimationArmature({
        fileName = "ef_mingge",
        autoRelease = true
    })
    armature:setScale( 0.95 )
    armature:setPosition( cc.p(_node:getContentSize().width/2,_node:getContentSize().height/2) )
    armature:getAnimation():playWithIndex(0)
    _node:addChild( armature, 2 )
    armature:getAnimation():setMovementEventCallFunc(function(armature, movementType, movementID)
        if 1 == tonumber(movementType) then
            armature:removeFromParent()
        end
    end)
end
function SmithyPracticeLayer:progressAction(_posx)
    local progress = self._refreshList["progress"]
    -- progress:stopAllActions()
    progress:runAction(cc.Sequence:create(
        cc.MoveTo:create(self._interval, cc.p(_posx, 12)),
        cc.CallFunc:create(function()
            if _posx == 290 then
                progress:setPositionX(0)
            end
        end)
    ))
end
function SmithyPracticeLayer:stopTimer()
    self:stopAllActions()
end
function SmithyPracticeLayer:onCleanup()
    ccs.ArmatureDataManager:getInstance():removeArmatureFileInfo( "res/animation/ef_mingge/ef_mingge.csb", true)
    if self._callback and type(self._callback) == "function" then
        self._callback()
    end
end
function SmithyPracticeLayer:onEnter()
    self:addGuide()
end

---------------------引导---------------------------
function SmithyPracticeLayer:addGuide()
    local _currentGID = getGuideManager():getCurrentGID()
    if _currentGID == GuideKey.KEY_13502 then
        zc.setGuideFuncNextStep(_currentGID)
        self:addGuide()
    elseif inArray(_currentGID, GuideGroup.DUI_HUA) then
        local function _callBack()
            getGuideManager():setObjTarget( self._userBtn2 )
            getGuideManager():startGuide()
        end
        getGuideManager():setHeroFuncCallBack(_callBack)
        getGuideManager():startGuide()
    end 
end

return SmithyPracticeLayer