--[[
FileName        TalentChangePop.lua
ProjectName     HJ2

Created by wangming on 16-03-29

]]
local TalentChangePop = class("TalentChangePop",function ()
    return zc.createNormalDialog({
        src = "res/Main/talent/new_bg.jpg",
        showBack = false,
        showFlower = false,
    })
end)

function TalentChangePop:create( data )
    return TalentChangePop.new( data )
end

function TalentChangePop:ctor( data )
    self._flag = data.isBreakthrough
    local _newInfo = data.mainInfo or {}
    local _nowInfo = data.nowHeroInfo or {}
    local _effInfo = data.effInfo or {}


    local _titleDi = zc.getSprite({
        src = "res/Main/talent/new_titlebg.png",
        ap = cc.p(0.5, 1),
        pos = cc.p(zc.width*0.5, zc.height),
    })
    self:addChild(_titleDi)

    local _file = self._flag and "res/Main/role/breakthrough/title.png" or "res/Main/talent/new_name_2.png"
    local _titleImg = zc.getSprite({
        src = _file,
        pos = cc.p(_titleDi:getContentSize().width*0.5, _titleDi:getContentSize().height*0.5),
    })
    _titleDi:addChild(_titleImg)

    local dizhuo = zc.createSprite("res/Main/talent/new_panzi.png")
    dizhuo:setPosition(zc.width*0.5, zc.height*0.5 - 50)
    self:addChild(dizhuo, 1)

    local _dizuoSize = dizhuo:getContentSize()

    local _nameDi = zc.getSprite({
        src = self._flag and "res/Main/role/breakthrough/infoDi.png" or "res/Main/talent/new_namebg.png",
        pos = cc.p(_dizuoSize.width*0.5 - 40, 20),
    })

    local congratulateLabel = zc.createLabel({
        text = zc.lang("main_role_advance_to"),
        fontSize = 20,
        ap = cc.p(0.5, 0.5),
        pos = cc.p(_nameDi:getContentSize().width*0.5, _nameDi:getContentSize().height*0.5),
        shadow = true,
        color = display.COLOR_YELLOW,
    })
    _nameDi:addChild(congratulateLabel)

    local _weapon, _nowModel
    
    if self._flag then
        _weapon = PlayerData:getWeaponsInfoById(_newInfo.id) or {}
        _nowModel = _newInfo.modelId
    else
        dizhuo:addChild(_nameDi)
        local _qualityDi = zc.getSprite({
            src = "res/Main/talent/new_zhizibg.png",
            pos = cc.p(_nameDi:getContentSize().width + 5, _nameDi:getContentSize().height*0.5),
        })
        _nameDi:addChild(_qualityDi)

        if data.convertId then
            local _qualifications = gameData.getDataFromCache( "hero_talent", {convertId = data.convertId}).convertQuality
            _qualifications = tonumber( _qualifications ) or 0
            if _qualifications ~= 0 then
                local _src =  zc.getHeroQualificationsPath(_qualifications, 2)
                local _qualitySp = zc.getSprite({
                    src = _src,
                    pos = cc.p(_qualityDi:getContentSize().width*0.5, _qualityDi:getContentSize().height*0.5),
                    scale = 10,
                })
                _qualityDi:addChild(_qualitySp)
                self._qualitySp = _qualitySp
                _qualitySp:setOpacity(0)
            end
        end
        _weapon = PlayerData:getRoleUserWeapons()
        _nowModel = PlayerData:getBaseInfoByTag("seigniorId") == 1 and "nanzhu" or "nvzhujue"
    end

    local skeletonNode = zc.battle.createHeroArmature({
        fileName = _nowModel, 
        actName = "idle",
        loop = true,
        heroDataWeaponId = _weapon.weaponId,
    })
    skeletonNode:setScale(1.2)
    skeletonNode:setPosition(_dizuoSize.width/2, _dizuoSize.height*0.5)
    dizhuo:addChild(skeletonNode, 1)
    zc.soldierChangeWeapon(skeletonNode, _weapon.weaponId)

    local _spine = zc.createSpine({
        fileName = "zhujueshengji_1",
        actName = "bao",
        loop = false,
        autoRemove = true,
    })
    _spine:setPosition(zc.width*0.5, zc.height*0.5 + 90)
    self:addChild(_spine, 5)
    
    local closeLab = zc.createLabel({
        text = zc.lang("tips_click_empty_continue"),
        fontSize = 20,
        pos = cc.p(zc.width*0.5, 30),
        color = cc.c3b(133,119,119),
    })
    closeLab:setVisible(false)
    self:addChild(closeLab, 5)
    self.closeLab = closeLab
    
    local _tb = {}
    if self._flag then
        local _attrTotleDi = cc.Node:create()
        _attrTotleDi:setPosition(zc.width*0.5, zc.height*0.5)
        self:addChild(_attrTotleDi)
        self._attrTotleDi = _attrTotleDi
        self._attrTotleDi:setVisible(false)

        local _arrowX = 210
        local _arrowY = 120
        local _arrow = zc.createSprite("res/Main/role/equip/arrow_2.png")
        _arrow:setPosition(_arrowX, _arrowY)
        _attrTotleDi:addChild(_arrow)
        self._attrTotleDi._arrow  = _arrow 

        local _newAdwance = tonumber(_nowInfo.newAdvance) or 1
        local _quality = tonumber(_nowInfo.quality) or 1  
        for i=1, 2 do
            local _di = zc.createSprite("res/Main/role/role_magic_bg.png")
            _di:setPosition(_arrowX - 100 + (i-1)*200, _arrowY)
            _attrTotleDi:addChild(_di)
            _di:setScale(0.7)
            self._attrTotleDi["di" .. i] = _di
            if i == 2 then
                _newAdwance = tonumber(_newInfo.newAdvance) or 1
                _quality = tonumber(_newInfo.quality) or 1  
            end
            local _icon = zc.createIconByData({
                data = {
                    mainType = zc.mainTypeSoldier,
                    type = _newInfo.heroId,
                    id = _newInfo.heroId,
                },
                quality = _quality,
                pos = cc.p(_di:getContentSize().width*0.5, _di:getContentSize().height*0.5),
            })
            _di:addChild(_icon)

            local _tmpSize = cc.size(120, 33)
            local _nameNode = zc.getScaleNode("res/Main/role/trinket/attrDi.png", _tmpSize)
            _nameNode:setPosition(_di:getPositionX(), _arrowY - 75)
            _attrTotleDi:addChild(_nameNode)
            _attrTotleDi["nameDi" .. i] = _nameNode

            local _label = zc.createRichLabel({
                text = zc.lang("breakthrough") .. " +" .. _newAdwance,
                fontSize = 20,
                pos = cc.p(_tmpSize.width*0.5, _tmpSize.height*0.5),
            })
            _label:setGradientColor(cc.c4b(244, 159, 8, 255), cc.c4b(255, 255, 124, 255), cc.p(0, -1))
            _nameNode:addChild(_label)
        end
        
        local _skillId = tonumber(_effInfo.skill) or 0
        local _skillDb = gameData.getDataFromCacheWithPrimaryKey("skill", _skillId)
        local _flag = _skillDb and next(_skillDb) ~= nil
        local _iconDi
        if _flag then
            _iconDi = zc.createSprite("res/Main/talent/new_skillbg.png")
        else
            _iconDi = zc.createSprite("res/Main/role/breakthrough/attrDi.png")    
        end
        _iconDi:setAnchorPoint(0, 0.5)
        _iconDi:setPosition(0, -50)
        _attrTotleDi._iconDi = _iconDi
        _attrTotleDi:addChild(_iconDi)
        local _iconPos = cc.p(82, _iconDi:getContentSize().height*0.5)

        local _line = zc.createSprite("res/Main/role/breakthrough/line.png")
        _line:setPosition(260, 5)
        _iconDi:addChild(_line)

        local _tipLabel = zc.createRichLabel({
            text = zc.lang("skill") .. LANGUAGE_ROLE.unlock,
            fontSize = 24,
            pos = cc.p(260, 95),
        })
        _tipLabel:setGradientColor(cc.c4b(244, 159, 8, 255), cc.c4b(255, 255, 124, 255), cc.p(0, -1))
        _iconDi:addChild(_tipLabel)

        if _flag then
            local _icon = zc.createIconByData({
                data = {
                    mainType = zc.mainTypeSkill,
                    type = _skillDb.id,
                    id = _skillDb.id,
                },
                pos = _iconPos
            })
            _icon:setScale(0.75)
            _iconDi:addChild(_icon)


            local _label1 = zc.createLabel({
                text = zc.lang("new") ..zc.lang("skill") .. "：",
                ap = cc.p(0, 0.5),
                fontSize = 20,
                color = cc.c3b(227, 226, 169),
                pos = cc.p(145, 60),
            })
            _iconDi:addChild(_label1)
            local _label2 = zc.createLabel({
                text = _skillDb.name,
                ap = cc.p(0, 0.5),
                fontSize = 20,
                pos = cc.p(_label1:getPositionX() + _label1:getContentSize().width, _label1:getPositionY()),
            })
            _iconDi:addChild(_label2)
            local _label3 = zc.createLabel({
                text = ("（1" .. zc.lang("level_1") .. "）"),
                ap = cc.p(0, 0.5),
                fontSize = 20,
                color = display.COLOR_RED,
                pos = cc.p(_label2:getPositionX() + _label2:getContentSize().width, _label2:getPositionY()),
            })
            _iconDi:addChild(_label3)

            local _desc = zc.buildSkillDesc(_skillDb.id)
            local _label4 = zc.createLabel({
                text = _desc,
                ap = cc.p(0, 0.5),
                fontSize = 16,
                color = cc.c3b(150, 125, 106),
                width = 360,
                pos = cc.p(_label1:getPositionX(), _label1:getPositionY() - 33),
            })
            _iconDi:addChild(_label4)
        else
            _tipLabel:setString(zc.lang("attribute_up"))
            _tipLabel:setPositionX(_iconDi:getContentSize().width*0.5)
            _line:setAnchorPoint(0.5, 0.5)
            _line:setPositionX(_iconDi:getContentSize().width*0.5)
            for j=1, 3 do
                local _effId = tonumber(_effInfo["effectId" .. j]) or 0
                if _effId ~= 0 then
                    local _showText = ""
                    local _target = tonumber(_effInfo["effectTarget" .. j]) or 0
                    if _target == 0 then
                        _showText = _showText .. zc.lang("all_heros")
                    end
                    local _num = tonumber(_effInfo["value" .. j]) or 0
                    _num = zc.getAttributeNumById(_effId, _num)
                    _showText = _showText .. zc.getEquipAttriNameByEffectType(_effId, true ) .. "+" .. _num
                    
                    local _row = (j - 1)%2
                    local _line = math.modf((j - 1)/2)
                    local _label = zc.createLabel({
                        text = _showText,
                        ap = cc.p(0, 0.5),
                        fontSize = 20,
                        pos = cc.p(30 + _row*200, 55 - _line*30),
                    })
                    _iconDi:addChild(_label)
                end
            end
        end
    else
        _tb = {
            {
                tip = LANGUAGE_getGemAttrByType(30) .. ":",
                now = _newInfo.attribute.attack,
                last = _nowInfo.attribute.attack,
            },
            {
                tip = LANGUAGE_getGemAttrByType(8) ..":",
                now = _newInfo.attribute.defense,
                last = _nowInfo.attribute.defense,
            },
            {
                tip = LANGUAGE_getGemAttrByType(12) ..":",
                now = _newInfo.attribute.defenseStrategy,
                last = _nowInfo.attribute.defenseStrategy,
            },
            {
                tip = LANGUAGE_getGemAttrByType(4) .. ":",
                now = _newInfo.attribute.hpLimit,
                last = _nowInfo.attribute.hpLimit,
            },
        }
        local _weaponId = _newInfo.weaponId
        local _heroTypeData = gameData.getDataFromCacheWithPrimaryKey( "weapon", _weaponId )
        local _heroType = tonumber( _heroTypeData.heroType ) or 1
        if _heroType == 2 then
            -- 策攻
            _tb[1].now = _newInfo.attribute.attackStrategy
            _tb[1].last = _nowInfo.attribute.attackStrategy
        end
        local _attrTotleDi = zc.createSprite("res/Main/talent/new_infobg.png")
        _attrTotleDi:setPosition(zc.width*0.7, zc.height*0.5)
        self:addChild(_attrTotleDi)
        self._attrTotleDi = _attrTotleDi
        self._attrTotleDi:setVisible(false)

        local _pDiY = 125
        for i=1, #_tb do
            local __data = _tb[i]
            local _posX = 120 -- -95
            local _posY = _pDiY - (i-2)*40
            local _node = cc.Node:create()
            _node:setPosition(_posX, _posY)
            _node:setVisible(false)
            _attrTotleDi:addChild(_node)
            _attrTotleDi["node" .. i] = _node
            local energyTip = zc.createRichLabel({
                text = __data.tip,
                fontSize = 22,
                anchor = cc.p(1, 0.5),
                pos = cc.p(0, 0),
                color = cc.c3b(166, 161, 113),
            })
            energyTip:setGradientColor(cc.c4b(244, 159, 8, 255), cc.c4b(255, 255, 124, 255), cc.p(0, -1))
            _node:addChild(energyTip)
            local lastNum = zc.createLabel({
                text = zc.getWan(__data.last),
                fontSize = 22,
                ap = cc.p(0.5, 0.5),
                pos = cc.p( 70, 0),
                color = cc.c3b(226, 203, 90),
            })
            _node:addChild(lastNum)

            local arrowImg = zc.getSprite({
                src = "res/Main/common/arrow_green.png",
                ap = cc.p(0.5, 0.5),
                pos = cc.p(130, 0),
            })
            _node:addChild(arrowImg)

            local nowNUM = zc.createLabel({
                text = zc.getWan(__data.now),
                fontSize = 22,
                ap = cc.p(0.5, 0.5),
                pos = cc.p(210, 0),
                color = display.COLOR_GREEN,
            })
            _node:addChild(nowNUM)
        end
    end

    performWithDelay(self, function()
        local new_bglight = zc.createSprite("res/Main/talent/new_bglight.png")
        new_bglight:setAnchorPoint(0.5, 0.5)
        new_bglight:setPosition(zc.width*0.5, zc.height*0.5)
        self:addChild(new_bglight)
        new_bglight:runAction(cc.RepeatForever:create(cc.Sequence:create(
            cc.Spawn:create(cc.ScaleTo:create(1.5, 0.8),cc.FadeTo:create(1.5, 255*0.8)),
            cc.Spawn:create(cc.ScaleTo:create(1.5, 1),cc.FadeTo:create(1.5, 255))
        )))

        if self._qualitySp then
            self._qualitySp:runAction(cc.Sequence:create(
                cc.Spawn:create(
                    cc.EaseOut:create(cc.ScaleTo:create(0.4, 0.9), 3),
                    cc.FadeIn:create(0.4)
                ),
                cc.ScaleTo:create(0.05, 1.05),
                cc.ScaleTo:create(0.02, 1)
            ))
        end

        local _nspine = zc.createSpine({
            fileName = "jinjie",
            actName = "animation",
            loop = true,
            needInit = false,
        })
        _nspine:setPosition(new_bglight:getContentSize().width*0.5, new_bglight:getContentSize().height*0.5)
        new_bglight:addChild(_nspine)

        performWithDelay(self, function()
            dizhuo:runAction(cc.Sequence:create(cc.MoveBy:create(0.3,cc.p(-200,-50))))
            new_bglight:runAction(cc.Sequence:create(
                cc.MoveBy:create(0.3, cc.p(-200, -50)),
                cc.CallFunc:create(function()
                    self._attrTotleDi:setVisible(true)
                    self._attrTotleDi:setOpacity(0)
                    if self._attrTotleDi._arrow then
                        self._attrTotleDi._arrow:setVisible(false)
                        self._attrTotleDi.di1:setVisible(false)
                        self._attrTotleDi.nameDi1:setVisible(false)
                        self._attrTotleDi.di2:setVisible(false)
                        self._attrTotleDi.nameDi2:setVisible(false)
                        self._attrTotleDi._iconDi:setVisible(false)
                    end
                    self._attrTotleDi:runAction(cc.Sequence:create(
                        cc.FadeIn:create(0.1),
                        cc.CallFunc:create(function()
                            if self._flag then
                                self._attrTotleDi.di1:setVisible(true)
                                self._attrTotleDi.nameDi1:setVisible(true)
                                zc.doFuncForAllChild(self._attrTotleDi.di1, function( child )
                                    child:setOpacity(0)
                                    child:runAction(cc.FadeIn:create(0.2))
                                end)
                                zc.doFuncForAllChild(self._attrTotleDi.nameDi1, function( child )
                                    child:setOpacity(0)
                                    child:runAction(cc.FadeIn:create(0.2))
                                end)
                                performWithDelay(self._attrTotleDi.di1, function()
                                    self._attrTotleDi._arrow:setVisible(true)
                                    self._attrTotleDi._arrow:setOpacity(0)
                                    self._attrTotleDi._arrow:runAction(cc.Sequence:create(
                                        cc.FadeIn:create(0.2),
                                        cc.CallFunc:create(function()
                                            self._attrTotleDi.di2:setVisible(true)
                                            self._attrTotleDi.nameDi2:setVisible(true)
                                            zc.doFuncForAllChild(self._attrTotleDi.di2, function( child )
                                                child:setOpacity(0)
                                                child:runAction(cc.FadeIn:create(0.2))
                                            end)
                                            zc.doFuncForAllChild(self._attrTotleDi.nameDi2, function( child )
                                                child:setOpacity(0)
                                                child:runAction(cc.FadeIn:create(0.2))
                                            end)
                                            performWithDelay(self._attrTotleDi._arrow, function()
                                                local armature= zc.createAnimationArmature({
                                                    fileName = "ef_mingge",
                                                    autoRemove = true,
                                                })
                                                armature:getAnimation():playWithIndex(0)
                                                armature:setScale( 1.2 )
                                                armature:setPosition( self._attrTotleDi.di2:getContentSize().width*0.5, self._attrTotleDi.di2:getContentSize().height*0.5 )    
                                                self._attrTotleDi.di2:addChild( armature )
                                            end, 0.2)
                                            performWithDelay(self._attrTotleDi._arrow, function()
                                                self._attrTotleDi._iconDi:setVisible(true)
                                                zc.doFuncForAllChild(self._attrTotleDi._iconDi, function( child )
                                                    child:setOpacity(0)
                                                    child:runAction(cc.FadeIn:create(0.2))
                                                end)
                                            end, 0.7)
                                        end)
                                    ))
                                end, 0.3)
                            else
                                for i=1, #_tb do
                                    local _node = self._attrTotleDi["node" .. i]
                                    if _node then
                                        _node:setVisible(false)
                                        performWithDelay(_node, function()
                                            _node:setVisible(true)
                                            zc.doFuncForAllChild(_node, function()
                                                _node:setOpacity(0)
                                                _node:runAction(cc.FadeIn:create(0.2))
                                            end)
                                        end, 0.05*i)
                                    end
                                end
                            end
                        end)
                    ))

                    self.closeLab:setVisible(true)
                    self:setTouchEndedCallback(function()
                        if self._flag then
                            LayerManager.removeLayout(true)
                        else
                            LayerManager.removeLayout()
                        end
                    end)
                end)
            ))
        end, 1)

        _nspine:setOpacity(255*0.4)
    end, 0.3)
end

return TalentChangePop