--[[
出售弹出框
jiangyan
2015-05-06
WushenBuyPop.lua
]]

local WushenBuyPop = class("WushenBuyPop",function()
    return ZCPopLayer:create()
end);

function WushenBuyPop:create(data)
    return WushenBuyPop.new(data)
end

-- 需要的基本数据类型
-- {
--  id = 主键
--  itemType = 物品类型
--  itemId = 物品id
--  itemNum = 物品数量
--  priceType1 = 价格类型1
--  price1 = 价格1数量
--  priceType2 = 价格类型2
--  price2 = 价格2数量
-- }

function WushenBuyPop:ctor(data)
    self._containerLayer:setTouchEndedCallback(function() 
        self:hide({noAction=true})
    end)
    self:initData(data)
    self:initUI()
    self:show()
end

function WushenBuyPop:initData( data )
    -- dump(data)
    self._info = data.info--物品信息
    -- self._ownNum = self._info["ownNum"]
    local timeLimit = data.info.buyNum or 1000000 --购买数量限制
    self._perBuyNum = data.info["itemNum"] or 1 --每次购买的商品数量
    self._leftBtnText = data.leftBtnText or zc.lang("cancel")
    self._rightBtnText = data.rightBtnText or LANGUAGE_SHOP.buy
    self._notMinAndMax = data.notMinMax and data.notMinMax or false
    self._addTenTimes = data.addTenTimes and data.addTenTimes or false
    self._leftFunc = data.leftFunc or nil
    self._rightFunc = data.rightFunc or nil
    self._hideAfterBuy = data.hideAfterBuy or false
    self._useNum = 0

    local _itemInfo = self._info
    local _ownNum = 0
    local _maxNum = 1
    if tonumber(_itemInfo["itemType"]) == zc.mainTypeResource then
        _ownNum = PlayerData:getResourcesInfoById(_itemInfo["itemId"])
    elseif tonumber(_itemInfo["itemType"]) == zc.mainTypeWeapon then --兵器
        _ownNum = PlayerData:getWeaponNumInBagById(_itemInfo["itemId"])
    elseif tonumber(_itemInfo["itemType"]) == zc.mainTypeProp then
        local itemInfo = PlayerData:getBagInfoByID(_itemInfo["itemId"]) or {}
        _ownNum = itemInfo["num"] or 0 
    end

    local ownRes = PlayerData:getResourcesInfoById(_itemInfo["priceType1"])
    _maxNum = math.floor(tonumber(ownRes)/tonumber(_itemInfo["price1"]))
    if _itemInfo["priceType2"] and tonumber(_itemInfo["priceType2"]) > 0 then
        local ownRes2 = PlayerData:getResourcesInfoById(_itemInfo["priceType2"])
        local _max2 = math.floor(tonumber(ownRes2)/tonumber(_itemInfo["price2"]))
        if _max2 < _maxNum then
            _maxNum = _max2
        end
    end
    if _maxNum <= 0 then
        _maxNum = 1
    end
    self._ownNum = _ownNum
    if _maxNum > timeLimit then
        _maxNum = timeLimit
    end
    self._maxNum = _maxNum
end

function WushenBuyPop:initUI()
    local bg = cc.Sprite:create("res/Main/common/popBg/popup_Bg_blue.png")
    bg:setPosition(zc.width/2, zc.height/2)
    self:addContent(bg)

    local titleLab = zc.getTipPopTitle( "goumai" )
    titleLab:setPosition( bg:getContentSize().width/2, bg:getContentSize().height - 30 )
    bg:addChild(titleLab, 2)
    
    local _bgSize = bg:getContentSize()
    local contentBgSize = cc.size(460, 200)
    local contentBg = zc.getScaleNode("res/Main/common/popBg/di_1.png", contentBgSize)
    contentBg:setPosition(_bgSize.width*0.5, _bgSize.height*0.5 + 30)
    bg:addChild(contentBg)

    --道具
    local item = nil
    if tonumber(self._info["itemType"]) == zc.mainTypeWeapon then 
        item = zc.createIconByData({
            data = {
                mainType = zc.mainTypeWeapon,
                type = 1, 
                id = self._info["itemId"],
                num = 1,
                quality = 1,
            }, 
            pos = cc.p(230, 145), 
        })
    elseif tonumber(self._info["itemType"]) == zc.mainTypeProp then
        item = zc.createIconByData({
            data = {
                mainType = zc.mainTypeProp,
                type = 1, 
                id = self._info["itemId"],
                num = self._info["itemNum"],
                quality = 1,
            }, 
            pos = cc.p(230, 145), 
        }) 
    elseif tonumber(self._info["itemType"]) == zc.mainTypeResource then
        item = zc.createIconByData({
            data = {
                mainType = self._info["itemType"],
                type = self._info["itemId"], 
                id = self._info["itemId"],
                num = self._info["itemNum"],
                quality = 1,
            }, 
            pos = cc.p(230, 145), 
        })
    end
    item:setScale(0.75)
    contentBg:addChild(item)
   
    local name = zc.createLabel({
        text = self._info["info"]["name"],
        fontSize = 20,
        pos = cc.p(230, 80),
        outLine = true,
        color = zc.getColorByQuality(self._info["info"]["star"]),
    })
    contentBg:addChild(name)
    local num = zc.createLabel({
        text = zc.lang("curr_have")..":",
        fontSize = 18,
        ap = cc.p(0, 0.5),
        pos = cc.p(10, 170),
        outLine = true,
        color = display.COLOR_WHITE,
    })
    contentBg:addChild(num)
    local num2 = zc.createLabel({
        text = self._ownNum,
        fontSize = 18,
        ap = cc.p(0, 0.5),
        pos = cc.p(num:getPositionX() + num:getContentSize().width + 10, 170),
        outLine = true,
        color =display.COLOR_YELLOW,
    })
    contentBg:addChild(num2)
    self._num2 = num2
    
    local addBg = zc.createScale9Sprite({
        size = cc.size(360, 65),
        rect = cc.rect(50, 50, 1, 1),
        file = "res/Main/common/img_empty.png",
        pos = cc.p(contentBg:getContentSize().width/2, 40),
    })
    contentBg:addChild(addBg)
    --   -1
    local plusOneBtn = zc.createPushButton({
        normalFile = "res/Main/common/button/common_btn8_u.png",
        selectedFile = "res/Main/common/button/common_btn8_d.png",
        needSwallow = false,
        touchScale = 0.9,
        endCallback = function()
            self:addNum(-1)
        end,
        pos = cc.p(110, addBg:getContentSize().height/2), 
    })
    addBg:addChild(plusOneBtn,2)
    local subTenBtn = zc.createPushButton({
        normalFile = "res/Main/bag/new/bag_max_btn_u.png",
        selectedFile = "res/Main/bag/new/bag_max_btn_d.png",
        needSwallow = false,
        touchScale = 0.9,
        text = "Min",
        endCallback = function()
            self:setMinNum(1)
        end,
        pos = cc.p(45, addBg:getContentSize().height/2), 
    })
    addBg:addChild(subTenBtn,2)

    --   +1
    local addOneBtn = zc.createPushButton({
        normalFile = "res/Main/common/button/common_btn2_u.png",
        selectedFile = "res/Main/common/button/common_btn2_d.png",
        needSwallow = false,
        touchScale = 0.9,
        endCallback = function()
            self:addNum(1)
        end,
        pos = cc.p(addBg:getContentSize().width -  110, addBg:getContentSize().height/2), 
    })
    addBg:addChild(addOneBtn,2)
    --   +10
    local addTenBtn = zc.createPushButton({
        normalFile = "res/Main/bag/new/bag_max_btn_u.png",
        selectedFile = "res/Main/bag/new/bag_max_btn_d.png",
        needSwallow = false,
        touchScale = 0.9,
        text = "Max",
        endCallback = function()
            self:setMaxNum(self._maxNum)
        end,
        pos = cc.p(addBg:getContentSize().width - 45, addBg:getContentSize().height/2), 
    })
    addBg:addChild(addTenBtn,2)

    if self._notMinAndMax then
        addTenBtn:setVisible(false)
        subTenBtn:setVisible(false)
    end

    if self._addTenTimes then
        local subTenBtn = zc.createPushButton({
            normalFile = "res/Main/bag/new/bag_max_btn_u.png",
            selectedFile = "res/Main/bag/new/bag_max_btn_d.png",
            needSwallow = false,
            touchScale = 0.9,
            text = "-10",
            fontSize = 22,
            endCallback = function()
                self:subTenNum()
            end,
            pos = cc.p(45, addBg:getContentSize().height/2), 
        })
        addBg:addChild(subTenBtn,2)

        local addTenBtn = zc.createPushButton({
            normalFile = "res/Main/bag/new/bag_max_btn_u.png",
            selectedFile = "res/Main/bag/new/bag_max_btn_d.png",
            needSwallow = false,
            touchScale = 0.9,
            text = "+10",
            fontSize = 22,
            endCallback = function()
                self:addTenNum()
            end,
            pos = cc.p(addBg:getContentSize().width - 45, addBg:getContentSize().height/2), 
        })
        addBg:addChild(addTenBtn,2)
    end


    local numBg =  zc.createScale9Sprite({
            size = cc.size(120, 40),
            file = "res/Main/bag/new/bag_text_bg_s.png",
            pos = cc.p(addBg:getContentSize().width/2, addBg:getContentSize().height/2),
        })
    addBg:addChild(numBg)
    local num = zc.createLabel({
        text = self._useNum,
        fontSize = 20,
        pos = cc.p(numBg:getContentSize().width/2, numBg:getContentSize().height/2),
        outLine = true,
        color = display.COLOR_YELLOW
    })
    numBg:addChild(num)
    self._num = num
    
    local sellImg = zc.createImageView({
        src = zc.getImgByType(self._info["priceType1"]),
        pos = cc.p(225, 100),
        scale = 0.9
    })
    bg:addChild(sellImg)
    local sellNum1 = zc.createLabel({
        text = (tonumber(self._info["price1"]) or 0)*self._useNum,
        fontSize = 22,
        ap = cc.p(0, 0.5),
        pos = cc.p(255, 100),
        outLine = true,
        color = display.COLOR_YELLOW,
    })
    bg:addChild(sellNum1)
    self._sell_label = sellNum1

    if self._info["priceType2"] and tonumber(self._info["priceType2"]) > 0 then
        local sellImg2 = zc.createImageView({
            src = zc.getImgByType(self._info["priceType2"]),
            pos = cc.p(200, sellImg:getPositionY()),
            scale = 0.9
        })
        contentBg:addChild(sellImg2)
        local sellNum2 = zc.createLabel({
            text = (tonumber(self._info["price2"]) or 0)*self._useNum,
            fontSize = 22,
            ap = cc.p(0, 0.5),
            pos = cc.p(230, sellImg:getPositionY()),
            outLine = true,
            color = display.COLOR_YELLOW,
        })
        contentBg:addChild(sellNum2)
        self._sell_label2 = sellNum2

        sellImg:setPositionX(160)
        sellNum1:setPositionX(sellImg:getPositionX()+sellImg:getContentSize().width/2)
        sellImg2:setPositionX(275)
        sellNum2:setPositionX(sellImg2:getPositionX()+sellImg2:getContentSize().width/2)
    end

    --使用按钮
    local useBtn = zc.createCommomBtn({
        tag = 1,
        pos = cc.p(bg:getContentSize().width/2, 50), 
        text = self._rightBtnText,
        listener = function ()
            if tonumber(self._useNum) <= 0 then
                return
            end
            if self._rightFunc then 
                local newinfo = table.copy(self._info)
                newinfo["sellnum"] = self._useNum
                self._maxNum = self._maxNum - self._useNum
                if tonumber(self._maxNum) <= 0 then 
                    self._num:setText(0)
                    self._sell_label:setText(0)
                    if self._sell_label2 then
                        self._sell_label2:setText(0)
                    end
                else
                    self._num:setText(1)
                    local _str_num = self._info["price1"]
                    self._sell_label:setText(_str_num)
                    if self._sell_label2 then
                        self._sell_label2:setText(self._info["price2"])
                    end
                end
                local useNum = self._useNum
                self._useNum = 1

                self._rightFunc(useNum, function()
                    if not tolua.isnull(self) then
                        --购买之后更新数据
                        local _ownNum = 0
                        if tonumber(self._info["itemType"]) == zc.mainTypeResource then
                            _ownNum = PlayerData:getResourcesInfoById(self._info["itemId"])
                        elseif tonumber(self._info["itemType"]) == zc.mainTypeWeapon then --兵器
                            _ownNum = PlayerData:getWeaponNumInBagById(self._info["itemId"])
                        elseif tonumber(self._info["itemType"]) == zc.mainTypeProp then
                            local itemInfo = PlayerData:getBagInfoByID(self._info["itemId"]) or {}
                            _ownNum = itemInfo["num"] or 0
                        end
                        self._num2:setText(_ownNum)
                        self._ownNum = _ownNum
                    end
                end)
                
                if self._hideAfterBuy or tonumber(self._maxNum) <= 0 then
                    self:hide({noAction = true})
                end
                --test
                -- self:hide({noAction = true})

            end
        end,
    })
    bg:addChild(useBtn)

end
function WushenBuyPop:addNum(addnum)
    self._useNum = self._useNum + addnum
    if self._useNum >= tonumber(self._maxNum) then 
        self._useNum = self._maxNum
    elseif self._useNum < 1 then
        self._useNum = 0
    end
    self._num:setText(self._useNum)
    local _str_num = tostring(tonumber(self._info["price1"])*tonumber(self._useNum))
    self._sell_label:setText(_str_num)
    if self._sell_label2 then
        local _str_num2 = tostring(tonumber(self._info["price2"])*tonumber(self._useNum))
        self._sell_label2:setText(_str_num2)
    end
end
function WushenBuyPop:addTenNum()
    if self._maxNum - self._useNum >= 10 then
        self._useNum = self._useNum + 10
    else
        self._useNum = self._maxNum
    end
    self._num:setText(self._useNum)
    local _str_num = tostring(tonumber(self._info["price1"])*tonumber(self._useNum))
    self._sell_label:setText(_str_num)
    if self._sell_label2 then
        local _str_num2 = tostring(tonumber(self._info["price2"])*tonumber(self._useNum))
        self._sell_label2:setText(_str_num2)
    end
end
function WushenBuyPop:subTenNum()
    if self._useNum > 10 then
        self._useNum = self._useNum - 10
    else
        self._useNum = 0
    end
    self._num:setText(self._useNum)
    local _str_num = tostring(tonumber(self._info["price1"])*tonumber(self._useNum))
    self._sell_label:setText(_str_num)
    if self._sell_label2 then
        local _str_num2 = tostring(tonumber(self._info["price2"])*tonumber(self._useNum))
        self._sell_label2:setText(_str_num2)
    end
end
function WushenBuyPop:setMaxNum(maxNum)
    self._useNum = maxNum
    self._num:setText(maxNum)
    local _str_num = tostring(tonumber(self._info["price1"])*tonumber(self._useNum))
    self._sell_label:setText(_str_num)
    if self._sell_label2 then
        local _str_num2 = tostring(tonumber(self._info["price2"])*tonumber(self._useNum))
        self._sell_label2:setText(_str_num2)
    end
end
function WushenBuyPop:setMinNum(minNum)
    self._useNum = minNum
    self._num:setText(minNum)
    local _str_num = tostring(tonumber(self._info["price1"])*tonumber(self._useNum))
    self._sell_label:setText(_str_num)
    if self._sell_label2 then
        local _str_num2 = tostring(tonumber(self._info["price2"])*tonumber(self._useNum))
        self._sell_label2:setText(_str_num2)
    end
end
return WushenBuyPop