-- DEBUG_BATTLE = true
require ("src/requires.lua")
requires("src/baseConfig.lua")
requires ("src/init.lua")

local function main()
    --cc.Director:getInstance():setContentScaleFactor(1)
    -- avoid memory leak
    collectgarbage("setpause", 100)
    collectgarbage("setstepmul", 5000)

    -- initialize director
    local director = cc.Director:getInstance()

    --turn on display FPS
    if APP_ENV == "dev" then
        director:setDisplayStats(true)
    end
    
    --set FPS. the default value is 1.0/60 if you don't call this
    director:setAnimationInterval(1.0 / 60)

    ZC_targetPlatform = cc.Application:getInstance():getTargetPlatform()
    
    --适配方案改在lua里面实现，方便以后上线之后的修改  yanyuling begin
    director:getOpenGLView():setDesignResolutionSize(1136, 640, cc.ResolutionPolicy.FIXED_WIDTH)

    cc.Texture2D:setDefaultAlphaPixelFormat(cc.TEXTURE2_D_PIXEL_FORMAT_AUTO)

    winSize = director:getWinSize();
    winWidth = winSize.width;
    winHeight = winSize.height;

    zc.width = winWidth
    zc.height = winHeight
    zc.cx = winWidth/2
    zc.cy = winHeight/2

    frameSize = director:getOpenGLView():getFrameSize();
    frameWidth = frameSize.width;
    frameHeight = frameSize.height;

    local scene = cc.Scene:create()
    director:replaceScene(scene)  
    zc.createSprite( "res/Main/common/tipResource/bg.png" )
    local node = cc.Node:create()
    cc.Director:getInstance():setNotificationNode(node)
    node:setPosition(0,0)
    zc.getGameInfoFromSdk(function()
        if zc.isGt() then
            requires "src/applang/languageGt.lua"
        else
            requires "src/applang/language.lua"
        end
        local _gameLoadingLayer = requires("src/GameLoadingLayer.lua"):create()
        scene:addChild(_gameLoadingLayer)
    end)

    -- test_battle() --战报播放
    -- battle_test() --武将单调
end

-- for CCLuaEngine traceback
function __G__TRACKBACK__(msg)
    print("----------------------------------------")
    print("LUA ERROR: " .. tostring(msg) .. "\n")
    

    print(debug.traceback())
    print("----------------------------------------")
    zc.showErrorDialog(msg)
    return msg
end


local status, msg = xpcall(main, __G__TRACKBACK__)
if not status then
    error(msg)
end

