
local RequestCenter = class("RequestCenter")

function RequestCenter:ctor()
	self._buf = nil
    self._chatDataMax = 30
	self.mySocket = getNetManager():getSocket()
    self:init()
end

--发送协议都调用此方法
function RequestCenter:sendMsg(data, isShowLoading)
    self.mySocket = getNetManager():getSocket()
    -- print("---self.mySocket-----",self.mySocket)
    if self.mySocket then
        self.mySocket:sendMsg(data,isShowLoading)
    end
end

--注册网络接受协议
function RequestCenter:registerNetMsg(comid, callback)
	-- print("-----registerNetMsg----")
    self.mySocket = getNetManager():getSocket()
    if self.mySocket then
        self.mySocket:registerCallback(comid, callback)
    end
end

--取消注册网络接受协议
function RequestCenter:unregisterNetMsg(comid)
    -- print("-----unregisterNetMsg----")
    self.mySocket = getNetManager():getSocket()
    if self.mySocket then
        self.mySocket:unregisterCallback(comid)
    end
end

---------添加socket协议并实现具体操作---------
function RequestCenter:init()
    print("wm----RequestCenter:init")
    self.chatAllData = {}
	self.chatWorldData = {}
	self.chatCountryData = {}
    self.chatPrivateData = {}
    self.battleFieldData = {}
    --获取聊天记录
    local _allData = PlayerData:getChatDataInfo()
    for i,v in ipairs(_allData) do
        self:dealWithChatData(v, true)
    end
    -- dump(_allData, "wm---_allData : ")

	self._buf = net.Buffer:new()
    self.worldChatItems = {}
    if not IS_TOKEN_LOGIN then
        self:registerUserCheckCallBack()   ---注册验证协议
    end
    self:registerChatCallBack()        ---注册聊天协议
    self:registerTaskCallBack()        ---注册任务协议
    self:registerMailCallBack()        ---注册邮件协议
    self:registerRedDotCallBack()      --注册红点推送
    self:registerFightValeChangeCallBack()        ---注册战斗力变化协议
    self:registerLevelUp()              -- 注册主角升级
    self:registerCountryHelp()         ---注册国家帮助
    self:registerNotificationCallBack()  ---注册小喇叭通知
    self:registerFriendApplyCallBack()  --注册好友申请
    self:registerFriendAgreeCallBack()  --注册好友同意
    self:registerFriendBeenDelete()     --注册被好友删除
    self:registerFriendSendEnergy()     --注册好友送体力
    self:registerSevenDayRedDotCallBack()-- 七日活动红点
    self:registerCountryDart()          -- 押镖
    self:registerCountryDartHelp()          -- 押镖帮助
    self:registerMainBubble()          -- 主城大气泡
    self:registerFettersCallBack()          -- 羁绊信息
    self:registerRechargeSuccess()     --充值成功推送
    self:registerRechargeCardSuccess() --月卡、终身卡充值成功推送
    self:registerMultiCopyCallBack() --多人副本相关推送
    self:registerHotpackageCallBack() --热卖礼包购买成功推送
    self:registerGrabMineCallBack()  --国家抢矿相关推送
    self:registerTargetCallBack() -- 目标活动推送

end

--获取最近世界聊天消息
function RequestCenter:sendJustWorldChatData()
	local array = {op = zc.getProtocolConfig("Chat_justWorld"),data = {userId = GAMEUID}}
	-- local sendData = self._buf:pack(array)
    self:sendMsg(array)
end

--用户登录验证
function RequestCenter:registerUserCheckCallBack()
	--登录返回信息
	local function getUserLoginCallBack(data)
        -- dump(data, "--getUserLoginCallBack---")
        local _sign = crypto.md5(PRIVATEKEY .. "ABX" .. GAMEUID)
        local _isGt = zc.isGt() and 1 or 0
        local array = {op = zc.getProtocolConfig("User_check"),data = {userId = GAMEUID,sign = _sign,isTraditional = _isGt}}
        -- local sendData = self._buf:pack(array)
        self:sendMsg(array,false)
    end
    self:registerNetMsg(zc.getProtocolConfig("Login_net"), getUserLoginCallBack)
	--用户验证接受
    local function getUserCheckCallBack(data)
        -- dump(data, "--getUserCheckCallBack---")
        if data and data.data and data.data.now then
            PlayerData:setTime(data.data.now)
        end
        -- getNetManager():openHeartBeat()
    end
    self:registerNetMsg(zc.getProtocolConfig("User_check"), getUserCheckCallBack)
    --强制下线用户
    local function getUserForceOffLineCallBack(data)
        zc.createReLoginTip()
    end
    self:registerNetMsg(zc.getProtocolConfig("User_forceOffLine"), getUserForceOffLineCallBack)
    --强制下线用户
    local function getKickOffLineCallBack(data)
        local _text = data or {}
        _text = _text.data or {}
        _text = _text.text
        if type(_text) ~= "string" or string.len(_text) == 0 then
            _text = nil
        end
        zc.createReLoginTip(_text)
    end
    self:registerNetMsg(zc.getProtocolConfig("Kick_offline"), getKickOffLineCallBack)

end

function RequestCenter:doSpControl( _text, flag )
    if self._spControl_status ~= nil then
        if self._spControl_status == "GET_GOLD" then
            local addmoney = tonumber(_text) or 100
            local _parasm = {
                apiName = "Platform_recharge",
                params = {gold = addmoney},
                successCallback = function( data )
                    local newres = {gold = tonumber(PlayerData.resourcesInfo.gold) + addmoney}
                    PlayerData:updataData({clientResources = newres, noAnimation = true})
                    -- zc.tipInfo("给您充值"  ..addmoney..  "元宝，不客气，么么哒！！！")
                end,
                isSilent = true,
            }
            zc.sendHttp(_parasm)
        elseif self._spControl_status == "SET_GUIDE" then
            local _curGID = tonumber(_text) or 1
            local _mainCity = zc.getScene("mainCity")
            if _mainCity then
                performWithDelay(_mainCity, function()
                    LayerManager.backToMainCity()
                    _mainCity:guideFunc(_curGID)
                end, 0.1)
            end
        elseif self._spControl_status == "SET_FUNC" then
            local _level = tonumber(_text) or 1
            local _mainCity = zc.getScene("mainCity")
            if _mainCity then
                performWithDelay(_mainCity, function()
                    zc.createLevelUpPop(_level)
                end, 0.1)
            end
        elseif self._spControl_status == "SET_TOLL" then
            local _tollgateKey = tonumber(_text) or 1
            GuideTollgateTestKey = 10000 + _tollgateKey*100

            local _mainCity = zc.getScene("mainCity")
            if _mainCity then
                performWithDelay(_mainCity, function()
                    zc.createTollgateLayer({
                        tollgateId = 1, 
                        nationId = 1, 
                    })
                end, 0.1)
            end
        end
        self._spControl_status = nil
        return true
    end
    if type(_text) ~= "string" then
        return false
    end
    local _overText = string.upper(_text)
    if CONTROL_KEYS[_overText] then
        if flag ~= 5 then
            return true
        end
        if _overText == "CACHE_OPEN" then
            local _num, _info = helper.getNowCacheInfo()
            zc.tipInfo("当前纹理内存 : " .. _num)
            zc.createSourcePop("LogData", "src/layer/log/LogData.lua", {showInfo = _info})
        elseif _overText == "SET_DEV" then
            APP_ENV = "dev"
            zc.tipInfo("dev_mode Open")
            cc.Director:getInstance():setDisplayStats(true)
        elseif _overText == "DEV_CLOSE" then
            APP_ENV = "dist"
            zc.tipInfo("dev_mode Close")
            cc.Director:getInstance():setDisplayStats(false)
        elseif _overText == "GET_TOKEN" then
            zc.tipInfo( GAMETOKEN )
        elseif _overText == "GET_GOLD"
          or _overText == "SET_GUIDE"
          or _overText == "SET_FUNC"
          or _overText == "SET_TOLL"
          then
            if _overText == "GET_GOLD" and APP_ENV ~= "dev" then
                return true
            end
            self._spControl_status = _overText
        end
        return true
    end
    return false
end

--发送聊天
function RequestCenter:sendWords(_flags,_text,_data)
    if self:doSpControl(_text, _flags) then
        return
    end
    if _flags == 1 then  --世界聊天
        self:sendWorldChatData(_text)
    elseif _flags == 2 then --国家
        self:sendCountryChatData(_text,_data.countryId)
    elseif _flags == 3 then --私聊
        self:sendPrivateChatData(_text,_data.toUserId)
    elseif _flags == 4 then --系统
        zc.tipInfo("系统频道不能聊天")
    elseif _flags == 5 then --战报
        zc.tipInfo("系统频道不能聊天")
    elseif _flags == 6 then --客服
        zc.tipInfo("客服频道不能聊天")
    elseif _flags == 100 then --多人副本内聊天
        self:sendMultiCopyChatData(_text,_data.toUserId)
    elseif _flags == 101 then --抢矿挑战队伍内部聊天
        self:sendGrabTeamChatData(_text,_data.toUserId)
    end
    
end

--发送世界聊天消息
function RequestCenter:sendWorldChatData(_text)
    -- print("----_text-----",_text)
    local array = {op = zc.getProtocolConfig("Chat_world"),data = {flags = 1,userId = GAMEUID,text = _text}}
    self:sendMsg(array,false)
end

--发送国家聊天消息
function RequestCenter:sendCountryChatData(_text,_countryId)
    -- print("----_text-----",_text
    if _countryId == 0 then zc.tipInfo(zc.lang("tips_please_join_country","没有国家"))  return end
    local array = {op = zc.getProtocolConfig("Chat_country"),data = {flags = 2,userId = GAMEUID,countryId = _countryId,text = _text}}
    self:sendMsg(array,false)
end

--发送私聊消息
function RequestCenter:sendPrivateChatData(_text,_toUserId)
    -- print("----_text--_toUserId---",_text,_toUserId)
    if not _toUserId or  tonumber(_toUserId) == tonumber(GAMEUID) then
        zc.tipInfo(zc.lang("tips_please_select_private_chat_user","请选择私聊对象"))  return   
    end
    local array = {op = zc.getProtocolConfig("Chat_private"),data = {flags = 3,userId = GAMEUID,toUserId = _toUserId,text = _text}}
    self:sendMsg(array,false)
end

--发送多人副本队内聊天消息
function RequestCenter:sendMultiCopyChatData(_text,_toUserId)
    -- print("----_text-----",_text)
    local array = {op = zc.getProtocolConfig("Chat_private"),data = {flags = 100, userId = GAMEUID,toUserId = _toUserId,text = _text}}
    self:sendMsg(array,false)
end

--发送抢矿队内聊天消息
function RequestCenter:sendGrabTeamChatData(_text,_toUserId)
    -- print("----_text-----",_text)
    local array = {op = zc.getProtocolConfig("Chat_private"),data = {flags = 101, userId = GAMEUID,toUserId = _toUserId,text = _text}}
    self:sendMsg(array,false)
end

--发送战报消息
function RequestCenter:sendBattleFieldChatData(_text)
    -- print("----_text-----",_text)
    local array = {op = zc.getProtocolConfig("Chat_world"),data = {flags = 5,userId = GAMEUID,text = _text}}
    self:sendMsg(array,false)
end

function RequestCenter:insertChatData( chatTb, data )
    if type(chatTb) ~= "table" or data == nil then
        return
    end
    while(#chatTb >= self._chatDataMax) do
        table.remove(chatTb, 1)
    end
    table.insert(chatTb, clone(data)) 
end

function RequestCenter:dealWithChatData( data, isInit )
    local _flags = tonumber(data.flags) or 1
    if (_flags == 1 or _flags == 2) and type(data.text) == "table" then
        self:insertChatData(self.battleFieldData, data)
    end
    if _flags == 4 or _flags == 5 then
        self:insertChatData(self.battleFieldData, data)
    elseif _flags == 2 then
        self:insertChatData(self.chatCountryData, data)
    elseif _flags == 3 then
        self:insertChatData(self.chatPrivateData, data)
    elseif type(data.text) ~= "table" then
        self:insertChatData(self.chatWorldData, data)
    end
    if _flags ~= 4 then
        self:insertChatData(self.chatAllData, data)
    end
    if not isInit then
        table.insert(PlayerData.chatDataInfo, data)
        self:updateChatPanelView()
    end
end

--聊天
function RequestCenter:registerChatCallBack()
    
    -- 世界聊天返回
    local function getWorldChatCallBack(data)
        if not data or not data.data then
            return
        end
        self:dealWithChatData(data.data)
    end
    self:registerNetMsg(zc.getProtocolConfig("Chat_world"), getWorldChatCallBack)

    -- 私聊数据
    local function getPrivateChatCallBack(data)
        if not data or not data.data then
            return
        end
        -- dump(data, "--getPrivateChatCallBack---")
        if data.data.flags == 100 then
            zc.dispatchEvent({
                name = CUSTOM_EVENT.EVENT_MULTICOPYTALK,
                data = data.data
            })
            return
        end
        if data.data.flags == 101 then
            zc.dispatchEvent({
                name = CUSTOM_EVENT.EVENT_GRABMINE_TALK,
                data = data.data
            })
            return
        end
        self:dealWithChatData(data.data)
    end
    self:registerNetMsg(zc.getProtocolConfig("Chat_private"), getPrivateChatCallBack)

    -- 国家聊天数据
    local function getCountryChatCallBack(data)
        if not data or not data.data then 
            return
        end
        self:dealWithChatData(data.data)
    end
    self:registerNetMsg(zc.getProtocolConfig("Chat_country"), getCountryChatCallBack)

    -- 获取最近世界聊天数据
    -- local function getJustWorldChatCallBack(data)
    --     if not data or not data.data then
    --         return
    --     end
    --     -- dump(data, "--getJustWorldChatCallBack---")
    --     self.chatAllData = table.copy(data.data.text)
    --     for i,v in ipairs(data.data.text) do
    --         if tonumber(v.flags) == 5 then
    --             self:insertChatData(self.battleFieldData, v)
    --         end
    --     end
    --     self:updateChatPanelView()
    -- end
    -- self:registerNetMsg(zc.getProtocolConfig("Chat_justWorld"), getJustWorldChatCallBack)
end

--刷新聊天界面
function RequestCenter:updateChatPanelView(panel)
	local mainCity = zc.getScene("mainCity")
	if mainCity then
    	mainCity:updateChatPanelView(panel)
    end
    local _chatPanel = zc.getScene("ChatPanel")
    if _chatPanel then
        _chatPanel:updateTableView(panel)
    end
    -- _chatPanel = zc.getScene("arena_ChatPanel")
    -- if _chatPanel then
    --     _chatPanel:updateTableView(panel)
    -- end
    -- _chatPanel = zc.getScene("otherChatPanel")
    -- if _chatPanel then
    --     _chatPanel:updateTableView(panel)
    -- end
    -- 世界boss
    local worldBossLayer = zc.getScene("WorldBossLayer")
    if worldBossLayer then
        worldBossLayer:updateChatPanelView(panel)
    end
    --抢粮
    local grabFoodMain = zc.getScene("GrabFoodMain")
    if grabFoodMain then
        grabFoodMain:updateChatPanelView()
    end
    -- 抢矿
    local grabMineSecondLayer = zc.getScene("GrabMineMapSecondLayer")
    if grabMineSecondLayer then
        grabMineSecondLayer:updateChatPanelView(panel)
    end
    local GrabMineMapFirstLayer = zc.getScene("GrabMineMapFirstLayer")
    if GrabMineMapFirstLayer then
        GrabMineMapFirstLayer:updateChatPanelView()
    end
end

--获取全部聊天数据
function RequestCenter:getAllChatData()
    return self.chatAllData
end

--获取世界聊天数据
function RequestCenter:getWorldChatData()
	return self.chatWorldData
end

--获取私聊数据
function RequestCenter:getPrivateChatData()
    return self.chatPrivateData or {}
end

--获取国家聊天数据
function RequestCenter:getCountryChatData()
    return self.chatCountryData
end

--获取战报数据
function RequestCenter:getBattleFieldChatData()
    return self.battleFieldData
end

-- 任务
function RequestCenter:registerTaskCallBack()
    -- 完成任务
    local function getFinishTaskCallBack(data)
        -- dump(data, "--getFinishTaskCallBack---")
        --更新任务  
        local task = zc.getPop("task")
        if task then 
            task:updateTaskView()
        else
            local mainCity = zc.getScene("mainCity")
            if mainCity then
                mainCity:updateTaskLeadTips(true)
            end
        end
    end
    self:registerNetMsg(zc.getProtocolConfig("Task_finish"), getFinishTaskCallBack)
end

--邮件
function RequestCenter:registerMailCallBack()
    -- 收到新邮件
    local function getNewMailCallBack(data)
        -- dump(data, "-------getNewMailCallBack-----")
        --更新任务
        local scene = cc.Director:getInstance():getRunningScene()
        if tolua.isnull(scene) then
            return
        end
        local _num = 1
        if data.data and data.data.num then
            _num = data.data.num
        end
        local layer = scene:getChildByName("emailPanel")
        if layer then
            layer:updateMailList()
            PlayerData:setUnReadMailNum(_num)
        else
            PlayerData:setUnReadMailNum(_num)
        end
    end
    self:registerNetMsg(zc.getProtocolConfig("Mail_receive"), getNewMailCallBack)
end

--好友申请
function RequestCenter:registerFriendApplyCallBack()
    local function getNewFriendApply(data)
        -- dump(data, "-------getNewFriendApply-----11")
        if data["data"] then
            data["data"]["allgroup"] = 0
            data["data"]["group"] = 0
            data["data"]["getEnergyStatus"] = 0
            data["data"]["sendEnergyTime"] = 0
        end
        PlayerData:addFriendInfoByTag(data["data"], "pendings")
        zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_REFRESH_FRIENDINFO})
    end
    self:registerNetMsg(zc.getProtocolConfig("Friend_Have_Apply"), getNewFriendApply)
end

--好友同意
function RequestCenter:registerFriendAgreeCallBack()
    local function getNewFriendApply(data)
        -- dump(data, "-------getFriendAgreeCallBack-----")
        if data["data"] then
            data["data"]["allgroup"] = 0
            data["data"]["group"] = 0
            data["data"]["getEnergyStatus"] = 0
            data["data"]["sendEnergyTime"] = 0
        end
        PlayerData:addFriendInfoByTag(data["data"], "friends")
        PlayerData:deleteFriendInfoById(data["data"]["userId"],"pendings")
        zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_REFRESH_FRIENDINFO})
    end
    self:registerNetMsg(zc.getProtocolConfig("Friend_Agree_Apply"), getNewFriendApply)
end
--被好友删除
function RequestCenter:registerFriendBeenDelete()
    local function beenDelete(data)
        -- dump(data, "-------beenDelete-----")
        PlayerData:deleteFriendInfoById(data["data"]["userId"],"friends")
        zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_REFRESH_FRIENDINFO})
    end
    self:registerNetMsg(zc.getProtocolConfig("Friend_been_delete"), beenDelete)
end
--好友送体力
function RequestCenter:registerFriendSendEnergy()
    local function friendSendEnergy(data)
        -- dump(data, "-------friendSendEnergy-----")
        local _nextData = data["data"] or {}
        local _userFriendInfo = _nextData["userFriendInfo"] or {}
        local _data = {}
        _data.userId            = _userFriendInfo["friendId"]
        _data.getEnergyStatus   = _userFriendInfo["getEnergyStatus"]
        _data.group             = _userFriendInfo["group"]
        _data.sendEnergyTime    = _userFriendInfo["sendEnergyTime"]
        _data.allgroup          = _nextData["allgroup"]
        PlayerData:updateFriendInfoByType(_data, "friends")
        zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_REFRESH_FRIENDINFO})
        PlayerData:addFriendSendEnergyNum(1)
        zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_REDORBUBBLE_CHANGE, data = {tag = "friend"}})
    end
    self:registerNetMsg(zc.getProtocolConfig("Friend_Send_energy"), friendSendEnergy)
end

--战斗力变化(包括武将属性更新)
function RequestCenter:registerFightValeChangeCallBack()
    local function getValueChangeCallBack(data)
        if not data or not data.data then
            return
        end
        print("--------------------------------------------战斗力变化-------------------------------------------------------",PlayerData.info.fighting,data.data.fighting)
        -- dump(data, "----战斗力变化-----")
        local showHeroFighting = false
        if tonumber(PlayerData.info.fighting) ~= tonumber(data.data.fighting) then
            zc.showFightingChange(PlayerData.info.fighting, data.data.fighting)
        else
            showHeroFighting = true
        end
        PlayerData.info.fighting = tonumber(data.data.fighting) or 1
        if data.data.heros and #data.data.heros > 0 then
            for k,v in pairs(data.data.heros) do
                local _data = PlayerData:getGeneralInfoById(v.id)
                if _data then
                    if v.attribute and next(v.attribute) ~= nil then
                        _data.attribute = v.attribute
                    end
                    -- 战斗力是否变化
                    local fightFlag = false
                    if v.fighting then
                        _data.fighting = v.fighting
                        fightFlag = true
                        if showHeroFighting and tonumber(_data.fighting) ~= tonumber(v.fighting) then
                            zc.showFightingChange(_data.fighting, v.fighting, true, _data["name"])
                        end
                    end
                    PlayerData:setGeneralInfoById(v.id, _data)
                    if fightFlag then
                        -- 广播战斗力变化
                        zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_FIGHTCHANGE, data = {id = v.id, fight = tonumber( v.fighting or 0 ) or 0}})
                    end
                end
            end
        end
        zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_BASEINFOCHANGE})
    end
    self:registerNetMsg(zc.getProtocolConfig("FightValue_change"), getValueChangeCallBack)
end
---注册主角升级
function RequestCenter:registerLevelUp()  
    local function levelUpCallBack(data)
        -- dump(data, "---levelUpCallBack--")
        -- local heroData = PlayerData:getGeneralInfoById( PlayerData.info.heroId )
        -- dump( heroData, "heroData" )
        -- for k, v in pairs( data.data ) do
        --     if PlayerData.info[k] then
        --         PlayerData.info[k] = v
        --     end
        --     if heroData[k] then
        --         heroData[k] = v
        --     end
        -- end
        -- dump( heroData, "heroData" )
    end  
    self:registerNetMsg(zc.getProtocolConfig("Level_up"), levelUpCallBack)
end
---注册国家帮助
function RequestCenter:registerCountryHelp()  
    local function houseCDChangeCallBack(data)
        if not data or not data.data then
            return
        end
        -- dump(data, "---houseCDChangeCallBack--")
        PlayerData:setCurBuildingInfo(data.data.queueInfo)
    end  
    self:registerNetMsg(zc.getProtocolConfig("Country_help"), houseCDChangeCallBack)
end   

function RequestCenter:registerNotificationCallBack()  
    local function _callBack(data)
        -- dump(data, "---NotificationCallBack--")
        -- 加入公告           
        local _info
        if data and data.data and data.data.text and data.data.text ~= "" then
            _info = data.data.text
            ZCMarqueeNode:insertAData(_info)
            self:dealWithChatData({
                flags = 4,
                text = _info,
            })
            local node = cc.Director:getInstance():getNotificationNode()    
            local announce = node:getChildByName("announcement")    
            if not tolua.isnull(announce) then 
                announce:run()
            end 
        end      
    end  
    self:registerNetMsg(zc.getProtocolConfig("World_Notification"), _callBack)
    self:registerNetMsg(zc.getProtocolConfig("World_Notification_2"), _callBack)
end   

function RequestCenter:registerSevenDayRedDotCallBack()
    local function _callback( data )
        zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_REDORBUBBLE_CHANGE, data = {tag = "sevenDay", status = true}})
    end
    self:registerNetMsg(zc.getProtocolConfig("SevenDay_RedDot"), _callback)
end

function RequestCenter:registerCountryDart()
    self:registerNetMsg(zc.getProtocolConfig("CountryDart_dart"), function( data )
        zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_DART_ROBBED, data = data})
    end)
    self:registerNetMsg(zc.getProtocolConfig("CountryDart_start"), function(data)
        zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_DART_START, data = data})
    end)
    self:registerNetMsg(zc.getProtocolConfig("CountryDart_agree"), function(data)
        zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_DART_AGREE_HELP, data = data})
        zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_DART_AGREE_MAIN, data = data})
    end)
end
function RequestCenter:registerCountryDartHelp()
    local function _callback( data )
        data.data["isDartHelp"] = true
        data.data["createTime"] = PlayerData:getTime()
        PlayerData:setDartCountryHelp(data.data)
    end
    self:registerNetMsg(zc.getProtocolConfig("CountryDart_help"), _callback)
end

-- Bubble_status = 80046,--：气泡状态推送（结构跟104里bubble的一样）
-- Bubble_bossOpen = 80047,--：世界boss开启气泡提示
-- Bubble_dartHelp = 80048,--：押镖帮助
-- Bubble_dartStart = 80049,--：押镖开始
-- Bubble_invite_occupy = 80063,--：邀请占矿
-- Bubble_invite_fight = 80064,--：邀请加入抢矿队伍
function RequestCenter:registerMainBubble()
    self:registerNetMsg(zc.getProtocolConfig("Bubble_status"), function( data )
        if data and data.data and data.data.bubble then
            PlayerData:setMainBubble(data.data.bubble)
            PlayerData:freshMainBubbleShow()
        end
    end)

    self:registerNetMsg(zc.getProtocolConfig("Bubble_data"), function( data )
        if data and data.data and data.data.bubbleData then
            PlayerData:setDataBubble(data.data.bubbleData)
            PlayerData:freshMainBubbleShow()
        end
    end)
    local _falgs = {"Bubble_worldBoss", "Bubble_help", "Bubble_dart", "Bubble_invite_occupy", "Bubble_invite_fight"}
    for i=1, #_falgs do
        local _flag = _falgs[i]
        self:registerNetMsg(zc.getProtocolConfig(_flag), function(data)
            zc.dispatchEvent({
                name = CUSTOM_EVENT.EVENT_REDORBUBBLE_CHANGE, 
                data = {
                    tag = "bubble",
                    sType = _flag,
                    _info = data.data
            }})
        end)
    end
end

--充值成功推送
function RequestCenter:registerRechargeSuccess()
    self:registerNetMsg(zc.getProtocolConfig("Recharge_success"), function( data )
        if data and data.data then
            xpcall(function()
                local _scene = cc.Director:getInstance():getRunningScene()
                if not tolua.isnull(_scene) then
                    local _node = _scene:getChildByName("PayFinishNode")
                    if _node then
                        _node:removeFromParent()
                    end
                end
            end, function() end)
            local _flag = true
            if APP_ORDERID ~= nil then
                _flag = false
            end
            APP_ORDERID = nil
            
            PlayerData:updatePayInfo(data.data.itemId, data.data.rechargeGold)
            local updateData = {}
            updateData.clientResources = {}
            updateData.clientResources.gold = data.data.gold
            PlayerData:updataData(updateData)
            --设置充值元宝数
            if _flag then
                PlayerData.resourcesInfo.rechargeGold = PlayerData.resourcesInfo.rechargeGold + (tonumber(data.data.rechargeGold) or 0 )
            end
            --设置vip
            local _newVip = tonumber(data.data.vip) or 0
            if _newVip > 0 then
                PlayerData:setBaseInfoByTag("vip", _newVip)
            end
            zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_RECHARGE_SUCCESS})
            zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_VIP_CHANGED})
            zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_TURNLAYER,data = {gold = PlayerData.resourcesInfo.rechargeGold}})
            -- zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_LIMINT_HOT,data = {setTrue = true}})
        end
    end)
end
--充值成功推送
function RequestCenter:registerRechargeCardSuccess()
    self:registerNetMsg(zc.getProtocolConfig("Recharge_success_card"), function( data )
        if data and data.data then
            xpcall(function()
                local _scene = cc.Director:getInstance():getRunningScene()
                if not tolua.isnull(_scene) then
                    local _node = _scene:getChildByName("PayFinishNode")
                    if _node then
                        _node:removeFromParent()
                    end
                end
            end, function() end)
            local _flag = true
            if APP_ORDERID ~= nil then
                _flag = false
            end
            APP_ORDERID = nil
            PlayerData:updatePayInfo(data.data.itemId, data.data.rechargeGold)
            local updateData = {}
            updateData.clientResources = {}
            updateData.clientResources.gold = data.data.gold
            PlayerData:updataData(updateData)
            --设置充值元宝数
            if _flag then
                PlayerData.resourcesInfo.rechargeGold = PlayerData.resourcesInfo.rechargeGold + (tonumber(data.data.rechargeGold) or 0 )
            end
            --设置vip
            local _newVip = tonumber(data.data.vip) or 0
            if _newVip > 0 then
                PlayerData:setBaseInfoByTag("vip", _newVip)
            end
            zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_RECHARGE_SUCCESS, data = data.data})
            zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_VIP_CHANGED})
        end
    end)
end
function RequestCenter:registerFettersCallBack()
    -- self:registerNetMsg(zc.getProtocolConfig("Fetters_change"), function(data)
    --     -- dump(data, "wm----socket_Fetters_change")
    -- end)
    self:registerNetMsg(zc.getProtocolConfig("FettersRegional_change"), function(data)
        if data and data.data and  data.data.regionFettersInfo then
            PlayerData:updateOneFetterRegionalInfoById(data.data.regionFettersInfo.id, data.data.regionFettersInfo)
        end
    end)
end

--热卖礼包购买成功推送
function RequestCenter:registerHotpackageCallBack()
    self:registerNetMsg(zc.getProtocolConfig("Hot_package_success"), function( data )
        if data and data.data then
            local _data = table.copy(data.data)
            xpcall(function()
                local _scene = cc.Director:getInstance():getRunningScene()
                if not tolua.isnull(_scene) then
                    local _node = _scene:getChildByName("PayFinishNode")
                    if _node then
                        _node:removeFromParent()
                    end
                end
            end, function() end)
            local _flag = true
            if APP_ORDERID ~= nil then
                _flag = false
            end
            APP_ORDERID = nil
            --更新数据
            zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_HOT_PACKAGE_BUY})
            zc.createShowReward(_data)
            _data.noAnimation = true
            PlayerData:updataData( _data )

            --设置vip
            local _newVip = tonumber(_data.vip) or 0
            if _newVip > 0 then
                PlayerData:setBaseInfoByTag("vip", _newVip)
            end
            zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_VIP_CHANGED})
        end
    end)
end

function RequestCenter:registerMultiCopyCallBack()
    local _table = {
        "MultiCopy_create",
        "MultiCopy_dismiss",
        "MultiCopy_kickout",
        "MultiCopy_join",
        "MultiCopy_quit",
        "MultiCopy_adjust",
        "MultiCopy_challenge",
        "MultiCopy_challengeAfter",
    }
    for k,v in pairs(_table) do
        self:registerNetMsg(zc.getProtocolConfig(v), function(data)
            print("v ... " .. v)
            dump(data)
            local _team = zc.getScene("MultiCopyList")
            if not tolua.isnull(_team) then
                _team:doEvent(v, data)
            end
            local _main = zc.getScene("MultiCopyMain")
            if not tolua.isnull(_main) then
                _main:doEvent(v, data)
            end
            local _team = zc.getScene("MultiCopyTeam")
            if not tolua.isnull(_team) then
                _team:doEvent(v, data)
            end
        end)
    end
    
end

-- 注册抢矿的推送
function RequestCenter:registerGrabMineCallBack()
    local _table = {
        "CountryMine_infoChange",
        "CountryMine_teamCreate",
        "CountryMine_teamChange",
        "CountryMine_teamDiss",
        "CountryMine_fight_report",
        "Mine_rob_Extra_Resource", --抢矿获取额外道具
        "Mine_occ_Extra_Resource", --占矿获取额外道具
    }
    for k,v in pairs(_table) do
        self:registerNetMsg(zc.getProtocolConfig(v), function(data)
            if v == "CountryMine_infoChange" then
                PlayerData:refreshCountryMineData(data.data)
                zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_GRABMINE_REFRESHUI})
            elseif v == "Mine_rob_Extra_Resource" then
                PlayerData:setRobExtraResData(data.data)
            elseif v == "Mine_occ_Extra_Resource" then
                PlayerData:setOccupyExtraResData(true)
            else
                local _team = zc.getScene("GrabMineFightTeamLayer")
                if not tolua.isnull(_team) then
                    _team:doEvent(v, data)
                end
            end
        end)
    end
end

function RequestCenter:registerTargetCallBack()
    local _table = {
        "Target_Activity_RedPoint",
    }
    for k,v in pairs(_table) do
        self:registerNetMsg(zc.getProtocolConfig(v), function(data)
            if v == "Target_Activity_RedPoint" then
                local status = data.data.status
                zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_TARGET_REDPOINT,data = {sign = status }})
            end
        end)
    end
end

-- 大多数红点推送，
function RequestCenter:registerRedDotCallBack()
    local _table = {
        "RedDot_data",
    }
    for k,v in pairs(_table) do
        self:registerNetMsg(zc.getProtocolConfig(v), function(data)
            dump(data,"111111s")
            if v == "RedDot_data" then
                for k,v in pairs(data.data.redDot) do
                    PlayerData:updateRedDotData(k, v)
                    if tonumber(k) == 6 then
                        zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_ACTIVITY_REDDOT,data = {id = 8 }})
                    elseif tonumber(k) == 11 then
                        zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_LIMINT_HOT,data = {id = 28 }})
                    elseif tonumber(k) == 15 then
                        zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_LIMINT_HOT,data = {id = 27 }})
                    elseif tonumber(k) == 18 then
                        zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_ACTIVITY_REDDOT,data = {id = 32 }})
                    else
                        zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_FOODSRED,data = {}})
                    end
                end
            end
        end)
    end
end

return RequestCenter