--[[

moreUserLoginPop.lua
]]

local moreUserLoginPop = class("moreUserLoginPop",function()
	return ZCPopLayer:create({isRemoveLayout = false})
end);

function moreUserLoginPop:create(data)
    local layer = moreUserLoginPop.new(data)
    return layer
end

function moreUserLoginPop:ctor(data)
    self._userTable = zc.LoadTable("userTable")
	self:initUI()
end
function moreUserLoginPop:initUI()
	local bg =  zc.createImageView({
        src = "res/Main/login/login_accountbg.png",
        ap = cc.p(0.5, 0),
        pos = cc.p(zc.width/2, 10),
    })
	self:addContent(bg)


	local userTable = cc.TableView:create(cc.size(400, 160))
    userTable:setDirection(cc.SCROLLVIEW_DIRECTION_VERTICAL)
    userTable:setPosition(cc.p(10, 10))
    userTable:setDelegate()
    userTable:setVerticalFillOrder(cc.TABLEVIEW_FILL_TOPDOWN)--kTableViewFillBottomUp  kTableViewFillTopDown
    local function tableCellTouched(table, cell)
    end
    local function cellSizeForTable(table, idx) 
        return 400,40--40, 400
    end
    local function tableCellAtIndex(table, cellIndex) 
        cellIndex = cellIndex + 1
        local cell = userTable:dequeueCell()
        -- 创建模板
        if cell == nil then
            cell = cc.TableViewCell:new()
            self:buildCell(cell, cellIndex)
        end
        -- 更新界面
        self:updateCell(cell, cellIndex)
        return cell
    end
    local function numberOfCellsInTableView()
        return  #self._userTable
    end
    
    userTable:registerScriptHandler(tableCellTouched, cc.TABLECELL_TOUCHED)
    userTable:registerScriptHandler(cellSizeForTable, cc.TABLECELL_SIZE_FOR_INDEX)
    userTable:registerScriptHandler(tableCellAtIndex, cc.TABLECELL_SIZE_AT_INDEX)
    userTable:registerScriptHandler(numberOfCellsInTableView, cc.NUMBER_OF_CELLS_IN_TABLEVIEW)
    bg:addChild(userTable)
    userTable:reloadData()

end
function moreUserLoginPop:buildCell(cell, cellIndex)
	--背景create
    local bg = zc.createImageView({
        src = "res/Main/common/img_empty.png",
        size = cc.size(400, 40),
        scale9 = true,
        pos = cc.p(200, 20),
        listener = function () 
            
        end,
    })
    cell:addChild(bg)
    cell._bg = bg
    local serverName = zc.createLabel({
        text = self._userTable[cellIndex]["name"],--"测试".. (cellIndex-1)*2+i .."服",
        fontSize = 25,
        ttf = zc.getFont(1),
        ap = cc.p(0, 0.5),
        pos = cc.p(90, bg:getContentSize().height/2),
        --color = cc.c3b(0, 0, 0),
    })
    bg:addChild(serverName)
    cell._serverName = serverName
end
function moreUserLoginPop:updateCell(cell, cellIndex)
	cell._bg:addTouchEventListener(function ( sender, eventType )
        if eventType == ccui.TouchEventType.ended then
            local _runningScene = cc.Director:getInstance():getRunningScene()
            if _runningScene then
                local _login = _runningScene:getChildByName("login")
                if _login and _login.setServerName then
                    _login:setUserName(self._userTable[cellIndex]["name"])
                end
            end
            self:removeFromParent()
        end 
    end)
	cell._serverName:setText(self._userTable[cellIndex]["name"])
	-- if tonumber(self._userTable[cellIndex]["login"]) == 1 then 
	-- 	cell._islogin:setVisible(true)
	-- else
	-- 	cell._islogin:setVisible(false)
	-- end
end

return moreUserLoginPop